'From Squeak3.1alpha of 7 March 2001 [latest update: #4173] on 25 July 2001 at 8:50:50 pm'!
Object subclass: #HttpResponse
	instanceVariableNames: 'contents contentType status request fields cookies '
	classVariableNames: 'StatusCodes '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!
Object subclass: #HttpSession
	instanceVariableNames: 'id attributes timestamp '
	classVariableNames: 'LastSessionID '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpSession commentStamp: 'DGD 7/24/2001 20:28' prior: 0!
I'm a Session in  a Http conexion.!

Smalltalk renameClassNamed: #SessionModule as: #HttpSessionModule!
Object subclass: #HttpSessionModule
	instanceVariableNames: 'module sessions mutex lastCleanup secondsToLive '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!HttpSessionModule commentStamp: 'DGD 7/24/2001 00:41' prior: 0!
I'm module decorator that add Session support to an existing module!


!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:25'!
cookies
^ cookies ifNil:[cookies _ OrderedCollection new]! !

!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:30'!
setCookieName: nameString value: valueString expiresDate: expiresDate expiresTime: expiresTime path: pathString domain: domainString secure: secureBoolean 
	"set a cookie in the Response"
	| temp |
	temp _ String new writeStream.
	"NAME=VALUE"
	temp nextPutAll: nameString;
		 nextPut: $=;
		 nextPutAll: valueString.
	"; expires=Wdy, DD-Mon-YYYY HH:MM:SS GMT"
	(expiresDate notNil and:[ expiresTime notNil])
		ifTrue: [temp nextPutAll: '; expires=';
				 nextPutAll: expiresDate weekday;
				 nextPutAll: ', '.
			expiresDate printOn: temp format: #(1 2 3 $- 2 2 2 ).
			temp nextPutAll: ' ';
				 nextPutAll: expiresTime print24;
				 nextPutAll: ' GMT'].
	"; path=PATH"
	pathString notNil
		ifTrue: [temp nextPutAll: '; path=';
				 nextPutAll: pathString].
	"; domain=DOMAIN"
	domainString notNil
		ifTrue: [temp nextPutAll: '; domain=';
				 nextPutAll: domainString].
	"; secure"
	(secureBoolean notNil
			and: [secureBoolean])
		ifTrue: [temp nextPutAll: '; secure'].
	""
	self cookies add: temp contents! !

!HttpResponse methodsFor: 'accessing-cookies' stamp: 'DGD 7/20/2001 00:24'!
setCookieName: nameString value: valueString path: pathString 
	"set a cookie in the Response"
	self
		setCookieName: nameString
		value: valueString
		expiresDate: nil
		expiresTime: nil
		path: pathString
		domain: nil
		secure: nil! !

!HttpResponse methodsFor: 'responding' stamp: 'DGD 7/20/2001 00:34'!
pvtWriteCookiesOn: aStream 
	cookies isEmptyOrNil
		ifTrue: [^ self].
	cookies
		do: [:cookie | aStream nextPutAll: 'Set-Cookie: ';
				 nextPutAll: cookie;
				 nextPutAll: String crlf]! !

!HttpResponse methodsFor: 'responding' stamp: 'DGD 7/20/2001 00:32'!
writeOn: aStream 
	"Header"
	| tmp |
	tmp _ WriteStream on: ''.
	self pvtWriteStatusOn: tmp.
	self pvtWriteServerOn: tmp.
	self pvtWriteFieldsOn: tmp.
self pvtWriteCookiesOn:tmp.
	self pvtWriteContentTypeOn: tmp.
	self pvtWriteContentLengthOn: tmp.
	tmp nextPutAll: String crlf.
	aStream nextPutAll: tmp contents;
		 flush.
	"Body"
	self pvtWriteContentsOn: aStream! !


!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 20:35'!
attributes
"answer the attributes stored in Session"
	^ attributes! !

!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 21:00'!
id
^id! !

!HttpSession methodsFor: 'accessing' stamp: 'DGD 7/24/2001 20:37'!
timestamp:aNumber
timestamp _ aNumber! !

!HttpSession methodsFor: 'asking' stamp: 'DGD 7/24/2001 20:40'!
usedSince: deadLineNumber 
	^ timestamp  < deadLineNumber! !

!HttpSession methodsFor: 'initialization' stamp: 'DGD 7/24/2001 21:00'!
initialize
	attributes _ Dictionary new.
id _ self class nextSessionID! !

!HttpSession methodsFor: 'printing' stamp: 'DGD 7/24/2001 21:08'!
printOn: aStream 
	aStream nextPutAll: self class name;
nextPutAll: ' id:';
		 nextPutAll: id asString;
nextPutAll: ' attributes:';
		 nextPutAll: attributes asString;
nextPutAll: ' timestamp:';
		 nextPutAll: timestamp asString! !


!HttpSession class methodsFor: 'class initialization' stamp: 'DGD 7/24/2001 20:58'!
initialize
	LastSessionID _ Time totalSeconds.! !

!HttpSession class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 20:33'!
new
^ super new initialize! !

!HttpSession class methodsFor: 'session id' stamp: 'DGD 7/24/2001 20:59'!
nextSessionID
	self flag: #TODO.
	"more robust unique number"
	LastSessionID _ LastSessionID + 1.
	^ (65535 atRandom hex allButFirst: 3)
		, (LastSessionID hex allButFirst: 3)
		, (65535 atRandom hex allButFirst: 3)! !


!HttpSessionModule methodsFor: 'accessing' stamp: 'DGD 7/24/2001 21:05'!
secondsToLive:anInteger
secondsToLive _ anInteger! !

!HttpSessionModule methodsFor: 'comanche' stamp: 'DGD 7/24/2001 21:44'!
process: aRequest 
	"process the request for session handling, then delegate #process: to the 
	decorated module, and send the new cookie to the browser"
	| response newSessionID |
	newSessionID _ self processRequestForSession: aRequest.
	response _ (module process: aRequest)
				asHttpResponseTo: aRequest.
	newSessionID notNil
		ifTrue: [response
				setCookieName: #SessionID
				value: newSessionID
				path: '/'].
	^ response! !

!HttpSessionModule methodsFor: 'initialization' stamp: 'DGD 7/24/2001 21:04'!
initialize
	sessions _ Dictionary new.
	mutex _ Semaphore forMutualExclusion.

	lastCleanup _ Time totalSeconds.
	"30 minutes"
	secondsToLive _ 30 * 60! !

!HttpSessionModule methodsFor: 'initialization' stamp: 'DGD 7/24/2001 00:40'!
initializeModule:aModule
module _ aModule! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:34'!
checkForCleanup
"PRIVATE: run the cleanup between time and time"
	lastCleanup + 60 < Time totalSeconds
		ifTrue: [self cleanup]! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:33'!
cleanup
"PRIVATE: iterate over all sessions and removes old ones"
	| totalSeconds deadLine session |
	totalSeconds _ Time totalSeconds.
	lastCleanup _ totalSeconds.
	deadLine _ totalSeconds - secondsToLive.
	sessions keys
		do: [:key | 
			session _ sessions at: key.
			(session usedSince: deadLine)
				ifTrue: [sessions removeKey: key]]! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:22'!
currentSession: aRequest 
	"PRIVATE: answer the current session based on the 'SessionID' cookie"
	| sessionID |
	sessionID _ aRequest cookies
				at: #SessionID
				ifAbsent: [^ nil].
	^ sessions
		at: sessionID
		ifAbsent: []! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:33'!
newSession
	"PRIVATE: creates a new Session and stores it"
	| session |
	session _ HttpSession new.
	sessions at: session id put: session.
	^ session! !

!HttpSessionModule methodsFor: 'private' stamp: 'DGD 7/24/2001 21:29'!
processRequestForSession: aRequest 
	"PRIVATE: process aRequest and put a Session (new or old) in aRequest"
	| session newSessionID |
	mutex
		critical: [
			self checkForCleanup.
			session _ self currentSession: aRequest.
			newSessionID _ session isNil
						ifTrue: [
							session _ self newSession.
							session id].
			aRequest session: session.
			session timestamp: Time totalSeconds]
		ifError: [:msg :rcvr | rcvr error: msg].
	^ newSessionID! !


!HttpSessionModule class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 21:03'!
module: aModule 
	^ self new initializeModule: aModule! !

!HttpSessionModule class methodsFor: 'instance creation' stamp: 'DGD 7/24/2001 00:56'!
new
^ super new initialize! !


!NetworkRequest methodsFor: 'accessing' stamp: 'DGD 7/24/2001 01:24'!
session
	^ session! !

!NetworkRequest methodsFor: 'accessing' stamp: 'DGD 7/24/2001 01:24'!
session: aSession
session _ aSession! !


!HttpRequest methodsFor: 'accessing' stamp: 'DGD 7/22/2001 23:41'!
cookies
	"answer a dictionary with the cookies in the request"
	^ self
		propertyAt: #cookies
		ifAbsentPut: [self
				parseCookies: (self header
						at: 'cookie'
						ifAbsent: [''])]! !

!HttpRequest methodsFor: 'private' stamp: 'DGD 7/22/2001 23:41'!
parseCookies: aString 
	"PRIVATE: Parse a string in the format:  
	Cookie: NAME1=OPAQUE_STRING1; NAME2=OPAQUE_STRING2 ..."
	| dict |
	dict _ Dictionary new.
	(aString findTokens: ';')
		collect: [:pairStr | 
			| pair | 
			pair _ pairStr findTokens: '='.
			pair size = 2
				ifTrue: [| key value | 
					key _ pair first withBlanksTrimmed asSymbol.
					value _ pair second withBlanksTrimmed.
					dict at: key put: value]
				ifFalse: [self log: 'Cookie invalid pair format: ''' , pairStr , '''']].
	^ dict! !

HttpRequest removeSelector: #pvtParseCookies:!

!HttpRequest reorganize!
('accessing' contentLength contentType cookies endOfRequestHeaderMarker getFields header header: host localAddress localPort method method: postFields protocol rawUrl referer remoteAddress remoteAddress: stream timestamp timestamp: url url: user)
('connection mgt' isPersistentConnection)
('defaults' defaultContentType defaultMethod defaultProtocol defaultUrl)
('initialize-release' destroy initRemoteAddress initStatusString: initializeFromStream: readRequestHeaderFrom:)
('multipart forms' multipartBoundary multipartFormFieldsDo: nextChunkHeader)
('printing' printOn: writeOn:)
('response' badRequest redirectTo: unauthorizedFor:)
('testing' isGetRequest isHeaderRequest isPostRequest)
('private' parseCookies:)
!

HttpSessionModule removeSelector: #getCurrentSession:!
HttpSessionModule removeSelector: #module:!
HttpSessionModule removeSelector: #newSession:!
HttpSessionModule removeSelector: #newSessionID!
HttpSessionModule removeSelector: #processSession:!

!HttpSessionModule reorganize!
('accessing' secondsToLive:)
('comanche' process:)
('initialization' initialize initializeModule:)
('private' checkForCleanup cleanup currentSession: newSession processRequestForSession:)
!

HttpSession initialize!

!HttpSession class reorganize!
('class initialization' initialize)
('instance creation' new)
('session id' nextSessionID)
!


!HttpSession reorganize!
('accessing' attributes id timestamp:)
('asking' usedSince:)
('initialization' initialize)
('printing' printOn:)
!

HttpResponse removeSelector: #setCookieName:value:expires:path:domain:secure:!

!HttpResponse reorganize!
('accessing' contentType contentType: contents contents: fieldAt: fieldAt:ifAbsent: fieldAt:ifAbsentPut: fieldAt:put: fields httpVersion request request: status status: statusCode statusCodeAndReason)
('accessing-cookies' cookies setCookieName:value:expiresDate:expiresTime:path:domain:secure: setCookieName:value:path:)
('comanche processing' asHttpPartialResponseBlock: asHttpResponseTo:)
('defaults' defaultChunkSize defaultContentType)
('initialize-release' destroy)
('responding' pvtWriteContentLengthOn: pvtWriteContentTypeOn: pvtWriteContentsOn: pvtWriteCookiesOn: pvtWriteFieldsOn: pvtWriteServerOn: pvtWriteStatusOn: writeOn:)
!

