'From Squeak3.3alpha of 30 January 2002 [latest update: #4664] on 31 January 2002 at 4:48:32 pm'!
Object subclass: #HtmlBuilder
	instanceVariableNames: 'request view isPost elements variables blockVariables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HttpView-base'!
HtmlBuilder class
	instanceVariableNames: ''!
Object subclass: #HttpView
	instanceVariableNames: 'prefix parent title model '
	classVariableNames: 'HtmlEntities '
	poolDictionaries: ''
	category: 'HttpView-base'!

!HttpView commentStamp: '<historical>' prior: 0!
A VHHttpView is a user interface 'application model' for a web interface (forms etc).

A view has a domain object as a model, and thus the VHHttpView hierarchy more or less typically mirrors the domain class hierarchy.
Each method in the "urls" category represents a "page/address" in the system, takes the HttpRequest as a single argument and should return HTML.!

HttpView class
	instanceVariableNames: ''!

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:55'!
beginPostForm
	^elements add: '<form action="', request url, '" method="post">'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:57'!
blockVar: block

	^self blockVar: block value: ''
! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:47'!
blockVar: block value: default

	blockVariables at: block put: default.
	elements add: block.
	^[:val | blockVariables at: block put: val ]

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:37'!
br
	^elements add: '<br>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:34'!
contents
	"Concatenate everything together and substituting variables with values
	and blocks with their results in the progress."

	| param |
	^String streamContents: [:stream |
		elements do: [:element |
			element class == String
				ifTrue:[ stream nextPutAll: element ]
				ifFalse:[ element class == Symbol
							ifTrue:[ stream nextPutAll: (variables at: element ifAbsent: [''])]
							ifFalse:[
								param _ blockVariables at: element ifAbsent: [nil].
								param ifNotNil: [ stream nextPutAll: (element value: param) ]]]]]

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:43'!
end
	^elements add: '</body></html>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:10'!
endForm
	^elements add: '</form>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:54'!
h1: text
	^elements add: '<h1>', text, '</h1>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:37'!
hr
	^elements add: '<hr>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:47'!
html: aString
	^elements add: aString! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:55'!
inputPassword: var

	^self inputPassword: var value: ''

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:58'!
inputPassword: var value: default

	| value |
	isPost
		ifTrue:[ value _ request postFields at: var ifAbsent:[default]]
		ifFalse:[ value _ default].
	elements add: '<input type="password" name="', var, '" value="'.
	self var: var value: value.
	elements add: '">'.
	^value

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:55'!
inputText: var

	^self inputText: var value: ''

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:56'!
inputText: var value: default

	| value |
	isPost
		ifTrue:[ value _ request postFields at: var ifAbsent:[default]]
		ifFalse:[ value _ default].
	elements add: '<input type="text" name="', var, '" value="'.
	self var: var value: value.
	elements add: '">'.
	^value

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:56'!
link: url text: text
	"Embed a HTML link."

	^elements add: '<a href="', url, '">', text, '</a>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:56'!
linkBack: text
	"Return a local backlink."

	^self link: view prefix text: text! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:56'!
reset: text

	^elements add: '<input type="reset" value="', text, '">'
! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:17'!
setVar: var to: value

	^variables at: var put: value

! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:57'!
srcLink
	| url slash |
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
	^self html: '<font size=-1>'; link: url text: 'See source for this page'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 14:52'!
start
	^elements add: '<html><head><title>', view title, '</title></head><body>'! !

!HtmlBuilder methodsFor: 'html' stamp: 'gh 1/31/2002 15:56'!
submit: text

	^elements add: '<input type="submit" value="', text, '">'
! !

!HtmlBuilder methodsFor: 'initialize-release' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView

	view _ aView.
	request _ aRequest.
	isPost _ request isPostRequest.
	elements _ OrderedCollection new.
	variables _ Dictionary new.
	blockVariables _ Dictionary new! !


!HtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:33'!
builderFor: aRequest
	^self new initializeWith: aRequest; yourself! !

!HtmlBuilder class methodsFor: 'instance creation' stamp: 'gh 1/31/2002 14:41'!
request: aRequest view: aView
	^self new request: aRequest view: aView; yourself! !


!HttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 14:22'!
message: message
	"Return a single page with a message and a back link to base page of this view."

	^self starthtml, '<h1>', message, '</h1>', (self linkback: 'Back'), self endhtml
! !

!HttpView methodsFor: 'simple messages' stamp: 'gh 1/29/2002 16:12'!
message: message backlink: link
	"Return a single page with a message and a hard link back."

	^self starthtml, '<h1>', message, '</h1>', (self linklocal: link text: 'Back'), self endhtml
! !

!HttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:54'!
message: message link: link
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self link: link text: 'Back'), self endhtml
! !

!HttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:55'!
message: message linklocal: link
	"Return a single page with a message and a back link relative to this view."

	^self starthtml, '<h1>', message, '</h1>', (self linklocal: '/', link text: 'Back'), self endhtml
! !

!HttpView methodsFor: 'simple messages' stamp: 'gh 1/30/2002 13:40'!
message: message request: request
	"Return a single page with a message and a link
	back to the same page that was requested."

	^self message: message backlink: request url! !

!HttpView methodsFor: 'simple messages' stamp: 'gh 1/14/2002 16:53'!
serverError: aString
	"Return an error to the user."

	^'Error returned by server: ', aString! !

!HttpView methodsFor: 'urls' stamp: 'gh 1/30/2002 13:39'!
default: request
	"This is the default method called on a HttpView if no other
	method is named in the url. It is the base page for the view.
	It should always be implemented."

	self subclassResponsibility ! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:38'!
dispatchOn: method request: request
	"Dispatch to correct method. If method is prefixed with 'src'
	we return a HTML page with the source for that method."

	| m |
	m _ (method, ':') asSymbol.
	(self respondsTo: m)
		ifTrue:[^self perform: m with: request]
		ifFalse:["Is it a request for the source?"
			(m beginsWith: 'src')
				ifTrue:[
					m _ (m asString last: (m size - 3)) asSymbol.
					^self showSourceFor: m]
				ifFalse:[^self class name, ' does not have a method called #', m]]! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/28/2002 14:59'!
extractMethodFromUrl: url prefix: aPrefix
	"Extracts the method from the url.
	The methodname is after the prefix upto the first $? $/ or end of url like this:
	'/prefix/method/knirk?habbadubba' => 'method'
	'/prefix/method?habbadubba' => 'method'
	'/prefix/method' => 'method'
	'/prefix/' => ''
	'/prefix' => ''"

	| method endq ends |
	(url = aPrefix) ifTrue:[ ^'' ].
	method _ url copyFrom: aPrefix size + 1 to: url size. "cut away prefix"
	(method = '/') ifTrue:[ ^'' ].
	method _ method allButFirst.
	endq _ method indexOf: $?.
	ends _ method indexOf: $/.
	(endq = 0) ifTrue:[ endq _ method size + 1].
	(ends = 0) ifTrue:[ ends _ method size + 1].
	^method copyFrom: 1 to: (ends min: endq) - 1! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:38'!
getAccount: request
	"Get the account for the request."

	^request session attributes at: #account ifAbsent: [nil]! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/28/2002 15:29'!
isLoggedIn: request
	"Check if the user is logged in."

	^request session attributes includesKey: #account! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 14:13'!
logout: request
	"Clear out the account attribute in the session.
	Return true if all succeded."

	request session attributes removeKey: #account ifAbsent: [^false].
	^true! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:38'!
openOn: request

	^self default: request.
! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:36'!
prefix
	"Return the full prefix which is composed by concatenating up the parent chain."

	^String streamContents: [:stream | stream nextPutAll: parent prefix; nextPutAll: prefix ]! !

!HttpView methodsFor: 'comanche' stamp: 'gh 1/30/2002 13:35'!
process: request
	"Process the request. This is the method that is called by Comanche.
	First we make sure that the request is for us -
	the url begins with prefix, otherwise we return nil and let someone else
	deal with it. Then we dispatch the request to a method of it's
	own based on the url, see #extractMethodFromUrl:prefix: for details.
	If there is no method we call #default: as default."

	| url method |
	url _ request url.
	(url beginsWith: prefix) ifFalse:[^nil].
	method _ self extractMethodFromUrl: url prefix: prefix.
	(method isEmpty)
		ifTrue: [ ^self default: request ]
		ifFalse:[ ^self dispatchOn: method request: request ]
! !

!HttpView methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:01'!
initializeWith: aParent
	self initialize.
	title _ 'No title set!!'.
	parent _ aParent! !

!HttpView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:15'!
model: aModel
	model _ aModel! !

!HttpView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/31/2002 14:40'!
builderFor: aRequest
	"Create a standard builder."

	^HtmlBuilder request: aRequest view: self! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:21'!
createSelectWidget: values name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: 1 name: name! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:20'!
createSelectWidget: values selected: selected name: name 
	"Create a select widget for forms."

	^self createSelectWidget: values selected: selected name: name withIds: true
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/18/2002 12:26'!
createSelectWidget: objects selected: selected name: name withIds: withIds
	"Create a select widget for forms."

	| obj id |
	^String streamContents: [:stream |
		stream nextPutAll: '<select name="', name, '" size="1">'.
		1 to: objects size do: [:n |
			obj _ objects at: n.
			withIds ifTrue:[ id _ obj id] ifFalse:[ id _ n].
			(id = selected)
				ifTrue: [ stream nextPutAll: '<option selected']
				ifFalse: [ stream nextPutAll: '<option' ].
			withIds
				ifTrue: [stream nextPutAll: ' value="', id fullPrintString, '">']
				ifFalse: [stream nextPut: $> ].
			stream nextPutAll: obj name; nextPutAll: '</option>'.
		].
		stream nextPutAll: '</select>']
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/15/2002 14:46'!
createTable: objects heads: heads block: aBlock
	"Create a table."

	^String streamContents: [:stream |
		stream nextPutAll: '<table border="1"><head>'.
		heads do: [:head | stream nextPutAll: '<th>'; nextPutAll: head; nextPutAll: '</th>'].
		stream nextPutAll: '</head>'.
		objects do: [:obj |
			stream nextPutAll: '<tr>'.
			(aBlock value: obj) do: [:val | stream nextPutAll: '<td>'; nextPutAll: val asString; nextPutAll: '</td>' ].
			stream 	nextPutAll: '</tr>'.
		].
		stream nextPutAll: '</table>' ]
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:58'!
endhtml
	"Standard end."

^'</body></html>'! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/30/2002 15:57'!
endhtml: request
	"Standard end. Attach a link to the source of the page."

	| url slash |
	slash _ request url findLast: [:c | c = $/ ].
	url _ (request url copyFrom: 1 to: slash), 'src', (request url copyFrom: slash + 1 to: request url size).
^'<hr><br><font size=-1>', (self link: url text: 'See source for this page'), '</font></body></html>'! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:32'!
fixForHtml: string
	"Replace a lot of characters with HTML friendly stuff."

	| temp |
	temp _ string copyReplaceAll: '&' with: '&amp;'.
	HtmlEntities keysAndValuesDo:
		[:entity :char |
		char = $& ifFalse:
			[temp _ temp copyReplaceAll: char asString with: '&' , entity , ';']].
	^'<pre>', temp, '</pre>'! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/28/2002 15:40'!
link: url text: text
	"Return a HTML link."

	^String streamContents: [:stream |
		stream
			nextPutAll: '<a href="';
			nextPutAll: url;
			nextPutAll: '">'; nextPutAll: text; nextPutAll: '</a>' ]
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:29'!
linkback: text
	"Return a local backlink."

	^self link: self prefix text: text
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:30'!
linkbackparent: text
	"Return a parent backlink."

	^self link: parent prefix text: text
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:24'!
linklocal: relativeUrl text: text
	"Return a local HTML link to the view."

	^self link: self prefix, relativeUrl text: text
! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 16:13'!
showSourceFor: selector
	"Show the source for given selector."

^self starthtml, '
<h2>Source for ', self class name, '>>', selector, '</h2>
<pre>
', (self fixForHtml: (self class sourceMethodAt: selector) asString), '
</pre>', self endhtml! !

!HttpView methodsFor: 'html creation' stamp: 'gh 1/29/2002 15:23'!
starthtml
	"Standard start."

^'<html><head><title>', self title, '</title></head><body>'! !


!HttpView class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 14:16'!
on: aModel
	^self new model: aModel; yourself! !

!HttpView class methodsFor: 'instance creation' stamp: 'gh 1/15/2002 16:45'!
on: aModel parent: aParent
	^(self on: aModel) initializeWith: aParent; yourself! !

!HttpView class methodsFor: 'class initialization' stamp: 'gh 1/28/2002 16:46'!
initialize
	"VHHttpView initialize"

HtmlEntities _ (Dictionary new: 128)
		at: 'amp'	put: $&;
		at: 'lt'		put: $<;
		at: 'gt'		put: $>;
		at: 'quot'	put: $";
		at: 'euro'	put: Character euro;
		yourself.
	"#('nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo: [:each :index | HtmlEntities at: each put: (index + 159) asCharacter isoToSqueak]"! !

HttpView initialize!
