'From Squeak3.3alpha of 30 January 2002 [latest update: #4664] on 31 January 2002 at 4:48:35 pm'!
Object subclass: #SDAccount
	instanceVariableNames: 'created parent username info password passphrase phraseword lastCheckPoint polls idCounter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
SDAccount class
	instanceVariableNames: ''!
Object subclass: #SDAccountInfo
	instanceVariableNames: 'fields '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
SDAccountInfo class
	instanceVariableNames: ''!
HttpView subclass: #SDHttpAccountView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
Object subclass: #SDObject
	instanceVariableNames: 'id created parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
SDObject class
	instanceVariableNames: ''!
SDObject subclass: #SDPoll
	instanceVariableNames: 'question choices votes daysValid anonymousAllowed valid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
Object subclass: #SDServer
	instanceVariableNames: 'module localUsernames accounts dir '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!
SDServer class
	instanceVariableNames: ''!
HttpView subclass: #SDTopView
	instanceVariableNames: 'server '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SD-server'!

!SDTopView commentStamp: '<historical>' prior: 0!
This is the Comanche module for managing (creating, logging in, moving, etc) accounts
using http. Use these three doits to start and stop.

"Start one up with cookie session support"
| service smodule server |
service := ComancheNetService named: 'SqueakDot' onPort: 8080.
server _ SDServer new.
service module: (smodule _ HttpSessionModule module: (SDTopView forServer: server)).
server module: smodule. "this is a hack to that the SDServer can get access to the sessions"
service start

"And to stop it"
(ComancheNetService serviceNamed: 'SqueakDot') unregister

"Check which are alive"
ComancheNetService services!

SDTopView class
	instanceVariableNames: ''!

!SDAccount methodsFor: 'private' stamp: 'gh 1/30/2002 14:08'!
deleteTreeForDir: dir
	dir directoryNames do: [:dName |
		self deleteTreeForDir: (dir directoryNamed: dName).
		dir deleteDirectory: dName].
	dir fileNames do: [:fName |
		dir deleteFileNamed: fName]! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/30/2002 11:18'!
dir
	"Get the directory for the account."

	^parent accountsDir directoryNamed: username! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/28/2002 14:24'!
fileName
	"Get the base filename for the account."

	^self class fileName! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/28/2002 14:24'!
fileNameExtension
	"Get the extension for the account."

	^self class fileNameExtension! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/30/2002 15:32'!
nextId
	^idCounter _ idCounter + 1! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/28/2002 14:24'!
parent: aServer
	"Set the parent. Is called when account is loaded from disk."

	parent _ aServer! !

!SDAccount methodsFor: 'private' stamp: 'gh 1/30/2002 14:01'!
remove
	"Remove the directory on disk and
	disconnect from the SDServer."

	self removeDirectory.
	^parent removeAccount: self.
! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/31/2002 10:14'!
initialize
	"Initialize Account."

	idCounter _ 0.
	created _ TimeStamp current asSeconds.
	info _ SDAccountInfo new.
	polls _ OrderedCollection new.! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 11:20'!
initializeDirectory
	"Create directory for Account."

	| accountsDir |
	accountsDir _ parent accountsDir.
	(accountsDir directoryExists: username) 
		ifFalse:[ accountsDir createDirectory: username ]
! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 15:25'!
initializeWithParent: aParent
	"Set the parent."

	parent _ aParent.
	self initialize! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 14:24'!
password: aPassword
	"Change password."

	password _ aPassword
! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 14:11'!
removeDirectory
	"Remove the directory for Account."

	| accountsDir |
	accountsDir _ parent accountsDir.
	(accountsDir directoryExists: username) 
		ifTrue: [ self deleteTreeForDir: (accountsDir directoryNamed: username).
				accountsDir deleteDirectory: username ]
! !

!SDAccount methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 14:24'!
username: aUsername password: aPassword
	"Initialize VHAccount."

	username _ aUsername.
	self password: aPassword.
	passphrase _ 'No passphrase set. Sorry.'.
	phraseword _ ''.
! !

!SDAccount methodsFor: 'polls' stamp: 'gh 1/30/2002 15:22'!
addPoll: aPoll
	"Add a poll in this account."

	polls add: aPoll.
	aPoll parent: self.
	^aPoll! !

!SDAccount methodsFor: 'polls' stamp: 'gh 1/30/2002 15:20'!
newPoll
	"Create a new poll in this account."

	| poll |
	poll _ SDPoll newWithParent: self.
	^self addPoll: poll! !

!SDAccount methodsFor: 'polls' stamp: 'gh 1/30/2002 15:41'!
removePollWithId: anId
	"Remove a poll in this account."

	| toRemove |
	toRemove _ polls detect: [:poll | poll id = anId ].
	^polls remove: toRemove! !

!SDAccount methodsFor: 'testing' stamp: 'gh 1/28/2002 14:24'!
getSession
	"Get session for account."

	^parent getSessionFor: self! !

!SDAccount methodsFor: 'testing' stamp: 'gh 1/28/2002 14:24'!
isLoggedIn
	"Is the user logged in?"

	^self getSession notNil! !

!SDAccount methodsFor: 'testing' stamp: 'gh 1/28/2002 14:24'!
lastAccessed
	"Return a timestamp for last access through web.
	The session stores last access as a #totalSeconds.
	If there is no session the answer will be nil."

	| session |
	session _ self getSession.
	session ifNil: [^nil] ifNotNil: [^TimeStamp fromSeconds: session timestamp]! !

!SDAccount methodsFor: 'testing' stamp: 'gh 1/28/2002 14:24'!
verifyPassword: aPassword
	"Verify that the password is correct."

	^password = aPassword! !

!SDAccount methodsFor: 'testing' stamp: 'gh 1/28/2002 14:24'!
verifyPhraseword: aPassword
	"Verify that the password is
	the correct phraseword."

	^phraseword = aPassword! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:17'!
created
	^TimeStamp fromSeconds: created! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:21'!
created: c
	created _ c! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:20'!
createdAsSeconds
	^created! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/31/2002 10:15'!
idCounter
	^idCounter! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
info
	^info! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
lastCheckPoint
	^lastCheckPoint! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
passphrase
	^passphrase! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
passphrase: aPhrase
	passphrase _ aPhrase! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
password
	^password! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
phraseword
	^phraseword! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
phraseword: aWord
	phraseword _ aWord! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/30/2002 16:17'!
pollWithId: anId
	"Get a poll in this account."

	^polls detect: [:poll | poll id = anId ] ifNone: [nil]! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:14'!
polls
	^polls ifNil: [#()]! !

!SDAccount methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:24'!
username
	^username! !

!SDAccount methodsFor: 'views' stamp: 'gh 1/28/2002 14:24'!
viewFor: uiObject
	"This is a double dispatch mechanism for multiple views
	for multiple uis."

	^uiObject accountViewOn: self! !

!SDAccount methodsFor: 'segments' stamp: 'gh 1/28/2002 14:24'!
checkpoint
	"Export me using an ImageSegment. Return nil on fail.
	This is used for checkpointing the account on disk
	in a form that can be brought into an independent image.
	We do not overwrite older versions - when the image does a
	snapshot it can purge old checkpoints."

	| is fname myParent dir stream |
	myParent _ parent.
	lastCheckPoint _ TimeStamp current.
	dir _ self dir.
	fname _ dir nextNameFor: self fileName extension: self fileNameExtension.
	stream _ dir newFileNamed: fname.
	[ parent _ nil.
	is _ ImageSegment new.
	is copyFromRoots: (Array with: self) sizeHint: 1000000 areUnique: true.
	"self verifyOutPointers: is outPointers."
	is writeForExportOn: stream ]
		ifError: [parent _ myParent. ^nil].
	parent _ myParent.
	^is! !

!SDAccount methodsFor: 'segments' stamp: 'gh 1/28/2002 14:24'!
revert
	"Replace me with my last checkpoint."

	^parent revertAccount: self! !


!SDAccount class methodsFor: 'as yet unclassified' stamp: 'gh 1/28/2002 14:24'!
fileName
	"The basename for the account file."

	^'account'! !

!SDAccount class methodsFor: 'as yet unclassified' stamp: 'gh 1/28/2002 14:24'!
fileNameExtension
	"The extension for the account file."

	^'extSeg'! !

!SDAccount class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 14:24'!
loadFrom: aDirectory
	"Load the account from given directory."

	| stream account |
	stream _ aDirectory oldFileNamed: (aDirectory lastNameFor: self fileName extension: self fileNameExtension).
	account _ (stream fileInObjectAndCode) install arrayOfRoots first.
	stream close.
	^account! !

!SDAccount class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 15:25'!
newWithParent: aParent
	^super new initializeWithParent: aParent! !


!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
email
	^fields at: #email ifAbsent: ['']! !

!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
email: email
	^fields at: #email put: email! !

!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
firstName
	^fields at: #firstName ifAbsent: ['']! !

!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
firstName: string
	^fields at: #firstName put: string! !

!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
lastName
	^fields at: #lastName ifAbsent: ['']! !

!SDAccountInfo methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:12'!
lastName: string
	^fields at: #lastName put: string! !

!SDAccountInfo methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 15:12'!
initialize
	fields _ Dictionary new! !


!SDAccountInfo class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 15:12'!
new
	^super new initialize! !


!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 15:22'!
addpoll: request
	"Add a new poll in this account."

	| msg question daysValid poll |
	daysValid _ 14.
	question _ ''.
	(request isPostRequest) ifTrue:[
		question _ request postFields at: 'question'.
		daysValid _ (request postFields at: 'daysvalid') asNumber.
		poll _ model newPoll.
		poll question: question; daysValid: daysValid.
		msg _ 'Poll created successfully'.
	].
^self starthtml, '
<h1>New poll</h1>
<form action="', request url, '" method="post">
Question: <input type="text" name="question" value="', question, '"><br>
Days valid: <input type="text" name="daysvalid" value="', daysValid printString, '"><br>
<input type="submit" value="Create">
<input type="reset" value="Reset">
</form>
', (msg ifNotNil: ['<h2 color="red">', msg, '</h2>'] ifNil:['']) , (self linkback: 'Back'), (self endhtml: request)! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 11:36'!
analysis: request
	"For debugging purposes. This takes some time to execute."

	| is report extractTime writeTime nrOfStubs installTime |
	extractTime _ Time millisecondsToRun: [
		is _ ImageSegment new.
		is copyFromRoots: (Array with: model) sizeHint: 1000000 areUnique: true.
		is segmentName: model username ].
	report _ String streamContents: [:stream | is printSpaceAnalysisOn: stream ].
	writeTime _ Time millisecondsToRun: [ is extract; writeToFile ].
	nrOfStubs _ (ImageSegmentRootStub allInstances collect: [:stub | stub xxxSegment = is ]) size.
	installTime _ Time millisecondsToRun: [ is install ].
^self starthtml, '
<h1>Account analysis</h1>
<pre>', report, '</pre><br>
Extract time:<b>', extractTime printString, ' ms</b> (250-4000 ms depending on size. 3500 ms is about 4Mb/200000 instances) <br>
Write to file time:<b>', writeTime printString, ' ms</b>  (includes one full GC at about 500 ms that can be removed) <br>
Install time:<b>', installTime printString, ' ms</b>  (should be 150-500 ms, includes loading of file)<br>
Stubs after extract:<b>', nrOfStubs printString, '</b>  (should be 1)<br>
', (self linkback: 'Back'), (self endhtml: request)! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 10:38'!
checkpoint: request
	"For debugging purposes. This takes some time to execute."

	model checkpoint.
	^request redirectTo: self prefix
! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 15:45'!
default: request
	"Standard entrypoint. Show account info and more."

| pollTable |
pollTable _ self createTable: model polls heads: #(Remove Question Created Daysvalid Daysleft) block: [:poll |
	{(self linklocal: '/removepoll?id=', poll id fullPrintString text: 'R'). poll question. poll created. poll daysValid. poll daysLeft}].
^self starthtml, '
<h1>', model username, '</h1>
Last checkpoint: ', ((model lastCheckPoint) ifNil: ['No checkpoint yet'] ifNotNil:[model lastCheckPoint]) asString, '<br>
<p>This is your personal account page, this page and the functions here can only be reached when logged in.</p>
', (self linklocal: '/settings' text: 'Settings'), ' - Your personal settings of the account.<br>
', (self linklocal: '/analysis' text: 'Account analysis'), ' - Run an analysis of the account. Takes a few seconds.<br>
', (self linklocal: '/checkpoint' text: 'Do a checkpoint'), ' - Checkpoint the account. Currently this stores the account as an export ImageSegment.<br>
', (self linklocal: '/revert' text: 'Revert to last checkpoint'), ' - Revert the account to the last checkpoint.<br>
', (self linklocal: '/addpoll' text: 'Add a poll'), ' - Add a new poll.<br>
', (self linklocal: '/seppuku' text: 'Seppuku'), ' - Commit seppuku. Yep, account will be deleted.<br><br>
', (self linklocal: '/logout' text: 'Logout'), ' - Logout from SqueakDot.<br><br>
<h2>My Polls</h2>', pollTable, '<br><br>
', (self linkbackparent: 'SqueakDot top page'), '<br><br><font size=-1>', (self linklocal: '/srcdefault' text: 'See source for this page'), '</font>', self endhtml! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 10:38'!
logout: request
	"Handle logout."

	^parent logout: request! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 15:39'!
removepoll: request
	"Remove a poll in this account."

	| id |
	id _ (request getFields at: 'id') asNumber.
	model removePollWithId: id.
	^request redirectTo: self prefix! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 10:38'!
revert: request
	"For debugging purposes. This takes some time to execute.
	Important to update the session association since the account
	object now is 'another guy'."

	| newAccount |
	newAccount _ model revert.
	request session attributes at: #account put: newAccount.
	^request redirectTo: self prefix
! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/30/2002 14:25'!
seppuku: request
	"Delete this account. First confirm it. Finish by performing logout."

	(request isPostRequest) ifTrue:[
		"Ok, then, have it your way..."
		[super logout: request.
		model remove.
		^self message: 'Seppuku succeded' link: parent prefix ]
			ifError: [^self message: 'Seppuku failed'].
	].
^self starthtml, '
<h1>Commit seppuku!!</h1>
<form action="', request url, '" method="post">
Are you really sure?<br>
<input type="submit" name="submit" value="Yep, waste me">
</form>
', (self linkback: 'No for god''s sake, get me out of here!!'), (self endhtml: request)
! !

!SDHttpAccountView methodsFor: 'comanche' stamp: 'gh 1/28/2002 13:20'!
settings: request
	"This is where we change settings in the account."

	| info |
	(request isPostRequest) ifTrue:[
		model
			password: (request postFields at: 'password');
			passphrase: (request postFields at: 'passphrase');
			phraseword: (request postFields at: 'phraseword').
		model info
			firstName: (request postFields at: 'firstname');
			lastName: (request postFields at: 'lastname');
			email: (request postFields at: 'email').
		^request redirectTo: self prefix
	].
	info _ model info.
^self starthtml, '
<h1>Account settings</h1>
<form action="', request url, '" method="post">
Username: ', model username, '<br>
Password: <input type="text" name="password" value="', model password, '"><br>
Passphrase: <input type="text" name="passphrase" value="', model passphrase, '"><br>
Phraseword (answer to the passphrase): <input type="text" name="phraseword" value="', model phraseword, '"><br>
Firstname: <input type="text" name="firstname" value="', info firstName, '"><br>
Lastname: <input type="text" name="lastname" value="', info lastName, '"><br>
Email: <input type="text" name="email" value="', info email, '"><br>
<input type="submit" name="submit" value="Save">
<input type="reset" value="Restore">
</form>
', (self linkback: 'Back'), (self endhtml: request)
! !

!SDHttpAccountView methodsFor: 'views' stamp: 'gh 1/30/2002 10:38'!
todoListViewOn: aResource
	"Wrap the resource in a view."

	^VHHttpTodoListView on: aResource parent: self! !

!SDHttpAccountView methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 11:31'!
initialize

	title _ 'My SqueakDot'.
	prefix _ '/account'! !


!SDObject methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 15:15'!
initialize
	"Initialize."

	created _ TimeStamp current asSeconds! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
account
	"Return the account for this object"

	self subclassResponsibility ! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
created
	^TimeStamp fromSeconds: created! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
created: c
	created _ c! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
createdAsSeconds
	^created! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
id
	^id! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:30'!
initializeWithParent: aParent
	"An SDObject should always have a parent."

	parent _ aParent.
	id _ self createIdFromParent.
	self initialize
	
! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:14'!
parent
	^parent! !

!SDObject methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:36'!
parent: aParent
	parent _ aParent! !


!SDObject class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 15:14'!
newWithParent: aParent
	^super new initializeWithParent: aParent! !


!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:05'!
addChoice: aString
	^choices add: aString! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:05'!
choices
	^choices! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:48'!
daysLeft
	| days |
	days _  (self created date addDays: daysValid) subtractDate: Date today.
	days <= 0 ifTrue:[^0] ifFalse: [^days]! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:23'!
daysValid
	^daysValid! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:23'!
daysValid: anInteger
	daysValid _ anInteger! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/30/2002 15:54'!
isValid
	valid ifNil: [(self daysLeft = 0) ifTrue:[^valid _ false] ifFalse: [^true]]! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:05'!
question
	^question! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:05'!
question: aString
	question _ aString! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:06'!
vote: aChoice
	"Anonymous vote."

	votes add: aChoice! !

!SDPoll methodsFor: 'accessing' stamp: 'gh 1/28/2002 16:06'!
votes
	^votes! !

!SDPoll methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 15:31'!
createIdFromParent
	"An SDPoll has an SDAccount as a parent.
	We ask him for the next available id."

	^parent nextId! !

!SDPoll methodsFor: 'initialize-release' stamp: 'gh 1/30/2002 15:18'!
initialize
	"Initialize poll."

	super initialize.
	question _ 'Question not set'.
	choices _ OrderedCollection new.
	choices add: 'Yes'; add: 'No'.
	votes _ Bag new! !


!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 14:22'!
accountForUsername: username
	"Find local account given username."

	^localUsernames at: username ifAbsent: [nil]! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 14:29'!
addAccount: account
	"Add an account in this server. Keeps the dictionaries in sync.
	If an account with the same username is already present we raise an exception."

	(localUsernames at: account username ifAbsent: [nil]) ifNotNil: [Exception signal: 'Account already present in server.'].
	accounts add: account.
	account parent: self.
	localUsernames at: account username put: account.
	^account! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 14:31'!
loadAccount: dirName
	"Load the account with username 'dirName'."

	| accountDir |
	accountDir _ self accountsDir directoryNamed: dirName.
	Transcript show: 'Loading account: ', dirName ;cr.
	^self addAccount: (SDAccount loadFrom: accountDir)
! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/29/2002 17:45'!
newAccount: aUsername password: aPassword
	"Create a new account in this server.
	The username has already been verified to be unique.
	The password has been verified to be ok.
	Let the account initialize itself with me as parent
	and add it to my collection of accounts."

	| account |
	account _ SDAccount newWithParent: self.
	account username: aUsername password: aPassword.
	account initializeDirectory.
	^self addAccount: account! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/30/2002 14:37'!
numberLoggedIn
	"Return number of accounts logged in."

	| n |
	n _ 0.
	module sessionsDo: [:s | (s attributes includesKey: #account) ifTrue:[n _ n+1]].
	^n! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 14:30'!
removeAccount: account
	"Remove an account in this server. Keeps the dictionaries in sync.
	If the account is missing we raise an exception."

	| toRemove |
	toRemove _ localUsernames at: account username ifAbsent: [Exception signal: 'Account not present in server.'].
	accounts remove: toRemove.
	account parent: nil. "deconnect it to make sure"
	localUsernames removeKey: toRemove username.
	^toRemove
! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/30/2002 11:27'!
replaceAccount: newAccount
	"Replace an existing account with a new version."

	| oldAccount |
	oldAccount _ localUsernames at: newAccount username ifAbsent: [VHException signal: 'Account not present in server.'].
	self removeAccount: oldAccount.
	^self addAccount: newAccount! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/30/2002 11:25'!
revertAccount: account
	"Load the last checkpoint for given account and replace it."

	| accountDir dirName |
	dirName _ account username.
	accountDir _ self accountsDir directoryNamed: dirName.
	Transcript show: 'Loading account: ', dirName ;cr.
	^self replaceAccount: (VHAccount loadFrom: accountDir)
! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 14:39'!
usernameOccupied: username
	"Check if a username is occupied."

	^localUsernames includesKey: username
	! !

!SDServer methodsFor: 'accounts' stamp: 'gh 1/28/2002 15:09'!
verifyPassword: aPassword
	"Verify requirements for password.
	Currently we just check that it is not empty."

	^aPassword size > 0! !

!SDServer methodsFor: 'accessing' stamp: 'gh 1/28/2002 15:06'!
accounts
	^accounts! !

!SDServer methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:26'!
accountsDir
	^dir directoryNamed: 'accounts'! !

!SDServer methodsFor: 'comanche' stamp: 'gh 1/30/2002 18:45'!
getSessionFor: account
	"Get session for account.
	Since an account does not know it's session
	we need to iterate and find it."

	module sessionsDo: [:session |
		((session attributes at: #account ifAbsent:[nil]) = account) ifTrue:[^session]].
	^nil! !

!SDServer methodsFor: 'comanche' stamp: 'gh 1/28/2002 13:44'!
module: aModule
	module _ aModule! !

!SDServer methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 14:27'!
initialize
	dir _ FileDirectory default.
	(dir directoryExists: 'sd') ifFalse:[dir createDirectory: 'sd'].
	dir _ dir directoryNamed: 'sd'.
	self initializeAccounts! !

!SDServer methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 14:28'!
initializeAccounts
	"Initialize and load any existing accounts."

	| accountsDir |
	accounts _ OrderedCollection new.
	localUsernames _ Dictionary new.
	(dir directoryExists: 'accounts')
		ifFalse:[dir createDirectory: 'accounts']
		ifTrue:[
			accountsDir _ self accountsDir.
			accountsDir directoryNames do: [:name | self loadAccount: name ]]! !


!SDServer class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 14:44'!
new
	"Create a new server."

	^super new initialize! !


!SDTopView methodsFor: 'initialize-release' stamp: 'gh 1/28/2002 15:07'!
initializeWith: aServer
	"super initialize."
	title _ 'SqueakDot'.
	prefix _ '/squeakdot'.
	server _ aServer! !

!SDTopView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:17'!
prefix
	"Return the full prefix.
	I am a topview so I only return prefix."

	^prefix! !

!SDTopView methodsFor: 'private' stamp: 'gh 1/30/2002 10:43'!
accountViewOn: anAccount
	"Wrap the account in a view."

	^SDHttpAccountView on: anAccount parent: self! !

!SDTopView methodsFor: 'private' stamp: 'gh 1/30/2002 17:22'!
renderPolls: request
	"Render current polls on HTML."

	| polls first votes |
	first _ true.
	^String streamContents: [:stream |
		server accounts do: [:account |
			polls _ account polls select: [:poll | poll isValid ].
			polls notEmpty ifTrue: [
				first ifTrue: [first _ false] ifFalse: [stream nextPutAll: '<hr>'].
				stream nextPutAll: '<b>', account username, ' asks:</b> <ul>'.
				account polls do: [:poll |
					(poll isValid) ifTrue:[
						stream
							nextPutAll: '<li><b>', poll question, '</b>&nbsp;&nbsp;'.
						poll choices do: [:choice |
							stream nextPutAll: (self linklocal: '/vote?account=', account username, '&id=', poll id asString,
												'&choice=', choice text: choice); nextPutAll: ' '].
						stream 
							nextPutAll: '<br>', poll votes size asString, ' votes distributed as: '.
						poll choices do: [:choice |
								votes _ poll votes occurrencesOf: choice.
								stream
									nextPutAll: choice;
									nextPutAll: ' = ', votes printString, '&nbsp;&nbsp;'].
						stream nextPutAll: '<br> (created on: ', poll created asString, ', ', poll daysLeft asString, ' days left.'.
						stream nextPutAll: '</li>']].
				stream nextPutAll: '</ul>']]]! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/30/2002 10:46'!
account: request
	"This is the users account page.
	We verify that we are logged in and delegate the rest
	onto the correct view for an account based on the rest of the urlpath."

	| account method view |
	(account _ self getAccount: request) ifNil: [^self notloggedin: request ].
	method _ self extractMethodFromUrl: request url prefix: prefix, '/account'.
	view _ account viewFor: self.
	(method isEmpty)
		ifTrue: [^view default: request]
		ifFalse: [^view dispatchOn: method request: request]! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/29/2002 17:40'!
accounts: request
	"Lists all accounts."

	| table |
	table _ self createTable: server accounts heads: #(Username 'Logged in' 'Last access (if logged in)') block: [:a |
				{a username. (a isLoggedIn ifTrue: ['YES'] ifFalse:['NO']). (a lastAccessed) printString}].
^self starthtml,
'<h1>All accounts</h1>', table, (self linkback: 'Back'), (self endhtml: request)
! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/29/2002 15:27'!
addpoll: request
	"Handle a new poll."

	| account msg question poll |
	(self isLoggedIn: request) ifFalse:[^self notloggedin: request].
	account _ request session attributes at: #account.
	(request isPostRequest) ifTrue:[
		question _ request postFields at: 'question'.	
		poll _ account newPoll.
		poll question: question.
		poll
			ifNotNil: [msg _ 'Poll created successfully']
			ifNil: [msg _ 'Something went wrong when creating poll'].
	].
	question ifNil: [question _ ''].
^self starthtml, '
<h1>New poll</h1>
<form action="', request url, '" method="post">
Poll question (Simple HTML is fine): <input type="textare" width="30" height="10" name="question" value="', question, '"><br>
<input type="submit" value="Create">
<input type="reset" value="Reset">
</form>
', (self linkback: 'Back'),'
', (msg ifNotNil: ['<h2>', msg, '</h2>'] ifNil:['']) , '
</body>
</html>'! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 10:46'!
default: request
	"Default request for the top view. Show the first page."

	| currentPolls loggedIn |
	currentPolls _ self renderPolls: request.
	loggedIn _ (self isLoggedIn: request)
		ifTrue:['<b><font color="red">Logged in as ', (self getAccount: request) username, '.</font></b>']
		ifFalse:['<b><font color="red">You are not logged in.</font></b>'].
^self starthtml, 
'<h1>Welcome to SqueakDot!!</h1>
', loggedIn, '
<p>SqueakDot is an experiment in ', (self linklocal: '/development' text: 'online concurrent community development'), '.
In short, this is dangerous stuff!! :-)</p>
<p><b>IMPORTANT: This server is for test/play. Persistence has been implemented for accounts as ImageSegments, if you feel nervous - do a checkpoint on your account!! :-) We will automate that soon.</b></p>
<p><font color="red">Currently there are ', server accounts size printString, ' registered accounts and ', server numberLoggedIn printString, ' logged in now.</font></p>
<p>Today you can play with it and:
<ol>
<li>', (self linklocal: '/newaccount' text: 'Get an account'), ' - Sign up with a username and password. Dead easy.</li>
<li>', (self linklocal: '/login' text: 'Login'), ' - Login using a username and password. Gives access to functions below.</li>
<li>', (self linklocal: '/accounts' text: 'List current users'), ' - Lists usernames and info about all users.</li>
<li>View the source for any page by appending "src" before the method name. Source for
', (self linklocal: '/srcdefault' text: 'this page'), '. There are also links for the source at the bottom of most pages.</li>
</ol>
And when you are logged in you can:
<ol>
<li>', (self linklocal: '/account' text: 'My SqueakDot'), ' - Go to your personal account view. More functions there.
<li>', (self linklocal: '/account/logout' text: 'Logout'), ' - Logout from SqueakDot. Will be done automatically after timeout.</li>
</ol></p>
<h2>Current polls</h2>
', currentPolls, '<hr>
<font size=-1>', (self linklocal: '/srcdefault' text: 'See source for this page'), '</font>', self endhtml! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 10:44'!
development: request
	"This is a request for the development page."

^self starthtml, '
<h1>SqueakDot development</h1>
<p><b>IMPORTANT NOTE: The following is not functional yet... You can not follow these steps below!! It is still just an idea on how to do it.</b></p>
<p>SqueakDot is meant to be <b>an experiment in online concurrent community development</b>.<br>
In the "direct modification" spirit of Swikis and Squeak the idea is that:
<ul>
<li>This site is running while we are changing the code beneath it.
<li>Several developers should be able to work with it "at the same time".
<li>Rollback functionality that can back us up from the ditch.
</ul></p>
<p>The server is a cocktail of:
<ul>
<li>Comanche by Bolot Kerimbaev.
<li>Session support using cookies posted on the PWS list by Diego Gomez Deck.
<li>Some small fixes to the above.
<li>A simple yet flexible and dare I say very nice, HttpView framework by me. :-)
</ul>
<b>Note: There are no HTML files involved at all and there is no Swiki code being used -
I did not like all that Squeak code trapped in files on disk -
it looked too much like the ASP/JSP tragedy to me. Everything here is done in pure Squeak.
Take a look at the source for ', (self linklocal: '/srcdefault' text: 'this page'), '. Do you like it?
Yes, it has it''s flaws - but it is so simple to work with!!</b></p>
<p>
If you would like to jump in the water, follow these steps:
<ul>
<li>Get username/password by mailing <a href="mailto:goran.hultgren@bluefish.se">Goran</a>. You must be at least "known" in the Squeak community to participate.
<li>Get rsync and synch it all down. You will get:
<ol>
<li>The current image + changelog
<li>A bunch of numbered changesets (these are all "commits" sofar)
</ol>
The only thing you will not get are the personal SDAccount instances which are living as ImageSegments on the server.
<li>Make a cool new feature, bugfix, whatever and test it on your local machine. There are a few testaccounts present that you can use.
<li>Produce a ChangeSet for your feature including logic for migration of live objects if needed.
<li>Select your ChangeSet in the changesorter and select "publish to SqueakDot". This will check that you are "in synch" (no new changesets that have slipped in behind your back) and if that is the case the ChangeSet will be uploaded using rsynch to the server.
<li>When a new zipfile appears on the server it will:
<ol>
<li>Turn of the webservice temporarily
<li>Save the image as a temporary rollback image (for quick rollback)
<li>Unpack the zipfile in a temp directory, the path to that directory can be found with "SDServer tempPath".
<ul>
<li>Load the first ChangeSet (*.cs) found in the temp directory. If the postscript of the changeset would like to abort it just needs to call "SDServer abort". This will quit the image without saving and restart the saved rollback image. When SqueakDot (re)boots it will move any temp directory to "failed.nnn", where "nnn" is the next available number.
<li>After loading the changeset (and obviously not aborting in the postscript) the image is saved properly and temp directory is moved to "changeset.nnn" where "nnn" is the next available number.
</ul>
</ul>
When all this fails horribly as things are bound to happen there is a VNC desktop running which all trusted developers can attach to using VNCViewer.</p>
', (self linkback: 'Back'), (self endhtml: request)! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 15:36'!
login: request
	"Handle a login."

	^self login: request heading: 'Login to SqueakDot'! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 14:34'!
login: request heading: aHeading
	"Handle a login."

	^self login: request heading: aHeading url: nil! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/30/2002 13:56'!
login: request heading: aHeading url: url
	"Handle a login."

	| username password account requestedUrl |
	request isPostRequest ifTrue:[
		requestedUrl _ request postFields at: 'requestedUrl' ifAbsent: [].
		(requestedUrl = (prefix, '/login')) ifTrue:[requestedUrl _ self prefix].
		username _ request postFields at: 'username' ifAbsent: [].
		password _ request postFields at: 'password' ifAbsent: [].
		account _ server accountForUsername: username.
		account ifNil: [^self message: 'No user with that name' linklocal: 'login'].
		(account verifyPassword: password)
			ifTrue:[
				request session attributes at: #account put: account.
				^request redirectTo: requestedUrl ]
			ifFalse:[
				request session attributes at: #failedAccount put: account.
				^self wrongpassword: request ]
	].
	requestedUrl _ url ifNil: [request url] ifNotNil: [url].
^self starthtml, '
<h1>', aHeading, '</h1>
<form action="', request url, '" method="post">
Username: <input type="text" name="username"><br>
Password: <input type="password" name="password"><br>
<input type="hidden" name="requestedUrl" value="', requestedUrl, '"><br>
<input type="submit" value="Login">
</form>
<a href="', prefix, '/newaccount">New account</a>
', (self linkback: 'Back'), (self endhtml: request)
! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/30/2002 14:14'!
logout: request
	"Handle a logout. If it fails we are probably not logged in.
	This version goes to the top page. A variant would be to go to the login page:
	^self login: request heading: 'Logged out' url: self prefix, '/account'"

	(super logout: request) ifFalse: [^self notloggedin: request].
	^request redirectTo: self prefix! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/31/2002 15:58'!
newaccount2: request 
	"Handle a newaccount request."
	| username password verifypassword msg builder |
	builder _ self builderFor: request.
	builder start; h1: 'Create account on SqueakDot'; beginPostForm; html: 'Name: '.
	username _ builder inputText: #username.
	password _ builder br; html: 'Password: '; inputPassword: #password.
	verifypassword _ builder br; html: 'Verify password: '; inputPassword: #verifypassword.
	builder br; submit: 'Create'; reset: 'Reset'; endForm.
	msg _ builder blockVar: [:m | '<h2>' , m , '</h2>'].
	builder linkBack: 'Back'; hr; br; srcLink; end.
	request isPostRequest
		ifTrue: [password = verifypassword
				ifFalse: [msg value: 'Password verification failed'. ^builder contents].
			(server usernameOccupied: username)
				ifTrue: [msg value: 'Username already occupied'. ^builder contents].
			(server verifyPassword: password)
				ifFalse: [msg value: 'Bad password'. ^builder contents].
			(server newAccount: username password: password)
				ifNil: [msg value: 'Something went wrong when creating account'. ^builder contents]
				ifNotNil: [^self message: 'Account created successfully' linklocal: 'login']].
	^builder contents! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/31/2002 15:44'!
newaccount: request 
	"Handle a newaccount request."
	| username password account verifypassword msg |
	request isPostRequest
		ifTrue: [username _ request postFields at: 'username'.
			password _ request postFields at: 'password'.
			verifypassword _ request postFields at: 'verifypassword'.
			password = verifypassword
				ifTrue: [(server usernameOccupied: username)
						ifTrue: [msg _ 'Username already occupied']
						ifFalse: [(server verifyPassword: password)
								ifTrue: [account _ server newAccount: username password: password.
									account
										ifNil: [msg _ 'Something went wrong when creating account']
										ifNotNil: [^ self message: 'Account created successfully' linklocal: 'login']]
								ifFalse: [msg _ 'Bad password']]]
				ifFalse: [msg _ 'Password verification failed']].
	username ifNil: [username _ ''].
^ '<html>
<head><title>SqueakDot</title></head>
<body>
<h1>Create account on SqueakDot</h1>
<form action="' , request url , '" method="post">
Name: <input type="text" name="username" value="' , username , '"><br>
Password: <input type="password" name="password"><br>
Verify password: <input type="password" name="verifypassword"><br>
<input type="submit" value="Create">
<input type="reset" value="Reset">
</form>
' , (msg ifNil: [''] ifNotNil: ['<h2>' , msg , '</h2>'])
, (self linkback: 'Back') , (self endhtml: request)! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 15:33'!
notloggedin: request
	"Not logged in."

	^self login: request heading: 'Not logged in'! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 14:16'!
process: request
	"Process the request - first we make sure that the request is for us -
	prefixed with prefix. Then we dispatch the request to a method of it's
	own based on the url, see #extractMethodFromUrl."

	| url method |
	url _ request url.
	(url beginsWith: prefix) ifFalse:[^nil].
	method _ self extractMethodFromUrl: url prefix: prefix.
	(method isEmpty) ifFalse:[  "another page"
		^self dispatchOn: method request: request
	].
	^self default: request! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 13:19'!
settings: request
	"This is where we change settings in the account."

	| account info |
	(self isLoggedIn: request) ifFalse:[^self notloggedin: request].
	account _ request session attributes at: #account.
	(request isPostRequest) ifTrue:[
		account
			password: (request postFields at: 'password');
			passphrase: (request postFields at: 'passphrase');
			phraseword: (request postFields at: 'phraseword').
		account info
			firstName: (request postFields at: 'firstname');
			lastName: (request postFields at: 'lastname');
			email: (request postFields at: 'email').
		"^request redirectTo: self prefix"
	].
	info _ account info.
^self starthtml, '
<h1>Account settings</h1>
<form action="', request url, '" method="post">
Username: ', account username, '<br>
Password: <input type="text" name="password" value="', account password, '"><br>
Passphrase: <input type="text" name="passphrase" value="', account passphrase, '"><br>
Phraseword (answer to the passphrase): <input type="text" name="phraseword" value="', account phraseword, '"><br>
Firstname: <input type="text" name="firstname" value="', info firstName, '"><br>
Lastname: <input type="text" name="lastname" value="', info lastName, '"><br>
Email: <input type="text" name="email" value="', info email, '"><br>
<input type="submit" name="submit" value="Save">
<input type="reset" value="Restore">
</form>
', (self linkback: 'Back'), (self endhtml: request)! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 16:01'!
verifylogin: request
	"Verify that the user is logged in. Return account."
	
	(self isLoggedIn: request) ifFalse:[^self notloggedin: request].
	^request session attributes at: #account! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/30/2002 16:41'!
vote: request
	"Vote on a poll."

	| account poll |
	account _ server accountForUsername: (request getFields at: 'account').
	poll _ account pollWithId: (request getFields at: 'id') asNumber.
	poll vote: (request getFields at: 'choice').
	^request redirectTo: self prefix! !

!SDTopView methodsFor: 'urls' stamp: 'gh 1/28/2002 14:33'!
wrongpassword: request
	"The user wrote the wrong password.
	First we make sure that it is 'our' page that was posted."

	| phraseword account |
	account _ request session attributes at: #failedAccount ifAbsent: [^self serverError: 'No account found'].
	(request url endsWith: '/wrongpassword')
		ifTrue:[
			request isPostRequest ifTrue:[
				phraseword _ request postFields at: 'phraseword' ifAbsent: [].
				(account verifyPhraseword: phraseword)
					ifTrue:[
						request session attributes removeKey: #failedAccount.
						request session attributes at: #account put: account.
						^request redirectTo: self prefix ]
					ifFalse:[ "fall through and resend the form" ]
			]
	].
^'<html>
<head><title>SqueakDot</title></head>
<body>
<h1>Wrong password</h1>
<form action="', prefix, '/wrongpassword" method="post">
Username: ', account username, '<br>
<input type="hidden" name="username" value="', account username, '">
Your passphrase is: <b>', account passphrase, '</b><br>
Phraseword: <input type="password" name="phraseword"><br>
<input type="submit" value="Login">
</form>
<a href="', prefix, '/login">Try to login normally again</a>
</body>
</html>'
! !


!SDTopView class methodsFor: 'instance creation' stamp: 'gh 1/28/2002 13:05'!
forServer: aSqueakDot
	"Create a http manager module for this SqueakDot.
	Check class comment for example."

	^self new initializeWith: aSqueakDot! !

