'From Squeak3.1alpha of 7 March 2001 [latest update: #4164] on 4 July 2001 at 7:19:57 pm'!
"Change Set:		ComSwiki
Date:			4 July 2001
Author:			Je77, Bolot Kerimbaev

SWIKI 1.1

Swiki 1.1 fixes several bugs and adds a few new features. Mainly, this is just a fixed 1.0.

COMANCHE 4.10

Comanche 4.10 beta, base package. kom/4.10 is a service release, primarily for ComSwiki 1.1 and for some minor bug fixes. Additionally, it features a few new beginnings, which are incomplete, but are included as a 'teaser' and will be expanded in kom/4.11 and beyond. Among teasers are: HttpFormDictionary (allows for multiple values for the same field name), ChieftainModule (application dispatcher).

Comanche is an open-source web server for Squeak (http://minnow.cc.gatech.edu/swiki).

To get started, try the following in the workspace:
ChieftainModule basicExample
it will start a server on port 8017, which serves two applications:
http://localhost:8017/displaycam
http://localhost:8017/helloworld

To stop the server, do the following:
| che | (che _ ComancheServer serverOnPort: 8017 ifAbsent: []) ifNotNil: [che stop].
ComancheNetService removeServiceNamed: 'basicExample'.

Comanche contains the server framework, which makes it possible to develop web applications entirely in Squeak, without the need to run an external web server.

Please check Kom-demo for more examples, look in the class comments.

Bug fixes in Kom 4.10:
- get and post field names are now case-sensitive
- on-going work on SocketStream, removed a potential infinite loop (happens under rare circumstances on some platforms)

What's new in Kom 4.10:
- HTML UI builder framework (early alpha)
- Kishi, an application framework
-- bare Comanche is too bare to build large applications, this should make it easier"!

Object subclass: #ChieftainModule
	instanceVariableNames: 'urlMap urlPrefixMap '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-Kishi'!

!ChieftainModule commentStamp: '<historical>' prior: 0!
ChieftainModule
bolot 6/21/2001 03:08

- decides which app/module/obj handles a given URL
- urlMap is for mapping a single URL to a single object
-- e.g., cached objects
- urlPrefixMap is for mapping a URL prefix to an application

----
- todo: cached objects
-- timeout
-- duplication (e.g., what if registering same object again?)
- todo: urlPrefix mapping
-- fast determination which module needs to run
- todo: session management
- todo: form processing!

StringHolder subclass: #ComSwikiLauncher
	instanceVariableNames: 'package port ports isShutdown startStopButton portButton '
	classVariableNames: 'ValidPorts '
	poolDictionaries: ''
	category: 'Swiki-Comanche'!

!ComSwikiLauncher commentStamp: '<historical>' prior: 0!
ComSwikiLauncher

This class provides a morphic interface to launch Swiki on Comanche.
In Morphic, doIt: (ComSwikiLauncher openAsMorph)
In MVC, doIt: (ComSwikiLauncher openMVCView)

BUTTON EXPLANATION
start/stop server button
	press on this button to start or stop the Swiki server on the given port.
save & exit button
	once everything is set up, this button will save and quit and turn
	the swiki on at the next reboot. This is not to be confused with 'save
	and quit' which does not restart the server.
port button
	press on this when the server is inactive to change the port number.
	Note: 80 is the default port for a web server, but many systems will
		not allow a user to use it (Windows NT, Unix)

TO EDIT SWIKI
start the server
bring up ComSwiki Launcher's menu
	press on the button next to X
chose 'open swiki browser...'
!

ComSwikiLauncher class
	instanceVariableNames: ''!
Object subclass: #ComancheServer
	instanceVariableNames: 'connectionHandler serviceProvider '
	classVariableNames: 'Servers '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ComancheServer
!

Object subclass: #ComancheService
	instanceVariableNames: 'autoStart log '
	classVariableNames: 'Services '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:43

ComancheService

Comment from kom46:
I am an abstract superclass.  My subclasses are services that can be established on any port.
!

ComancheService subclass: #ComancheNetService
	instanceVariableNames: 'comancheServer protocolAdaptor module '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ComancheNetService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ComancheNetService

Comment from kom46:
I'm a service that sets up a ComancheServer to listen on a given port.  I use a protocol adaptor to adapts TCP/IP based protocol conversations into message based conversations.

protocolAdaptor - an object that supports the NetworkProtocolAdaptor class interface (specifically, I send it #processSocket:target:).
comancheServer - an instance of a ComancheServer that handles all the details of setting up to listen for sockets on a given port.
!

Object subclass: #ConnectionHandler
	instanceVariableNames: 'portNumber socketClass process priority handlerBlock lastError socketsToDestroy '
	classVariableNames: 'Registry '
	poolDictionaries: ''
	category: 'Kom-kernel'!

!ConnectionHandler commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:44

ConnectionHandler

Comment from kom46:
- also see ConnectionQueue
- does not keep the queue of open sockets
- launches the applications/modules immediately
  upon accepting a connection!

Object subclass: #DisplayCamModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!DisplayCamModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

DisplayCamModule
- formerly, RemoteDisplayModule
-- renamed to make it more specific
-- we're not VNC
- serves a scaled snapshot of the current Display

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'DisplayCamExample' onPort: 8000.
service module: (DisplayCamModule new).
service start
!

Object subclass: #HelloWorldModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!HelloWorldModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:54

HelloWorldModule
- a mandatory example
- just serves a String, which Comanche converts to HttpResponse

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'HelloWorldExample' onPort: 8000.
service module: (HelloWorldModule new).
"alternatively, service module: (SinglePlugModule displayCam)"
service start
!

Error subclass: #HttpBadRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpBadRequest commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:48

HttpBadRequest
- an error that gets translated to HTTP error code 400!

Dictionary subclass: #HttpFormDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpFormDictionary commentStamp: '<historical>' prior: 0!
kom/4.10 (Comanche beta 4.10)
HttpFormDictionary
bolot 6/22/2001 12:09

- use this instead of plain Dictionary for GET and POST forms
- maintains multiple values for the same field
-- but is backwards compatible, #at: returns the first value (?)
-- so do #booleanAt:, #numberAt:
- to access the actual value at key, use #rawAt:
-- returns an OrderedCollection

TODO:
- file upload support
-- idea: first value is file name, second is FileStream?
!

Object subclass: #HttpParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpParser commentStamp: '<historical>' prior: 0!
Kom/4.10 (Comanche beta 4.10)
bolot 6/22/2001 11:59

HttpParser
- everything is on class side
- all parsing utilities (form fields, forms, headers, etc.)
-- moved out of other Http$$ classes

what's new in kom/4.10
- case-sensitive form fields (case is preserved)
- multiple values for fields
-- through using HttpFormDictionary!

Error subclass: #HttpRedirect
	instanceVariableNames: 'location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpRedirect commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:50

HttpRedirect
- an error that gets translated to HTTP error code 30x
-- relocate to the given URL!

Object subclass: #HttpResponse
	instanceVariableNames: 'contents contentType status request fields '
	classVariableNames: 'StatusCodes '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpResponse commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:52

HttpResponse

Comment from kom46:
I am a response to an HttpRequest.  I can formulate an HTTP response and send it out over a socket.  An HttpAdapter will accept an HttpRequest, dispatch a method call to an HttpPlug (which will result in a stream or an error), and then formulat an instance of me to deliver the response to the client.!

HttpResponse subclass: #HttpPartialResponse
	instanceVariableNames: 'producerBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpPartialResponse commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:49

HttpPartialResponse
- not a very accurate name
- a subclass of HttpResponse
-- allows for long-execution modules to write directly to the client
!

Error subclass: #HttpUnauthorized
	instanceVariableNames: 'realm '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpUnauthorized commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:52

HttpUnauthorized
- an error that gets translated to HTTP error code 401
!

Object subclass: #IdFormatter
	instanceVariableNames: 'idBlock startBlock transitionBlock endBlock formatter settings '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!IdFormatter commentStamp: '<historical>' prior: 0!
IdFormatter

This formatter is used by LineFormatter to format text.

SPECIFIC INSTANCES:
anchor: places an anchor for lines beginning with '@'
append: adds an append area for lines beginning with '+'
appendRender: removes an append area for render
break: adds '<hr>' for lines beginning with '_'
heading: makes headings out of lines beginning with '!!'
leaveAlone: leaves the text as it is
list: makes lists out of lines beginning with '-' or '#'
preformatted: makes text beginning with '=' into equal length font
saveAppend: adds a specific text to a line beginning with '+'
table: makes a table out of lines beginning with '|'
text: (default) adds '<br>' to the end of the line!

IdFormatter class
	instanceVariableNames: ''!
Object subclass: #KomHtmlEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlEntity commentStamp: '<historical>' prior: 0!
KomHtmlEntity
bolot 6/20/2001 22:31

- the root of the HTML UI widget hierarchy
- each element is a wrapper for converting objects into HTML components
-- e.g., KomHtmlSelectionList -- coll as: KomHtmlSelectionList
!

KomHtmlEntity subclass: #KomHtmlForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlForm commentStamp: '<historical>' prior: 0!
KomHtmlForm
bolot 6/20/2001 22:57

- this is used in form construction, primarily in SSP
- we want to make form creation/manipulation as automatic as possible
- when we add a form on the page, all subsequent form elements belong to the form
- form generates its name and URL automatically
- when we process the form, the values submitted are processed by appropriate entities
-- ?how? -- we want to create a design pattern
- maybe forms should be associated with HTTP sessions?
-- that way, we can keep track of values
-- create a copy of KomHtmlForm for each session?!

KomHtmlEntity subclass: #KomHtmlFormEntity
	instanceVariableNames: 'form name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!
KomHtmlFormEntity subclass: #KomHtmlSelectionList
	instanceVariableNames: 'collection defaultSelection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-HTML UI builder'!

!KomHtmlSelectionList commentStamp: '<historical>' prior: 0!
KomHtmlSelectionList
bolot 6/20/2001 22:47

- wrapper for collections to convert them into SELECT tag
- collection contains associations:
-- <OPTION VALUE="key">value</OPTION>!

ComancheServer subclass: #LTDComancheServer
	instanceVariableNames: 'maxThreads ltdSema '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!LTDComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:45

LTDComancheServer
- based on Lex Spoon's limitConnections change set
-- except that it creates a subclass of ComancheServer
-- ... and renames inst vars
- maxThreads - how many connections to handle simultaneously
- ltdSema - semaphore that only allows maxThreads connections

Inst Vars:
	maxThreads		#(Integer SmallInteger)
	ltdSema			#(Semaphore)
!

ComancheNetService subclass: #LTDComancheService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!LTDComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:45

LTDComancheService
- service corresponding to LTDComanchServer
- kom50 will refactor service/server/adaptor framework
-- may not be necessary to subclass all hierarchies!

Object subclass: #LineFormatter
	instanceVariableNames: 'exceptions formatters storeID convertToCrlf '
	classVariableNames: 'CR LF '
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!LineFormatter commentStamp: '<historical>' prior: 0!
LineFormatter

This formatter is used to format text. Exceptions are processed using their own formatters. They are later placed in their former positions. Formatters are assigned based on the value that follows cr. There is also a default formatter.

SPECIFIC INSTANCES:
appendFormatter: used to add append text to the swiki text
renderFormatter: used to convert the raw text to the rendered HTML text
showFormatter: used to convert the raw text to the view HTML text!

LineFormatter class
	instanceVariableNames: ''!
Object subclass: #MultipartChunk
	instanceVariableNames: 'header properties multipartBoundary request '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!MultipartChunk commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:52

MultipartChunkHeader
- in kom49 (or kom50) this will be used only for internal purposes
-- applications will access multipart form fields through regular fieldAt: technique

Comment from kom46:
- this is a hack (bolot 10/25/2000 17:17)
- store a part's (from a multipart message) header information:
-- header (raw)
-- properties (extracted and converted info, such as file-name, content-length, etc.)!

Object subclass: #NetworkProtocolAdaptor
	instanceVariableNames: 'readStream writeStream target log '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol Abstract'!

!NetworkProtocolAdaptor commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

NetworkProtocolAdaptor

Comment from Kom46:
I represent an adaptor that adapts a network protocol into a message based dialog between me and my target.  Thus, I must have knowledge of the underlying network protocol.  My target must implement a protocol designed to work with a specific subclass.

*NOTE* At the moment, this class and subclasses only work as servers.  A small amount of additional work is needed to get them functioning as clients.

My subclasses should only be concerned with specializing for a particular network protocol.

Instance variables:

readStream - The stream to read requests or responses from.
writeStream - The stream to write requests or responses to.
target - The target object with which I will converse.
!

NetworkProtocolAdaptor subclass: #HttpAdaptor
	instanceVariableNames: 'request response startTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpAdaptor commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:48

HTTPAdaptor
- logging is removed from kom46 core
- so is Process>>contextAt:ifAbsent:
- kom48 adds rudimentary persistent connections
-- see keepAliveConnection senders (also in Preferences)

Comment from kom46:
I encapsulate the HTTP protocol from my clients (who must support the HttpPlug interface).  I use an HttpRequest to pick apart a request and I use an HttpResponse to formulate a response.  Mainly, I broker the conversation, turning a request into a message send (to an HttpPlug) and converting the answer to an HttpResponse.  Thus, my clients must simply implement a message based protocol (eliminating the need for them to be concerned with HTTP syntax).!

NetworkProtocolAdaptor class
	instanceVariableNames: ''!
Object subclass: #NetworkRequest
	instanceVariableNames: 'properties session '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-protocol Abstract'!

!NetworkRequest commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:53

NetworkRequest
- a generic request object
- properties are some ad-hoc properties
- session is not currently used

Note about Kom46:
- this class contained more methods
-- some methods have been depricated since!

NetworkRequest subclass: #HttpRequest
	instanceVariableNames: 'url stream header rawUrl '
	classVariableNames: 'EndOfRequestHeaderMarker HttpStatusCodeDict '
	poolDictionaries: ''
	category: 'Kom-protocol HTTP'!

!HttpRequest commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:51

HttpRequest
- HTTP request object wrapper
- handles details of HTTP
-- headers, formats, etc.
- as of kom47, handles multipart posts
- in kom49 (or kom50) a minor refactoring will happen!

NetworkRequest class
	instanceVariableNames: ''!
ComancheServer subclass: #PWSComancheServer
	instanceVariableNames: 'portNumber serverProcess priority '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!PWSComancheServer commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:46

PWSComancheServer
- a version of ComancheServer that works like PWS
-- i.e., using ConnectionQueue
!

ComancheNetService subclass: #PWSComancheService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!PWSComancheService commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:46

PWSComancheService
- service for PWSComancheServer
- kom50 will refactor service/server/adaptor framework
-- won't be necessary to subclass all hierarchies!

Object subclass: #PartialResponseModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!PartialResponseModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:54

PartialResponseModule
- an example of using HttpPartialResponse
-- to serve results of a slow computation!

Object subclass: #SinglePlugModule
	instanceVariableNames: 'processBlock urlPattern '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!SinglePlugModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/1/2001 02:50

SinglePlugModule

This is very similar to SinglePlugServerAction of PWS. Its processBlock is what fulfills the request. But the important difference arises because of the architectural differences between Comanche and PWS. SinglePlugModule's processBlock needs to return a value which will get served to the web browser (whereas PWS SinglePlugServerAction's processBlock needs to write, by way of #reply:, directly to the socket).

To make SinglePlugModule only respond to certain URLs, its urlPattern instance variable should be set appropriately, for example, through using #urlPrefix:, #urlSuffix:, or #urlPattern.

Here's an example (select all and do it):
| service module |
service := ComancheNetService named: 'SinglePlugExample' onPort: 8080.
module _ SinglePlugModule newBlock: [:request | request url].
module urlPrefix: '/singlePlugExample'.
service module: module.
service start

To stop the above server:
| server |
(server _ ComancheServer serverOnPort: 8080 ifAbsent: [])
	ifNotNil: [server stop].
ComancheNetService removeServiceNamed: 'SinglePlugExample'.
!

Object subclass: #StaticFileModule
	instanceVariableNames: 'folder slashXlat '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!StaticFileModule commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:55

StaticFileModule
- this is a "web-server proper"
-- serve files from the local file system (okay, there's NFS and Samba)
-- very simple mapping from URL to relative file path
- default folder location is 'htdocs' in FileDirectory default

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'StaticFileExample' onPort: 8000.
service module: (StaticFileModule new).
service start
!

Stream subclass: #BufferStream
	instanceVariableNames: 'buffer startPos endPos '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!BufferStream commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:43

BufferStream

Comment in Com46:
- is-a ReadWriteStream on a String
- like a queue
  removeNext:/nextPutAll: protocol!

Stream subclass: #SocketStream
	instanceVariableNames: 'socket inStream outStream status '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-kernel'!

!SocketStream commentStamp: '<historical>' prior: 0!
Kom48 (Comanche beta 4.8)
bolot 4/2/2001 18:47

SocketStream
- some changes to gradually enable client-side work

Comment from kom46:
SocketStream
- stream interface to Socket
- HttpRequest (and other users) don't know anything about sockets

bolot 12/16/1999 15:01
- re-doing the interface
  - inStream will replace buffer
  - outStream will be the buffer for sending data
  - nextPut:/nextPutAll: will write to outStream
  - flush will be required to send data
- TODO
  - stop using buffer, eventually remove it
!

StringHolder subclass: #SwikiBrowser
	instanceVariableNames: 'shelf bookList bookListIndex functionList functionListIndex categoryList categoryListIndex elementList elementListIndex booksAsHierarchy logFile '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Comanche'!

!SwikiBrowser commentStamp: '<historical>' prior: 0!
SwikiBrowser

this is a browser to edit the swikis.

To open, use the ComSwikiLauncher:
1. Start the server.
2. Chose "open swiki browser..." from the window menu (next to the X)!

SwikiBrowser class
	instanceVariableNames: ''!
Object subclass: #SwikiColorScheme
	instanceVariableNames: 'directory fileServer templates altTags buttonEnding activeButton emoteEnding mimeEnding '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiColorScheme commentStamp: '<historical>' prior: 0!
SwikiColorScheme

are used by Swikis to reference buttons and graphics.

INSTANCE VARIABLES:
directory = the corresponding SwikiDirectory
fileServer = the corresponding SwikiFileServer
templates = a dictionary mapping names of templates to the templates (such as beforeButtons)
altTags = a dictionary mapping image names to their ALTernate tag (from tags.xml)
buttonEnding = the suffix of button files (such as .gif)
activeButton = a boolean that is true if the button should have a rollover
emoteEnding = the suffix of emote (happy, sad, etc.) files (such as .gif)
mimeEnding = the suffix of mime types (image, video, audio, etc.)!

SwikiColorScheme class
	instanceVariableNames: ''!
Object subclass: #SwikiEntry
	instanceVariableNames: 'name modificationTime creationTime '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiEntry commentStamp: '<historical>' prior: 0!
SwikiEntry

is similar to FileEntry, but more lightweight. This contains the information that is associated with a specific file or directory. This is an abstract class; it holds the joint features of SwikiFile and SwikiDirectory.

INSTANCE VARIABLES:
name = name of the file (a String)
modificationTime = when the file was last modified (a number)
creationTime = when the file was created (a number)!

SwikiEntry subclass: #SwikiDirectory
	instanceVariableNames: 'dir dirServeCache dirRefsCache fileServeCache fileRefsCache '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiDirectory commentStamp: '<historical>' prior: 0!
SwikiDirectory

is a cacheing file directory that allows you to reference and serve files in it.

INSTANCE VARIABLES:
dir = the corresponding FileDirectory
dirServeCache = a dictionary mapping relative HTTP paths to the corresponding subdirectories
dirRefsCache = a dictionary mapping directory names to the corresponding directories
fileServeCache = a dictionary mapping relative HTTP paths to the corresponding files
fileRefsCache = a dictionary mapping file names to the corresponding SwikiFileVersions!

SwikiEntry class
	instanceVariableNames: ''!
SwikiDirectory class
	instanceVariableNames: ''!
SwikiEntry subclass: #SwikiFile
	instanceVariableNames: 'fileSize versions '
	classVariableNames: 'MimeToClass '
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiFile commentStamp: '<historical>' prior: 0!
SwikiFile

contains the information that is associated with a specific file. During instance creation, the correct subclass of SwikiFile is chosen according to MIME type.

INSTANCE VARIABLES:
fileSize = size of the file in bytes
versions = the SwikiFileVersions that this file belongs to

CLASS VARIABLES:
MimeToClass = a dictionary of MIMETypes to the subclasses of SwikiFile that handle them!

SwikiFile class
	instanceVariableNames: ''!
Object subclass: #SwikiFileServer
	instanceVariableNames: 'refFileDict serveFileDict refFileBlock refDirectoryBlock refMissingFileBlock serveFileBlock serveDirectoryBlock serveMissingFileBlock '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiFileServer commentStamp: '<historical>' prior: 0!
SwikiFileServer

is a pluggable functionality module. It is used by the Swiki to reference or serve files and directories in different ways.

INSTANCE VARIABLES:
refFileDict = a Dictionary of classes to the block used to reference them
serveFileDict = a Dictionary of classes to the block used to serve them
refFileBlock = a block that determines how to reference a SwikiFile
refDirectoryBlock = a block that determines how to reference a SwikiDirectory
refMissingFileBlock = a block that determines how to reference a missing file
serveFileBlock = a block that determines how to serve a SwikiFile or SwikiImage
serveDirectoryBlock = a block that determines how to serve a SwikiDirectory
serveMissingFileBlock = a block that determines how to serve a missing file!

SwikiFileServer class
	instanceVariableNames: ''!
OrderedCollection subclass: #SwikiFileVersions
	instanceVariableNames: 'name mimeType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiFileVersions commentStamp: '<historical>' prior: 0!
SwikiFileVersions

is a subclass of OrderedCollection that holds all versions of a Swiki file.

INSTANCE VARIABLES:
name = the full name of the file (this may be an alias for the actual file name)
mimeType = the mimeType for the files!

SwikiFileVersions class
	instanceVariableNames: ''!
SwikiFile subclass: #SwikiImage
	instanceVariableNames: 'width height '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiImage commentStamp: '<historical>' prior: 0!
SwikiImage

is a file entry for an image (usually, a file that ends with gif, jpeg, jpg, or png). It includes width and height as further instance variables.

INSTANCE VARIABLES:
width = the width of the image (as a number)
height = the height of the image (as a number)!

SwikiImage class
	instanceVariableNames: ''!
Object subclass: #SwikiModule
	instanceVariableNames: 'shelf '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Comanche'!

!SwikiModule commentStamp: '<historical>' prior: 0!
SwikiModule

This class gets Comanche to talk to swiki.

In the folder for the swiki, several things are of significants:

	settings.xml		The XML file which contains the settings
	security.xml		The XML file which contains the security
	setup.xml		The XML file which contains the setup
	log.txt			The log file if 'logging' is set to 'local' in the setup file
	addresses		This directory contains the valid addresses
	templates		This directory contains the valid templates
	actions			This directory contains the valid actions
	pages			This directory contains the swiki pages
	uploads			This directory contains the uploads
	rendered		This directory will contain the rendered swiki if the swiki is rendered!

SwikiModule class
	instanceVariableNames: ''!
Object subclass: #SwikiRequest
	instanceVariableNames: 'book page address security settings '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!SwikiRequest commentStamp: '<historical>' prior: 0!
SwikiRequest

This is an abstract class that is sent into a SwikiShelf to be processed to create a response.

INSTANCE VARIABLES:
book = the name of the book it might belong to
page = the index of the page it might belong to
address = the possible addressing for the element
security = a SwikiSecurityMember
settings = a dictionary for the process to put things so that others along the process path can use them.!

SwikiRequest subclass: #HttpSwikiRequest
	instanceVariableNames: 'raw '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Comanche'!

!HttpSwikiRequest commentStamp: '<historical>' prior: 0!
HttpSwikiRequest

This subclass of SwikiRequest is sent by the SwikiModule to the SwikiShelf for processing. The HttpSwikiRequest is created from the HTTPRequest, which becomes the raw instance variable.

book, page, and address are determined like this:
	The url is tokenized by /.
	The first element is the book.
	If the second element is a number, then it is the page.
	The next element is the address.
!

HttpSwikiRequest class
	instanceVariableNames: ''!
Object subclass: #SwikiSecurityMember
	instanceVariableNames: 'settings privileges '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Security'!

!SwikiSecurityMember commentStamp: '<historical>' prior: 0!
SwikiSecurityMember

This class provides the members that will belong to the SwikiSecurityModule. These are passed along with the request for identification and security reasons.

INSTANCE VARIABLES:
settings = a Dictionary (user, password, and ip are the settings that are used by the security module)
privileges = a SwikiSecurityPrivileges (this determines what capabilities this user has)
!

SwikiSecurityMember class
	instanceVariableNames: ''!
Object subclass: #SwikiSecurityModule
	instanceVariableNames: 'aclDict ipColl default '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Security'!

!SwikiSecurityModule commentStamp: '<historical>' prior: 0!
SwikiSecurityModule

This is what a 'security.xml' file is supposed to look like:

**********************************************************
<?xml version="1.0"?>
<security>
<default priv="defaultPrivilege" />
<group priv="groupPrivilege">
<member>
<m type="user">userName</m>
<m type="password">passWord</m>
<m type="ip">IPNumber</m>
...
</member>
...
</group>
...
</security>
**********************************************************

'...'						means that there can be several of the type proceeding it.
defaultPrivilege			the privilege of the default group (for example: 'Read Only')
groupPrivilege			the privilege of the specific group (for example: 'Write')
userName				the user name that the user must enter
passWord				the password the user must enter
IPNumber				the IPNumber of the user
!

SwikiSecurityModule class
	instanceVariableNames: ''!
Object subclass: #SwikiSecurityPrivileges
	instanceVariableNames: 'name default pageAddresses bookAddresses shelfAddresses other '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Security'!

!SwikiSecurityPrivileges commentStamp: '<historical>' prior: 0!
SwikiSecurityPrivileges

This class provides privileges for the various servers and modules to inspect. Try the category testing to figure out which one is right for the purpose.

If a privilege of the type does exist, the instance returns (default not). If the privilege of the type does not exist, the instance returns (default).

INSTANCE VARIABLES:
name = the name of the privilege. This identifies the privilege.
default = the default value as to whether something is allowed
pageAddresses = the list of exceptions to the default value having to do with page addresses
bookAddresses = the list of exceptions to the default value having to do with book addresses
other = the list of exceptions to the default value not having to do with addresses !

SwikiSecurityPrivileges class
	instanceVariableNames: ''!
Object subclass: #SwikiStorage
	instanceVariableNames: 'dir dict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Storage'!

!SwikiStorage commentStamp: '<historical>' prior: 0!
SwikiStorage

Subclass this to determine the storage mechanisms for a Swiki.
By default, these rules apply:
	addresses are Smalltalk blocks that get compiled at run time
	templates are text files indicating actions with <? and ?>
	actions are Smalltalk blocks that get compiled at run time!

SwikiStorage class
	instanceVariableNames: ''!
Object subclass: #SwikiStructure
	instanceVariableNames: 'name storage settings modules sema '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!SwikiStructure commentStamp: '<historical>' prior: 0!
SwikiStructure

This is a basis class that shares the common functionalities for NuSwikiPage, SwikiBook, SwikiShelf, and SwikiSubBook

INSTANCE VARIABLES:
name = the name of the object
storage = a type of SwikiStorage that is used to initialize and store new values
settings = a dictionary of save values
modules = a dictionary of run-time values that will not be saved
sema = a Semaphore used for saving!

SwikiStructure subclass: #NuSwikiPage
	instanceVariableNames: 'id versionId date time user text '
	classVariableNames: 'BadCharTable '
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!NuSwikiPage commentStamp: '<historical>' prior: 0!
NuSwikiPage

This is a class for swiki pages that are part of a SwikiBook.

INSTANCE VARIABLES:
id = numerical ID of the page
versionId = the version of the page. 1 indicates the first version. 0 indicates the current version.
date = the last date the page was edited
time = the last time the page was edited
user = the last user to edit the page
text = an object that contains information on how to get the text for the page!

SwikiStructure subclass: #SwikiBook
	instanceVariableNames: 'setup children pages pageAddresses bookAddresses privAddresses pageTemplates bookTemplates pageActions bookActions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!SwikiBook commentStamp: '<historical>' prior: 0!
SwikiBook

A Swiki is a container for pages and a way to access those pages. 'process: request response: response shelf: shelf' processes the request to fill in the necessary parts of the response.

INSTANCE VARIABLES:
setup = a place to keep all the start-up information for the book.
pages = The SwikiPages of this book
children = the SwikiBooks that inherit from this book
pageAddresses = The ways a page can be addressed (dictionary of strings to blocks)
bookAddresses = The ways the book can be addressed (dictionary of strings to blocks)
privAddresses = These are private addresses that are not determined by the URL
	there are several normal usages:
	create = for creating new swikis
	filter = for security filtering
	initialize = for initializing the swiki
	log = for logging
	search = for searching the pages
	security = returns the security possibilities
	settings = return the settings possibilities
pageActions = The actions that can be used for a page (dictionary of strings to blocks)
bookActions = The actions that can be used for the book (dictionary of strings to blocks)
pageTemplates = The templates that are specific to the page; they can call either page or book actions (dictionary of strings to strings)
bookTemplates = The templates that are specific to the book; they can call book actions (dictionary of strings to strings)!

SwikiStructure subclass: #SwikiShelf
	instanceVariableNames: 'books privAddresses shelfAddresses bookTemplates shelfTemplates bookActions shelfActions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!SwikiShelf commentStamp: '<historical>' prior: 0!
SwikiShelf

This is how a swiki is accessed. Processing the request and the return together. The shelf directs the process to the correct book.

INSTANCE VARIABLES:
books = the SwikiBooks of this shelf
shelfAddresses = The ways the shelf can be addressed (dictionary of strings to blocks)
privAddresses = These are private addresses that are not determined by the URL
bookTemplates = The templates that are specific to a book (dictionary of strings to strings)
shelfTemplates = The templates that are specific to the shelf (dictionary of strings to strings)
bookActions = The actions that can be used for a book (dictionary of strings to blocks)
shelfActions = The actions that can be used for the shelf (dictionary of strings to blocks)
!

SwikiStructure class
	instanceVariableNames: ''!
NuSwikiPage class
	instanceVariableNames: ''!
SwikiBook subclass: #SwikiSubBook
	instanceVariableNames: 'parent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-Structure'!

!SwikiSubBook commentStamp: '<historical>' prior: 0!
SwikiSubBook

this is a SwikiBook that inherits its properties from another SwikiBook.

INSTANCE VARIABLES:
parent = the SwikiBook that the swiki inherits from!

SwikiDirectory subclass: #SwikiSubDirectory
	instanceVariableNames: 'containingDirectory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Swiki-FileServer'!

!SwikiSubDirectory commentStamp: '<historical>' prior: 0!
SwikiSubDirectory

is a sub-directory. Thus, it has all the features of a SwikiDirectory, but it also has a containingDirectory.

INSTANCE VARIABLES:
containingDirectory = the SwikiDirectory which contains this instance (may be nil)!

SwikiSubDirectory class
	instanceVariableNames: ''!
Object subclass: #TextFormatter
	instanceVariableNames: 'match formattingArray '
	classVariableNames: 'CrToCrlf CrlfToCr DecodeFromHttp DecodeFromXmlCr DecodeFromXmlCrlf EncodeToHttp EncodeToStrictXmlCr EncodeToStrictXmlCrlf EncodeToXmlCr EncodeToXmlCrlf '
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!TextFormatter commentStamp: '<historical>' prior: 0!
TextFormatter

This is a general text formatter. You create an instance which is a text formatter. Then, using 'format:' you format a text to get a formatted stream back.

There are two type of formatting that can be added: mapping and action. A mapping is when an original in the text gets replaced with the replacement in the formatted stream. An action is when the text between the two elements is send into the code block and the result is sent to the formatted stream. In case of conflict, the longer match wins; for instance, in a SwikiFormatter, '----' might match to '<HR>', while '-' might match to '<LI>'.!

TextFormatter subclass: #BookTemplateFormatter
	instanceVariableNames: ''
	classVariableNames: 'SwikiFormatter '
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!BookTemplateFormatter commentStamp: '<historical>' prior: 0!
BookTemplateFormatter

This specialty TextFormatter is created for a SwikiBook to use in processing templates. It takes elements between '<?' and '?>' and executes the actions associated with the text inbetween.!

TextFormatter subclass: #PageFormatter
	instanceVariableNames: 'storeID '
	classVariableNames: 'ToSafeAlias ToSafeLocation '
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!PageFormatter commentStamp: '<historical>' prior: 0!
PageFormatter

This formatter is used to format the page text at various points in the swiki architecture.

SPECIFIC INSTANCES:
editFormatter: used to convert the raw page text to the edit text
saveFormatter: used to convert the edit text from the user to the raw text for the file
updateFormatter: used to update pages after a new page was created

CLASS VARIABLES:
ToSafeUrl: converts normal text into something that can be put into a url without messing up the url
FromSafeUrl: does the opposite of ToSageUrl
RemoveLf: removes all instances of Lf
RemoveCrLf: removes all instances of Cr, Lf or CrLf
ToSafeAlias: converts a swiki url text and converts the special symbols (<>@*&)!

TextFormatter subclass: #ShelfTemplateFormatter
	instanceVariableNames: ''
	classVariableNames: 'SwikiFormatter '
	poolDictionaries: ''
	category: 'Swiki-Formatting'!

!ShelfTemplateFormatter commentStamp: '<historical>' prior: 0!
ShelfTemplateFormatter

This specialty TextFormatter is created for a SwikiShelf to use in processing templates. It takes elements between '<?' and '?>' and executes the actions associated with the text inbetween.!

TextFormatter class
	instanceVariableNames: ''!
BookTemplateFormatter class
	instanceVariableNames: ''!
PageFormatter class
	instanceVariableNames: ''!
ShelfTemplateFormatter class
	instanceVariableNames: ''!
Magnitude subclass: #TimeStamp
	instanceVariableNames: 'date time '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Magnitudes'!

!TimeStamp commentStamp: '<historical>' prior: 0!
An instance of this class serves as a container for a Date and a Time.  Because TimeStamp is a subclass of Magnitude, you can do lots of interesting comparisons and arithmetic operations with TimeStamps.

Structure:
	date	 --> a Date - The day on which the TimeStamp occurs.
	time --> a Time - The time at which the TimeStamp occurs.

Examples:
	TimeStamp current
	TimeStamp date: Date today time: Time now
	TimeStamp fromString: '1-10-2000 11:55:00 am'   "MM-DD-YYYY HH:MM:SS AM"
	TimeStamp current < TimeStamp noon
!

SinglePlugModule subclass: #TurtleGraphicsModule
	instanceVariableNames: 'form pen '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!TurtleGraphicsModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/7/2001 18:50

TurtleGraphicsModule
- this is an example of serving two elements from the same module
-- on '/prefix/something.gif', serve the form (which converts to GIF)
-- on everything else, serve the web page
-- also, interpret form fields as commands for the turtle

Here's an example (select all and do it):
| service |
service := ComancheNetService named: 'TurtleGraphicsExample' onPort: 8000.
service module: (TurtleGraphicsModule new initialize).
service start
!

TurtleGraphicsModule subclass: #TurtleFrameGraphicsModule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kom-demo'!

!TurtleFrameGraphicsModule commentStamp: '<historical>' prior: 0!
Kom49 (Comanche beta 4.9)
bolot 5/7/2001 18:53

TurtleFrameGraphicsModule
- same idea as TurtleGraphicsModule, but use two frames
-- top -- image
-- bottom -- command console!

SwikiStorage subclass: #XmlSwikiStorage
	instanceVariableNames: ''
	classVariableNames: 'AssocDict TypesDict '
	poolDictionaries: ''
	category: 'Swiki-Storage'!

!XmlSwikiStorage commentStamp: '<historical>' prior: 0!
XmlSwikiStorage
Use streams for versions (to conserve memory) and strings for current version (for speed).

This is the first implementation of storage for Swiki. It primarily uses XML. Here are the rules as they apply.

PAGES
The current version is placed in the #.xml file. The previous versions are stored in the #.old file. This is the general pattern for these files:
	<?xml version="1.0"?>
	<page>
	<version date="..." time="..." user="..." />
	<settings>
	<s name="..." type="...">...</s>
	...
	</settings>
	<name>...</name>
	<text>...</text>
	</page>

SETTINGS
The settings are placed in the settings.xml file. This is the general pattern for these files:
	<?xml version="1.0"?>
	<settings>
	<s name="..." type="...">...</s>
	...
	</settings>
The setting types are boolean (true or false), number (a number), text (a String), coll (a collection of numbers), and code (Squeak code).!

XmlSwikiStorage class
	instanceVariableNames: ''!

!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:17'!
asHtmlDocumentForRequest: aNetworkRequest

	self error: 
		('The requested object (', 
		self asString, 
		'), could not be converted into HTML for your browser.')! !

!Object methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:23'!
asHttpResponseTo: anHttpRequest

	^(self asHtmlDocumentForRequest: anHttpRequest) 
		asHttpResponseTo: anHttpRequest
! !

!Object methodsFor: 'MIME' stamp: 'SVP 8/17/1999 17:51'!
mimeType

	^MIMEDocument defaultContentType! !


!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:16'!
cacheRootUrl
	^'/kom/cache/'! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:19'!
clearObjectCache
	urlMap _ Dictionary new! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:17'!
generateUniqueUrlForObject: anObject
	"prepend a special root URL"
	^self cacheRootUrl, anObject hash asString, '/', Time totalSeconds asString! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:19'!
initialize
	urlMap _ Dictionary new.
	urlPrefixMap _ Dictionary new! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:20'!
mapObject: anObject
	"generate a random, unique URL, add the object there"
	urlMap at: (self generateUniqueUrlForObject: anObject) put: anObject! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:20'!
mapPrefix: aString to: aModule
	"make a given prefix map to the module"
	urlPrefixMap at: aString put: aModule! !

!ChieftainModule methodsFor: 'accessing' stamp: 'bolot 6/21/2001 03:24'!
process: request
	"first, check if any cached objects are referenced"
	(urlMap includesKey: request url)
		ifTrue: [^urlMap at: request url].

	"then check if any application's prefix matches"
	urlPrefixMap keysAndValuesDo: [:urlPrefix :module |
		(request url beginsWith: urlPrefix) ifTrue: [^module process: request]].

	"otherwise, the default response"
	^nil! !


!ChieftainModule class methodsFor: 'examples' stamp: 'bolot 6/21/2001 03:48'!
basicExample
	"ChieftainModule basicExample"

	| service chief |
	chief _ self new initialize.
	chief
		mapPrefix: '/displaycam' to: DisplayCamModule new;
		mapPrefix: '/helloworld' to: HelloWorldModule new;
		mapPrefix: '/turtlegraphics' to:
				(TurtleGraphicsModule new initialize urlPrefix: '/turtlegraphics');
		mapPrefix: '/turtleframe' to:
				(TurtleFrameGraphicsModule new initialize urlPrefix: '/turtleframe').

	service := ComancheNetService named: 'basicExample' onPort: 8017.
	service module: chief.
	service start
! !


!Color methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:16'!
hex
	^(self red * 255) asInteger asCharacter hex,
	(self green * 255) asInteger asCharacter hex,
	(self blue * 255) asInteger asCharacter hex! !


!ComSwikiLauncher methodsFor: 'accessing'!
isShutdown
	^isShutdown ifNil: [false] ifNotNil: [isShutdown]! !

!ComSwikiLauncher methodsFor: 'accessing'!
isShutdown: boolean
	(self isShutdown = boolean) ifFalse: [
		isShutdown _ boolean.
		self changed: #isShutdown]! !

!ComSwikiLauncher methodsFor: 'accessing'!
package: aSymbol
	package _ aSymbol! !

!ComSwikiLauncher methodsFor: 'accessing' stamp: 'bolot 1/12/2001 14:46'!
port: anInteger
	port _ anInteger.
	portButton label: self portText.
	self changed: #portText! !

!ComSwikiLauncher methodsFor: 'accessing'!
ports: col
	ports _ col.
	port _ col at: 1.! !

!ComSwikiLauncher methodsFor: 'action' stamp: 'bolot 1/12/2001 14:45'!
changePort
	| index |

	self isOn ifFalse: [index _ 1.
		1 to: (ports size) do: [:i | (ports at: i) = port ifTrue: [index _ i + 1]].
		(ports size < index) ifTrue: [index _ 1].
		self port: (ports at: index)]! !

!ComSwikiLauncher methodsFor: 'action'!
isOn
	^(ComancheServer serverOnPort: port ifAbsent: []) notNil! !

!ComSwikiLauncher methodsFor: 'action'!
isPort
	^false! !

!ComSwikiLauncher methodsFor: 'action' stamp: 'je77 2/26/2001 13:03'!
openSwikiBrowser
	| shelf label |
	label _ (port = 80)
		ifTrue: ['Swiki Browser']
		ifFalse: ['Swiki Browser: ', port asString].
	shelf _ (ComancheServer serverOnPort: port ifAbsent: [^self]) serviceProvider module shelf.
	(SwikiBrowser asMorphOnShelf: shelf label: label) openInWorld! !

!ComSwikiLauncher methodsFor: 'action'!
shutdown
	self class shutdown! !

!ComSwikiLauncher methodsFor: 'action' stamp: 'je77 1/12/2001 18:48'!
startServer
	"To Start Swiki on Comanche:"
	| module |
	Socket initializeNetwork.
	module _ SwikiModule perform: package.
	module ifNil: [self error: 'Did not start!!'].
	(ComancheNetService named: ((package asString), '-', (port asString)) onPort: port)
		module: module;
		start.
	startStopButton label: self startStopLabel.
	self changed: #startStopLabel.
	self changed: #isOn
! !

!ComSwikiLauncher methodsFor: 'action' stamp: 'je77 4/2/2001 11:56'!
stopServer
	"To End Swiki on Comanche:"
	| che shelf |
	Smalltalk garbageCollect.
	shelf _ (ComancheServer serverOnPort: port ifAbsent: [nil]) serviceProvider module shelf.
	((SwikiBrowser allInstances select: [:browser | browser shelf = shelf]) size > 0)
		ifTrue: [PopUpMenu notify: 'Before stopping the server, you
need to close the Swiki Brower'.
			^self].
	ComancheNetService removeServiceNamed: ((package asString), '-', (port asString)).
	(che _ ComancheServer serverOnPort: port ifAbsent: [])
		ifNotNil: [che stop].
	Smalltalk garbageCollect.
	startStopButton label: self startStopLabel.
	self changed: #startStopLabel.
	self changed: #isOn! !

!ComSwikiLauncher methodsFor: 'action'!
toggleState
	(self isOn)
		ifTrue: [self stopServer]
		ifFalse: [self startServer]! !

!ComSwikiLauncher methodsFor: 'buttons'!
portButton: aMorph
	portButton _ aMorph.
	portButton label: self portText! !

!ComSwikiLauncher methodsFor: 'buttons'!
portText
	^'port: ', (port asString)! !

!ComSwikiLauncher methodsFor: 'buttons'!
startStopButton: aMorph
	startStopButton _ aMorph.
	startStopButton label: self startStopLabel! !

!ComSwikiLauncher methodsFor: 'buttons'!
startStopLabel
	^(self isOn)
		ifTrue: ['stop server']
		ifFalse: ['start server']! !

!ComSwikiLauncher methodsFor: 'initialize-release'!
initialize
	self ports: ValidPorts.
	super initialize.! !

!ComSwikiLauncher methodsFor: 'looks' stamp: 'je77 5/17/2000 10:06'!
defaultBackgroundColor
	^Color yellow! !

!ComSwikiLauncher methodsFor: 'looks'!
initialExtent
	^300@50! !

!ComSwikiLauncher methodsFor: 'window menu' stamp: 'je77 2/26/2001 11:24'!
addModelItemsToWindowMenu: aMenu
	(self isOn) ifTrue: [
		aMenu addLine.
		aMenu add: 'open swiki browser...' target: self action: #openSwikiBrowser].
	^super addModelItemsToWindowMenu: aMenu! !


!ComSwikiLauncher class methodsFor: 'initialize-release' stamp: 'Je77 8/10/2000 16:59'!
initialize
	ValidPorts _ OrderedCollection new.
	ValidPorts add: 80.
	ValidPorts add: 8000.
	ValidPorts add: 8080.
	ValidPorts add: 8888.! !

!ComSwikiLauncher class methodsFor: 'instance creation'!
openAsMorph
	^self openAsMorphPackage: #swikiWebServer! !

!ComSwikiLauncher class methodsFor: 'instance creation' stamp: 'je77 5/17/2000 09:34'!
openAsMorphPackage: package
	| instance window aColor startStopButton shutdownButton portButton |

	"Instance of ComSwiki Launcher"
	instance _ self new.
	instance package: package.
	"Display Morph"
	window _ (SystemWindow labelled: 'ComSwiki Launcher') model: instance.
	aColor _ Color colorFrom: instance defaultBackgroundColor.
	"Start/Stop Button"
	startStopButton _ PluggableButtonMorph on: instance getState: #isOn action: #toggleState.
	instance startStopButton: startStopButton.
	startStopButton askBeforeChanging: true.
	startStopButton color: aColor; onColor: (Color red) offColor: (Color green).
	window addMorph: startStopButton frame: (0@0 corner: 0.35@1).
	"Shutdown Button"
	shutdownButton _ PluggableButtonMorph on: instance getState: #isShutdown action: #shutdown.
	shutdownButton label: 'save & exit'; askBeforeChanging: true.
	shutdownButton color: aColor; onColor: aColor darker offColor: aColor.
	window addMorph: shutdownButton frame: (0.35@0 corner: 0.7@1).
	"Port Button"
	portButton _ PluggableButtonMorph on: instance getState: #isPort action: #changePort.
	instance portButton: portButton.
	portButton askBeforeChanging: true.
	portButton color: aColor; onColor: aColor offColor: aColor.
	window addMorph: portButton frame: (0.7@0 corner: 1@1).
	"Add to World"
	window openInWorld.! !

!ComSwikiLauncher class methodsFor: 'instance creation' stamp: 'bolot 1/12/2001 14:41'!
openMVCView
	^self openMVCViewPackage: #swikiWebServer! !

!ComSwikiLauncher class methodsFor: 'instance creation' stamp: 'je77 1/12/2001 15:19'!
openMVCViewPackage: package
	"ComSwikiLauncher openMVCViewPackage: #swikiWebServer."
	| instance window aColor startStopButton shutdownButton portButton |

	"Instance of ComSwiki Launcher"
	instance _ self new.
	instance package: package.
	"Display View"
	window _ StandardSystemView new model: instance.
	window label: 'ComSwiki Launcher'.

	aColor _ Color colorFrom: instance defaultBackgroundColor.
	"Start/Stop Button"
	startStopButton _ PluggableButtonView on: instance getState: #isOn action: #toggleState label: #startStopLabel.
	instance startStopButton: startStopButton.
	startStopButton askBeforeChanging: true.
	startStopButton
		backgroundColor: aColor;
		borderWidth: 1.
		"; onColor: (Color red) offColor: (Color green)."
	window addSubView: startStopButton.
	"Shutdown Button"
	shutdownButton _ PluggableButtonView on: instance getState: #isShutdown action: #shutdown.
	shutdownButton label: 'save & exit'; askBeforeChanging: true.
	shutdownButton
		backgroundColor: aColor;
		borderWidth: 1.
		"; onColor: aColor darker offColor: aColor."
	window addSubView: shutdownButton toRightOf: startStopButton.

	"Port Button"
	portButton _ PluggableButtonView on: instance getState: #isPort action: #changePort label: #portText.
	instance portButton: portButton.
	portButton askBeforeChanging: true.
	portButton
		backgroundColor: aColor;
		borderWidth: 1.
		"; onColor: aColor offColor: aColor."
	window addSubView: portButton toRightOf: shutdownButton.

	"open window"
	window controller open! !

!ComSwikiLauncher class methodsFor: 'private'!
shutdown
	self allInstances do: [:launcher |
		launcher isShutdown: true.
		launcher isOn ifTrue: [launcher stopServer]].
	Smalltalk snapshot: true andQuit: true.
	self allInstances do: [:launcher |
		launcher startServer.
		launcher isShutdown: false]! !

!ComSwikiLauncher class methodsFor: 'utility' stamp: 'je77 2/24/2001 13:28'!
convertOldATA
	"Convert Addresses, Templates, and Actions from Beta to Release"
	| dir bookOrShelfDir |
	dir _ FileDirectory default directoryNamed: 'swiki'.
	dir directoryNames do: [:dName |
		bookOrShelfDir _ dir directoryNamed: dName.
		(bookOrShelfDir directoryExists: 'addresses') ifTrue: [
			self convertOldATADirectory: (bookOrShelfDir directoryNamed: 'addresses')].
		(bookOrShelfDir directoryExists: 'templates') ifTrue: [
			self convertOldATADirectory: (bookOrShelfDir directoryNamed: 'templates')].
		(bookOrShelfDir directoryExists: 'actions') ifTrue: [
			self convertOldATADirectory: (bookOrShelfDir directoryNamed: 'actions')]]
! !

!ComSwikiLauncher class methodsFor: 'utility' stamp: 'je77 5/31/2001 15:44'!
convertOldATADirectory: dir
	| id xmlMeta subDir |
	id _ 1.
	xmlMeta _ WriteStream on: String new.
	xmlMeta
		nextPutAll: '<?xml version="1.0"?>';
		nextPut: Character cr;
		nextPutAll: '<meta>';
		nextPut: Character cr.
	dir fileNames do: [:fName |
		((fName endsWith: '.book') or: [fName endsWith: '.page']) ifTrue: [
			xmlMeta
				nextPutAll: '<file id="';
				nextPutAll: id asString;
				nextPutAll: '" type="';
				nextPutAll: (fName copyAfterLast: $.);
				nextPutAll: '" name="';
				nextPutAll: (fName copyUpTo: $.);
				nextPutAll: '" />';
				nextPut: Character cr.
			dir rename: fName toBe: id asString.
			id _ id + 1]].
	dir directoryNames do: [:dName |
		subDir _ dir directoryNamed: dName.
		subDir fileNames do: [:fName |
			((fName endsWith: '.book') or: [fName endsWith: '.page']) ifTrue: [
				xmlMeta
					nextPutAll: '<file id="';
					nextPutAll: id asString;
					nextPutAll: '" type="';
					nextPutAll: (fName copyAfterLast: $.);
					nextPutAll: '" name="';
					nextPutAll: (fName copyUpTo: $.);
					nextPutAll: '" category="';
					nextPutAll: dName;
					nextPutAll: '" />';
					nextPut: Character cr.
				dir rename: (subDir fullNameFor: fName) toBe: id asString.
				id _ id + 1]].
		dir deleteDirectory: dName].
	xmlMeta
		nextPutAll: '</meta>'.
	(dir newFileNamed: 'meta.xml')
		nextPutAll: xmlMeta contents;
		close
! !

!ComSwikiLauncher class methodsFor: 'utility' stamp: 'Je77 8/17/2000 08:57'!
convertOldPages
	"Conversion method used to convert old Swikis (pre-Beta 11) to the new file format.
	This is to be run after the new server is up and running."
	| oldAlerts newAlerts |
	NuSwikiPage allInstances do: [:page |
		(page settingsIncludes: 'alerts')	ifTrue: [
			oldAlerts _ page settingsAt: 'alerts'.
			newAlerts _ ''.
			(oldAlerts isKindOf: String) ifFalse: [
				oldAlerts do: [:address | newAlerts _ newAlerts, ', ', address].
				newAlerts _ newAlerts copyFrom: 3 to: (newAlerts size).
				page settingsAt: 'alerts' put: newAlerts]].
		page text: (page text).
		page write]! !


!ComancheServer methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:35'!
initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler stop ].
	connectionHandler _ ConnectionHandler
		onPort: aNumber
		handler: self
		priority: pNum.
	serviceProvider _ sp! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:30'!
connectionHandler
	^connectionHandler! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:13'!
portNumber
	self connectionHandler
		ifNotNil: [^self connectionHandler portNumber]
		ifNil: [^nil]! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:30'!
priority
	^self connectionHandler priority! !

!ComancheServer methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority: priorityLevel

	self connectionHandler priority: priorityLevel! !

!ComancheServer methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:31'!
serviceProvider
	^serviceProvider! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/18/2000 23:30'!
register
	(self class portTaken: self portNumber) ifFalse: [
		self class register: self.
		^self
	].
	self error: ('There is already an active server on port ', self portNumber asString)! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/18/2000 23:30'!
unregister
	self class unregister: self! !

!ComancheServer methodsFor: 'private' stamp: 'bolot 12/19/2000 00:23'!
value: aSocket
	[ self serviceProvider serve: aSocket ] fork! !

!ComancheServer methodsFor: 'queries' stamp: 'bolot 12/18/2000 23:14'!
isRunning
	self connectionHandler
		ifNotNil: [^self connectionHandler isRunning]
		ifNil: [^false]! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 1/31/2001 23:46'!
start
	self register.
	Socket initializeNetwork.
	self connectionHandler start! !

!ComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:44'!
stop
	self connectionHandler stop.
	self unregister.
	connectionHandler _ serviceProvider _ nil! !

!ComancheServer methodsFor: 'printing' stamp: 'bolot 12/18/2000 23:29'!
printOn: aStream
	aStream nextPutAll: ('ComancheServer port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	]! !


!ComancheServer class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 18:12'!
onPort: aNumber priority: pNum serviceProvider: sp
	^super new initializeOnPort: aNumber priority: pNum serviceProvider: sp! !

!ComancheServer class methodsFor: 'initialization' stamp: 'bolot 1/11/2001 14:56'!
initialize
	" ComancheServer initialize "

	Servers _ Dictionary new! !

!ComancheServer class methodsFor: 'accessing' stamp: 'bolot 1/11/2001 14:58'!
serverOnPort: portNumber ifAbsent: absentBlock 
	^self servers at: portNumber ifAbsent: absentBlock! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
portTaken: portNumber
	self servers at: portNumber ifAbsent: [ ^false ].
	^true! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
register: aComancheServer
	self servers at: aComancheServer portNumber ifAbsent: [
		^self servers at: aComancheServer portNumber put: aComancheServer.
	].
	self error: ('A server is already registered on port ', aComancheServer portNumber)! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
servers
	^Servers! !

!ComancheServer class methodsFor: 'registration' stamp: 'bolot 1/11/2001 14:59'!
unregister: aComancheServer
	self servers removeKey: 
		(self servers keyAtIdentityValue: aComancheServer ifAbsent: [ ^self ])! !


!ComancheService methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:56'!
initialize
	autoStart _ false! !

!ComancheService methodsFor: 'registration' stamp: 'bolot 12/16/2000 18:59'!
registerAs: aString
	self unregister.
	self class addService: self named: aString! !

!ComancheService methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:00'!
unregister
	self stop.
	self class removeService: self! !

!ComancheService methodsFor: 'startup and shutdown' stamp: 'bolot 12/16/2000 18:59'!
prepareForShutdown
	"The squeak system is about to shutdown"! !

!ComancheService methodsFor: 'startup and shutdown' stamp: 'bolot 12/16/2000 18:59'!
prepareForStartup
	"The squeak system just started up"! !

!ComancheService methodsFor: 'printing' stamp: 'bolot 12/16/2000 18:59'!
printOn: aStream
	aStream nextPutAll: ('Service: ', self name).
	self isRunning ifTrue: [ 
		aStream nextPutAll: '[running]'
	] ifFalse: [
		aStream nextPutAll: '[stopped]'
	]! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:57'!
autoStart
	^autoStart == true! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
autoStart: aBoolean
	autoStart _ aBoolean! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
log
	^log! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
log: aLog
	log _ aLog! !

!ComancheService methodsFor: 'accessing' stamp: 'bolot 12/16/2000 18:58'!
name
	^self class nameForService: self! !

!ComancheService methodsFor: 'queries' stamp: 'bolot 12/16/2000 18:58'!
isRunning
	self subclassResponsibility! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 19:00'!
start
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !

!ComancheService methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 19:00'!
stop
	"Subclasses should override this method to take whatever
	is necessary to start this service"

	"self subclassResponsibility"! !


!ComancheNetService methodsFor: 'initialization' stamp: 'bolot 2/5/2001 19:47'!
initializeOnPort: portNum priority: priorityLevel protocolAdaptor: aPA
	comancheServer _ self defaultServerClass 
		onPort: portNum
		priority: priorityLevel
		serviceProvider: self.

	protocolAdaptor _ aPA! !

!ComancheNetService methodsFor: 'initialization' stamp: 'bolot 2/5/2001 19:47'!
initializeOnPort: portNum priority: priorityLevel protocolAdaptor: aPA serverClass: serverClass
	comancheServer _ serverClass 
		onPort: portNum
		priority: priorityLevel
		serviceProvider: self.

	protocolAdaptor _ aPA! !

!ComancheNetService methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^self class defaultProtocolAdaptor! !

!ComancheNetService methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:46'!
defaultServerClass
	^self class defaultServerClass! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:46'!
start
	self comancheServer ifNotNil: [
		self comancheServer start
	]! !

!ComancheNetService methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:45'!
stop
	self comancheServer ifNotNil: [
		self comancheServer stop
	].
	comancheServer _ nil.
	module _ nil.
	protocolAdaptor _ nil! !

!ComancheNetService methodsFor: 'conversation' stamp: 'bolot 12/18/2000 23:46'!
processNetworkRequest: aNetworkRequest
	^self module process: aNetworkRequest! !

!ComancheNetService methodsFor: 'conversation' stamp: 'bolot 12/18/2000 22:47'!
serve: aSocket
	"Provided for TCP/IP conversations.  Works in conjunction with 
	a ComancheServer.  Services that do not serve TCP/IP connections
	do not need to implement this method."

	self protocolAdaptor 
		readAndWriteTo: (SocketStream on: aSocket)
		target: self! !

!ComancheNetService methodsFor: 'queries' stamp: 'bolot 1/11/2001 15:00'!
isRunning
	self comancheServer ifNotNil: [ 
		^self comancheServer isRunning
	].
	^false! !

!ComancheNetService methodsFor: 'printing' stamp: 'bolot 1/11/2001 15:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' port: ', self portNumber asString! !

!ComancheNetService methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:00'!
comancheServer
	^comancheServer! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:25'!
module
	"Answer a ComancheModule that will process network
	requests for this ComancheNetService"

	^module! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:30'!
module: aComancheModule

	module _ aComancheModule! !

!ComancheNetService methodsFor: 'accessing' stamp: 'bolot 12/18/2000 23:15'!
portNumber
	self comancheServer
		ifNotNil: [^self comancheServer portNumber]
		ifNil: [^nil]! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/27/1999 13:50'!
priority

	^self comancheServer priority! !

!ComancheNetService methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:13'!
protocolAdaptor
	"Answer the NetworkProtocolAdaptor that is being used to
	translate Socket based conversations into message based ones."
	"HttpAdaptor is the default protocol adaptor."

	^protocolAdaptor! !


!ComancheService class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 19:02'!
named: aString
	^self new registerAs: aString! !

!ComancheService class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 19:02'!
new
	^super new initialize! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
addService: aComancheService named: aString
	| tmp |
	tmp _ self services.
	(tmp includesKey: aString)
		ifTrue: [ ^self error: 'A service by the same name already exists' ].
	tmp at: aString put: aComancheService! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
nameForService: aComancheService
	^self services 
		keyAtIdentityValue: aComancheService 
		ifAbsent: [ '(unregisterd service)' ]! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
removeService: aComancheService
	| tmp |
	tmp _ self services.
	tmp removeKey: 
		(tmp keyAtIdentityValue: aComancheService ifAbsent: [ ^self ])! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
removeServiceNamed: aString
	self services removeKey: aString ifAbsent: []! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:01'!
replaceServiceNamed: aString with: aComancheService
	self services at: aString put: aComancheService! !

!ComancheService class methodsFor: 'registration' stamp: 'bolot 12/16/2000 19:02'!
services
	^Services! !

!ComancheService class methodsFor: 'snapshots' stamp: 'bolot 12/16/2000 19:02'!
shutDown
	self services do: [ :ea |
		ea prepareForShutdown
	]! !

!ComancheService class methodsFor: 'snapshots' stamp: 'bolot 12/16/2000 19:02'!
startUp
	self services do: [ :ea |
		ea prepareForStartup
	].
	self services do: [ :ea |
		ea autoStart ifTrue: [ ea start ]
	]! !

!ComancheService class methodsFor: 'accessing' stamp: 'bolot 12/16/2000 19:03'!
defaultPriority
	^Processor highIOPriority! !

!ComancheService class methodsFor: 'accessing' stamp: 'bolot 1/16/2001 11:39'!
defaultSearchPriority
	^self defaultPriority - 1! !

!ComancheService class methodsFor: 'initialization' stamp: 'bolot 12/16/2000 19:03'!
initialize
	" ComancheService initialize  "

	Services _ Dictionary new.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self! !


!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:00'!
named: aString onPort: portNumber
	^self named: aString onPort: portNumber priority: self defaultPriority! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:01'!
named: aString onPort: portNumber priority: priorityNum
	^self 
		named: aString 
		onPort: portNumber 
		priority: priorityNum 
		protocolAdaptor: self defaultProtocolAdaptor! !

!ComancheNetService class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:01'!
named: aString onPort: portNumber priority: priorityNum protocolAdaptor: aPA
	^(super named: aString) 
		initializeOnPort: portNumber priority: priorityNum protocolAdaptor: aPA! !

!ComancheNetService class methodsFor: 'defaults' stamp: 'SVP 8/13/1999 14:13'!
defaultProtocolAdaptor

	^HttpAdaptor! !

!ComancheNetService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:47'!
defaultServerClass
	^ComancheServer! !


!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:27'!
destroySockets
	socketsToDestroy ~~ nil ifTrue: [ 
		socketsToDestroy do: [ :ea | ea destroy ].
	].
	socketsToDestroy _ OrderedCollection new! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'svp 12/1/1999 18:52'!
finalize

	"Like #stop, but without the #unregister"

	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.
	self destroySockets.


! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:38'!
initializeOnPort: aNumber handler: aBlock priority: pNumber
	portNumber _ aNumber.
	handlerBlock _ aBlock.
	priority _ pNumber.
	socketsToDestroy _ OrderedCollection new! !

!ConnectionHandler methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 18:45'!
initializeProcessAtPriority: pNumber
	process _ [ self pvtListenLoop ] newProcess.
	process priority: pNumber! !

!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'bolot 12/16/2000 18:42'!
start
	self stop.
	self process resume.
	self register! !

!ConnectionHandler methodsFor: 'starting and stopping' stamp: 'bolot 12/18/2000 23:57'!
stop
	self unregister.
	process ~~ nil ifTrue: [
		process terminate.
	].
	process _ nil.

	"We do the following in a timely manner instead of relying on
	finalization because we may want to turn right around and start
	listening again.  If an old socket is still around an listening, it may
	interfere with a new one's ability to hear."

	self destroySockets! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
register

	^self class register: self! !

!ConnectionHandler methodsFor: 'registry' stamp: 'svp 12/1/1999 18:46'!
unregister

	^self class unregister: self! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 2/22/2001 16:58'!
newListener
	| listener |

	self flag: #todo. "listener _ self socketClass newTCP."
	listener _ Socket newTCP.

	"backlog is how many simultaneous connections to accept at the same time"
	listener listenOn: portNumber backlogSize: 10.
	^listener! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 12/19/2000 00:24'!
pvtListenLoop
	[
		self pvtNewListenLoop
	] on: Error do: [ :ex |
		process _ nil.
		self destroySockets.
	]! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 12/19/2000 00:24'!
pvtNewListenLoop
	| socket listener |

	listener _ self newListener.
	self socketsToDestroy add: listener.	

	"If the listener is not valid then the we cannot use the
	BSD style accept() mechanism."
	listener isValid ifFalse: [^self pvtOldListenLoop].
	[ true ] whileTrue: [
		socket _ listener waitForAcceptUntil: (Socket deadlineSecs: 10).
		(socket notNil and: [ socket isConnected ])
			ifTrue: [
				handlerBlock value: socket.
				socket _ nil]
			ifFalse: [
				socket notNil ifTrue: [socket destroy].
				listener isValid
					ifFalse: [(Delay forMilliseconds: 100) wait.
						listener destroy.
						listener _ self newListener].
			].
	]! !

!ConnectionHandler methodsFor: 'private' stamp: 'bolot 12/19/2000 00:24'!
pvtOldListenLoop
	"see comment on ConnectionQueue>>oldStyleListenLoop"
	| socket |
	socket _ nil.

	[ true ] whileTrue: [
		(socket == nil) ifTrue: [
			"try to create a new socket for listening"
			socket _ Socket createIfFail: [ nil ]].

		(socket == nil)
		ifTrue: [(Delay forMilliseconds: 100) wait]
		ifFalse: [
			socket isUnconnected ifTrue: [ socket listenOn: portNumber ].
			socket waitForConnectionUntil: (Socket deadlineSecs: 10).
			socket isConnected
				ifTrue: ["connection established"
					"mutex critical: [" handlerBlock value: socket "]".
					socket _ nil]
				ifFalse: [
					socket isWaitingForConnection
						ifFalse: [socket destroy. socket _ nil]].
		].
	]! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
portNumber
	^portNumber! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
priority
	^priority! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'bolot 1/11/2001 15:01'!
process
	process == nil ifTrue: [
		self initializeProcessAtPriority: self priority.
	].
	^process! !

!ConnectionHandler methodsFor: 'accessing' stamp: 'svp 12/1/1999 17:58'!
socketsToDestroy

	socketsToDestroy == nil ifTrue: [
		socketsToDestroy _ OrderedCollection new.
	].
	^socketsToDestroy! !

!ConnectionHandler methodsFor: 'printing' stamp: 'bolot 1/11/2001 15:02'!
printOn: aStream
	aStream nextPutAll: (self class name asString, ' port: ', self portNumber asString).
	self isRunning ifTrue: [
		aStream nextPutAll: ' [running]'
	] ifFalse:[
		aStream nextPutAll: ' [stopped]'
	]! !

!ConnectionHandler methodsFor: 'queries' stamp: 'svp 12/1/1999 17:51'!
isRunning

	^process ~~ nil! !


!ConnectionHandler class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 18:43'!
onPort: aNumber handler: aBlock priority: pNum
	^self new
		initializeOnPort: aNumber
		handler: aBlock
		priority: pNum! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
register: anObject

	self registry add: anObject! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:49'!
registry

	Registry == nil ifTrue: [
		Registry := WeakRegistry new
	].
	^Registry! !

!ConnectionHandler class methodsFor: 'registry' stamp: 'svp 12/1/1999 18:50'!
unregister: anObject

	self registry remove: anObject ifAbsent: [ ]! !


!Date methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:32'!
asTimeStamp
	"Answer the receiver as a TimeStamp at midnight."

	^TimeStamp date: self time: (Time fromSeconds: 0)! !

!Date methodsFor: 'printing' stamp: 'bolot 2/22/2001 17:00'!
yyyymmdd
	"no delimiters"
	"Date today yyyymmdd"

	^ self printFormat: #(3 2 1 $- 1 1 2)! !


!DisplayCamModule methodsFor: 'kom-processing' stamp: 'bolot 4/2/2001 16:21'!
process: request
	^Display magnifyBy: 1/8 ! !


!Form methodsFor: 'comanche processing' stamp: 'bolot 2/14/2000 15:59'!
asHttpResponseTo: request
	^HttpResponse fromMIMEDocument: self asWebImage! !

!Form methodsFor: 'comanche processing' stamp: 'bolot 12/18/2000 22:31'!
asWebImage
	"return a MIMEDocument"
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	GIFReadWriter putForm: (self asFormOfDepth: 8) onStream: aStream.
	aStream reset.
	^MIMEDocument contentType: MIMEDocument contentTypeGif content: aStream! !


!HelloWorldModule methodsFor: 'comanche' stamp: 'bolot 2/5/2001 19:33'!
process: request
	^'Hello World!!'! !


!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:25'!
at: key
	^(super at: key) first! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:27'!
at: key put: value
	(self includesKey: key)
		ifFalse: [super at: key put: (OrderedCollection new)].

	(super at: key) add: value.

	^value! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:25'!
booleanAt: key
	^(self at: key) = 'true'! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:34'!
booleansAt: key
	^(self rawAt: key) collect: [:value | value == 'true']! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:33'!
numberAt: key
	^[(self at: key) asNumber]
		ifError: [:err :rcvr | Float nan]! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:34'!
numbersAt: key
	^(self rawAt: key) collect: [:value |
		[value asNumber] ifError: [:err :rcvr | Float nan]]! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:30'!
rawAt: key
	^super at: key! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:35'!
stringAt: key
	^self at: key! !

!HttpFormDictionary methodsFor: 'accessing' stamp: 'bolot 6/22/2001 12:35'!
stringsAt: key
	^(self rawAt: key) copy! !


!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:28'!
addKey: key value: value toForm: dict multipleValues: boolean
	boolean
		ifTrue: [dict at: key put: value]
		ifFalse: [(dict includesKey: key)
			ifFalse: [dict at: key put: value]
			ifTrue: [dict at: key modify: [:oldValue | oldValue, value]]]! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:06'!
decodeUrlEncodedForm: string
	^self decodeUrlEncodedForm: string multipleValues: false! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 6/22/2001 12:27'!
decodeUrlEncodedForm: string multipleValues: boolean
	| dict key value start end eqSignPos more |
	dict _ boolean ifTrue: [HttpFormDictionary new] ifFalse: [Dictionary new].
	string isEmptyOrNil ifTrue: [^dict].
	more _ true.
	start _ 1.
	[end _ string indexOf: $& startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	eqSignPos _ string indexOf: $= startingAt: start.
	(eqSignPos > end or: [eqSignPos == 0])
		ifTrue: [key _ (key _ string copyFrom: start to: end) unescapePercents.
			value _ '']
		ifFalse: [key _ (key _ string copyFrom: start to: eqSignPos-1) unescapePercents.
			value _ (value _ string copyFrom: eqSignPos+1 to: end) unescapePercents].
	self addKey: key value: value toForm: dict multipleValues: boolean.
	start _ end + 2.
	more] whileTrue.

	^dict! !

!HttpParser class methodsFor: 'utilities' stamp: 'bolot 12/16/2000 03:21'!
parseHttpHeader: string
	| dict key value start end more colonPos fieldDelims lastKey keyValueDelim |
	dict _ Dictionary new.
	string isEmptyOrNil ifTrue: [^dict].
	fieldDelims _ String crlf asCharacterSet.
	keyValueDelim _ $:.
	more _ true.
	start _ end _ 1.
	lastKey _ ''.
	[end _ string indexOfAnyOf: fieldDelims startingAt: start.
	end == 0
		ifTrue: [end _ string size. more _ false]
		ifFalse: [end _ end - 1].
	(end >= start and: [start < string size])
		ifTrue: [
			(string at: start) isSeparator
				ifTrue:
					[dict
						at: lastKey
						modify: [:item | item, (string copyFrom: start to: end)]]
				ifFalse:
					[colonPos _ string indexOf: keyValueDelim startingAt: start.
					(colonPos > end or: [colonPos == 0])
						ifTrue:
							[key _ (string copyFrom: start to: end) asLowercase.
							value _ '']
						ifFalse:
							[key _ (string copyFrom: start to: colonPos-1) asLowercase.
							value _ (string copyFrom: colonPos+1 to: end) withBlanksTrimmed]].
			key isEmpty
				ifFalse: [dict at: key put: value.
					lastKey _ key.
					key _ ''].
			start _ string skipDelimiters: String crlf startingAt: end+1].
	more] whileTrue.

	^dict! !


!HttpRedirect methodsFor: 'as yet unclassified' stamp: 'bolot 3/31/2001 15:39'!
asHttpResponseTo: request

	^(HttpResponse
			status: #tempMoved
			description: 'Temporarily moved to: <A HREF="', location, '">', location, '</A>')
		fieldAt: 'Location' put: location;
		fieldAt: 'URI' put: location;
	yourself! !

!HttpRedirect methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:24'!
signalLocation: aString

	location _ aString.
	self signal.! !


!HttpResponse methodsFor: 'initialize-release' stamp: 'SVP 8/26/1999 08:06'!
destroy

	self contents close.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType

	^contentType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contentType: aMimeType

	contentType _ aMimeType! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
contents

	^contents! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:54'!
contents: aStream

	contents _ aStream! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString

	^self fields at: aString! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsent: absBlock

	^self fields at: aString ifAbsent: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:08'!
fieldAt: aString ifAbsentPut: absBlock

	^self fields at: aString ifAbsentPut: absBlock! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fieldAt: aString put: aValue

	self fields at: aString put: aValue! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/17/1999 11:07'!
fields

	fields ifNil: [
		fields _ Dictionary new.
	].

	^fields! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 12/16/1999 11:33'!
httpVersion

	^'HTTP/1.1'! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request

	^request
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/23/1999 11:00'!
request: anHttpRequest

	request _ anHttpRequest.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status

	^status! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/16/1999 11:53'!
status: aSymbol

	status _ aSymbol! !

!HttpResponse methodsFor: 'accessing' stamp: 'svp 11/18/1999 13:03'!
statusCode

	^(StatusCodes at: self status) key.
! !

!HttpResponse methodsFor: 'accessing' stamp: 'SVP 8/26/1999 10:41'!
statusCodeAndReason
	| tmp |

	tmp _ StatusCodes at: self status.
	^tmp key, ' ', tmp value.! !

!HttpResponse methodsFor: 'comanche processing' stamp: 'bolot 1/11/2001 17:51'!
asHttpPartialResponseBlock: aBlock
	^(self as: HttpPartialResponse)
		producerBlock: aBlock;
		yourself! !

!HttpResponse methodsFor: 'comanche processing'!
asHttpResponseTo: aRequest
	^self! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:28'!
pvtWriteContentLengthOn: aStream
	aStream
		nextPutAll: 'Content-length: ';
		nextPutAll: self contents size asString;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:27'!
pvtWriteContentTypeOn: aStream
	aStream
		nextPutAll: 'Content-type: ';
		nextPutAll: self contentType;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:28'!
pvtWriteContentsOn: aStream
	| chunkSize cnts |
	chunkSize _ self defaultChunkSize.
	cnts _ self contents.

	[ cnts atEnd ] whileFalse: [
		aStream nextPutAll: (cnts next: chunkSize); flush.
		"Processor yield."
	]! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:26'!
pvtWriteFieldsOn: aStream
	fields isEmptyOrNil ifTrue: [ ^self ].

	fields keysAndValuesDo: [ :k :v |
		aStream
			nextPutAll: k;
			nextPutAll: ': ';
			nextPutAll: v;
			nextPutAll: String crlf
	]! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 6/21/2001 04:03'!
pvtWriteServerOn: aStream
	aStream
		nextPutAll: 'Server: Comanche/kom-4.10';
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:29'!
pvtWriteStatusOn: aStream
	aStream
		nextPutAll: self httpVersion;
		nextPut: $ ;
		nextPutAll: self statusCodeAndReason;
		nextPutAll: String crlf! !

!HttpResponse methodsFor: 'responding' stamp: 'bolot 12/16/2000 09:30'!
writeOn: aStream

	| tmp |
	"Header"

	tmp _ WriteStream on: ''.
	self pvtWriteStatusOn: tmp.
	self pvtWriteServerOn: tmp.
	self pvtWriteFieldsOn: tmp.
	self pvtWriteContentTypeOn: tmp.
	self pvtWriteContentLengthOn: tmp.
	tmp nextPutAll: String crlf.
	aStream nextPutAll: tmp contents; flush.

	"Body"
	self pvtWriteContentsOn: aStream! !

!HttpResponse methodsFor: 'defaults' stamp: 'bolot 2/9/2001 18:30'!
defaultChunkSize

	^ 131072! !

!HttpResponse methodsFor: 'defaults' stamp: 'SVP 8/12/1999 14:08'!
defaultContentType

	^MIMEDocument contentTypeHtml! !


!HttpPartialResponse methodsFor: 'accessing' stamp: 'bolot 1/11/2001 17:49'!
producerBlock: aBlock
	producerBlock _ aBlock! !

!HttpPartialResponse methodsFor: 'responding' stamp: 'bolot 1/11/2001 17:50'!
pvtWriteContentLengthOn: aStream
	"do nothing, since the length is not known yet"
	self flag: #todo. "in HTTP/1.1, can set chunking"! !

!HttpPartialResponse methodsFor: 'responding' stamp: 'bolot 1/11/2001 17:49'!
pvtWriteContentsOn: aStream
	producerBlock value: aStream! !


!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 16:43'!
initialize
	"  HttpResponse initialize  "

	self initializeStatusCodes.! !

!HttpResponse class methodsFor: 'initialization' stamp: 'SVP 8/16/1999 12:17'!
initializeStatusCodes
	"  HttpResponse initializeStatusCodes  "

	StatusCodes _ IdentityDictionary new
		at: #ok				put: ('200' -> 'OK');
		at: #created			put: ('201' -> 'Created');
		at: #accepted		put: ('202' -> 'Accepted');
		at: #noContent		put: ('204' -> 'No Content');
		at: #permMoved		put: ('301' -> 'Moved Permanently');
		at: #tempMoved		put: ('302' -> 'Moved Temporarily');
		at: #notModified		put: ('304' -> 'Not Modified');
		at: #badRequest		put: ('400' -> 'Bad Request');
		at: #unauthorized	put: ('401' -> 'Unauthorized');
		at: #forbidden		put: ('403' -> 'Forbidden');
		at: #notFound		put: ('404' -> 'Not Found');
		at: #serverError		put: ('500' -> 'Internal Server Error');
		at: #notImplemented	put: ('501' -> 'Not Implemented');
		at: #badGateway	put: ('502' -> 'Bad Gateway');
		at: #serviceUnavailable	put: ('503' -> 'Service Unavailable');
 		yourself.! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromFileStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: (AsyncFile from: aStream);
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromMIMEDocument: aMIMEDoc
	| content |

	content _ aMIMEDoc content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aMIMEDoc mimeType;
		contents: content;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:02'!
fromRedirect: redirect
	| tmp |
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: (tmp _ redirect fullHttpUrl);
		fieldAt: 'pragma' put: 'no-cache';
		fieldAt: 'Cache-control' put: 'private';
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', tmp,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 12/21/1999 13:09'!
fromStream: aStream

	^self new
		status: #ok;
		"fieldAt: 'Expires' put: 'Thu, 15 Apr 2010 20:00:00 GMT';"
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: aStream mimeType;
		contents: aStream;
		yourself

	! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 18:27'!
fromString: aString

	^self new
		status: #ok;
		"fieldAt: 'Cache-Control' put: 'max-age=86400';"
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'bolot 1/11/2001 15:02'!
fromUrl: aUrl
	^self new
		status: #tempMoved;
		fieldAt: 'Location' put: aUrl asString;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: '<head><title>Object moved</title></head>
<body><h1>Object Moved</h1>This object may be found <a HREF="', aUrl asString,'">here</a>.</body>');
		yourself! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'svp 11/30/1999 14:41'!
status: aSymbol description: aString

	^self new
		status: aSymbol;
		contentType: MIMEDocument contentTypeHtml;
		contents: (ReadStream on: aString);
		yourself
! !

!HttpResponse class methodsFor: 'instance creation' stamp: 'SVP 8/17/1999 19:04'!
status: aSymbol mimeDescription: aMIMEDocument
	| content |

	content _ aMIMEDocument content.
	(content isKindOf: String) ifTrue: [
		content _ ReadStream on: content.
	].
	^self new
		status: aSymbol;
		contentType: aMIMEDocument mimeType;
		contents: content;
		yourself
! !


!HttpUnauthorized methodsFor: 'as yet unclassified' stamp: 'bolot 3/31/2001 15:41'!
asHttpResponseTo: request

	^(HttpResponse status: #unauthorized description: 'Unauthorized for: ', realm)
		fieldAt: 'WWW-Authenticate' put: 'Basic realm="', realm, '"';
		yourself! !

!HttpUnauthorized methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:27'!
signalRealm: aString

	realm _ aString.
	self signal.! !


!HttpUnauthorized class methodsFor: 'as yet unclassified' stamp: 'bolot 12/16/2000 02:28'!
for: realm
	^self new signalRealm: realm! !


!IdFormatter methodsFor: 'accessing'!
endBlock: aBlock
	endBlock _ aBlock! !

!IdFormatter methodsFor: 'accessing'!
formatter: aBlock
	formatter _ aBlock! !

!IdFormatter methodsFor: 'accessing'!
idBlock: aBlock
	idBlock _ aBlock! !

!IdFormatter methodsFor: 'accessing'!
settingsAt: key put: value
	settings ifNil: [settings _ Dictionary new].
	settings at: key put: value.! !

!IdFormatter methodsFor: 'accessing'!
startBlock: aBlock
	startBlock _ aBlock! !

!IdFormatter methodsFor: 'accessing'!
transitionBlock: aBlock
	transitionBlock _ aBlock! !

!IdFormatter methodsFor: 'private'!
id: text
	^(idBlock copy fixTemps) value: text! !

!IdFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 09:47'!
endAfter: oldId on: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((transitionBlock copy fixTemps) value: oldId value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	stream nextPutAll: ((endBlock copy fixTemps) value: id).
	^id! !

!IdFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 09:49'!
singleOn: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((startBlock copy fixTemps) value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	stream nextPutAll: ((endBlock copy fixTemps) value: id).
	^id! !

!IdFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 09:49'!
startOn: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((startBlock copy fixTemps) value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	^id! !

!IdFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 09:48'!
transitionAfter: oldId on: stream text: text request: request response: response shelf: shelf book: book page: page
	| id strippedText |

	id _ self id: text.
	((text size) > (id size))
		ifTrue: [strippedText _ text copyFrom: (id size + 1) to: text size]
		ifFalse: [strippedText _ ''].
	stream nextPutAll: ((transitionBlock copy fixTemps) value: oldId value: id).
	stream nextPutAll: ((formatter copy fixTemps) valueWithArguments: (Array with: strippedText with: request with: response with: shelf with: book with: page)).
	^id! !


!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 12/7/2000 17:02'!
anchor
	| instance |

	instance _ self new.
	instance idBlock: [:text | '@'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | '<a name="', (PageFormatter toSafeLocation: text), '"></a>', String cr].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 13:18'!
append
	| instance |

	instance _ self new.
	instance idBlock: [:text | '+'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | book formatPageTemplate: 'append' request: request response: response shelf: shelf page: page].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 09:42'!
appendRender
	| instance |

	instance _ self new.
	instance idBlock: [:text | '+'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | ''].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 1/3/2001 11:25'!
break
	| instance |

	instance _ self new.
	instance idBlock: [:text | '_'].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | (book formatBookAction: 'bar' request: request response: response shelf: shelf), String cr].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 12/7/2000 17:01'!
heading: formatter
	| instance |

	instance _ self new.
	instance idBlock: [:text | (text beginsWith: '!!!!')
		ifTrue: [(text beginsWith: '!!!!!!')
			ifTrue: ['!!!!!!']
			ifFalse: ['!!!!']]
		ifFalse: ['!!']].
	instance startBlock: [:id | '<h', (4 - id size) asString, '>'].
	instance endBlock: [:id | '</h', (4 - id size) asString, '>', String cr].
	instance transitionBlock: [:idOld :idNew | '</h', (4 - idOld size) asString, '>', String cr, '<h', (4 - idNew size) asString, '>'].
	instance formatter: [:text :request :response :shelf :book :page | formatter format: text request: request response: response shelf: shelf book: book page: page].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 12/7/2000 17:01'!
leaveAlone
	| instance |

	instance _ self new.
	instance idBlock: [:text | ''].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | text, String cr].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 13:09'!
list: formatter
	| instance match return |

	instance _ self new.
	instance idBlock: [:text | return _ 1.
		[(text size >= return) and: [((text at: return) = $-) or: [(text at: return) = $#]]]
			whileTrue: [return _ return + 1].
		text copyFrom: 1 to: (return-1)].
	instance startBlock: [:id | return _ ''.
		id do: [:char | (char = $-)
			ifTrue: [return _ return, '<ul>', String cr]
			ifFalse: [return _ return, '<ol>', String cr]].
		return].
	instance endBlock: [:id | return _ ''.
		id do: [:char | (char = $-)
			ifTrue: [return _ '</ul>', String cr, return]
			ifFalse: [return _ '</ol>', String cr, return]].
		return].
	instance transitionBlock: [:idOld :idNew | return _ ''.
		match _ 1.
		[((idOld size >= match) and: [idNew size >= match]) and: [(idOld at: match) = (idNew at: match)]] whileTrue: [match _ match + 1].
		(idOld size > (match - 1)) ifTrue: [(idOld copyFrom: match to: idOld size) do: [:char | (char = $-) ifTrue: [return _ '</ul>', String cr, return] ifFalse: [return _ '</ol>', String cr, return]]].
		(idNew size > (match - 1)) ifTrue: [(idNew copyFrom: match to: idNew size) do: [:char | (char = $-) ifTrue: [return _ return, '<ul>', String cr] ifFalse: [return _ return, '<ol>', String cr]]].
		return].
	instance formatter: [:text :request :response :shelf :book :page | '<li>', (formatter format: text request: request response: response shelf: shelf book: book page: page), String cr].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 13:10'!
preformatted: formatter
	| instance |

	instance _ self new.
	instance idBlock: [:text | '='].
	instance startBlock: [:id | '<pre>'].
	instance endBlock: [:id | '</pre>', String cr].
	instance transitionBlock: [:idOld :idNew | String cr].
	instance formatter: [:text :request :response :shelf :book :page | formatter format: text request: request response: response shelf: shelf book: book page: page].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 4/4/2001 14:36'!
saveAppend
	| instance |

	instance _ self new.
	instance idBlock: [:text | ''].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page |
		"Add appendId setting"
		(request settingsIncludes: 'appendId')
			ifTrue: [request settingsAt: 'appendId' put: 1 + (request settingsAt: 'appendId')]
			ifFalse: [request settingsAt: 'appendId' put: 1].
		((request settingsAt: 'appendId') asString = (request fieldsKey: 'appendid'))
			ifTrue: [(request settingsIncludes: 'formId')
				ifTrue: [((request settingsAt: 'formId') = (request fieldsKey: 'formid'))
					ifTrue: [
						request settingsAt: 'appendSuccess' put: true.
						((text = '+') ifTrue: [''] ifFalse: [(text copyFrom: 2 to: text size), String cr]), ((page settingsAt: 'saveFormatter' ifAbsent: [book settingsAt: 'saveFormatter']) format: (request fieldsKey: 'append') request: request response: response shelf: shelf book: book page: page), String cr, text, String cr]
					ifFalse: [text, String cr]]
				ifFalse: [
					request settingsAt: 'appendSuccess' put: true.
					((text = '+') ifTrue: [''] ifFalse: [(text copyFrom: 2 to: text size), String cr]), ((page settingsAt: 'saveFormatter' ifAbsent: [book settingsAt: 'saveFormatter']) format: (request fieldsKey: 'append') request: request response: response shelf: shelf book: book page: page), String cr, text, String cr]]
			ifFalse: [text, String cr]].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 13:10'!
table: formatter
	| instance return |

	instance _ self new.
	instance idBlock: [:text | '|'].
	instance startBlock: [:id | '<table border=1 cellspacing=0 cellpadding=5>', String cr, '<tr>'].
	instance endBlock: [:id | '</tr>', String cr, '</table>', String cr].
	instance transitionBlock: [:idOld :idNew | '</tr>', String cr, '<tr>'].
	instance formatter: [:text :request :response :shelf :book :page | return _ ''.
		(text findTokens: '|') do: [:token | return _ return, '<td>', (formatter format: token request: request response: response shelf: shelf book: book page: page), '</td>'].
		return].
	^instance! !

!IdFormatter class methodsFor: 'instance creation' stamp: 'je77 5/1/2000 13:10'!
text: formatter
	| instance |

	instance _ self new.
	instance idBlock: [:text | ''].
	instance startBlock: [:id | ''].
	instance endBlock: [:id | ''].
	instance transitionBlock: [:idOld :idNew | ''].
	instance formatter: [:text :request :response :shelf :book :page | (formatter format: text request: request response: response shelf: shelf book: book page: page), '<br>', String cr].
	^instance! !


!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
form
	^form! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
form: aForm
	form _ aForm! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:49'!
name
	^name! !

!KomHtmlFormEntity methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:49'!
name: aName
	name _ aName! !


!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
collection
	^collection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:37'!
collection: aCollection
	collection _ aCollection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:38'!
defaultSelection
	^defaultSelection! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:38'!
defaultSelection: anObject
	defaultSelection _ anObject! !

!KomHtmlSelectionList methodsFor: 'accessing' stamp: 'bolot 6/20/2001 22:51'!
sspStreamOn: strm
	strm nextPutAll: '<select>';
		cr.

	collection associationsDo: [:assoc |
		strm nextPutAll: '<option value="';
			nextPutAll: assoc key asString encodeForHTTP;
			nextPutAll: '">';
			nextPutAll: assoc value asString encodeForHTTP;
			nextPutAll: '</option>';
			cr].

	strm nextPutAll: '</select>';
		cr
! !


!KomHtmlSelectionList class methodsFor: 'instance creation' stamp: 'bolot 6/20/2001 22:42'!
newFrom: anObject
	(anObject isKindOf: Dictionary)
		ifTrue: [^self new collection: anObject].
	(anObject isKindOf: SequenceableCollection)
		ifTrue: [^self new collection: ((1 to: anObject size) collect: [:i | i -> (anObject at: i)])].
	(anObject isKindOf: Collection)
		ifTrue: [^self new collection: (anObject collect: [:obj | obj -> obj])].

	^self new collection: {anObject}! !


!LTDComancheServer methodsFor: 'initialize-release' stamp: 'bolot 2/5/2001 19:27'!
limitConnectionsTo: anInteger
	"limit to anInteger number of connections"
	maxThreads := anInteger! !

!LTDComancheServer methodsFor: 'private' stamp: 'bolot 2/5/2001 19:29'!
value: aSocket
	"handle a new connection"
	ltdSema wait.
	[
		[ self serviceProvider serve: aSocket  ]
			ensure:
		[ ltdSema signal ].
	] fork! !

!LTDComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/5/2001 19:45'!
start
	self register.
	Socket initializeNetwork.
	maxThreads ifNotNil: [ 
		ltdSema := Semaphore new.
		maxThreads timesRepeat: [ ltdSema signal ] ].
	self connectionHandler start! !


!LTDComancheService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:50'!
defaultServerClass
	^LTDComancheServer! !


!LineFormatter methodsFor: 'accessing' stamp: 'je77 5/26/2001 16:55'!
addDefaultFormatter: anIdFormatter
	(formatters = nil) ifTrue: [formatters _ Dictionary new].
	formatters at: LF put: anIdFormatter! !

!LineFormatter methodsFor: 'accessing'!
addExceptionFrom: startsWith to: endsWith using: formatter
	| element |

	(exceptions = nil) ifTrue: [exceptions _ OrderedCollection new].
	element _ Array new: 3.
	element
		at: 1 put: startsWith;
		at: 2 put: endsWith;
		at: 3 put: formatter.
	exceptions add: element.! !

!LineFormatter methodsFor: 'accessing'!
addFormatter: anIdFormatter at: char
	(formatters = nil) ifTrue: [formatters _ Dictionary new].
	formatters at: char put: anIdFormatter! !

!LineFormatter methodsFor: 'accessing' stamp: 'je77 5/26/2001 16:44'!
convertToCrlf: aBoolean
	convertToCrlf _ aBoolean! !

!LineFormatter methodsFor: 'accessing'!
exceptions
	^exceptions! !

!LineFormatter methodsFor: 'accessing'!
formatters
	^formatters! !

!LineFormatter methodsFor: 'accessing'!
storeID
	^storeID! !

!LineFormatter methodsFor: 'accessing'!
storeID: id
	storeID _ id! !

!LineFormatter methodsFor: 'private' stamp: 'je77 5/26/2001 16:56'!
combine: formattedText with: exceptionCollection
	| i return pos1 pos2 |

	i _ 0.
	return _ WriteStream on: (String new: (formattedText size * 2)).
	pos1 _ 1.
	[(pos2 _ formattedText indexOf: LF startingAt: pos1 ifAbsent: [0]) == 0] whileFalse: [
		(pos1 = pos2) ifFalse: [return nextPutAll: (formattedText copyFrom: pos1 to: (pos2 - 1))].
		return nextPutAll: (exceptionCollection at: (i _ i + 1) ifAbsent: ['']).
		pos1 _ pos2 + 1].
	(pos1 > formattedText size) ifFalse: [return nextPutAll: (formattedText copyFrom: pos1 to: formattedText size)].
	^return contents! !

!LineFormatter methodsFor: 'private' stamp: 'je77 5/26/2001 16:56'!
formattedTextFrom: text request: request response: response shelf: shelf book: book page: page
	| return start end coll types id |

	return _ ReadWriteStream on: (String new: text size).
	coll _ OrderedCollection new.
	types _ OrderedCollection new.
	start _ 1.
	[start <= (text size)] whileTrue: [
		end _ text indexOf: CR startingAt: start ifAbsent: [end _ text size + 1].
		coll add: ((start = end) ifTrue: [''] ifFalse: [text copyFrom: start to: end-1]).
		start _ end + 1].
	(coll size = 0) ifTrue: [^return contents].
	coll do: [:element | types add: (self typeFrom: element)].
	(coll size = 1) ifTrue: [(types at: 1) singleOn: return text: (coll at: 1) request: request response: response shelf: shelf book: book page: page.
		^return contents].
	((types at: 2) = (types at: 1))
		ifTrue: [id _ (types at: 1) startOn: return text: (coll at: 1) request: request response: response shelf: shelf book: book page: page]
		ifFalse: [id _ (types at: 1) singleOn: return text: (coll at: 1) request: request response: response shelf: shelf book: book page: page].
	(coll size > 2) ifTrue: [
		2 to: (coll size - 1) do: [:i | ((types at: i) = (types at: i+1))
			ifTrue: [((types at: i) = (types at: i-1))
				ifTrue: [id _ (types at: i) transitionAfter: id on: return text: (coll at: i) request: request response: response shelf: shelf book: book page: page]
				ifFalse: [id _ (types at: i) startOn: return text: (coll at: i) request: request response: response shelf: shelf book: book page: page]]
			ifFalse: [((types at: i) = (types at: i-1))
				ifTrue: [id _ (types at: i) endAfter: id on: return text: (coll at: i) request: request response: response shelf: shelf book: book page: page]
				ifFalse: [id _ (types at: i) singleOn: return text: (coll at: i) request: request response: response shelf: shelf book: book page: page]]]].
	((types last) = (types at: (types size - 1)))
		ifTrue: [id _ (types last) endAfter: id on: return text: (coll last) request: request response: response shelf: shelf book: book page: page]
		ifFalse: [id _ (types last) singleOn: return text: (coll last) request: request response: response shelf: shelf book: book page: page].
	^return contents
! !

!LineFormatter methodsFor: 'private' stamp: 'je77 5/26/2001 16:58'!
splitTextAndExceptionsFrom: text request: request response: response shelf: shelf book: book page: page
	| col formatterText start tempStart matchStart matchException matchEnd matchText |

	col _ OrderedCollection new.
	formatterText _ ReadWriteStream on: (String new: text size).
	start _ 1.
	[start <= (text size)] whileTrue: [
		matchStart _ text size.
		matchException _ nil.
		exceptions do: [:exception | tempStart _ text findString: (exception at: 1) startingAt: start.
			((tempStart > 0) and: [tempStart < matchStart]) ifTrue: [matchStart _ tempStart.
				matchException _ exception]].
		matchException
			ifNil: ["No more found"
				formatterText nextPutAll: (text copyFrom: start to: text size).
				start _ text size + 1]
			ifNotNil: [
				(start = matchStart) ifFalse: [formatterText nextPutAll: (text copyFrom: start to: matchStart-1)].
				formatterText nextPut: LF.
				matchEnd _ text findString: (matchException at: 2) startingAt: matchStart.
				(matchEnd = 0)
					ifTrue: ["End of text"
						matchText _ text copyFrom: (matchStart + (matchException at: 1) size) to: text size.
						start _ text size + 1]
					ifFalse: [
						matchText _ text copyFrom: (matchStart + (matchException at: 1) size) to: (matchEnd - 1).
						start _ matchEnd + (matchException at: 2) size].
				col add: (((matchException at: 3) copy fixTemps) valueWithArguments: (Array with: matchText with: request with: response with: shelf with: book with: page))]].
	^Array with: formatterText contents with: col! !

!LineFormatter methodsFor: 'private'!
storeString
	"Overwrite of Object method to save space for storing"
	(storeID) ifNotNil: ["Check to make sure this storeID is valid"
		(self class respondsTo: storeID)
			ifTrue: [^'(', self class asString, ' ', storeID asString, ')']].
	^super storeString! !

!LineFormatter methodsFor: 'private' stamp: 'je77 5/26/2001 16:57'!
typeFrom: text
	^(text size = 0)
		ifTrue: [formatters at: LF]
		ifFalse: [formatters at: (text at: 1) ifAbsent: [formatters at: LF]]! !

!LineFormatter methodsFor: 'processing' stamp: 'je77 5/26/2001 16:47'!
format: text request: request response: response shelf: shelf book: book page: page
	| textAndException crText |

	"textAndException will be a 2 element array with the readToFormatText and the exceptionCollection"
	textAndException _ self splitTextAndExceptionsFrom: text request: request response: response shelf: shelf book: book page: page.
	crText _ self combine: (self formattedTextFrom: textAndException first request: request response: response shelf: shelf book: book page: page) with: textAndException last.
	^convertToCrlf
		ifTrue: [TextFormatter crToCrlf: crText]
		ifFalse: [crText]! !


!LineFormatter class methodsFor: 'instance creation' stamp: 'je77 5/26/2001 16:45'!
appendFormatter
	| instance |

	instance _ self new.
	instance storeID: #appendFormatter.
	instance convertToCrlf: false.
	instance addExceptionFrom: '<html>' to: '</html>' using: [:text :request :response :shelf :book :page | '<html>', (TextFormatter crlfToCr: text), '</html>'].
	instance addExceptionFrom: '<HTML>' to: '</HTML>' using: [:text :request :response :shelf :book :page | '<HTML>', (TextFormatter crlfToCr: text), '</HTML>'].
	instance addFormatter: (IdFormatter saveAppend) at: $+.
	instance addDefaultFormatter: (IdFormatter leaveAlone).
	^instance! !

!LineFormatter class methodsFor: 'instance creation' stamp: 'je77 5/26/2001 16:45'!
renderFormatter
	| instance textFormatter listFormatter |

	instance _ self new.
	instance storeID: #renderFormatter.
	instance convertToCrlf: true.
	textFormatter _ PageFormatter new.
	textFormatter
		initialize;
		addRenderInternalLinks;
		addTagIntegrity;
		addShowSpecialCharacters;
		addRenderUploadLinks.
	instance addExceptionFrom: '<html>' to: '</html>' using: [:text :request :response :shelf :book :page | TextFormatter crToCrlf: text].
	instance addExceptionFrom: '<HTML>' to: '</HTML>' using: [:text :request :response :shelf :book :page | TextFormatter crToCrlf: text].
	instance addFormatter: (IdFormatter break) at: $_.
	instance addFormatter: (IdFormatter anchor) at: $@.
	instance addFormatter: (IdFormatter appendRender) at: $+.
	instance addFormatter: (IdFormatter heading: textFormatter) at: $!!.
	listFormatter _ IdFormatter list: textFormatter.
	instance addFormatter: (listFormatter) at: $-.
	instance addFormatter: (listFormatter) at: $#.
	instance addFormatter: (IdFormatter table: textFormatter) at: $|.
	instance addFormatter: (IdFormatter preformatted: textFormatter) at: $=.
	instance addDefaultFormatter: (IdFormatter text: textFormatter).
	^instance! !

!LineFormatter class methodsFor: 'instance creation' stamp: 'je77 5/26/2001 16:45'!
showFormatter
	| instance textFormatter listFormatter |

	instance _ self new.
	instance storeID: #showFormatter.
	instance convertToCrlf: true.
	textFormatter _ PageFormatter new.
	textFormatter
		initialize;
		addInternalLinks;
		addTagIntegrity;
		addShowSpecialCharacters;
		addUploadLinks.
	instance addExceptionFrom: '<html>' to: '</html>' using: [:text :request :response :shelf :book :page | TextFormatter crToCrlf: text].
	instance addExceptionFrom: '<HTML>' to: '</HTML>' using: [:text :request :response :shelf :book :page | TextFormatter crToCrlf: text].
	instance addFormatter: (IdFormatter break) at: $_.
	instance addFormatter: (IdFormatter anchor) at: $@.
	instance addFormatter: (IdFormatter append) at: $+.
	instance addFormatter: (IdFormatter heading: textFormatter) at: $!!.
	listFormatter _ IdFormatter list: textFormatter.
	instance addFormatter: (listFormatter) at: $-.
	instance addFormatter: (listFormatter) at: $#.
	instance addFormatter: (IdFormatter table: textFormatter) at: $|.
	instance addFormatter: (IdFormatter preformatted: textFormatter) at: $=.
	instance addDefaultFormatter: (IdFormatter text: textFormatter).
	^instance! !

!LineFormatter class methodsFor: 'initialize-release' stamp: 'je77 5/26/2001 16:55'!
initialize
	CR _ Character cr.
	LF _ Character lf! !


!MIMEDocument methodsFor: 'access' stamp: 'svp 12/16/1999 11:55'!
mimeType

	^self type! !


!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 1/11/2001 18:35'!
defaultMIMEdatabase
	| d |
	(d _ Dictionary new)
	at: 'html' put: 'text/html';
	at: 'htm' put: 'text/html';
	at: 'xml' put: 'text/xml';
	at: 'txt' put: 'text/plain';
	at: 'c' put: 'text/plain';
	at: 'gif' put: 'image/gif';
	at: 'jpg' put: 'image/jpeg';
	at: 'jpeg' put: 'image/jpeg';
	at: 'png' put: 'image/png';
	at: 'xbm' put: 'image/x-xbitmap';
	at: 'mid' put: 'audio/midi';
	at: 'doc' put: 'application/ms-word-document'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 6/22/2001 02:28'!
extendedMIMEdatabase
	| d |
	(d _ self defaultMIMEdatabase)
	at: 'sts' put: 'application/x-squeak-source';
	at: 'pr' put: 'application/x-squeak-project';
	at: 'hqx' put: 'application/mac-binhex40';
	at: 'doc' put: 'application/msword';
	at: 'xls' put: 'application/x-excel';
	at: 'ppt' put: 'application/mspowerpoint';
	at: 'ppz' put: 'application/mspowerpoint';
	at: 'pot' put: 'application/mspowerpoint';
	at: 'pps' put: 'application/mspowerpoint';
	at: 'cpt' put: 'application/mac-compactpro';
	at: 'pdf' put: 'application/pdf';
	at: 'ps' put: 'application/postscript';
	at: 'ai' put: 'application/postscript';
	at: 'eps' put: 'application/postscript';
	at: 'rtf' put: 'text/rtf';
	at: 'bin' put: 'application/octet-stream';
	at: 'dms' put: 'application/octet-stream';
	at: 'lha' put: 'application/octet-stream';
	at: 'lzh' put: 'application/octet-stream';
	at: 'exe' put: 'application/octet-stream';
	at: 'class' put: 'application/octet-stream';
	at: 'zip' put: 'application/zip';
	at: 'gtar' put: 'application/x-gtar';
	at: 'swf' put: 'application/x-shockwave-flash';
	at: 'sit' put: 'application/x-stuffit';
	at: 'tar' put: 'application/x-tar';
	at: 'au' put: 'audio/basic';
	at: 'snd' put: 'audio/basic';
	at: 'mid' put: 'audio/midi';
	at: 'midi' put: 'audio/midi';
	at: 'mpga' put: 'audio/mpeg';
	at: 'mp2' put: 'audio/mpeg';
	at: 'mp3' put: 'audio/mpeg';
	at: 'aiff' put: 'audio/x-aiff';
	at: 'aif' put: 'audio/x-aiff';
	at: 'aifc' put: 'audio/x-aiff';
	at: 'rm' put: 'audio/x-pn-realaudio';
	at: 'ram' put: 'audio/x-pn-realaudio';
	at: 'rpm' put: 'audio/x-pn-realaudio-plugin';
	at: 'ra' put: 'audio/x-realaudio';
	at: 'wav' put: 'audio/x-wav';
	at: 'css' put: 'text/css';
	at: 'mpeg' put: 'video/mpeg';
	at: 'mpg' put: 'video/mpeg';
	at: 'mpe' put: 'video/mpeg';
	at: 'qt' put: 'video/quicktime';
	at: 'mov' put: 'video/quicktime';
	at: 'avi' put: 'video/x-msvideo';
	at: 'movie' put: 'video/x-sgi-movie'.
	^d! !

!MIMEDocument class methodsFor: 'initialize-release' stamp: 'bolot 12/19/2000 00:53'!
initialize
	"MIMEDocument initialize"

	self resetMIMEdatabase! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'svp 12/16/1999 10:35'!
contentTypeGif
	^'image/gif'! !


!MacFileDirectory methodsFor: 'private' stamp: 'je77 4/9/2001 11:20'!
primRename: oldFileFullName to: newFileFullName 
	"Macs do not deal well with renaming, so copy and delete instead."
	| fromFile toFile |
	fromFile _ FileStream readOnlyFileNamed: oldFileFullName.
	toFile _ FileStream newFileNamed: newFileFullName.
	"Copy"
	self copyFile: fromFile toFile: toFile.
	fromFile close.
	toFile close.
	"Delete original"
	self class deleteFilePath: oldFileFullName! !


!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:38'!
initializeFrom: aDictionary
	| str fileName fieldName idx contentType |
	"PRE: all keys in aDictionary are low-case"
	header _ aDictionary.
	properties _ Dictionary new.
self flag: #todo.
	"parse the header, pick out: filename, etc."

	str _ (header at: 'content-disposition' ifAbsent: ['']).
	fileName _ fieldName _ ''.

	idx _ str findString: 'filename='.
	idx > 0 ifTrue:
		[fileName _ str copyFrom: idx + 10 to: (str indexOf: $" startingAt: idx+10) - 1].
	properties at: #fileName put: fileName.

	idx _ str findString: 'name='.
	idx > 0 ifTrue:
		[fieldName _ str copyFrom: idx + 6 to: (str indexOf: $" startingAt: idx+6) - 1].
	properties at: #fieldName put: fieldName.

	contentType _ header at: 'content-type' ifAbsent: [MIMEDocument defaultContentType].
	properties at: #contentType put: contentType.

"Transcript show: 'field=', fieldName; cr; show: 'file=', fileName; cr;
	show: 'content-type=', contentType; cr."
! !

!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:39'!
multipartBoundary: aString
	multipartBoundary _ aString! !

!MultipartChunk methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 02:39'!
request: aRequest
	request _ aRequest! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
contentType
	^properties at: #contentType! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fieldName
	^properties at: #fieldName! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fileName
	^properties at: #fileName! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:36'!
fileName: aString
	properties at: #fileName put: aString! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:38'!
multipartBoundary
	^multipartBoundary! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:39'!
saveToStream: outStream
	"Save this chunk's body in outStream"
	"the caller is responsible for closing outStream (if applicable)"
	| body origFileName idx str |

	self setSavedFlag.

	origFileName _ self fileName.

	body _ request stream nextChunk.
	"IE4 for Mac appends 128 bytes of Mac file system info - must remove"
	"this fix assumes that body size >= 128"
	((body at: 1) asciiValue = 0
			and: [(body at: 2) asciiValue = origFileName size
				and: [(body copyFrom: 3 to: origFileName size + 2) = origFileName]])
		ifTrue: [body _ body copyFrom: 129 to: body size].
	[(idx _ body findString: multipartBoundary) = 0]
		whileTrue:
			[idx _ body size - multipartBoundary size + 1 max: 1.
			str _ request stream nextChunk.
			outStream nextPutAll: (body copyFrom: 1 to: idx - 1).
			body _ (body copyFrom: idx to: body size) , str].
	" save the last chunk in the file "
	outStream nextPutAll: (body copyFrom: 1 to: idx-3). " idx-1 - String crlf size "
	request stream putDataBack: (body copyFrom: idx to: body size).
! !

!MultipartChunk methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:37'!
setSavedFlag
	properties at: #isSaved put: true! !

!MultipartChunk methodsFor: 'testing' stamp: 'bolot 12/16/2000 02:36'!
isSaved
	^(properties at: #isSaved ifAbsent: [false]) == true! !


!MultipartChunk class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 02:41'!
from: aDictionary
	aDictionary isEmptyOrNil
		ifTrue: [^nil].
	^self new initializeFrom: aDictionary! !


!NetworkProtocolAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 00:42'!
beginConversation
	"Process the stream, converting protocol requests into messages, and
		answers into protocol responses"

	self subclassResponsibility! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
log

	^log
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
log: aLog

	log _ aLog
! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
readStream

	^readStream! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
target

	^target! !

!NetworkProtocolAdaptor methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:43'!
writeStream

	^writeStream! !

!NetworkProtocolAdaptor methodsFor: 'dispatching' stamp: 'bolot 12/16/2000 00:43'!
dispatchRequest: aNetworkRequest
	"<Stream> Dispatches a NetworkRequest as a method to the target and
	answers a stream to be transferred to the client in the response"

	^self target processNetworkRequest: aNetworkRequest
! !

!NetworkProtocolAdaptor methodsFor: 'initialize-release' stamp: 'bolot 12/18/2000 22:45'!
initializeReadFrom: rStream writeTo: wStream target: aTarget
	readStream _ rStream.
	writeStream _ wStream.
	target _ aTarget! !


!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 5/11/2001 13:46'!
beginConversation
	startTime _ Time millisecondClockValue.
	[
		[(self pvtReadRequest) ifNotNil:
			[self pvtGetResponseAndDo:
				[self pvtWriteResponse.
				self pvtDestroyGently.
				"self pvtWriteLogAndDestroy"]
			].
		self isPersistentConnection and: [Preferences keepAliveConnections]] whileTrue.
		self pvtDestroy
	] on: Error do: [ :ex |
		(Preferences standaloneServer) ifTrue:
			[self pvtDestroy.
			self pvtHandleError: ex]
		ifFalse: "re-raise the exception"
			[ex signal].
	]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 4/12/2001 19:48'!
isPersistentConnection
	^request ifNotNil: [request isPersistentConnection] ifNil: [false]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/18/2000 23:19'!
pvtDestroy
	[
		self readStream close.
		self writeStream close.
		response ~~ nil ifTrue: [ response destroy ].
		readStream _ writeStream _ target _ response _ nil.
	]
	ifError: [:err :rcvr | "ignore"]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 2/11/2001 01:29'!
pvtDestroyGently
	"for persistent connections, only destroy response"
	[
		response ~~ nil ifTrue: [ response destroy ].
		response _ nil.
	]
	ifError: [:err :rcvr | "ignore"]! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 3/31/2001 17:52'!
pvtGetResponseAndDo: blk
	[
		response _ ((self dispatchRequest: request) asHttpResponseTo: request)
			request: request;
			yourself.
	] on: Error do: [ :ex |
self flag: #todo. "figure out how to handle this error"
"ex signal."
"'error in HttpAdaptor>>pvtGetResponseAndDo:' displayAt: 10@160."

		response _ (ex asHttpResponseTo: request)
			request: request;
			yourself.
		blk value.
		self pvtHandleError: ex.
		^self
	].

	blk value! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:46'!
pvtHandleError: ex
	"place holder"! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:48'!
pvtLogActivity
	"place holder"! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 09:03'!
pvtReadRequest

	request _ HttpRequest readFromStream: self readStream.
	"Processor activeProcess contextAt: #request put: request"
	^request! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 12/16/2000 08:48'!
pvtWriteLogAndDestroy
	self pvtWriteResponse.
	self pvtLogActivity.
	self pvtDestroy! !

!HttpAdaptor methodsFor: 'processing' stamp: 'bolot 7/4/2001 18:52'!
pvtWriteResponse
	[
		(self isPersistentConnection and: [Preferences keepAliveConnections])
			ifTrue: [response fieldAt: 'Connection' put: 'Keep-Alive']
			ifFalse: [response fieldAt: 'Connection' put: 'close'].
		response writeOn: self writeStream
	]
	on: Error do: [ :ex | 
		"If we're here, it's likely because something on the other
		end of the socket it hosed.  Do nothing, a log entry will 
		be written and the socket and response will be destroyed"
	]! !


!NetworkProtocolAdaptor class methodsFor: 'instance creation' stamp: 'bolot 12/19/2000 00:26'!
readAndWriteTo: aStream target: aTarget
	^self new
		initializeReadFrom: aStream writeTo: aStream target: aTarget;
		beginConversation;
		yourself! !


!NetworkRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:35'!
method

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 00:36'!
url

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 00:36'!
initialize

	properties _ IdentityDictionary new.! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isGetRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isHeaderRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'testing' stamp: 'bolot 12/16/2000 00:37'!
isPostRequest

	self subclassResponsibility! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol

	^properties at: aSymbol! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol ifAbsent: absentBlock

	^properties at: aSymbol ifAbsent: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol ifAbsentPut: absentBlock

	^properties at: aSymbol ifAbsentPut: absentBlock! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
propertyAt: aSymbol put: anObject

	properties at: aSymbol put: anObject! !

!NetworkRequest methodsFor: 'properties' stamp: 'bolot 12/16/2000 00:38'!
removePropertyAt: aSymbol

	properties removeKey: aSymbol! !


!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:04'!
destroy
	stream close.
	stream _ nil! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:01'!
initRemoteAddress
	(stream respondsTo: #remoteAddress) ifTrue: [
		self remoteAddress: stream remoteAddress.
	]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 1/11/2001 15:07'!
initStatusString: aString
	| statusLine |
	statusLine _ aString findTokens: ' '.
	(statusLine size = 3 or: [statusLine = 2])
		ifTrue: [self method: statusLine first.
			rawUrl _ statusLine second.
			url _ rawUrl copyUpTo: $?.
			"self protocol: statusLine third"]
		ifFalse: [^nil]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 6/22/2001 13:18'!
initializeFromStream: aStream
	stream _ aStream.
	self initRemoteAddress.
	self timestamp: Time totalSeconds.
	[(self readRequestHeaderFrom: stream)
		ifNil: [^nil]
	] ifError: [:err :rcvr | ^nil]! !

!HttpRequest methodsFor: 'initialize-release' stamp: 'bolot 5/14/2001 00:54'!
readRequestHeaderFrom: aStream
	| reqHeader |

	(reqHeader _ [aStream upToAll: self endOfRequestHeaderMarker]
			ifError: [:err :rcvr | ''])
		isEmpty ifTrue: [^nil].
	aStream match: self endOfRequestHeaderMarker.

	reqHeader _ BufferStream on: reqHeader.
	(self initStatusString: (reqHeader upToAll: String crlf))
		ifNil: [^nil].
	reqHeader match: String crlf.

	self header: (HttpParser parseHttpHeader: reqHeader upToEnd).
	self propertyAt: #headerBytes put: stream inBytes.

	self postFields. "force reading/parsing post fields"! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:03'!
contentLength

	^self propertyAt: #contentLength ifAbsentPut: [
		(header at: 'content-length' ifAbsent: [0]) asNumber
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 1/4/2000 18:49'!
contentType
	| i contentType |
	^self propertyAt: #contentType ifAbsentPut: [
		contentType _ self header at: 'content-type' ifAbsent: [self defaultContentType].
		contentType ifNotNil: [i _ contentType indexOf: $;. "get rid of charset field"
			i > 0 ifTrue: [contentType _ contentType copyFrom: 1 to: i-1]].
		contentType asLowercase]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:08'!
endOfRequestHeaderMarker
	^self class endOfRequestHeaderMarker! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/24/2000 15:45'!
getFields
	"retrieve fields encoded in the URL: http://aha/ha?a=1&b=2"
	| in |
	^self propertyAt: #getFields ifAbsentPut: [
		((in _ rawUrl indexOf: $?) > 0) ifTrue: [
			HttpParser decodeUrlEncodedForm: 
				(rawUrl copyFrom: (in + 1) to: rawUrl size)
		] ifFalse: [
			Dictionary new.
		].
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:13'!
header
	^header! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:18'!
header: aDict
	header _ aDict! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 2/11/2001 01:23'!
host
	^self propertyAt: #host ifAbsentPut: [self header at: 'host' ifAbsent: []]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
localAddress
	"Answer the address of the request originator"
	^self propertyAt: #localAddress ifAbsentPut: [
		(stream respondsTo: #localAddress) ifTrue: [
			stream localAddress
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
localPort
	"Answer the address of the request originator"
	^self propertyAt: #localPort ifAbsentPut: [
		(stream respondsTo: #localPort) ifTrue: [
			stream localPort
		] ifFalse: [
			nil
		]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:14'!
method
	^self propertyAt: #method ifAbsent: ['GET']! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/19/2000 00:16'!
method: aString
	self propertyAt: #method put: aString! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:40'!
postFields
	"Answer the multipart fields for a post request (if in fact this is a
	POST request"

	^self propertyAt: #postFields ifAbsentPut: [
		" parse POST fields in the body of request, if it's standard form data "

		(self isPostRequest and: [ 
			self contentType = MIMEDocument contentTypeFormData 
		]) ifTrue: [
			HttpParser decodeUrlEncodedForm: 
				(stream next: self contentLength).
		] ifFalse: [
			Dictionary new
		].
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
protocol
	^self propertyAt: #protocol ifAbsent: [self defaultProtocol]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:58'!
rawUrl
	^rawUrl! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
referer
	^self propertyAt: #referer ifAbsentPut: [
		header at: 'referer' ifAbsent: [ nil ]
	]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:57'!
remoteAddress
	^self propertyAt: #remoteAddress ifAbsent: [nil]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 09:18'!
remoteAddress: aRemoteAddress
	self propertyAt: #remoteAddress put: aRemoteAddress! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:59'!
stream
	^stream! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:00'!
timestamp

	^self propertyAt: #timestamp ifAbsent: [ nil ]! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:00'!
timestamp: aTimestamp

	self propertyAt: #timestamp put: aTimestamp! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:58'!
url
	^url! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 6/21/2001 04:03'!
url: aUrl
	url _ aUrl! !

!HttpRequest methodsFor: 'accessing' stamp: 'bolot 12/16/2000 02:23'!
user
	"currently, only basic authentication is supported"
	| userID i |
	userID _ self header at: 'authorization' ifAbsent: [^nil].
	(userID notNil and: [(i _ userID findString: 'Basic ') > 0])
		ifTrue: [userID _ userID copyFrom: i+6 to: userID size]
		ifFalse: [userID _ nil].
	^userID! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 1/11/2001 15:05'!
multipartBoundary
	| str idx |
	"boundary specification in the HTTP header looks like:
	Content-Type: multipart/form-data; boundary=BOUNDARY "

	^self propertyAt: #multipartBoundary ifAbsentPut: [
		(self contentType beginsWith: MIMEDocument contentTypeMultipart)
			ifTrue: ["contentType gets lowercased, so access the raw header"
				str _ header at: 'content-type' ifAbsent: [ '' ].
				idx _ str indexOf: $=.
				'--', (str copyFrom: idx + 1 to: str size)]
			ifFalse: [ nil ]]! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 12/16/2000 02:39'!
multipartFormFieldsDo: aBlock
	"USAGE:
	request multipartFormFieldsDo: [:chunk |
		chunk saveToStream: aStream]."
	"NOTE: if the chunk is not saved, save it after aBlock"

	| mChunk aFieldValue |
	(self method = 'POST' and: [self contentType = MIMEDocument contentTypeMultipart])
		ifFalse: [^nil].

	[stream match: self multipartBoundary.
	stream match: '--']
	whileFalse:
	[
	stream match: String crlf.

	mChunk _ self nextChunkHeader.
	aBlock value: mChunk.
	mChunk flag: #todo. "review chunk saving logic"
	mChunk isSaved
		ifFalse: [
			mChunk fileName isEmptyOrNil
				ifFalse: [mChunk saveToStream: (DummyStream on: String new)]
				ifTrue: [
					aFieldValue _ String streamContents: [:aStream |
						mChunk saveToStream: aStream].
					self postFields at: mChunk fieldName put: aFieldValue
				]
		].

	]! !

!HttpRequest methodsFor: 'multipart forms' stamp: 'bolot 12/16/2000 03:05'!
nextChunkHeader
	"Read the next multipart data chunk's header"

	| string dict mChunk |
	string _ stream upToAll: self endOfRequestHeaderMarker.
	stream match: self endOfRequestHeaderMarker.

	dict _ HttpParser parseHttpHeader: string.
	mChunk _ MultipartChunk from: dict.
	mChunk request: self.
	mChunk multipartBoundary: self multipartBoundary.
	^mChunk! !

!HttpRequest methodsFor: 'printing' stamp: 'bolot 12/16/2000 02:09'!
printOn: printStream
	printStream nextPutAll: self class name;
		nextPutAll: ' (URL=', self url asString;
		nextPutAll: '; protocol=', self protocol asString;
		nextPutAll: '; header=', self header asString;
		nextPutAll: '; getFields=', self getFields asString;
		nextPutAll: '; postFields=', self postFields asString;
		nextPutAll: ')'! !

!HttpRequest methodsFor: 'printing' stamp: 'bolot 12/16/2000 02:09'!
writeOn: aStream
	"this can be used to form a client-side request and send it over network"
	aStream nextPutAll: self method, ' ', self url, ' ', self protocol, String crlf.
	self header keysAndValuesDo: [:key :value |
		aStream nextPutAll: key, ': ', value, String crlf].
	aStream nextPutAll: String crlf.
	aStream nextPutAll: self body asString! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:27'!
badRequest
	^HttpBadRequest signal! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:26'!
redirectTo: aUrl
	^HttpRedirect new signalLocation: aUrl! !

!HttpRequest methodsFor: 'response' stamp: 'bolot 12/16/2000 02:28'!
unauthorizedFor: realm
	^HttpUnauthorized new signalRealm: realm! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultContentType

	^self class defaultContentType! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultMethod

	^self class defaultMethod! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:52'!
defaultProtocol

	^self class defaultProtocol! !

!HttpRequest methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:40'!
defaultUrl

	^self class defaultUrl! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isGetRequest

	^self method = 'GET'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isHeaderRequest

	^self method = 'HEAD'! !

!HttpRequest methodsFor: 'testing' stamp: 'SVP 8/25/1999 08:55'!
isPostRequest

	^self method = 'POST'! !

!HttpRequest methodsFor: 'connection mgt' stamp: 'bolot 2/11/2001 01:21'!
isPersistentConnection
	| connectionHeader |
	^self propertyAt: #persistentConnection ifAbsentPut:
		[connectionHeader _ self header at: 'connection' ifAbsent: [nil].
		connectionHeader
			ifNil: [false]
			ifNotNil: [connectionHeader asLowercase = 'keep-alive']
		]! !


!NetworkRequest class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 00:42'!
new

	^super new initialize! !


!HttpRequest class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 03:08'!
readFromStream: aStream

	^self new initializeFromStream: aStream! !

!HttpRequest class methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 09:35'!
initialize
	EndOfRequestHeaderMarker _ String crlf, String crlf! !

!HttpRequest class methodsFor: 'accessing' stamp: 'bolot 12/16/2000 03:23'!
endOfRequestHeaderMarker
	"This marks the end of an HTTP request (two consecutive CR-LFs)"

	^EndOfRequestHeaderMarker! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/12/1999 11:39'!
defaultContentType

	^MIMEDocument defaultContentType! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultMethod

	^'GET'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:50'!
defaultProtocol

	^'HTTP/1.0'! !

!HttpRequest class methodsFor: 'defaults' stamp: 'SVP 8/11/1999 11:51'!
defaultUrl

	^''! !


!PWSComancheServer methodsFor: 'initialize-release' stamp: 'bolot 1/31/2001 23:56'!
initializeOnPort: aNumber priority: pNum serviceProvider: sp
	connectionHandler ifNotNil: [ connectionHandler destroy ].
	portNumber _ aNumber.
	priority _ pNum.
	serviceProvider _ sp! !

!PWSComancheServer methodsFor: 'initialize-release' stamp: 'bolot 1/31/2001 23:54'!
serverLoop
	"see PWS class>>loopOnPort:loggingTo:"

	| socket |
	[true] whileTrue: [
		socket _ connectionHandler getConnectionOrNil.
		socket notNil
			ifTrue: [self value: socket]
			ifFalse: [(Delay forMilliseconds: 100) wait]
	]! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:55'!
portNumber
	^portNumber! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:56'!
priority
	^priority! !

!PWSComancheServer methodsFor: 'accessing' stamp: 'bolot 1/31/2001 23:57'!
priority: aNum
	"do nothing"! !

!PWSComancheServer methodsFor: 'queries' stamp: 'bolot 1/31/2001 23:58'!
isRunning
	^self connectionHandler notNil! !

!PWSComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/1/2001 00:03'!
start
	self register.
	Socket initializeNetwork.
	connectionHandler _ ConnectionQueue portNumber: portNumber queueLength: 6.
	serverProcess _ [self serverLoop] newProcess.
	serverProcess priority: Processor lowIOPriority.
	serverProcess resume.! !

!PWSComancheServer methodsFor: 'starting and stopping' stamp: 'bolot 2/1/2001 00:00'!
stop
	self connectionHandler ifNotNil: [self connectionHandler destroy].
	serverProcess ifNotNil: [serverProcess terminate].
	self unregister.
	connectionHandler _ serviceProvider _ nil! !


!PWSComancheService class methodsFor: 'defaults' stamp: 'bolot 2/5/2001 19:49'!
defaultServerClass
	^PWSComancheServer! !


!PartialResponseModule methodsFor: 'kom-processing' stamp: 'bolot 1/11/2001 18:02'!
process: request
	| response |
	response _ HttpPartialResponse fromString: ''.
	response producerBlock: [:aStream | self writeToStream: aStream] copy fixTemps.
	^response ! !

!PartialResponseModule methodsFor: 'kom-processing' stamp: 'bolot 1/11/2001 18:24'!
writeToStream: aStream
	aStream nextPutAll: 'aloha <BR>'.
	aStream nextPutAll: 'bloha <BR>'.! !


!Preferences class methodsFor: 'standard queries'!
keepAliveConnections
	^ self
		valueOfFlag: #keepAliveConnections
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries'!
standaloneServer
	^ self
		valueOfFlag: #standaloneServer
		ifAbsent: [true]! !

!Preferences class methodsFor: 'initial values' stamp: 'bolot 4/2/2001 16:17'!
initialValuesKomanche
	"initial values for Comanche"

	^ #(	
		(standaloneServer					true	(comanche))
		(keepAliveConnections				false	(comanche))
)
	"Preferences resetCategoryInfo"


! !

!Preferences class methodsFor: 'help' stamp: 'bolot 4/2/2001 16:16'!
helpMsgsKomanche
		^ #(

(standaloneServer
	'If true, then errors are suppressed.
If false, all errors are popped up')

(keepAliveConnections
	'Keep connections alive or terminate after each request')

		)! !


!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 2/22/2001 18:47'!
processBlock: aBlock
	processBlock := aBlock! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:47'!
urlPattern
	^urlPattern ifNil: ['*']! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:45'!
urlPattern: aString
	urlPattern _ aString! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:43'!
urlPrefix: aString
	urlPattern _ aString, '*'! !

!SinglePlugModule methodsFor: 'accessing' stamp: 'bolot 5/1/2001 02:44'!
urlSuffix: aString
	urlPattern _ '*', aString! !

!SinglePlugModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 02:56'!
matchesUrl: aUrlString
	^self urlPattern match: aUrlString! !

!SinglePlugModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 02:46'!
process: request
	^(self matchesUrl: request url)
		ifTrue: [processBlock value: request]
		ifFalse: []! !


!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:52'!
displayCam
	"SinglePlugModule displayCam"
	"this creates an equivalent of DisplayCamModule"
	| module |
	module _ self newBlock: [:request | Display magnifyBy: 1/8].
	module urlPrefix: '/desktopcam'.
	^module
! !

!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:53'!
helloWorld
	"SinglePlugModule helloWorld"
	"this creates an equivalent of HelloWorldModule"
	| module |
	module _ self newBlock: [:request | 'Hello World!!'].
	module urlPrefix: '/helloworld'.
	^module
! !

!SinglePlugModule class methodsFor: 'examples' stamp: 'bolot 5/1/2001 02:54'!
redirectToDisplayCam
	"SinglePlugModule redirectToDisplayCam"
	| module |
	module _ self newBlock: [:request | request redirectTo: '/desktopcam'].
	module urlPrefix: '/desktopcamera'.
	^module
! !

!SinglePlugModule class methodsFor: 'instance creation' stamp: 'bolot 3/26/2001 21:55'!
newBlock: aBlock
	^self new processBlock: aBlock! !

!SinglePlugModule class methodsFor: 'instance creation' stamp: 'bolot 3/26/2001 21:55'!
newPlug: aBlock
	^self newBlock: aBlock! !


!Socket methodsFor: 'queries' stamp: 'bolot 10/21/1999 13:24'!
isOtherEndConnected
	| status |
	"Return true if this socket is connected or if the other end hasn't signalled a close yet."

	socketHandle == nil ifTrue: [^ false].
	status _ (self primSocketConnectionStatus: socketHandle).
	^(status = Connected or: [ status = ThisEndClosed ])! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 10/22/1999 11:29'!
discardReceivedData
	"Discard any data received up until now, and return the number of bytes discarded."

	| buf totalBytesDiscarded |
	buf _ String new: 10000.
	totalBytesDiscarded _ 0.
	[self isOtherEndConnected and: [ self dataAvailable ]] whileTrue: [
		totalBytesDiscarded _
			totalBytesDiscarded + (self receiveDataInto: buf)].
	^ totalBytesDiscarded
! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 12/18/2000 19:27'!
getData
	"Get some data"

	| buf bytesRead |
	(self waitForDataUntil: Socket standardDeadline) ifFalse: [self error: 'getData timeout'].
	buf _ String new: 4000.
	bytesRead _ self primSocket: socketHandle receiveDataInto: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: (bytesRead max: 0)! !

!Socket methodsFor: 'sending-receiving' stamp: 'bolot 5/14/2001 00:59'!
getDataQuicker
	"Get some data, as getData, but with a shorter timeout"

	| buf bytesRead |
	(self waitForDataUntil: Socket quickDeadline) ifFalse: [self error: 'getData timeout'].
	buf _ String new: 4000.
	bytesRead _ self primSocket: socketHandle receiveDataInto: buf startingAt: 1 count: buf size.
	^ buf copyFrom: 1 to: (bytesRead max: 0)! !

!Socket methodsFor: 'waiting' stamp: 'bolot 12/18/2000 19:30'!
waitForDisconnectionUntil: deadline
	"Wait up until the given deadline for the the connection to be broken. Return true if it is broken by the deadline, false if not."
	"Note: The client should know the the connect is really going to be closed (e.g., because he has called 'close' to send a close request to the other end) before calling this method.
JMM 00/5/17 note that other end can close which will terminate wait"

	| extraBytes status |
	extraBytes _ 0.
	status _ self primSocketConnectionStatus: socketHandle.
	[((status = Connected) or: [status = ThisEndClosed]) and:
	 [Time millisecondClockValue < deadline]] whileTrue: [
		self dataAvailable
			ifTrue: [extraBytes _ extraBytes + self discardReceivedData].
		semaphore waitTimeoutMSecs: (deadline - Time millisecondClockValue).
		status _ self primSocketConnectionStatus: socketHandle].

	^ status ~= Connected
! !


!Socket class methodsFor: 'utilities' stamp: 'bolot 5/14/2001 00:59'!
quickDeadline
	^ self deadlineSecs: 10! !


!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 19:51'!
folder
	^folder ifNil: [folder _ FileDirectory default directoryNamed: 'htdocs']! !

!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 20:09'!
process: request
	| filePath |
	filePath _ (request url copyFrom: 2 to: request url size) translateWith: self slashXlat.
	^self folder fileNamed: filePath! !

!StaticFileModule methodsFor: 'kom processing' stamp: 'bolot 2/9/2001 20:09'!
slashXlat
	slashXlat ifNil: [slashXlat _ (0 to: 255) as: ByteArray].
	slashXlat at: ($/ asciiValue + 1) put: FileDirectory pathNameDelimiter asciiValue.
	^ slashXlat! !


!Stream methodsFor: 'accessing' stamp: 'SVP 8/26/1999 08:06'!
close

	"Do nothing by default"! !

!Stream methodsFor: 'accessing' stamp: 'SVP 8/12/1999 14:25'!
mimeType

	^MIMEDocument defaultContentType! !

!Stream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!BufferStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:42'!
on: aString
	buffer _ aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:42'!
reset
	"hack"
	self on: ''! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:36'!
contents
	"return contents, non-destructive"
	^buffer copyFrom: startPos to: endPos! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/19/2000 00:21'!
match: aString
	self size < aString size
		ifTrue: [^false].
	(self next: aString size) = aString
		ifTrue: [^true]
		ifFalse: [self on: aString, self upToEnd].
	^false! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:37'!
next
	"return the next character"
	"consume it"
	^buffer at: (startPos _ startPos + 1) - 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:37'!
next: anInteger
	"return next anInteger characters"
	"consumes them"
	^buffer copyFrom: startPos to: (startPos _ startPos + anInteger) - 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
nextPutAll: aString
	buffer _ (buffer copyFrom: startPos to: endPos), aString.
	startPos _ 1.
	endPos _ buffer size! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:43'!
size
	^endPos - startPos + 1! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upTo: aChar
	"return String up to aChar, but not including"
	"consumes the returned string"
	| i |
	i _ buffer indexOf: aChar startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upToAll: aString
	"return a string before the occurence of aString, if any"
	"consume it"
	| i |
	i _ buffer findString: aString startingAt: startPos.
	(i <= 0 or: [i > endPos])
		ifTrue: [^self upToEnd].
	^self next: (i-startPos)! !

!BufferStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:38'!
upToEnd
	"return buffer contents,
	consume all my buffer"
	| string |
	string _ self contents.
	self reset.
	^string! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
includes: aChar
	"answer whether buffer includes aChar within bounds"
	| tmp |
	tmp _ buffer indexOf: aChar startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
includesAll: aString
	"answer whether the buffer contains aString"
	| tmp |
	tmp _ buffer findString: aString startingAt: startPos.
	^(tmp >= startPos) and: [tmp <= endPos]! !

!BufferStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:37'!
isEmpty
	^self size <= 0! !

!BufferStream methodsFor: 'printing' stamp: 'bolot 12/16/2000 01:41'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self size asString, ')'! !


!BufferStream class methodsFor: 'instance creation' stamp: 'bolot 12/16/2000 01:44'!
on: aString
	^self basicNew on: aString! !


!PositionableStream methodsFor: 'string functions' stamp: 'je77 2/19/2001 15:10'!
bufferSize
	^5000! !

!PositionableStream methodsFor: 'string functions' stamp: 'je77 2/19/2001 15:33'!
copyFrom: pos1 to: pos2
	self position: pos1 - 1.
	^self next: pos2 - pos1 + 1! !

!PositionableStream methodsFor: 'string functions' stamp: 'je77 2/19/2001 14:16'!
findString: subString
	"Answer the index of subString within the receiver, starting at start. If 
	the receiver does not contain subString, answer 0."
	^self findString: subString startingAt: 1.! !

!PositionableStream methodsFor: 'string functions' stamp: 'je77 2/19/2001 14:18'!
findString: subString startingAt: start
	^self findString: subString startingAt: start caseSensitive: true! !

!PositionableStream methodsFor: 'string functions' stamp: 'je77 2/19/2001 16:55'!
findString: subString startingAt: start caseSensitive: caseSensitive
	"Use buffers to find the subString on this stream"
	| buffer pos return |
	pos _ start - 1.
	[self atEnd] whileFalse: [
		self position: pos.
		buffer _ self next: self bufferSize.
		return _ buffer findString: subString startingAt: 1 caseSensitive: caseSensitive.
		(return = 0) ifFalse: [
			self position: 0.
			^pos + return].
		pos _ pos + buffer size - subString size].
	^0! !


!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 2/5/2001 15:46'!
close
	self flush.
	self socket closeAndDestroy: 30! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:46'!
initialize
	self resetStatus.
	self setBuffered.
	self resetInStream.
	self resetOutStream! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:46'!
initialize: aSocket
	self initialize.
	self socket: aSocket! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:52'!
resetInStream
	inStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:52'!
resetOutStream
	outStream _ BufferStream on: ''! !

!SocketStream methodsFor: 'initialize-release' stamp: 'bolot 12/16/2000 01:53'!
resetStatus
	(status _ Dictionary new)
	at: #inDataCount put: 0;
	at: #outDataCount put: 0! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
localAddress
	^status at: #localAddress! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
localPort
	^status at: #localPort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
remoteAddress
	^status at: #remoteAddress! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:48'!
remotePort
	^status at: #remotePort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:50'!
setBuffered
	status at: #buffered put: true! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:50'!
setUnBuffered
	status at: #buffered put: false! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 2/5/2001 15:44'!
socket
	^socket! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 2/5/2001 15:40'!
socket: aSocket
	socket _ aSocket.
	status at: #localAddress put: aSocket localAddress.
	status at: #localPort put: aSocket localPort.
	status at: #remoteAddress put: aSocket remoteAddress.
	status at: #remotePort put: aSocket remotePort! !

!SocketStream methodsFor: 'accessing' stamp: 'bolot 12/16/2000 01:51'!
status
	^status! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/16/2000 03:04'!
match: aString
	"position past the next occurrence of aString"
	"bolot 12/13/2000 00:49 - must begin with it"
	"answer if aString is found"
	inStream size < aString size
		ifTrue: [self flag: #todo. "should try to read in more, unless #atEnd"
			"but since atEnd is somewhat broken, don't use it yet"
			^false].

	(inStream contents beginsWith: aString)
		ifTrue: [inStream next: aString size.
			^true].

	^false! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:31'!
next
	self atEnd ifTrue: [^nil].
	inStream isEmpty ifTrue: [self pvtGetData].
	^inStream next! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:30'!
next: n
	| limit |

	[(inStream size < n) and: [ self isConnected ]]
		whileTrue: [self pvtGetData].

	limit _ n min: inStream size.
	^inStream next: limit! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/5/2000 15:59'!
nextChunk
	"getData front - retrieve all data available now"
	inStream isEmpty
		ifTrue: [self pvtGetData].
	^inStream upToEnd! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:06'!
putDataBack: string
	| tempString |
	tempString _ inStream contents.
	self resetInStream.
	inStream nextPutAll: string; nextPutAll: tempString! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 1/4/2000 20:29'!
upTo: delim 
	| string |
	(inStream includes: delim)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upTo: delim].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			string _ inStream contents.
			self resetInStream.
			^string].
	"Never found it, but there's more..."
	self pvtGetData.
	^self upTo: delim! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 6/21/2001 04:08'!
upToAll: delims
	(inStream includesAll: delims)
		ifTrue: ["Found the delimiter part way into buffer"
			^inStream upToAll: delims].
	self atEnd
		ifTrue: ["Never found it, and hit end of file"
			^inStream upToEnd].
	"Never found it, but there's more..."
	self pvtGetData isEmpty ifTrue: [^inStream upToEnd].
	^self upToAll: delims! !

!SocketStream methodsFor: 'stream in' stamp: 'bolot 12/22/1999 17:13'!
upToEnd
	| rest |
	rest _ socket getRestOfBuffer: inStream contents totalLength: self contentLength.
	self resetInStream.
	(rest isKindOf: String) ifTrue: [^'']. " error "
	^rest contents
! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:17'!
cr
	self nextPutAll: String cr! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 8/11/1999 22:13'!
crlf
	self nextPutAll: String crlf! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 1/21/2000 16:33'!
flush
	socket isOtherEndConnected
		ifTrue: [socket sendData: outStream contents].
	self incOutDataCountBy: outStream contents size.
	self resetOutStream! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:24'!
nextPut: char
	self nextPutAll: char asString! !

!SocketStream methodsFor: 'stream out' stamp: 'bolot 12/27/1999 12:25'!
nextPutAll: string
	outStream nextPutAll: string.
	self isBuffered ifTrue: [self flush]! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:50'!
atEnd
	^self isConnected not
	and: [inStream isEmpty
	and: [self isDataAvailable not]]! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 12/16/2000 01:50'!
isBuffered
	^true = (status at: #buffered ifAbsent: [false])! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:47'!
isConnected
	^self socket isConnected! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:47'!
isDataAvailable
	^self socket dataAvailable! !

!SocketStream methodsFor: 'testing' stamp: 'bolot 2/5/2001 15:48'!
isOtherEndConnected
	^self socket isOtherEndConnected! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 03:03'!
inBytes "actual number of bytes read by the app"
	^self inDataCount - inStream size! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:51'!
inDataCount
	^status at: #inDataCount! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
incInDataCountBy: increment
	"increment inDataCount by"
	status at: #inDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
incOutDataCountBy: increment
	"increment outDataCount by"
	status at: #outDataCount modify: [:n | n + increment]! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 12/16/2000 01:52'!
outDataCount
	^status at: #outDataCount! !

!SocketStream methodsFor: 'statistics' stamp: 'bolot 5/14/2001 01:00'!
pvtGetData
	| string |
	inStream nextPutAll: (string _ socket getDataQuicker).
	self incInDataCountBy: string size.
	^string! !


!SocketStream class methodsFor: 'instance creation' stamp: 'bolot 12/16/1999 18:06'!
on: socket
	"create a socket stream on a server socket"
	"for HTTP style header must call readHeader explicitly"
	^self basicNew initialize: socket! !


!String methodsFor: 'converting' stamp: 'bolot 2/5/2001 20:01'!
asHttpResponseTo: request

	^HttpResponse fromString: self! !


!SwikiBrowser methodsFor: 'accessing' stamp: 'je77 2/16/2001 11:38'!
shelf
	^shelf! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/16/2001 11:52'!
book
	^(shelf books select: [:book | book name = self bookName]) first! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/15/2001 12:54'!
bookList
	bookList ifNil: [self createBookList].
	^bookList! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/15/2001 12:58'!
bookListIndex
	^bookListIndex ifNil: [0] ifNotNil: [bookListIndex]! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/15/2001 17:51'!
bookListIndex: anInteger
	bookListIndex _ anInteger.
	self changed: #bookListIndex.
	self updateFunctionList! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/17/2001 11:47'!
bookName
	^(bookList at: bookListIndex) withBlanksTrimmed! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/17/2001 17:05'!
createBookList
	booksAsHierarchy
		ifTrue: [
			bookList _ OrderedCollection new.
			((shelf books select: [:book | book hasParent not]) asSortedCollection: [:a :b | a name asLowercase < b name asLowercase]) do: [:book |
				bookList addAll: (self hierarchyForBook: book indent: '')]]
		ifFalse: [bookList _ ((shelf books collect: [:book | book name]) asSortedCollection: [:a :b | a asLowercase < b asLowercase]) asOrderedCollection].
	bookList addFirst: '[shelf]'! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/15/2001 17:44'!
isSelectingABook
	^bookListIndex > 1! !

!SwikiBrowser methodsFor: 'book list' stamp: 'je77 2/15/2001 17:43'!
isSelectingAShelf
	^bookListIndex = 1! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:28'!
bookListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"List as Hierarchy"
	labels add: (booksAsHierarchy
		ifTrue: ['sort alphabetically']
		ifFalse: ['sort as hierarchy']).
	selections add: #toggleBooksAsHierarchy.
	self isSelectingABook ifTrue: [
		"inspect & explore"
		lines add: labels size.
		labels add: 'inspect'.
		selections add: #inspectBook.
		labels add: 'explore'.
		selections add: #exploreBook.
		"reload"
		lines add: labels size.
		labels add: 'reload'.
		selections add: #reloadBook.
		(self book hasChildren) ifFalse: [
			"remove"
			lines add: labels size.
			labels add: 'remove'.
			selections add: #removeBook]].
	self isSelectingAShelf ifTrue: [
		"inspect & explore"
		lines add: labels size.
		labels add: 'inspect'.
		selections add: #inspectShelf.
		labels add: 'explore'.
		selections add: #exploreShelf.
		"reload"
		lines add: labels size.
		labels add: 'reload'.
		selections add: #reloadShelf].
	^aMenu labels: labels lines: lines selections: selections
! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:29'!
exploreBook
	self isSelectingABook ifTrue: [self book explore]
! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:29'!
exploreShelf
	shelf explore! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:28'!
inspectBook
	self isSelectingABook ifTrue: [self book inspect]
! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:29'!
inspectShelf
	shelf inspect! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 19:45'!
reloadBook
	| book |
	Cursor execute showWhile: [
		book _ self book.
		book formatPrivAddress: 'stop' request: nil response: nil shelf: shelf.
		book loadFrom: shelf.
		book formatPrivAddress: 'initialize' request: nil response: nil shelf: shelf.
		"Update list"
		bookList _ nil.
		self changed: #bookList.
		2 to: bookList size do: [:i | ((bookList at: i) withBlanksTrimmed = book name)
			ifTrue: [self bookListIndex: i]]]! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:37'!
reloadShelf
	Cursor execute showWhile: [
		shelf reload.
		self changed: #bookList.
		self bookListIndex: 1]! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 3/29/2001 17:24'!
removeBook
	| book |
	book _ self book.
	shelf books remove: book.
	book formatPrivAddress: 'stop' request: nil response: nil shelf: shelf.
	book hasParent ifTrue: [book parent removeChild: book].
	bookList _ nil.
	self changed: #bookList.
	self bookListIndex: 0.
	PopUpMenu notify: ('It is now safe to (re)move the ', book name, String cr, 'directory to permanently remove that Swiki.')
! !

!SwikiBrowser methodsFor: 'book list menu' stamp: 'je77 2/24/2001 17:20'!
toggleBooksAsHierarchy
	| bookName |
	booksAsHierarchy _ booksAsHierarchy not.
	(bookListIndex > 1) ifTrue: [
		bookName _ self bookName].
	bookList _ nil.
	self changed: #bookList.
	(bookListIndex < 2) ifTrue: [^self].
	"Select same book"
	2 to: (bookList size) do: [:i |
		(bookName = (bookList at: i) withBlanksTrimmed) ifTrue: [
			^self bookListIndex: i]]! !

!SwikiBrowser methodsFor: 'private' stamp: 'je77 2/15/2001 16:19'!
defaultBackgroundColor
	^Color r: 0.6 g: 1.0 b: 0.8! !

!SwikiBrowser methodsFor: 'private' stamp: 'je77 2/17/2001 11:48'!
hierarchyForBook: book indent: indent
	| return |
	return _ OrderedCollection new.
	return add: (indent, book name).
	book hasChildren ifFalse: [^return].
	(book children asSortedCollection: [:a :b | a name asLowercase < b name asLowercase])
		do: [:child | return addAll: (self hierarchyForBook: child indent: (indent, '  '))].
	^return! !

!SwikiBrowser methodsFor: 'private' stamp: 'je77 2/17/2001 13:26'!
put: aText
	aText asString inspect.
	^true "accepted"! !

!SwikiBrowser methodsFor: 'initialization' stamp: 'je77 2/17/2001 17:04'!
initialize
	super initialize.
	bookListIndex _ 0.
	functionListIndex _ 0.
	categoryListIndex _ 0.
	elementListIndex _ 0.
	booksAsHierarchy _ false! !

!SwikiBrowser methodsFor: 'initialization' stamp: 'je77 3/7/2001 14:19'!
shelf: aSwikiShelf
	shelf _ aSwikiShelf.
	(shelf storage dir fileExists: 'browser.log')
		ifTrue: [logFile _ shelf storage dir fileNamed: 'browser.log'.
			logFile setToEnd]
		ifFalse: [logFile _ DummyStream basicNew]! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/17/2001 13:53'!
ata
	"addresses, templates, or actions"
	^self function copyUpTo: $ ! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/17/2001 13:53'!
ataSingle
	"address, template, or action"
	^self ata caseOf: {
		['addresses']->['address'].
		['templates']->['template'].
		['actions']->['action']}
		otherwise: [self error: 'ataSingle is only valid for addresses, templates, and actions']! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/15/2001 17:46'!
function
	(functionListIndex = 0) ifTrue: [^nil].
	functionListIndex ifNil: [^nil].
	^self functionList at: functionListIndex! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/15/2001 16:54'!
functionList
	^functionList ifNil: [^OrderedCollection new] ifNotNil: [functionList]! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/15/2001 16:53'!
functionListIndex
	^functionListIndex ifNil: [0] ifNotNil: [functionListIndex]! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/15/2001 17:42'!
functionListIndex: anInteger
	functionListIndex _ anInteger.
	self changed: #functionListIndex.
	self updateCategoryList! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/23/2001 14:00'!
type
	^self function caseOf: {
		['addresses (shelf)']->['shelf'].
		['addresses (book)']->['book'].
		['addresses (page)']->['page'].
		['addresses (priv)']->['priv'].
		['templates (shelf)']->['shelf'].
		['templates (book)']->['book'].
		['templates (page)']->['page'].
		['actions (shelf)']->['shelf'].
		['actions (book)']->['book'].
		['actions (page)']->['page']}
		otherwise: ['']

! !

!SwikiBrowser methodsFor: 'function list' stamp: 'je77 2/22/2001 20:36'!
updateFunctionList
	functionList _ self bookListIndex caseOf:
		{[0]->[OrderedCollection new].
		[1]->["Shelf Functions"
			#('addresses (shelf)'
			'addresses (priv)'
			'templates (shelf)'
			'templates (book)'
			'actions (shelf)'
			'actions (book)'
			'settings')]}
		otherwise: ["Book Functions"
			#('addresses (book)'
			'addresses (page)'
			'addresses (priv)'
			'templates (book)'
			'templates (page)'
			'actions (book)'
			'actions (page)'
			'settings'
			'setup')].
	functionListIndex _ 0.
	self changed: #functionList.
	self updateCategoryList! !

!SwikiBrowser methodsFor: 'category list' stamp: 'je77 2/17/2001 11:10'!
category
	(categoryListIndex = 0) ifTrue: [^nil].
	^categoryList at: categoryListIndex! !

!SwikiBrowser methodsFor: 'category list' stamp: 'je77 2/15/2001 16:57'!
categoryList
	^categoryList ifNil: [^OrderedCollection new] ifNotNil: [categoryList]! !

!SwikiBrowser methodsFor: 'category list' stamp: 'je77 2/15/2001 16:57'!
categoryListIndex
	^categoryListIndex ifNil: [0] ifNotNil: [categoryListIndex]! !

!SwikiBrowser methodsFor: 'category list' stamp: 'je77 2/15/2001 19:29'!
categoryListIndex: anInteger
	categoryListIndex _ anInteger.
	self changed: #categoryListIndex.
	self updateElementList! !

!SwikiBrowser methodsFor: 'category list' stamp: 'je77 2/24/2001 13:48'!
updateCategoryList
	| function |
	function _ self function.
	function ifNil: [
		categoryList _ OrderedCollection new.
		categoryListIndex _ 0.
		self changed: #categoryList.
		self updateElementList.
		^self].
	(self isSelectingABook) ifTrue: [function caseOf: {
		['addresses (book)']->["Book Address Categories"
			categoryList _ self book storage categoriesBookFunction: 'addresses' type: 'book'.
 			categoryListIndex _ 1].
		['addresses (page)']->["Page Address Categories"
			categoryList _ self book storage categoriesBookFunction: 'addresses' type: 'page'.
 			categoryListIndex _ 1].
		['addresses (priv)']->["Private Address Categories"
			categoryList _ self book storage categoriesBookFunction: 'addresses' type: 'priv'.
 			categoryListIndex _ 1].
		['templates (book)']->["Book Templates Categories"
			categoryList _ self book storage categoriesBookFunction: 'templates' type: 'book'.
 				categoryListIndex _ 1].
		['templates (page)']->["Page Templates Categories"
			categoryList _ self book storage categoriesBookFunction: 'templates' type: 'page'.
 				categoryListIndex _ 1].
		['actions (book)']->["Book Actions Categories"
			categoryList _ self book storage categoriesBookFunction: 'actions' type: 'book'.
 				categoryListIndex _ 1].
		['actions (page)']->["Page Actions Categories"
			categoryList _ self book storage categoriesBookFunction: 'actions' type: 'page'.
 				categoryListIndex _ 1].
		['settings']->["Settings"
			categoryList _ OrderedCollection with: '-- all --'.
			categoryListIndex _ 1].
		['setup']->["Setup"
			categoryList _ OrderedCollection with: '-- all --'.
			categoryListIndex _ 1]}
		otherwise: [self error: (function, ' is not a valid function.')]].
	(self isSelectingAShelf) ifTrue: [function caseOf: {
		['addresses (shelf)']->["Shelf Address Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'addresses' type: 'shelf'.
 			categoryListIndex _ 1].
		['addresses (priv)']->["Private Address Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'addresses' type: 'priv'.
 			categoryListIndex _ 1].
		['templates (shelf)']->["Shelf Templates Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'templates' type: 'shelf'.
 				categoryListIndex _ 1].
		['templates (book)']->["Book Templates Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'templates' type: 'book'.
 				categoryListIndex _ 1].
		['actions (shelf)']->["Shelf Actions Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'actions' type: 'shelf'.
 				categoryListIndex _ 1].
		['actions (book)']->["Book Actions Categories"
			categoryList _ shelf storage categoriesShelfFunction: 'actions' type: 'book'.
 				categoryListIndex _ 1].
		['settings']->["Settings"
			categoryList _ OrderedCollection with: '-- all --'.
			categoryListIndex _ 1]}
		otherwise: [self error: (function, ' is not a valid function.')]].
	self changed: #categoryList.
	self updateElementList! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:06'!
addBookATACategory
	| response |
	(response _ FillInTheBlank request: 'Please type new category name' initialAnswer: 'category name') isEmpty ifTrue: [^self].
	self book storage addBookFunction: self ata type: self type category: response.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: response)! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:08'!
addShelfATACategory
	| response |
	(response _ FillInTheBlank request: 'Please type new category name' initialAnswer: 'category name') isEmpty ifTrue: [^self].
	shelf storage addShelfFunction: self ata type: self type category: response.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: response)! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/17/2001 10:05'!
bookATACategoryListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new category"
	labels add: 'new category...'.
	selections add: #addBookATACategory.
	"Selected item"
	self category caseOf:
		{[nil]->["No selection"].
		['-- all --']->["All is selected"].
		['as yet unclassified']->[
			lines add: (labels size).
			"Rename category"
			labels add: 'rename...'.
			selections add: #renameBookATACategory]}
		otherwise: [
			lines add: (labels size).
			"Rename category"
			labels add: 'rename...'.
			selections add: #renameBookATACategory.
			"Remove category"
			labels add: 'remove'.
			selections add: #removeBookATACategory].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/17/2001 13:40'!
bookCategoryListMenu: aMenu
	self function caseOf:
		{['addresses (book)']->["Book Address"
			^self bookATACategoryListMenu: aMenu].
		['addresses (page)']->["Page Address"
			^self bookATACategoryListMenu: aMenu].
		['addresses (priv)']->["Private Address"
			^self bookATACategoryListMenu: aMenu].
		['templates (book)']->["Book Template"
			^self bookATACategoryListMenu: aMenu].
		['templates (page)']->["Page Template"
			^self bookATACategoryListMenu: aMenu].
		['actions (book)']->["Book Action"
			^self bookATACategoryListMenu: aMenu].
		['actions (page)']->["Page Action"
			^self bookATACategoryListMenu: aMenu].
		['settings']->["Settings"
			^nil].
		['setup']->["Setup"
			^nil].
		[nil]->["No Function"
			^nil]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/17/2001 13:35'!
categoryListMenu: aMenu
	self isSelectingABook ifTrue: [^self bookCategoryListMenu: aMenu].
	self isSelectingAShelf ifTrue: [^self shelfCategoryListMenu: aMenu].
	^nil! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/23/2001 14:02'!
removeBookATACategory
	"Remove category"
	self book storage deleteBookFunction: self ata type: self type category: self category.
	self updateCategoryList.
	self categoryListIndex: 0! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:09'!
removeShelfATACategory
	"Remove category"
	shelf storage deleteShelfFunction: self ata type: self type category: self category.
	self updateCategoryList.
	self categoryListIndex: 0! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/23/2001 15:11'!
renameBookATACategory
	| category response |
	category _ self category.
	(response _ FillInTheBlank request: 'Please type new category name' initialAnswer: category) isEmpty ifTrue: [^self].
	(category = response) ifTrue: [^self].
	(category = 'as yet unclassified') ifTrue: [category _ nil].
	self book storage renameBookFunction: self ata type: self type category: category to: response.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: response)! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:11'!
renameShelfATACategory
	| category response |
	category _ self category.
	(response _ FillInTheBlank request: 'Please type new category name' initialAnswer: category) isEmpty ifTrue: [^self].
	(category = response) ifTrue: [^self].
	(category = 'as yet unclassified') ifTrue: [category _ nil].
	shelf storage renameShelfFunction: self ata type: self type category: category to: response.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: response)! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:05'!
shelfATACategoryListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new category"
	labels add: 'new category...'.
	selections add: #addShelfATACategory.
	"Selected item"
	self category caseOf:
		{[nil]->["No selection"].
		['-- all --']->["All is selected"].
		['as yet unclassified']->[
			lines add: (labels size).
			"Rename category"
			labels add: 'rename...'.
			selections add: #renameShelfATACategory]}
		otherwise: [
			lines add: (labels size).
			"Rename category"
			labels add: 'rename...'.
			selections add: #renameShelfATACategory.
			"Remove category"
			labels add: 'remove'.
			selections add: #removeShelfATACategory].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'category list menu' stamp: 'je77 2/24/2001 17:04'!
shelfCategoryListMenu: aMenu
	self function caseOf:
		{['addresses (shelf)']->["Shelf Address"
			^self shelfATACategoryListMenu: aMenu].
		['addresses (priv)']->["Private Address"
			^self shelfATACategoryListMenu: aMenu].
		['templates (shelf)']->["Shelf Template"
			^self shelfATACategoryListMenu: aMenu].
		['templates (book)']->["Book Template"
			^self shelfATACategoryListMenu: aMenu].
		['actions (shelf)']->["Book Action"
			^self shelfATACategoryListMenu: aMenu].
		['actions (book)']->["Page Action"
			^self shelfATACategoryListMenu: aMenu].
		['settings']->["Settings"
			^nil].
		[nil]->["No Function"
			^nil]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/23/2001 13:38'!
contentFromBookElement
	| book element |
	book _ self book.
	element _ elementList at: elementListIndex.
	^self function caseOf:
		{['addresses (book)']->["Book Address"
			book storage bookFunction: 'addresses' type: 'book' name: element].
		['addresses (page)']->["Page Address"
			book storage bookFunction: 'addresses' type: 'page' name: element].
		['addresses (priv)']->["Private Address"
			book storage bookFunction: 'addresses' type: 'priv' name: element].
		['templates (book)']->["Book Template"
			book storage bookFunction: 'templates' type: 'book' name: element].
		['templates (page)']->["Page Template"
			book storage bookFunction: 'templates' type: 'page' name: element].
		['actions (book)']->["Book Action"
			book storage bookFunction: 'actions' type: 'book' name: element].
		['actions (page)']->["Page Action"
			book storage bookFunction: 'actions' type: 'page' name: element].
		['settings']->["Settings"
			(book settingsAt: element) storeString].
		['setup']->["Setup"
			(book setup at: element) storeString]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/24/2001 15:42'!
contentFromShelfElement
	| element |
	element _ elementList at: elementListIndex.
	^self function caseOf:
		{['addresses (shelf)']->["Shelf Address"
			shelf storage shelfFunction: 'addresses' type: 'shelf' name: element].
		['addresses (priv)']->["Private Address"
			shelf storage shelfFunction: 'addresses' type: 'priv' name: element].
		['templates (shelf)']->["Shelf Template"
			shelf storage shelfFunction: 'templates' type: 'shelf' name: element].
		['templates (book)']->["Book Template"
			shelf storage shelfFunction: 'templates' type: 'book' name: element].
		['actions (shelf)']->["Shelf Action"
			shelf storage shelfFunction: 'actions' type: 'shelf' name: element].
		['actions (book)']->["Book Action"
			shelf storage shelfFunction: 'actions' type: 'book' name: element].
		['settings']->["Settings"
			(shelf settingsAt: element) storeString]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/17/2001 15:43'!
element
	^elementList at: elementListIndex! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/15/2001 16:59'!
elementList
	^elementList ifNil: [^OrderedCollection new] ifNotNil: [elementList]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/23/2001 13:23'!
elementListForBook
	| book category |
	book _ self book.
	category _ self category.
	self function caseOf:
		{['addresses (book)']->["Book Address Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'addresses' type: 'book'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'addresses' type: 'book'].
			^book storage bookFunction: 'addresses' type: 'book' category: category].
		['addresses (page)']->["Page Address Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'addresses' type: 'page'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'addresses' type: 'page'].
			^book storage bookFunction: 'addresses' type: 'page' category: category].
		['addresses (priv)']->["Private Address Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'addresses' type: 'priv'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'addresses' type: 'priv'].
			^book storage bookFunction: 'addresses' type: 'priv' category: category].
		['templates (book)']->["Book Templates Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'templates' type: 'book'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'templates' type: 'book'].
			^book storage bookFunction: 'templates' type: 'book' category: category].
		['templates (page)']->["Page Templates Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'templates' type: 'page'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'templates' type: 'page'].
			^book storage bookFunction: 'templates' type: 'page' category: category].
		['actions (book)']->["Book Actions Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'actions' type: 'book'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'actions' type: 'book'].
			^book storage bookFunction: 'actions' type: 'book' category: category].
		['actions (page)']->["Page Actions Categories"
			(category = '-- all --') ifTrue: [
				^book storage allBookFunction: 'actions' type: 'page'].
			(category = 'as yet unclassified') ifTrue: [
				^book storage ayuBookFunction: 'actions' type: 'page'].
			^book storage bookFunction: 'actions' type: 'page' category: category].
		['settings']->["Settings"
			^book rawSettings keys asSortedCollection: [:a :b | a asLowercase < b asLowercase]].
		['setup']->["Setup"
			^book setup keys asSortedCollection: [:a :b | a asLowercase < b asLowercase]]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/24/2001 15:39'!
elementListForShelf
	| category |
	category _ self category.
	self function caseOf: {
		['addresses (shelf)']->["Shelf Address Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'addresses' type: 'shelf'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'addresses' type: 'shelf'].
			^shelf storage shelfFunction: 'addresses' type: 'shelf' category: category].
		['addresses (priv)']->["Private Address Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'addresses' type: 'priv'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'addresses' type: 'priv'].
			^shelf storage shelfFunction: 'addresses' type: 'priv' category: category].
		['templates (shelf)']->["Shelf Templates Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'templates' type: 'shelf'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'templates' type: 'shelf'].
			^shelf storage shelfFunction: 'templates' type: 'shelf' category: category].
		['templates (book)']->["Book Templates Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'templates' type: 'book'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'templates' type: 'book'].
			^shelf storage shelfFunction: 'templates' type: 'book' category: category].
		['actions (shelf)']->["Shelf Actions Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'actions' type: 'shelf'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'actions' type: 'shelf'].
			^shelf storage shelfFunction: 'actions' type: 'shelf' category: category].
		['actions (book)']->["Book Actions Categories"
			(category = '-- all --') ifTrue: [
				^shelf storage allShelfFunction: 'actions' type: 'book'].
			(category = 'as yet unclassified') ifTrue: [
				^shelf storage ayuShelfFunction: 'actions' type: 'book'].
			^shelf storage shelfFunction: 'actions' type: 'book' category: category].
		['settings']->["Settings"
			^shelf settings keys asSortedCollection: [:a :b | a asLowercase < b asLowercase]]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/15/2001 16:59'!
elementListIndex
	^elementListIndex ifNil: [0] ifNotNil: [elementListIndex]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/16/2001 15:08'!
elementListIndex: anInteger
	elementListIndex _ anInteger.
	self changed: #elementListIndex.
	(elementListIndex = 0) ifTrue: [
		contents _ ''.
		self changed: #contents.
		^self].
	(self isSelectingABook) ifTrue: [
		contents _ self contentFromBookElement.
		self changed: #contents.
		^self].
	(self isSelectingAShelf) ifTrue: [
		contents _ self contentFromShelfElement.
		self changed: #contents.
		^self]! !

!SwikiBrowser methodsFor: 'element list' stamp: 'je77 2/16/2001 15:49'!
updateElementList
	(categoryListIndex = 0)
		ifTrue: [elementList _ OrderedCollection new]
		ifFalse: [
			self isSelectingABook ifTrue: [elementList _ self elementListForBook].
			self isSelectingAShelf ifTrue: [elementList _ self elementListForShelf]].
	elementListIndex _ 0.
	self changed: #elementList.
	contents _ ''.
	self changed: #contents! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:32'!
bookATAElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new element"
	labels add: ('new ', self ataSingle, '...').
	selections add: #newBookATAElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Move element"
		labels add: 'move to...'.
		selections add: #moveBookATAElement.
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameBookATAElement.
		"Rename element"
		labels add: 'remove'.
		selections add: #removeBookATAElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/16/2001 17:12'!
bookActionElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Senders of"
	labels add: 'senders of'.
	selections add: #sendersBookAction.
	lines add: (labels size).
	"Add a new element"
	labels add: ('new ', self ataSingle, '...').
	selections add: #newBookATAElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Move element"
		labels add: 'move to...'.
		selections add: #moveBookATAElement.
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameBookATAElement.
		"Remove element"
		labels add: 'remove'.
		selections add: #removeBookATAElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/16/2001 17:10'!
bookElementListMenu: aMenu
	self function caseOf:
		{['addresses (book)']->["Book Address"
			^self bookATAElementListMenu: aMenu].
		['addresses (page)']->["Page Address"
			^self bookATAElementListMenu: aMenu].
		['addresses (priv)']->["Private Address"
			^self bookATAElementListMenu: aMenu].
		['templates (book)']->["Book Template"
			^self bookATAElementListMenu: aMenu].
		['templates (page)']->["Page Template"
			^self bookATAElementListMenu: aMenu].
		['actions (book)']->["Book Action"
			^self bookActionElementListMenu: aMenu].
		['actions (page)']->["Page Action"
			^self bookActionElementListMenu: aMenu].
		['settings']->["Settings"
			^self bookSettingsElementListMenu: aMenu].
		['setup']->["Setup"
			^self bookSetupElementListMenu: aMenu].
		[nil]->["No Function"
			^nil]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/16/2001 17:12'!
bookSettingsElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new element"
	labels add: ('new setting...').
	selections add: #newBookSettingElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameBookSettingElement.
		"Remove element"
		labels add: 'remove'.
		selections add: #removeBookSettingElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/16/2001 17:14'!
bookSetupElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new element"
	labels add: ('new setup...').
	selections add: #newBookSetupElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameBookSetupElement.
		"Remove element"
		labels add: 'remove'.
		selections add: #removeBookSetupElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/17/2001 13:36'!
elementListMenu: aMenu
	self isSelectingABook ifTrue: [^self bookElementListMenu: aMenu].
	self isSelectingAShelf ifTrue: [^self shelfElementListMenu: aMenu].
	^nil! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/23/2001 14:20'!
moveBookATAElement
	| categories lines select category |
	categories _ categoryList copy.
	lines _ OrderedCollection new.
	categories remove: '-- all --'.
	(categories includes: 'as yet unclassified') ifTrue: [
		categories remove: 'as yet unclassified'].
	(self category = 'as yet unclassified') ifFalse: [
		(self category = '-- all --') ifFalse: [
			categories remove: self category]].
	lines add: categories size.
	categories add: 'as yet unclassified'.
	select _ (PopUpMenu labelArray: categories lines: lines)
				startUpWithCaption: 'move to category'.
	(select = 0) ifTrue: [^self].
	select _ categories at: select.
	(select = 'as yet unclassified')
		ifTrue: [self book storage moveBookFunction: self ata type: self type name: self element]
		ifFalse: [self book storage moveBookFunction: self ata type: self type name: self element toCategory: select].
	category _ self category.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: category)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 3/19/2001 20:03'!
moveShelfATAElement
	| categories lines select category |
	categories _ categoryList copy.
	lines _ OrderedCollection new.
	categories remove: '-- all --'.
	(categories includes: 'as yet unclassified') ifTrue: [
		categories remove: 'as yet unclassified'].
	(self category = 'as yet unclassified') ifFalse: [
		(self category = '-- all --') ifFalse: [
			categories remove: self category]].
	lines add: categories size.
	categories add: 'as yet unclassified'.
	select _ (PopUpMenu labelArray: categories lines: lines)
				startUpWithCaption: 'move to category'.
	(select = 0) ifTrue: [^self].
	select _ categories at: select.
	(select = 'as yet unclassified')
		ifTrue: [shelf storage moveShelfFunction: self ata type: self type name: self element]
		ifFalse: [shelf storage moveShelfFunction: self ata type: self type name: self element toCategory: select].
	category _ self category.
	self updateCategoryList.
	self categoryListIndex: (categoryList indexOf: category)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/23/2001 14:40'!
newBookATAElement
	| response book inACategory |
	(response _ FillInTheBlank request: ('Please name new ', self ataSingle) initialAnswer: '') isEmpty ifTrue: [^self].
	book _ self book.
	inACategory _ self category caseOf: {
		['as yet unclassified']->[false].
		['-- all --']->[false]}
		otherwise: [true].
	"Add to book function"
	self function caseOf: {
		['addresses (book)']->[(book bookAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookAddresses at: response put: (Compiler evaluate: '[:request :response :shelf :book |]')]].
		['addresses (page)']->[(book pageAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageAddresses at: response put: (Compiler evaluate: '[:request :response :shelf :book :page |]')]].
		['addresses (priv)']->[(book privAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book privAddresses at: response put: (Compiler evaluate: '[:request :response :shelf :book |]')]].
		['templates (book)']->[(book bookTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookTemplates at: response put: '']].
		['templates (page)']->[(book pageTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageTemplates at: response put: '']].
		['actions (book)']->[(book bookActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookActions at: response put: (Compiler evaluate: '[:request :response :shelf :book |]')]].
		['actions (page)']->[(book pageActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageActions at: response put: (Compiler evaluate: '[:request :response :shelf :book :page |]')]]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"Add to storage"
	inACategory
		ifTrue: [book storage addBookFunction: self ata type: self type name: response category: self category]
		ifFalse: [book storage addBookFunction: self ata type: self type name: response].
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 11:59'!
newBookSettingElement
	| response book |
	(response _ FillInTheBlank request: ('Please name new setting') initialAnswer: '') isEmpty ifTrue: [^self].
	book _ self book.
	(book rawSettingsIncludes: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	book settingsAt: response put: ''.
	book writeSettings.
	"Update List"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/27/2001 17:26'!
newBookSetupElement
	| response book |
	(response _ FillInTheBlank request: ('Please name new setup') initialAnswer: '') isEmpty ifTrue: [^self].
	book _ self book.
	(book setup includesKey: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	book setup at: response put: ''.
	shelf storage writeSetupForBook: book.
	"Update List"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:54'!
newShelfATAElement
	| response inACategory |
	(response _ FillInTheBlank request: ('Please name new ', self ataSingle) initialAnswer: '') isEmpty ifTrue: [^self].
	inACategory _ self category caseOf: {
		['as yet unclassified']->[false].
		['-- all --']->[false]}
		otherwise: [true].
	"Add to shelf function"
	self function caseOf: {
		['addresses (shelf)']->[(shelf shelfAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfAddresses at: response put: (Compiler evaluate: '[:request :response :shelf |]')]].
		['addresses (priv)']->[(shelf privAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf privAddresses at: response put: (Compiler evaluate: '[:request :response :shelf |]')]].
		['templates (shelf)']->[(shelf shelfTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfTemplates at: response put: '']].
		['templates (book)']->[(shelf bookTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf bookTemplates at: response put: '']].
		['actions (shelf)']->[(shelf shelfActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfActions at: response put: (Compiler evaluate: '[:request :response :shelf |]')]].
		['actions (book)']->[(shelf bookActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf bookActions at: response put: (Compiler evaluate: '[:request :response :shelf :book |]')]]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"Add to storage"
	inACategory
		ifTrue: [shelf storage addShelfFunction: self ata type: self type name: response category: self category]
		ifFalse: [shelf storage addShelfFunction: self ata type: self type name: response].
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:12'!
newShelfSettingElement
	| response |
	(response _ FillInTheBlank request: ('Please name new setting') initialAnswer: '') isEmpty ifTrue: [^self].
	(shelf settingsIncludes: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	shelf settingsAt: response put: ''.
	shelf writeSettings.
	"Update List"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/23/2001 14:13'!
removeBookATAElement
	| book element |
	book _ self book.
	element _ self element.
	self function caseOf: {
		['addresses (book)']->["Remove book address"
			book bookAddresses removeKey: element.
			book storage deleteBookFunction: 'addresses' type: 'book' name: element].
		['addresses (page)']->["Remove page address"
			book pageAddresses removeKey: element.
			book storage deleteBookFunction: 'addresses' type: 'page' name: element].
		['addresses (priv)']->["Remove priv address"
			book privAddresses removeKey: element.
			book storage deleteBookFunction: 'addresses' type: 'priv' name: element].
		['templates (book)']->["Remove book template"
			book bookTemplates removeKey: element.
			book storage deleteBookFunction: 'templates' type: 'book' name: element].
		['templates (page)']->["Remove page template"
			book pageTemplates removeKey: element.
			book storage deleteBookFunction: 'templates' type: 'page' name: element].
		['actions (book)']->["Remove book action"
			book bookActions removeKey: element.
			book storage deleteBookFunction: 'actions' type: 'book' name: element].
		['actions (page)']->["Remove page action"
			book pageActions removeKey: element.
			book storage deleteBookFunction: 'actions' type: 'page' name: element]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"Update element list"
	self updateElementList.
	self elementListIndex: 0! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:02'!
removeBookSettingElement
	(self book)
		rawSettingsRemove: (self element);
		writeSettings.
	"Update element list"
	self updateElementList.
	self elementListIndex: 0! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/27/2001 17:24'!
removeBookSetupElement
	| book |
	book _ self book.
	book setup removeKey: self element.
	shelf storage writeSetupForBook: book.
	"Update element list"
	self updateElementList.
	self elementListIndex: 0! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:47'!
removeShelfATAElement
	| element |
	element _ self element.
	self function caseOf: {
		['addresses (shelf)']->["Remove shelf address"
			shelf shelfAddresses removeKey: element.
			shelf storage deleteShelfFunction: 'addresses' type: 'shelf' name: element].
		['addresses (priv)']->["Remove priv address"
			shelf privAddresses removeKey: element.
			shelf storage deleteShelfFunction: 'addresses' type: 'priv' name: element].
		['templates (shelf)']->["Remove shelf template"
			shelf shelfTemplates removeKey: element.
			shelf storage deleteShelfFunction: 'templates' type: 'shelf' name: element].
		['templates (book)']->["Remove book template"
			shelf bookTemplates removeKey: element.
			shelf storage deleteShelfFunction: 'templates' type: 'book' name: element].
		['actions (shelf)']->["Remove shelf action"
			shelf shelfActions removeKey: element.
			shelf storage deleteShelfFunction: 'actions' type: 'shelf' name: element].
		['actions (book)']->["Remove book action"
			shelf bookActions removeKey: element.
			shelf storage deleteShelfFunction: 'actions' type: 'book' name: element]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"Update element list"
	self updateElementList.
	self elementListIndex: 0! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:13'!
removeShelfSettingElement
	shelf
		settingsRemove: (self element);
		writeSettings.
	"Update element list"
	self updateElementList.
	self elementListIndex: 0! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/23/2001 14:29'!
renameBookATAElement
	| response element book |
	(response _ FillInTheBlank request: ('Please name new ', self ataSingle) initialAnswer: self element) isEmpty ifTrue: [^self].
	element _ self element.
	(response = element) ifTrue: [^self].
	book _ self book.
	self function caseOf: {
		['addresses (book)']->[(book bookAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookAddresses at: response put: (book bookAddresses removeKey: element)]].
		['addresses (page)']->[(book pageAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageAddresses at: response put: (book pageAddresses removeKey: element)]].
		['addresses (priv)']->[(book privAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book privAddresses at: response put: (book privAddresses removeKey: element)]].
		['templates (book)']->[(book bookTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookTemplates at: response put: (book bookTemplates removeKey: element)]].
		['templates (page)']->[(book pageTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageTemplates at: response put: (book pageTemplates removeKey: element)]].
		['actions (book)']->[(book bookActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book bookActions at: response put: (book bookActions removeKey: element)]].
		['actions (page)']->[(book pageActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [book pageActions at: response put: (book pageActions removeKey: element)]]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"move in storage"
	book storage renameBookFunction: self ata type: self type name: element to: response.
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:09'!
renameBookSettingElement
	| response element book |
	element _ self element.	
	(response _ FillInTheBlank request: ('Please name new setting') initialAnswer: element) isEmpty ifTrue: [^self].
	(response = element) ifTrue: [^self].
	book _ self book.
	(book rawSettingsIncludes: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	book settingsAt: response put: (book settingsAt: element).
	book rawSettingsRemove: element.
	book writeSettings.
	"Update element list"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/27/2001 17:25'!
renameBookSetupElement
	| response element book |
	element _ self element.	
	(response _ FillInTheBlank request: ('Please name new setup') initialAnswer: element) isEmpty ifTrue: [^self].
	(response = element) ifTrue: [^self].
	book _ self book.
	(book setup includesKey: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	book setup
		at: response put: (book setup at: element);
		removeKey: element.
	shelf storage writeSetupForBook: book.
	"Update element list"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 17:00'!
renameShelfATAElement
	| response element |
	(response _ FillInTheBlank request: ('Please name new ', self ataSingle) initialAnswer: self element) isEmpty ifTrue: [^self].
	element _ self element.
	(response = element) ifTrue: [^self].
	self function caseOf: {
		['addresses (shelf)']->[(shelf shelfAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfAddresses at: response put: (shelf shelfAddresses removeKey: element)]].
		['addresses (priv)']->[(shelf privAddresses includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf privAddresses at: response put: (shelf privAddresses removeKey: element)]].
		['templates (shelf)']->[(shelf shelfTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfTemplates at: response put: (shelf shelfTemplates removeKey: element)]].
		['templates (book)']->[(shelf bookTemplates includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf bookTemplates at: response put: (shelf bookTemplates removeKey: element)]].
		['actions (shelf)']->[(shelf shelfActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf shelfActions at: response put: (shelf shelfActions removeKey: element)]].
		['actions (book)']->[(shelf bookActions includesKey: response)
			ifTrue: [^PopUpMenu notify: 'That name is already taken']
			ifFalse: [shelf bookActions at: response put: (shelf bookActions removeKey: element)]]}
		otherwise: [self error: (self function, ' is not a valid function.')].
	"move in storage"
	shelf storage renameShelfFunction: self ata type: self type name: element to: response.
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:17'!
renameShelfSettingElement
	| response element |
	element _ self element.	
	(response _ FillInTheBlank request: ('Please name new setting') initialAnswer: element) isEmpty ifTrue: [^self].
	(response = element) ifTrue: [^self].
	(shelf settingsIncludes: response) ifTrue: [
		^PopUpMenu notify: 'That name is already taken'].
	shelf settingsAt: response put: (shelf settingsAt: element).
	shelf settingsRemove: element.
	shelf writeSettings.
	"Update element list"
	self updateElementList.
	self elementListIndex: (elementList indexOf: response)! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:34'!
sendersBookAction
	| myBook books action result return |
	action _ '<?', self element, '?>'.
	myBook _ self book.
	books _ myBook allChildren.
	books add: myBook.
	[myBook hasParent] whileTrue: [
		myBook _ myBook parent.
		books add: myBook].
	result _ OrderedCollection new.
	(self function = 'actions (book)') ifTrue: [
		books do: [:book | book bookTemplates keysAndValuesDo: [:key :template |
			((template findString: action) = 0) ifFalse: [
				result add: (Array with: book with: 'book' with: key)]]]].
	books do: [:book | book pageTemplates keysAndValuesDo: [:key :template |
		((template findString: action) = 0) ifFalse: [
			result add: (Array with: book with: 'page' with: key)]]].
	return _ WriteStream on: String new.
	return
		nextPutAll: (result size asString);
		nextPutAll: ' MATCHES'.
	result do: [:arr | return
		nextPut: Character cr;
		nextPutAll: (arr at: 1) name;
		nextPutAll: ': ';
		nextPutAll: (arr at: 2);
		nextPutAll: ' template named ';
		nextPutAll: (arr at: 3)].
	(Workspace new)
		openLabel: ('Senders of ', action);
		contents: return contents;
		contentsChanged
		! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:40'!
sendersShelfAction
	| action result return |
	action _ '<?', self element, '?>'.
	result _ OrderedCollection new.
	(self function = 'actions (shelf)') ifTrue: [
		shelf shelfTemplates keysAndValuesDo: [:key :template |
			((template findString: action) = 0) ifFalse: [
				result add: (Array with: 'shelf' with: key)]]].
	shelf bookTemplates keysAndValuesDo: [:key :template |
		((template findString: action) = 0) ifFalse: [
			result add: (Array with: 'book' with: key)]].
	return _ WriteStream on: String new.
	return
		nextPutAll: (result size asString);
		nextPutAll: ' MATCHES'.
	result do: [:arr | return
		nextPut: Character cr;
		nextPutAll: (arr at: 1);
		nextPutAll: ' template named ';
		nextPutAll: (arr at: 2)].
	(Workspace new)
		openLabel: ('Senders of ', action);
		contents: return contents;
		contentsChanged
		! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:33'!
shelfATAElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new element"
	labels add: ('new ', self ataSingle, '...').
	selections add: #newShelfATAElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Move element"
		labels add: 'move to...'.
		selections add: #moveShelfATAElement.
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameShelfATAElement.
		"Rename element"
		labels add: 'remove'.
		selections add: #removeShelfATAElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 2/24/2001 16:35'!
shelfActionElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Senders of"
	labels add: 'senders of'.
	selections add: #sendersShelfAction.
	lines add: (labels size).
	"Add a new element"
	labels add: ('new ', self ataSingle, '...').
	selections add: #newShelfATAElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Move element"
		labels add: 'move to...'.
		selections add: #moveShelfATAElement.
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameShelfATAElement.
		"Rename element"
		labels add: 'remove'.
		selections add: #removeShelfATAElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:14'!
shelfElementListMenu: aMenu
	self function caseOf:
		{['addresses (shelf)']->["Shelf Address"
			^self shelfATAElementListMenu: aMenu].
		['addresses (priv)']->["Private Address"
			^self shelfATAElementListMenu: aMenu].
		['templates (shelf)']->["Shelf Template"
			^self shelfATAElementListMenu: aMenu].
		['templates (book)']->["Book Template"
			^self shelfATAElementListMenu: aMenu].
		['actions (shelf)']->["Book Action"
			^self shelfActionElementListMenu: aMenu].
		['actions (book)']->["Page Action"
			^self shelfActionElementListMenu: aMenu].
		['settings']->["Settings"
			^self shelfSettingsElementListMenu: aMenu].
		[nil]->["No Function"
			^nil]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'element list menu' stamp: 'je77 4/26/2001 12:15'!
shelfSettingsElementListMenu: aMenu
	| labels lines selections |
	labels _ OrderedCollection new.
	lines _ OrderedCollection new.
	selections _ OrderedCollection new.
	"Add a new element"
	labels add: ('new setting...').
	selections add: #newShelfSettingElement.
	"Selected item"
	(elementListIndex = 0) ifFalse: [
		lines add: (labels size).
		"Rename element"
		labels add: 'rename...'.
		selections add: #renameShelfSettingElement.
		"Remove element"
		labels add: 'remove'.
		selections add: #removeShelfSettingElement].
	^aMenu labels: labels lines: lines selections: selections! !

!SwikiBrowser methodsFor: 'contents' stamp: 'je77 4/2/2001 10:28'!
bookContents: input notifying: aController
	| inputString inputCode book |
	inputString _ input asString.
	book _ self book.
	self function caseOf:
		{['addresses (book)']->["Book Address"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			book bookAddresses at: self element put: inputCode.
			book storage bookFunction: 'addresses' type: 'book' name: self element content: inputString.
			contents _ inputString.
			^true].
		['addresses (page)']->["Page Address"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book :page | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book :page |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			book pageAddresses at: self element put: inputCode.
			book storage bookFunction: 'addresses' type: 'page' name: self element content: inputString.
			contents _ inputString.
			^true].
		['addresses (priv)']->["Private Address"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			book privAddresses at: self element put: inputCode.
			book storage bookFunction: 'addresses' type: 'priv' name: self element content: inputString.
			contents _ inputString.
			^true].
		['templates (book)']->["Book Template"
			book bookTemplates at: self element put: (TextFormatter crToCrlf: inputString).
			book storage bookFunction: 'templates' type: 'book' name: self element content: inputString.
			contents _ inputString.
			^true].
		['templates (page)']->["Page Template"
			book pageTemplates at: self element put: (TextFormatter crToCrlf: inputString).
			book storage bookFunction: 'templates' type: 'page' name: self element content: inputString.
			contents _ inputString.
			^true].
		['actions (book)']->["Book Action"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			book bookActions at: self element put: inputCode.
			book storage bookFunction: 'actions' type: 'book' name: self element content: inputString.
			contents _ inputString.
			^true].
		['actions (page)']->["Page Action"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book :page | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book :page |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			book pageActions at: self element put: inputCode.
			book storage bookFunction: 'actions' type: 'page' name: self element content: inputString.
			contents _ inputString.
			^true].
		['settings']->["Settings"
			inputCode _ Compiler evaluate: inputString notifying: aController logged: false.
			inputCode ifNil: [^false].
			book rawSettings at: self element put: inputCode.
			book writeSettings.
			contents _ aController text asString.
			^true].
		['setup']->["Setup"
			inputCode _ Compiler evaluate: inputString notifying: aController logged: false.
			inputCode ifNil: [^false].
			book setup at: self element put: inputCode.
			shelf storage writeSetupForBook: book.
			contents _ aController text asString.
			^true]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !

!SwikiBrowser methodsFor: 'contents' stamp: 'je77 5/12/2001 16:03'!
contents: input notifying: aController
	(elementListIndex = 0) ifTrue: ["Nothing is selected to update"
		PopUpMenu notify: 'This text cannot be accepted
in this part of the browser'.
		^false].
	[self isSelectingABook ifTrue: [^self bookContents: input notifying: aController].
	self isSelectingAShelf ifTrue: [^self shelfContents: input notifying: aController]]
		on: OutOfScopeNotification do: [:ex | ex resume: true].
	^true! !

!SwikiBrowser methodsFor: 'contents' stamp: 'je77 2/17/2001 15:02'!
contentsMenu: aMenu shifted: shifted
| shiftMenu |
^ shifted 
	ifFalse: [aMenu 
		labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
accept (s)
cancel (l)
more...' 
		lines: #(3 5 9 12 14)
		selections: #(find findAgain setSearchString
again undo
copySelection cut paste pasteRecent
doIt printIt inspectIt
accept cancel
shiftedYellowButtonActivity)]

	ifTrue: [shiftMenu _ ParagraphEditor shiftedYellowButtonMenu.
		aMenu 
			labels: shiftMenu labelString 
			lines: shiftMenu lineArray
			selections: shiftMenu selections]! !

!SwikiBrowser methodsFor: 'contents' stamp: 'je77 4/2/2001 10:30'!
shelfContents: input notifying: aController
	| inputString inputCode |
	inputString _ input asString.
	self function caseOf:
		{['addresses (shelf)']->["Shelf Address"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			shelf shelfAddresses at: self element put: inputCode.
			shelf storage shelfFunction: 'addresses' type: 'shelf' name: self element content: inputString.
			contents _ inputString.
			^true].
		['addresses (priv)']->["Private Address"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			shelf privAddresses at: self element put: inputCode.
			shelf storage shelfFunction: 'addresses' type: 'priv' name: self element content: inputString.
			contents _ inputString.
			^true].
		['templates (shelf)']->["Shelf Template"
			shelf shelfTemplates at: self element put: (TextFormatter crToCrlf: inputString).
			shelf storage shelfFunction: 'templates' type: 'shelf' name: self element content: inputString.
			contents _ inputString.
			^true].
		['templates (book)']->["Book Template"
			shelf bookTemplates at: self element put: (TextFormatter crToCrlf: inputString).
			shelf storage shelfFunction: 'templates' type: 'book' name: self element content: inputString.
			contents _ inputString.
			^true].
		['actions (shelf)']->["Shelf Action"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			shelf shelfActions at: self element put: inputCode.
			shelf storage shelfFunction: 'actions' type: 'shelf' name: self element content: inputString.
			contents _ inputString.
			^true].
		['actions (book)']->["Book Action"
			Parser new parse: (ReadStream on: inputString) class: (nil class) noPattern: true context: (Compiler evaluate: '[:request :response :shelf :book | ]') notifying: aController ifFail: [^false].
			inputString _ aController text asString.
			inputCode _ Compiler evaluate: ('[:request :response :shelf :book |', inputString, ']') notifying: aController logged: false.
			inputCode ifNil: [^false].
			shelf bookActions at: self element put: inputCode.
			shelf storage shelfFunction: 'actions' type: 'book' name: self element content: inputString.
			contents _ inputString.
			^true].
		['settings']->["Settings"
			inputCode _ Compiler evaluate: inputString notifying: aController logged: false.
			inputCode ifNil: [^false].
			shelf settingsAt: self element put: inputCode.
			shelf writeSettings.
			contents _ aController text asString.
			^true]}
		otherwise: [self error: (self function, ' is not a valid function.')]! !


!SwikiBrowser class methodsFor: 'instance creation' stamp: 'je77 2/26/2001 13:04'!
asMorphOnShelf: aSwikiShelf
	^self asMorphOnShelf: aSwikiShelf label: 'Swiki Browser'! !

!SwikiBrowser class methodsFor: 'instance creation' stamp: 'je77 2/26/2001 13:03'!
asMorphOnShelf: aSwikiShelf label: label
	| aSwikiBrowser window |
	aSwikiBrowser _ self new shelf: aSwikiShelf.
	window _ (SystemWindow labelled: label) model: aSwikiBrowser.
	"book list"
	window addMorph: (PluggableListMorph on: aSwikiBrowser list: #bookList selected: #bookListIndex changeSelected: #bookListIndex: menu: #bookListMenu:) frame: (0@0 corner: 0.25@0.3).
	"function list"
	window addMorph: (PluggableListMorph on: aSwikiBrowser list: #functionList selected: #functionListIndex changeSelected: #functionListIndex: menu: nil) frame: (0.25@0 corner: 0.5@0.3).
	"category list"
	window addMorph: (PluggableListMorph on: aSwikiBrowser list: #categoryList selected: #categoryListIndex changeSelected: #categoryListIndex: menu: #categoryListMenu:) frame: (0.5@0 corner: 0.75@0.3).
	"element list"
	window addMorph: (PluggableListMorph on: aSwikiBrowser list: #elementList selected: #elementListIndex changeSelected: #elementListIndex: menu: #elementListMenu:) frame: (0.75@0 corner: 1@0.3).
	"content area"
	window addMorph: (PluggableTextMorph on: aSwikiBrowser text: #contents accept: #contents:notifying: readSelection: #contentsSelection menu: #contentsMenu:shifted:) frame: (0@0.3 corner: 1@1).
	^window! !


!SwikiColorScheme methodsFor: 'accessing' stamp: 'je77 3/8/2001 11:27'!
directory
	^directory! !

!SwikiColorScheme methodsFor: 'accessing' stamp: 'je77 3/7/2001 16:05'!
directory: aSwikiDirectory
	directory _ aSwikiDirectory! !

!SwikiColorScheme methodsFor: 'accessing' stamp: 'je77 3/21/2001 18:55'!
fileServer
	^fileServer! !

!SwikiColorScheme methodsFor: 'accessing' stamp: 'je77 3/7/2001 16:04'!
fileServer: fs
	fileServer _ fs! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/21/2001 18:53'!
button: button
	^self button: button alt: (altTags at: button ifAbsent: ['Missing Alternate Tag'])! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/19/2001 15:02'!
button: button alt: altText
	^directory referenceFileNamed: (button, buttonEnding)
		fs: fileServer
		options: (Dictionary new
			at: 'border' put: 0;
			at: 'alt' put: altText;
			yourself)! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/21/2001 18:53'!
button: button link: link
	^self button: button link: link alt: (altTags at: button ifAbsent: ['Missing Alternate Tag'])! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/19/2001 15:02'!
button: button link: link alt: altText
	| imgref |
	activeButton
		ifTrue: ["With rollovers"
			imgref _ directory referenceFileNamed: (button, buttonEnding)
				fs: fileServer
				options: (Dictionary new
					at: 'border' put: 0;
					at: 'alt' put: altText;
					at: 'name' put: button;
					yourself).
			^'<a href="', link, '" onMouseOver="rollOver(''', button, ''', true)" onMouseOut="rollOver(''', button, ''', false)">', imgref, '</a>']
		ifFalse: ["Without rollovers"
			imgref _ directory referenceFileNamed: (button, buttonEnding)
				fs: fileServer
				options: (Dictionary new
					at: 'border' put: 0;
					at: 'alt' put: altText;
					yourself).
			^'<a href="', link, '">', imgref, '</a>']! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/8/2001 10:28'!
emote: emote
	^directory referenceFileNamed: (emote, emoteEnding)
		fs: fileServer
		options: (Dictionary new
			at: 'border' put: 0;
			at: 'alt' put: (altTags at: emote ifAbsent: ['Missing Alternate Tag']);
			yourself)! !

!SwikiColorScheme methodsFor: 'buttons' stamp: 'je77 3/8/2001 12:07'!
mime: mime alt: altTag
	^directory referenceFileNamed: (mime, mimeEnding)
		fs: fileServer
		options: (Dictionary new
			at: 'border' put: 0;
			at: 'alt' put: altTag;
			yourself)! !

!SwikiColorScheme methodsFor: 'initialization' stamp: 'je77 3/26/2001 17:12'!
initialize
	self initializeTemplates.
	self initializeEndings.
	self initializeAltTags! !

!SwikiColorScheme methodsFor: 'initialization' stamp: 'je77 3/26/2001 17:09'!
initializeAltTags
	| file pos1 pos2 |
	altTags _ Dictionary new.
	(file _ directory fileRefsCacheAt: 'tags.xml' ifAbsent: [nil]) ifNotNil: [
		(directory readOnlyFile: file last) contentsOfEntireFile linesDo: [:line |
			(line beginsWith: '<button name="') ifTrue: [
				pos1 _ line findString: '" alt="' startingAt: 15.
				pos2 _ line findString: '" />' startingAt: (pos1 + 7).
				altTags
					at: (line copyFrom: 15 to: (pos1 - 1))
					put: (line copyFrom: (pos1 + 7) to: (pos2 - 1))]]]! !

!SwikiColorScheme methodsFor: 'initialization' stamp: 'je77 3/26/2001 17:11'!
initializeEndings
	"default ending is .gif"
	buttonEnding _ (directory fileRefsExists: 'top.gif')
		ifTrue: ['.gif']
		ifFalse: [(directory fileRefsExists: 'top.png')
			ifTrue: ['.png']
			ifFalse: [(directory fileRefsExists: 'top.jpg')
				ifTrue: ['.jpg']
				ifFalse: ['.gif']]].
	activeButton _ directory fileRefsExists: ('topact', buttonEnding).
	emoteEnding _ (directory fileRefsExists: 'happy.gif')
		ifTrue: ['.gif']
		ifFalse: [(directory fileRefsExists: 'happy.png')
			ifTrue: ['.png']
			ifFalse: [(directory fileRefsExists: 'happy.jpg')
				ifTrue: ['.jpg']
				ifFalse: ['.gif']]].
	mimeEnding _ (directory fileRefsExists: 'folder.gif')
		ifTrue: ['.gif']
		ifFalse: [(directory fileRefsExists: 'folder.png')
			ifTrue: ['.png']
			ifFalse: [(directory fileRefsExists: 'folder.jpg')
				ifTrue: ['.jpg']
				ifFalse: ['.gif']]]! !

!SwikiColorScheme methodsFor: 'initialization' stamp: 'je77 3/26/2001 17:29'!
initializeTemplates
	| name template |
	templates _ Dictionary new.
	directory filesAlphabetically do: [:versions |
		name _ versions name.
		(name endsWith: '.sm') ifTrue: ["Swiki Markup"
			name _ name copyUpToLast: $..
			template _ (directory readOnlyFile: versions last) contentsOfEntireFile.
			template _ TextFormatter crToCrlf: template.
			templates at: name put: template]]! !

!SwikiColorScheme methodsFor: 'templates' stamp: 'je77 3/19/2001 14:40'!
formatTemplate: templateName request: request response: response shelf: shelf
	^(ShelfTemplateFormatter swikiFormatter) format: (templates at: templateName ifAbsent: [^'']) request: request response: response shelf: shelf! !

!SwikiColorScheme methodsFor: 'templates' stamp: 'je77 3/7/2001 17:39'!
formatTemplate: templateName request: request response: response shelf: shelf book: book
	^(BookTemplateFormatter swikiFormatter) format: (templates at: templateName ifAbsent: [^'']) request: request response: response shelf: shelf book: book! !


!SwikiColorScheme class methodsFor: 'instance creation' stamp: 'je77 3/7/2001 16:06'!
on: aSwikiDirectory fileServer: fs
	| instance |
	instance _ self new.
	instance
		directory: aSwikiDirectory;
		fileServer: fs;
		initialize.
	^instance! !


!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:43'!
creationDate
	^Date fromSeconds: creationTime! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/8/2001 10:49'!
creationTime
	^Time fromSeconds: (creationTime \\ 86400)! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/4/2001 18:36'!
httpName
	^TextFormatter encodeToHttp: name! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:43'!
modificationDate
	^Date fromSeconds: modificationTime! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/8/2001 10:50'!
modificationTime
	^Time fromSeconds: (modificationTime \\ 86400)! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:40'!
name
	^name! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/5/2001 23:12'!
strictXmlName
	^TextFormatter encodeToStrictXmlCrlf: name! !

!SwikiEntry methodsFor: 'accessing' stamp: 'je77 1/5/2001 23:13'!
xmlName
	^TextFormatter encodeToXmlCrlf: name! !

!SwikiEntry methodsFor: 'initialization' stamp: 'je77 1/4/2001 16:40'!
fromArray: arr
	name _ arr at: 1.
	creationTime _ arr at: 2.
	modificationTime _ arr at: 3.! !

!SwikiEntry methodsFor: 'testing' stamp: 'je77 1/11/2001 17:56'!
isAnImage
	^false! !

!SwikiEntry methodsFor: 'testing' stamp: 'je77 1/9/2001 11:18'!
isValid
	^true! !


!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 1/8/2001 15:25'!
dir
	^dir! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 1/4/2001 16:04'!
dir: aFileDirectory
	dir _ aFileDirectory! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 1/9/2001 10:47'!
directoriesAlphabetically
	^dirRefsCache values asSortedCollection: [:a :b | (a name asLowercase) < (b name asLowercase)]! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:48'!
filesAlphabetically
	^fileRefsCache values asSortedCollection: [:a :b | (a name asLowercase) < (b name asLowercase)]! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 2/1/2001 17:12'!
httpPath
	^''! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 2/2/2001 15:02'!
localHttpPath
	^''! !

!SwikiDirectory methodsFor: 'accessing' stamp: 'je77 1/5/2001 23:18'!
size
	^(fileRefsCache size) + (dirRefsCache size)! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/4/2001 17:06'!
addToDirRefsCache: aSubSwikiDir at: key
	dirRefsCache at: key put: aSubSwikiDir
	! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 2/1/2001 17:11'!
addToDirServeCache: aSubSwikiDir at: key
	dirServeCache at: key put: aSubSwikiDir! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/4/2001 19:15'!
addToFileRefsCache: entry at: fullName
	| versions |
	(versions _ fileRefsCache at: fullName ifAbsent: [nil]) ifNil: [
		versions _ SwikiFileVersions named: fullName.
		fileRefsCache at: fullName put: versions].
	versions addEntry: entry! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/4/2001 18:38'!
addToFileServeCache: entry at: key
	fileServeCache at: key put: entry! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 2/1/2001 17:12'!
directoryNamed: dirName
	| subSwikiDir |
	^self directoryNamed: dirName ifAbsent: ["Create One"
		dir createDirectory: dirName.
		subSwikiDir _ SwikiSubDirectory fromArray: (dir entryAt: dirName) onDir: (dir directoryNamed: dirName) containingDirectory: self.
		self addToDirRefsCache: subSwikiDir at: subSwikiDir name.
		subSwikiDir]! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/9/2001 10:54'!
directoryNamed: dirName ifAbsent: aBlock
	^dirRefsCache at: dirName ifAbsent: aBlock! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/9/2001 10:36'!
fileRefsCacheAt: key ifAbsent: block
	^fileRefsCache at: key ifAbsent: block! !

!SwikiDirectory methodsFor: 'cacheing' stamp: 'je77 1/9/2001 10:36'!
fileServeCacheAt: key ifAbsent: block
	^fileServeCache at: key ifAbsent: block! !

!SwikiDirectory methodsFor: 'file operations' stamp: 'je77 1/7/2001 12:19'!
addAliasFrom: key to: value
	| aliasFile |
	aliasFile _ dir fileNamed: '.aliases'.
	aliasFile setToEnd.
	aliasFile
		nextPutAll: key;
		nextPut: $	;
		nextPutAll: value;
		nextPutAll: String crlf;
		close! !

!SwikiDirectory methodsFor: 'file operations' stamp: 'je77 1/9/2001 10:31'!
aliasDict
	| return key value |
	return _ Dictionary new.
	(dir fileExists: '.aliases') ifFalse: [^return].
	((dir readOnlyFileNamed: '.aliases') contentsOfEntireFile findTokens: String crlf)
		do: [:lineEntry | (lineEntry includes: $	) ifTrue: [
			key _ lineEntry copyUpTo: $	.
			value _ lineEntry copyFrom: (key size + 2) to: (lineEntry size).
			return at: key put: value]].
	^return! !

!SwikiDirectory methodsFor: 'file operations' stamp: 'je77 1/9/2001 10:31'!
fileEntries
	^(dir entries select: [:arr | (arr at: 4) not and: [(arr at: 1) ~= '.aliases']]) collect: [:arr | SwikiFile fromArray: arr onDir: dir]! !

!SwikiDirectory methodsFor: 'file operations' stamp: 'je77 2/22/2001 17:31'!
moveFileNamed: fullPath toFileName: fileName
	| rootName actualFileName versions entry |
	rootName _ self class rootNameFor: fileName.
	(versions _ fileRefsCache at: rootName ifAbsent: [nil])
		ifNil: [actualFileName _ dir checkName: rootName fixErrors: true.
			(rootName = actualFileName) ifFalse: ["Add alias"
				self addAliasFrom: actualFileName to: rootName]]
		ifNotNil: [actualFileName _ versions nextVersionName].
	"Move file to new location"
	dir rename: fullPath toBe: actualFileName.
	"Get and Add Entry"
	entry _ SwikiFile fromArray: (dir entryAt: actualFileName) onDir: dir.
	self addToFileRefsCache: entry at: rootName.
	self addToFileServeCache: entry at: entry httpName.
	"Return Versions"
	^fileRefsCache at: rootName! !

!SwikiDirectory methodsFor: 'file operations' stamp: 'je77 1/9/2001 10:31'!
readOnlyFile: aSwikiFile
	^dir readOnlyFileNamed: aSwikiFile name! !

!SwikiDirectory methodsFor: 'initialization' stamp: 'je77 1/5/2001 15:11'!
initialize
	"Fill Directories and Files"
	self initializeDirectories.
	self initializeFiles! !

!SwikiDirectory methodsFor: 'initialization' stamp: 'je77 2/1/2001 17:11'!
initializeDirectories
	| subSwikiDir |
	"Initialize Caches"
	dirServeCache _ Dictionary new.
	dirRefsCache _ Dictionary new.
	"Add subSwikiDirs"
	(dir entries select: [:entry | entry at: 4]) do: [:arr |
		subSwikiDir _ SwikiSubDirectory fromArray: arr onDir: (dir directoryNamed: (arr at: 1)) containingDirectory: self.
		"dirRefsCache"
		self addToDirRefsCache: subSwikiDir at: subSwikiDir name]! !

!SwikiDirectory methodsFor: 'initialization' stamp: 'je77 1/4/2001 19:16'!
initializeFiles
	| aliasDict rootName |
	"Initialize Caches"
	fileServeCache _ Dictionary new.
	fileRefsCache _ Dictionary new.
	"Add Files"
	aliasDict _ self aliasDict.
	self fileEntries do: [:entry | rootName _ entry rootName.
		(entry name = rootName)
			ifFalse: [rootName _ aliasDict at: entry name ifAbsent: [rootName]].
		self addToFileRefsCache: entry at: (aliasDict at: rootName ifAbsent: [rootName]).
		self addToFileServeCache: entry at: entry httpName]! !

!SwikiDirectory methodsFor: 'referencing' stamp: 'je77 1/9/2001 19:00'!
referenceDirFs: fs options: dict
	^fs referenceDirectory: self options: dict! !

!SwikiDirectory methodsFor: 'referencing' stamp: 'je77 1/9/2001 11:41'!
referenceFileNamed: aFileName fs: fs options: dict
	| versionEntry |
	^(versionEntry _ fileRefsCache at: aFileName ifAbsent: [nil])
		ifNil: [fs referenceMissingFileNamed: aFileName onDir: self options: dict]
		ifNotNil: [fs referenceFile: versionEntry onDir: self options: dict]! !

!SwikiDirectory methodsFor: 'serving' stamp: 'je77 1/9/2001 19:02'!
serveDirFs: fs options: dict
	^fs serveDirectory: self options: dict! !

!SwikiDirectory methodsFor: 'serving' stamp: 'je77 1/9/2001 11:08'!
serveFilePath: aFilePath fs: fs options: dict
	| fileEntry |
	^(fileEntry _ fileServeCache at: aFilePath ifAbsent: [nil])
		ifNil: [fs serveMissingFilePath: aFilePath onDir: self options: dict]
		ifNotNil: [fs serveFile: fileEntry onDir: self options: dict]! !

!SwikiDirectory methodsFor: 'serving' stamp: 'je77 1/9/2001 11:10'!
servePath: aPath fs: fs options: dict
	| dirPath filePath dirEntry |
	(aPath includes: $/) ifFalse: [^(aPath = '')
		ifTrue: [self serveDirFs: fs options: dict]
		ifFalse: [self serveFilePath: aPath fs: fs options: dict]].
	(aPath last = $/) ifTrue: [^(dirEntry _ dirServeCache at: aPath ifAbsent: [nil])
		ifNil: [filePath _ (aPath copyUpTo: '/'), '/'.
			(dirEntry _ dirServeCache at: filePath ifAbsent: [nil])
				ifNil: [fs serveMissingFilePath: aPath onDir: self options: dict]
				ifNotNil: [dirEntry servePath: (aPath copyFrom: (filePath size + 1) to: (aPath size)) fs: fs options: dict]]
		ifNotNil: [dirEntry serveDirFs: fs options: dict]].
	dirPath _ (aPath copyUpToLast: $/), '/'.
	(dirEntry _ dirServeCache at: dirPath ifAbsent: [nil]) ifNotNil: [
		^dirEntry serveFilePath: (aPath copyAfterLast: $/) fs: fs options: dict].
	filePath _ (aPath copyUpTo: '/'), '/'.
	^(dirEntry _ dirServeCache at: filePath ifAbsent: [nil])
		ifNil: [fs serveMissingFilePath: aPath onDir: self options: dict]
		ifNotNil: [dirEntry servePath: (aPath copyFrom: (filePath size + 1) to: (aPath size)) fs: fs options: dict]
! !

!SwikiDirectory methodsFor: 'testing' stamp: 'je77 1/9/2001 10:45'!
directoryExists: dirName
	^dirRefsCache includesKey: dirName! !

!SwikiDirectory methodsFor: 'testing' stamp: 'je77 1/5/2001 17:25'!
fileExists: fileName
	^dir fileExists: fileName! !

!SwikiDirectory methodsFor: 'testing' stamp: 'je77 1/9/2001 10:46'!
fileRefsExists: fileName
	^fileRefsCache includesKey: fileName! !

!SwikiDirectory methodsFor: 'testing' stamp: 'je77 1/9/2001 10:46'!
fileServeExists: fileName
	^fileServeCache includesKey: fileName! !

!SwikiDirectory methodsFor: 'testing' stamp: 'je77 2/1/2001 17:17'!
isASubDirectory
	^false! !


!SwikiEntry class methodsFor: 'instance creation' stamp: 'je77 1/4/2001 16:38'!
fromArray: arr
	^self new fromArray: arr! !

!SwikiEntry class methodsFor: 'private' stamp: 'je77 2/14/2001 15:26'!
rootNameFor: aString
	| tokens return ignore |
	tokens _ aString findTokens: '.'.
	(tokens size = 1) ifTrue: [^tokens at: 1].
	return _ WriteStream on: String new.
	return nextPutAll: (tokens at: 1).
	tokens _ tokens copyFrom: 2 to: tokens size.
	ignore _ true.
	tokens do: [:token | (ignore and: [token isAllDigits])
		ifTrue: [ignore _ false]
		ifFalse: [return
			nextPut: $.;
			nextPutAll: token]].
	^return contents! !


!SwikiDirectory class methodsFor: 'instance creation' stamp: 'je77 1/4/2001 17:35'!
fromArray: arr onDir: dir
	| instance |
	instance _ self fromArray: arr.
	instance dir: dir.
	instance initialize.
	^instance! !

!SwikiDirectory class methodsFor: 'instance creation' stamp: 'je77 1/8/2001 13:05'!
onDir: dir
	^self fromArray: (dir containingDirectory entryAt: (dir pathParts last)) onDir: dir! !


!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:38'!
fileSize
	^fileSize! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:39'!
fileSizeInWords
	(fileSize < 1000) ifTrue: [^fileSize asString, ' b'].
	(fileSize < 10000) ifTrue: [^((fileSize // 100) / 10) asFloat asString, ' kb'].
	(fileSize < 1000000) ifTrue: [^(fileSize // 1000) asString, ' kb'].
	(fileSize < 10000000) ifTrue: [^((fileSize // 100000) / 10) asFloat asString, ' Mb'].
	^(fileSize // 1000000) asString, ' Mb'! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:06'!
mimeType
	^versions mimeType! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/7/2001 12:08'!
rootName
	^self class rootNameFor: name! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 2/14/2001 13:33'!
version
	| tokens |
	"Files have versions of the form myfile.3.ext, where 3 is the version.
	A file without a numbered extension has version of 0"
	tokens _ name findTokens: '.'.
	(tokens size = 1) ifTrue: [^0].
	(tokens at: 2) isAllDigits ifFalse: [^0].
	^(tokens at: 2) asNumber! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:26'!
versions
	^versions! !

!SwikiFile methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:26'!
versions: aSwikiFileVersions
	versions _ aSwikiFileVersions! !

!SwikiFile methodsFor: 'initialization' stamp: 'je77 1/26/2001 17:23'!
dir: dir mimeType: mimeType
	"Sub-classes can overwrite this"! !

!SwikiFile methodsFor: 'initialization' stamp: 'je77 1/4/2001 17:36'!
fromArray: arr
	super fromArray: arr.
	fileSize _ arr at: 5.! !


!SwikiFile class methodsFor: 'initialize-release' stamp: 'je77 1/4/2001 17:17'!
handlesMime: aMimeType
	MimeToClass at: aMimeType put: self! !

!SwikiFile class methodsFor: 'initialize-release' stamp: 'je77 1/4/2001 17:14'!
initialize
	MimeToClass _ Dictionary new! !

!SwikiFile class methodsFor: 'instance creation' stamp: 'je77 1/26/2001 17:24'!
fromArray: arr onDir: dir
	| mime instance |
	mime _ MIMEDocument guessTypeFromName: (arr at: 1).
	instance _ (MimeToClass at: mime ifAbsent: [SwikiFile]) fromArray: arr.
	instance dir: dir mimeType: mime.
	instance isValid ifFalse: [
		instance _ SwikiFile fromArray: arr.
		instance dir: dir mimeType: mime].
	^instance! !


!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:56'!
refDirectoryBlock: aBlock
	refDirectoryBlock _ aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:20'!
refFileBlock: aBlock
	refFileBlock _ aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/11/2001 17:57'!
refFileDictAt: aClass put: aBlock
	refFileDict at: aClass put: aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/11/2001 17:58'!
refImageBlock: aBlock
	self refFileDictAt: SwikiImage put: aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:20'!
refMissingFileBlock: aBlock
	refMissingFileBlock _ aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 19:00'!
serveDirectoryBlock: aBlock
	serveDirectoryBlock _ aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:20'!
serveFileBlock: aBlock
	serveFileBlock _ aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/11/2001 17:57'!
serveFileDictAt: aClass put: aBlock
	serveFileDict at: aClass put: aBlock! !

!SwikiFileServer methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:20'!
serveMissingFileBlock: aBlock
	serveMissingFileBlock _ aBlock! !

!SwikiFileServer methodsFor: 'initialization' stamp: 'je77 2/8/2001 19:58'!
initialize
	refFileDict _ Dictionary new.
	serveFileDict _ Dictionary new! !

!SwikiFileServer methodsFor: 'referencing' stamp: 'je77 1/9/2001 19:00'!
referenceDirectory: aSwikiDir options: dict
	^refDirectoryBlock copy fixTemps value: aSwikiDir value: dict! !

!SwikiFileServer methodsFor: 'referencing' stamp: 'je77 1/11/2001 17:51'!
referenceFile: aSwikiFile onDir: aSwikiDir options: dict
	^(refFileDict at: (aSwikiFile last class) ifAbsent: [refFileBlock]) copy fixTemps value: aSwikiFile value: aSwikiDir value: dict! !

!SwikiFileServer methodsFor: 'referencing' stamp: 'je77 1/9/2001 18:20'!
referenceMissingFileNamed: aString onDir: aSwikiDir options: dict
	^refMissingFileBlock copy fixTemps value: aString value: aSwikiDir value: dict! !

!SwikiFileServer methodsFor: 'serving' stamp: 'je77 1/9/2001 19:01'!
serveDirectory: aSwikiDir options: dict
	^serveDirectoryBlock copy fixTemps value: aSwikiDir value: dict! !

!SwikiFileServer methodsFor: 'serving' stamp: 'je77 1/11/2001 17:50'!
serveFile: aSwikiFile onDir: aSwikiDir options: dict
	^(serveFileDict at: aSwikiFile class ifAbsent: [serveFileBlock]) copy fixTemps value: aSwikiFile value: aSwikiDir value: dict! !

!SwikiFileServer methodsFor: 'serving' stamp: 'je77 1/9/2001 18:20'!
serveMissingFilePath: path onDir: aSwikiDir options: dict
	^serveMissingFileBlock copy fixTemps value: path value: aSwikiDir value: dict! !


!SwikiFileServer class methodsFor: 'instance creation' stamp: 'je77 1/11/2001 17:47'!
new
	^super new initialize! !


!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:28'!
addEntry: aSwikiEntry
	| version size |
	aSwikiEntry versions: self.
	version _ aSwikiEntry version.
	size _ self size.
	"Pad collection, so that entries can be added in incorrect order"
	(size = version) ifTrue: [^self add: aSwikiEntry].
	(size > version) ifTrue: [^self at: (version + 1) put: aSwikiEntry].
	[self size = version] whileFalse: [self add: nil].
	self add: aSwikiEntry! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:49'!
httpName
	^TextFormatter encodeToHttp: name! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:07'!
mimeType
	^mimeType! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/26/2001 17:07'!
mimeType: mime
	mimeType _ mime! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:47'!
name
	^name! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/10/2001 10:37'!
name: aString
	name _ aString! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 2/14/2001 13:42'!
nextVersionName
	| tokens return |
	tokens _ self first rootName findTokens: '.'.
	return _ WriteStream on: String new.
	return
		nextPutAll: (tokens at: 1);
		nextPut: $.;
		nextPutAll: (self size asString).
	(tokens size = 1) ifFalse: [2 to: tokens size do: [:i | return
		nextPut: $.;
		nextPutAll: (tokens at: i)]].
	^return contents! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:48'!
strictXmlName
	^TextFormatter encodeToStrictXmlCrlf: name! !

!SwikiFileVersions methodsFor: 'accessing' stamp: 'je77 1/9/2001 18:48'!
xmlName
	^TextFormatter encodeToXmlCrlf: name! !

!SwikiFileVersions methodsFor: 'testing' stamp: 'je77 1/30/2001 19:15'!
isAnImage
	^self last isAnImage! !


!SwikiFileVersions class methodsFor: 'instance creation' stamp: 'je77 1/26/2001 17:15'!
named: aString
	^self new name: aString; mimeType: (MIMEDocument guessTypeFromName: aString)! !


!SwikiImage methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:59'!
height
	^height! !

!SwikiImage methodsFor: 'accessing' stamp: 'je77 1/4/2001 17:59'!
width
	^width! !

!SwikiImage methodsFor: 'initialization' stamp: 'je77 1/26/2001 17:20'!
dir: dir mimeType: mimeType
	| fileStream |
	"Get Width and Height information from file stream.
	On error, width and height become nil"
	fileStream _ dir readOnlyFileNamed: name.
	(mimeType = 'image/gif') ifTrue: [
		[self getWHFromGifStream: fileStream]
			ifError: [:a :b | width _ nil. height _ nil]].
	(mimeType = 'image/jpeg') ifTrue: [
		[self getWHFromJpegStream: fileStream]
			ifError: [:a :b | width _ nil. height _ nil]].
	(mimeType = 'image/png') ifTrue: [
		[self getWHFromPngStream: fileStream]
			ifError: [:a :b | width _ nil. height _ nil]].
	fileStream close! !

!SwikiImage methodsFor: 'initialization' stamp: 'je77 1/4/2001 17:57'!
getWHFromGifStream: stream
	"Get Width and Height from a GIF image"
	| reader |
	reader _ GIFReadWriter new on: stream.
	(reader hasMagicNumber: 'GIF87a' asByteArray) ifFalse: [
		(reader hasMagicNumber: 'GIF89a' asByteArray) ifFalse: [
			"Not a valid gif"
			^self]].
	width _ reader readWord.
	height _ reader readWord! !

!SwikiImage methodsFor: 'initialization' stamp: 'je77 3/26/2001 11:30'!
getWHFromJpegStream: stream
	"Get Width and Height from a JPEG image"
	stream binary.
	stream next: 4.
	stream next: ((stream next bitShift: 8) + (stream next) - 2).
	[#(16rFFC0 16rFFC1 16rFFC2 16rFFC3 16rFFC5 16rFFC6 16rFFC7 16rFFC9 16rFFCA 16rFFCB 16rFFCD 16rFFCE 16rFFCF) includes: ((stream next bitShift: 8) + (stream next))] whileFalse: [
		stream next: ((stream next bitShift: 8) + (stream next) - 2)].
	stream next: 3.
	height _ (stream next bitShift: 8) + (stream next).
	width _ (stream next bitShift: 8) + (stream next)! !

!SwikiImage methodsFor: 'initialization' stamp: 'je77 1/4/2001 17:58'!
getWHFromPngStream: stream
	"Get Width and Height from a PNG image"
	stream binary.
	(stream size > 24) ifTrue: ["Check to make sure it is a PNG"
		((stream next: 8) = (ByteArray withAll: #(137 80 78 71 13 10 26 10))) ifTrue: [
			stream next: 8.
			width _ (stream next bitShift: 24) + (stream next bitShift: 16) + (stream next bitShift: 8) + (stream next).
			height _ (stream next bitShift: 24) + (stream next bitShift: 16) + (stream next bitShift: 8) + (stream next)]]! !

!SwikiImage methodsFor: 'testing' stamp: 'je77 1/5/2001 21:17'!
isAnImage
	^true! !

!SwikiImage methodsFor: 'testing' stamp: 'je77 1/9/2001 11:19'!
isValid
	(width = nil) ifTrue: [^false].
	(height = nil) ifTrue: [^false].
	^super isValid! !


!SwikiImage class methodsFor: 'initialize-release' stamp: 'je77 1/4/2001 17:20'!
initialize
	self handlesMime: 'image/png'.
	self handlesMime: 'image/jpeg'.
	self handlesMime: 'image/gif'! !


!SwikiModule methodsFor: 'accessing' stamp: 'je77 5/6/2000 13:03'!
shelf
	^shelf! !

!SwikiModule methodsFor: 'accessing' stamp: 'je77 5/6/2000 13:03'!
shelf: aSwikiShelf
	shelf _ aSwikiShelf! !

!SwikiModule methodsFor: 'processing' stamp: 'je77 5/6/2000 13:19'!
filter: rawRequest
	^HttpSwikiRequest fromHttpRequest: rawRequest! !

!SwikiModule methodsFor: 'processing' stamp: 'je77 4/26/2001 11:40'!
process: rawRequest
	| request response |
	request _ self filter: rawRequest.
	response _ Dictionary new.
	shelf process: request response: response.
	^self responseFrom: response! !

!SwikiModule methodsFor: 'processing' stamp: 'je77 1/11/2001 18:53'!
responseFrom: dict
	| response content |
	response _ HttpResponse new.
	"header status"
	response status: (dict at: 'headerStatus' ifAbsent: [#ok]).
	"cacheing"
	(dict at: 'cacheing' ifAbsent: [false]) ifFalse: [
		response fieldAt: 'Pragma' put: 'no-cache';
			fieldAt: 'Expires' put: '0';
			fieldAt: 'Cache-Control' put: 'no cache'].
	"location (in case of redirect)"
	(dict includesKey: 'location') ifTrue: [
		response fieldAt: 'Location' put: (dict at: 'location')].
	"authenticate (in case of unauthorized)"
	(dict includesKey: 'authenticate') ifTrue: [
		response fieldAt: 'WWW-Authenticate' put: (dict at: 'authenticate')].
	"content type"
	response contentType: (dict at: 'contentType' ifAbsent: [MIMEDocument contentTypeHtml]).
	"contents"
	content _ dict at: 'content'.
	(content isKindOf: String)
		ifTrue: [response contents: (ReadStream on: content)]
		ifFalse: [(content isKindOf: BlockContext)
			ifTrue: [response _ response asHttpPartialResponseBlock: content]
			ifFalse: [response contents: content]].
	"return the response to be served"
	^response! !

!SwikiModule methodsFor: 'processing' stamp: 'je77 9/29/2000 10:14'!
stop
	^shelf stopProcessing! !


!SwikiModule class methodsFor: 'instance creation' stamp: 'je77 2/7/2001 14:59'!
swikiWebServer
	| instance |
	instance _ self new.
	instance shelf: (SwikiShelf new
		name: 'swiki';
		storage: (XmlSwikiStorage fromDir: (FileDirectory default directoryNamed: 'swiki'));
		load;
		yourself).
	^instance! !


!SwikiRequest methodsFor: 'accessing' stamp: 'je77 5/1/2000 16:12'!
address
	^address! !

!SwikiRequest methodsFor: 'accessing' stamp: 'je77 5/1/2000 16:12'!
book
	^book! !

!SwikiRequest methodsFor: 'accessing' stamp: 'je77 5/1/2000 16:12'!
page
	^page! !

!SwikiRequest methodsFor: 'accessing' stamp: 'je77 5/1/2000 16:15'!
security
	^security! !

!SwikiRequest methodsFor: 'accessing' stamp: 'je77 6/6/2000 08:23'!
security: aSwikiSecurityMember
	security _ aSwikiSecurityMember! !

!SwikiRequest methodsFor: 'initializing' stamp: 'je77 5/6/2000 16:54'!
initialize
	settings _ Dictionary new! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:02'!
settings
	^settings! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:02'!
settingsAt: key
	^settings at: key! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:03'!
settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: block! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:03'!
settingsAt: key put: value
	^settings at: key put: value! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:03'!
settingsIncludes: key
	^settings includesKey: key! !

!SwikiRequest methodsFor: 'settings' stamp: 'je77 5/6/2000 17:03'!
settingsRemove: key
	settings removeKey: key ifAbsent: []! !


!HttpSwikiRequest methodsFor: 'accessing' stamp: 'je77 5/6/2000 13:41'!
raw
	^raw! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 12:50'!
fieldsAsBooleanKey: aKey
	^self fieldsAsBooleanKey: aKey ifAbsent: [false]! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 12:49'!
fieldsAsBooleanKey: aKey ifAbsent: block
	(raw postFields)
		ifNil: [(raw getFields)
			ifNil: [^block value]
			ifNotNil: [^(raw getFields at: aKey ifAbsent: [^block value]) = 'true']]
		ifNotNil: [^(raw postFields at: aKey ifAbsent: [
			(raw getFields)
				ifNil: [^block value]
				ifNotNil: [^(raw getFields at: aKey ifAbsent: [^block value]) = 'true']]) = 'true']! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 10:55'!
fieldsAsNumberKey: aKey
	^self fieldsAsNumberKey: aKey ifAbsent: [0]! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 12:49'!
fieldsAsNumberKey: aKey ifAbsent: block
	(raw postFields)
		ifNil: [(raw getFields)
			ifNil: [^block value]
			ifNotNil: [^(raw getFields at: aKey ifAbsent: [^block value]) asNumber]]
		ifNotNil: [^(raw postFields at: aKey ifAbsent: [
			(raw getFields)
				ifNil: [^block value]
				ifNotNil: [^(raw getFields at: aKey ifAbsent: [^block value]) asNumber]]) asNumber]! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 10:39'!
fieldsHasKey: aKey
	^(raw postFields)
		ifNil: [(raw getFields)
			ifNil: [false]
			ifNotNil: [raw getFields includesKey: aKey]]
		ifNotNil: [(raw postFields includesKey: aKey)
			ifTrue: [true]
			ifFalse: [(raw getFields)
				ifNil: [false]
				ifNotNil: [raw getFields includesKey: aKey]]]! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 11:23'!
fieldsKey: aKey
	^self fieldsKey: aKey ifAbsent: ['']! !

!HttpSwikiRequest methodsFor: 'fields' stamp: 'je77 5/7/2000 11:23'!
fieldsKey: aKey ifAbsent: block
	^(raw postFields)
		ifNil: [(raw getFields)
			ifNil: [block value]
			ifNotNil: [raw getFields at: aKey ifAbsent: block]]
		ifNotNil: [raw postFields at: aKey ifAbsent: [
			(raw getFields)
				ifNil: [block value]
				ifNotNil: [raw getFields at: aKey ifAbsent: block]]]! !

!HttpSwikiRequest methodsFor: 'initializing' stamp: 'je77 6/3/2000 22:28'!
fromHttpRequest: rawRequest
	| tokens |
	raw _ rawRequest.
	tokens _ (raw url copyUpTo: $?) findTokens: '/.'.
	(tokens size = 0) ifTrue: [^self].
	book _ tokens at: 1.
	(tokens size = 1) ifTrue: [address _ 'default'.
		^self].
	(tokens at: 2) isAllDigits
		ifTrue: [page _ (tokens at: 2) asNumber.
			address _ (tokens size > 2) ifTrue: [tokens at: 3] ifFalse: ['default']]
		ifFalse: [address _ tokens at: 2]! !

!HttpSwikiRequest methodsFor: 'references' stamp: 'je77 6/19/2000 09:46'!
referenceShelf: shelf address: theAddress
	^'/', theAddress! !

!HttpSwikiRequest methodsFor: 'references' stamp: 'je77 5/25/2000 09:08'!
referenceShelf: shelf book: theBook
	^'/', theBook name! !

!HttpSwikiRequest methodsFor: 'references' stamp: 'je77 5/25/2000 09:07'!
referenceShelf: shelf book: theBook address: theAddress
	^'/', theBook name, '/', theAddress! !

!HttpSwikiRequest methodsFor: 'references' stamp: 'je77 5/6/2000 17:25'!
referenceShelf: shelf book: theBook page: thePage
	^'/', theBook name, '/', (thePage id asString)! !

!HttpSwikiRequest methodsFor: 'references' stamp: 'je77 5/6/2000 17:25'!
referenceShelf: shelf book: theBook page: thePage address: theAddress
	^'/', theBook name, '/', (thePage id asString), '.', theAddress! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 5/7/2000 12:41'!
formText
	| texts index |
	(self fieldsHasKey: 'text1') ifFalse: [^''].
	texts _ Dictionary new.
	index _ 1.
	[self fieldsHasKey: ('text', index asString)]
		whileTrue: [texts at: (index asString) put: (self fieldsKey: ('text', index asString)).
			index _ index + 1].
	^texts! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 5/7/2000 12:25'!
isFramesCapable
	^((raw header at: 'user-agent' ifAbsent: [^false]) asLowercase beginsWith: 'lynx') not! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 5/7/2000 12:40'!
text
	^self fieldsKey: 'text' ifAbsent: [self formText]! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 6/6/2000 08:31'!
url
	^raw url! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 5/7/2000 13:53'!
user
	"Give IP address since this is the closest that an HttpRequest without login, password."
	^raw remoteAddress! !

!HttpSwikiRequest methodsFor: 'utility' stamp: 'je77 6/6/2000 08:31'!
userID
	"Should be refactored"
	| userID i |
	userID _ raw header at: 'authorization' ifAbsent: [^nil].
	(userID notNil and: [(i _ userID findString: 'Basic ') > 0])
		ifTrue: [userID _ userID copyFrom: i+6 to: userID size]
		ifFalse: [userID _ nil].
	^userID! !


!HttpSwikiRequest class methodsFor: 'instance creation' stamp: 'je77 5/6/2000 17:07'!
fromHttpRequest: rawRequest
	^self new initialize; fromHttpRequest: rawRequest! !


!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 14:17'!
ip
	^(self settingsAt: 'ip' ifAbsent: [^nil]) asNumber! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 13:34'!
mask
	^(self settingsAt: 'mask' ifAbsent: [^16rFFFFFFFF]) asNumber! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 14:18'!
password
	^self settingsAt: 'password' ifAbsent: [nil]! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/6/2000 09:38'!
privileges
	^privileges! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/7/2000 11:05'!
privileges: privs
	privileges _ privs! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 12:26'!
settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: block! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 12:27'!
settingsAt: key put: setting
	settings at: key put: setting! !

!SwikiSecurityMember methodsFor: 'accessing' stamp: 'je77 7/10/2000 14:18'!
user
	^self settingsAt: 'user' ifAbsent: [nil]! !

!SwikiSecurityMember methodsFor: 'initializing' stamp: 'je77 7/7/2000 11:05'!
initialize
	settings _ Dictionary new.! !

!SwikiSecurityMember methodsFor: 'storage' stamp: 'je77 9/20/2000 14:14'!
asXml
	| return |
	return _ '<member>', String cr.
	settings keysAndValuesDo: [:key :value | return _ return, '<m type="', (TextFormatter encodeToStrictXmlCr: key), '">', (TextFormatter encodeToXmlCr: value), '</m>', String cr].
	^return, '</member>'! !

!SwikiSecurityMember methodsFor: 'testing'!
handlesBookAddress: test
	^privileges handlesBookAddress: test! !

!SwikiSecurityMember methodsFor: 'testing' stamp: 'je77 7/7/2000 10:55'!
handlesOther: test
	^privileges handlesOther: test! !

!SwikiSecurityMember methodsFor: 'testing'!
handlesPageAddress: test
	^privileges handlesPageAddress: test! !

!SwikiSecurityMember methodsFor: 'testing' stamp: 'Je77 8/8/2000 13:04'!
handlesShelfAddress: test
	^privileges handlesShelfAddress: test! !


!SwikiSecurityMember class methodsFor: 'instance creation' stamp: 'je77 9/20/2000 14:12'!
fromXml: xml
	| instance pos1 pos2 type |

	instance _ self new.
	instance initialize.
	"Get Member Settings"
	pos1 _ (xml findString: '<member>') + 8.
	pos1 _ xml findString: '<m' startingAt: pos1.
	[pos1 > 0] whileTrue: [
		pos1 _ (xml findString: 'type="' startingAt: pos1) + 6.
		pos2 _ (xml findString: '"' startingAt: pos1) - 1.
		type _ TextFormatter decodeFromXmlCrlf: ((xml copyFrom: pos1 to: pos2) asLowercase).
		pos1 _ (xml findString: '>' startingAt: pos2) + 1.
		pos2 _ (xml findString: '<' startingAt: pos1) - 1.
		instance settingsAt: type put: (TextFormatter decodeFromXmlCrlf: (xml copyFrom: pos1 to: pos2)).
		pos1 _ xml findString: '<m' startingAt: pos2].
	^instance
! !

!SwikiSecurityMember class methodsFor: 'instance creation' stamp: 'Je77 8/2/2000 09:36'!
new
	^super new initialize! !


!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/10/2000 16:49'!
aclDict
	^aclDict! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 1/16/2001 11:47'!
addACLMember: member
	aclDict at: (self class encode: (member user) password: (member password)) put: member! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/10/2000 12:24'!
addIPMember: member
	ipColl add: (Array with: (member mask) with: (member ip) with: member)! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/10/2000 14:18'!
addMember: member
	(member user) ifNotNil: [self addACLMember: member].
	(member ip) ifNotNil: [self addIPMember: member]! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/6/2000 09:38'!
default
	^default! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/7/2000 11:23'!
default: defaultMember
	default _ defaultMember! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'je77 7/10/2000 16:49'!
ipColl
	^ipColl! !

!SwikiSecurityModule methodsFor: 'accessing' stamp: 'Je77 8/2/2000 10:53'!
members
	| members |

	members _ OrderedCollection new.
	aclDict valuesDo: [:member | members add: member].
	ipColl do: [:element | (members includes: (element at: 3)) ifFalse: [
		members add: (element at: 3)]].
	^members! !

!SwikiSecurityModule methodsFor: 'initializing' stamp: 'je77 7/10/2000 10:05'!
initialize
	aclDict _ Dictionary new.
	ipColl _ OrderedCollection new! !

!SwikiSecurityModule methodsFor: 'processing' stamp: 'je77 7/10/2000 16:07'!
filterIP: request
	| ipInt |

	(ipColl size = 0) ifTrue: [^request security: default].
	ipInt _ 0.
	request user do: [:i | ipInt _ (ipInt*256) + i].
	ipColl do: [:ipArr | ((ipInt bitAnd: (ipArr at: 1)) = (ipArr at: 2))
		ifTrue: [^request security: (ipArr at: 3)]].
	^request security: default! !

!SwikiSecurityModule methodsFor: 'processing' stamp: 'je77 2/20/2001 10:27'!
process: request response: response shelf: shelf
	| address userID |	

	(address _ request address) ifNil: [address _ 'default'].
	(userID _ request userID) ifNotNil: ["Process by UserID"
		request security: (aclDict at: userID ifAbsent: [default]).
		((request fieldsHasKey: 'book')
			ifTrue: [request security handlesBookAddress: address]
			ifFalse: [request security handlesShelfAddress: address])
			ifTrue: [^true]].
	"Process by IP"
	self filterIP: request.
	^(request fieldsHasKey: 'book')
		ifTrue: [request security handlesBookAddress: address]
		ifFalse: [request security handlesShelfAddress: address]! !

!SwikiSecurityModule methodsFor: 'processing' stamp: 'je77 2/20/2001 10:38'!
process: request response: response shelf: shelf book: book
	| address userID |

	"Get Address"
	address _ request address.
	address _ (request page)
		ifNil: [(book hasBookAddress: address)
			ifTrue: [address]
			ifFalse: ['default']]
		ifNotNil: [(book hasPageAddress: address)
			ifTrue: [address]
			ifFalse: ['default']].
	(userID _ request userID) ifNotNil: ["Process by UserID"
		request security: (aclDict at: userID ifAbsent: [default]).
		((request page)
			ifNil: [request security handlesBookAddress: address]
			ifNotNil: [request security handlesPageAddress: address])
			ifTrue: [^true]].
	"Process by IP"
	self filterIP: request.
	^(request page)
		ifNil: [request security handlesBookAddress: address]
		ifNotNil: [request security handlesPageAddress: address]! !

!SwikiSecurityModule methodsFor: 'storage' stamp: 'Je77 8/2/2000 10:51'!
asXml
	| return privDict |
	return _ '<?xml version="1.0"?>
<security>
<default priv="', (default privileges name), '" />
'.
	privDict _ Dictionary new.
	self members do: [:member | (privDict includesKey: (member privileges))
		ifTrue: [(privDict at: (member privileges)) add: member]
		ifFalse: [privDict at: (member privileges) put: (OrderedCollection with: member)]].
	privDict keysAndValuesDo: [:priv :members |
		return _ return, '<group priv="', (priv name), '">', String cr.
		members do: [:member | return _ return, member asXml, String cr].
		return _ return, '</group>', String cr].
	^return, '</security>'! !

!SwikiSecurityModule methodsFor: 'storage' stamp: 'Je77 8/2/2000 09:37'!
fromXml: xml withDict: dict
	| pos1 pos2 pos3 priv members member |
	"Get Default Swiki Security Member"
	pos1 _ xml findString: '<default priv="'.
	pos2 _ xml findString: '" />' startingAt: pos1.
	default _ SwikiSecurityMember new.
	priv _ dict at: (xml copyFrom: (pos1 + 15) to: (pos2 - 1)).
	default privileges: priv.
	[(pos1 _ xml findString: '<group priv="' startingAt: pos1) = 0] whileFalse: [
		pos2 _ xml findString: '">' startingAt: pos1.
		priv _ dict at: (xml copyFrom: (pos1 + 13) to: (pos2 - 1)).
		pos1 _ xml findString: '</group>' startingAt: pos2.
		members _ xml copyFrom: (pos2 + 2) to: (pos1 - 1).
		pos3 _ 1.
		[(pos2 _ members findString: '<member>' startingAt: pos3) = 0] whileFalse: [
			pos3 _ members findString: '</member>' startingAt: pos2.
			member _ SwikiSecurityMember fromXml: (members copyFrom: pos2 to: (pos3 + 8)).
			member privileges: priv.
			self addMember: member]].! !


!SwikiSecurityModule class methodsFor: 'instance creation' stamp: 'Je77 8/2/2000 09:33'!
fromXml: xml withDict: dict
	| instance |
	instance _ self new.
	instance fromXml: xml withDict: dict.
	^instance! !

!SwikiSecurityModule class methodsFor: 'instance creation' stamp: 'Je77 8/2/2000 09:33'!
new
	^super new initialize! !

!SwikiSecurityModule class methodsFor: 'utility' stamp: 'je77 1/16/2001 11:48'!
encode: nameString password: pwdString
	"Encode per RFC1421 of the username:password combination."

	| clear code clearSize idx map |
	clear := (nameString, ':', pwdString) asByteArray.
	clearSize := clear size.
	[ clear size \\ 3 ~= 0 ] whileTrue: [ clear := clear, #(0) ].
	idx := 1.
	map := 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'.
	code := WriteStream on: ''.
	[ idx < clear size ] whileTrue: [ code 
		nextPut: (map at: (clear at: idx) // 4 + 1);
		nextPut: (map at: (clear at: idx) \\ 4 * 16 + ((clear at: idx + 1) // 16) + 1);
   		nextPut: (map at: (clear at: idx + 1) \\ 16 * 4 + ((clear at: idx + 2) // 64) + 1);
   		nextPut: (map at: (clear at: idx + 2) \\ 64 + 1).
		idx := idx + 3 ].
	code := code contents.
	idx := code size.
	clear size - clearSize timesRepeat: [ code at: idx put: $=. idx := idx - 1].
	^code! !

!SwikiSecurityModule class methodsFor: 'utility' stamp: 'Je77 8/2/2000 09:59'!
isIpString: aString
	| tokens asNumber |
	tokens _ aString findTokens: '.'.
	(tokens size = 4) ifFalse: [^false].
	tokens do: [:token | "Check for 0..255"
		token isAllDigits ifFalse: [^false].
		asNumber _ token asNumber.
		(asNumber < 256) ifFalse: [^false].
		(asNumber >= 0) ifFalse: [^false]].
	^true! !

!SwikiSecurityModule class methodsFor: 'utility' stamp: 'je77 7/11/2000 09:33'!
toIpNumber: string
	| return |
	return _ 0.
	(string findTokens: '.') do: [:i | (i isAllDigits)
		ifTrue: [return _ (256 * return) + (i asNumber)]].
	^return! !

!SwikiSecurityModule class methodsFor: 'utility' stamp: 'je77 7/11/2000 09:39'!
toIpString: int
	| one two three four |
	two _ int // 256.
	one _ int - (256 * two).
	three _ two // 256.
	two _ two - (256 * three).
	four _ three // 256.
	three _ three - (256 * four).
	^four asString, '.', three asString, '.', two asString, '.', one asString! !


!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'Je77 8/8/2000 12:26'!
addAddress: priv
	| tokens |

	tokens _ priv findTokens: '.'.
	(tokens size = 2) ifFalse: [^false].
	((tokens at: 2) = 'page') ifTrue: [
		pageAddresses add: (tokens at: 1).
		^true].
	((tokens at: 2) = 'book') ifTrue: [
		bookAddresses add: (tokens at: 1).
		^true].
	((tokens at: 2) = 'shelf') ifTrue: [
		shelfAddresses add: (tokens at: 1).
		^true].
	^false! !

!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'je77 7/7/2000 11:15'!
addOther: priv
	other add: priv.
	^true! !

!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'je77 7/6/2000 14:09'!
default
	^default! !

!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'je77 7/7/2000 10:57'!
default: aBoolean
	default _ aBoolean! !

!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'je77 7/7/2000 10:58'!
name
	^name! !

!SwikiSecurityPrivileges methodsFor: 'accessing' stamp: 'je77 7/7/2000 10:58'!
name: aString
	name _ aString! !

!SwikiSecurityPrivileges methodsFor: 'initializing' stamp: 'Je77 8/8/2000 12:25'!
initialize
	default _ true.
	other _ OrderedCollection new.
	pageAddresses _ OrderedCollection new.
	bookAddresses _ OrderedCollection new.
	shelfAddresses _ OrderedCollection new! !

!SwikiSecurityPrivileges methodsFor: 'testing'!
handlesBookAddress: test
	(bookAddresses includes: test)
		ifTrue: [^default not]
		ifFalse: [^default]! !

!SwikiSecurityPrivileges methodsFor: 'testing' stamp: 'je77 7/7/2000 10:54'!
handlesOther: test
	(other includes: test)
		ifTrue: [^default not]
		ifFalse: [^default]! !

!SwikiSecurityPrivileges methodsFor: 'testing'!
handlesPageAddress: test
	(pageAddresses includes: test)
		ifTrue: [^default not]
		ifFalse: [^default]! !

!SwikiSecurityPrivileges methodsFor: 'testing' stamp: 'Je77 8/8/2000 12:25'!
handlesShelfAddress: test
	(shelfAddresses includes: test)
		ifTrue: [^default not]
		ifFalse: [^default]! !


!SwikiSecurityPrivileges class methodsFor: 'instance creation' stamp: 'je77 7/7/2000 11:13'!
named: aName default: aBoolean
	^(self new)
		initialize;
		name: aName;
		default: aBoolean;
		yourself! !


!SwikiStorage methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:42'!
dir
	^dir! !

!SwikiStorage methodsFor: 'accessing' stamp: 'je77 2/23/2001 11:22'!
dir: aFileDirectory
	dir _ aFileDirectory.
	dict _ Dictionary new! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'Je77 8/4/2000 15:03'!
createBook: book
	dir createDirectory: book name.
	self writeSetupForBook: book! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'je77 2/24/2001 13:39'!
loadActionsForShelf: shelf
	| actionsDir metaColl content |
	actionsDir _ dir directoryNamed: 'default'.
	(actionsDir directoryExists: 'actions') ifFalse: [^self].
	actionsDir _ actionsDir directoryNamed: 'actions'.
	metaColl _ self getMetaCollForDir: actionsDir.
	dict at: 'actions' put: metaColl.
	metaColl do: [:arr |
		content _ (actionsDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		(arr at: 2) caseOf: {
			['book']->[shelf bookActions at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book | ', content , ']')].
			['shelf']->[shelf shelfActions at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf | ', content , ']')]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'je77 2/24/2001 13:42'!
loadAddressesForShelf: shelf
	| addressesDir metaColl content |
	addressesDir _ dir directoryNamed: 'default'.
	(addressesDir directoryExists: 'addresses') ifFalse: [^self].
	addressesDir _ addressesDir directoryNamed: 'addresses'.
	metaColl _ self getMetaCollForDir: addressesDir.
	dict at: 'addresses' put: metaColl.
	metaColl do: [:arr |
		content _ (addressesDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		(arr at: 2) caseOf: {
			['priv']->[shelf privAddresses at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf | ', content , ']')].
			['shelf']->[shelf shelfAddresses at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf | ', content , ']')]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'je77 5/2/2000 10:32'!
loadSettingsForShelf: shelf
	shelf settings: Dictionary new! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'je77 5/2/2000 09:48'!
loadShelf: shelf
	self
		loadSettingsForShelf: shelf;
		loadAddressesForShelf: shelf;
		loadTemplatesForShelf: shelf;
		loadActionsForShelf: shelf! !

!SwikiStorage methodsFor: 'shelf (load)' stamp: 'je77 2/24/2001 13:45'!
loadTemplatesForShelf: shelf
	| templatesDir metaColl content |
	templatesDir _ dir directoryNamed: 'default'.
	(templatesDir directoryExists: 'templates') ifFalse: [^self].
	templatesDir _ templatesDir directoryNamed: 'templates'.
	metaColl _ self getMetaCollForDir: templatesDir.
	dict at: 'templates' put: metaColl.
	metaColl do: [:arr |
		content _ (templatesDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		"Use Internet Line Endings"
		content _ TextFormatter crToCrlf: content.
		(arr at: 2) caseOf: {
			['book']->[shelf bookTemplates at: (arr at: 3) put: content].
			['shelf']->[shelf shelfTemplates at: (arr at: 3) put: content]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 17:08'!
addShelfFunction: function type: type category: category
	(dict includesKey: (function, type))
		ifTrue: [(dict at: (function, type)) add: category]
		ifFalse: [dict at: (function, type) put: (OrderedCollection with: category)]! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 16:54'!
addShelfFunction: function type: type name: name
	^self addShelfFunction: function type: type name: name category: nil! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 4/2/2001 10:47'!
addShelfFunction: function type: type name: name category: category
	| dDir fDir fileNames id coll |
	dDir _ dir directoryNamed: 'default'.
	(dDir directoryExists: function) ifFalse: [dDir createDirectory: function].	
	fDir _ dDir directoryNamed: function.
	fileNames _ fDir fileNames.
	id _ 1.
	[fileNames includes: id asString] whileTrue: [id _ id + 1].
	coll _ dict at: function ifAbsent: [dict at: function put: OrderedCollection new].
	coll add: (Array with: id asString with: type with: name with: category).
	(fDir newFileNamed: id asString) close.
	"Remove category from empty categories"
	(category notNil and: [dict includesKey: (function, type)]) ifTrue: [
		(dict at: (function, type)) remove: category ifAbsent: []].
	"Update meta and browser log files"
	self putMetaColl: coll forDir: fDir.
	self logChangeShelfFunction: function type: type name: name! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 15:34'!
allShelfFunction: function type: type
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return select: [:arr | (arr at: 2) = type] thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 15:35'!
ayuShelfFunction: function type: type
	"As Yet Unclassified"
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return
		select: [:arr | ((arr at: 2) = type) and: [(arr at: 4) isNil]]
		thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 13:47'!
categoriesShelfFunction: function type: type
	| metaColl return ayu |
	metaColl _ dict at: function ifAbsent: [^(OrderedCollection with: '-- all --')].
	ayu _ false.
	return _ SortedCollection sortBlock: [:a :b | a asLowercase < b asLowercase].
	metaColl do: [:arr | ((arr at: 2) = type) ifTrue: [(arr at: 4)
		ifNil: [ayu _ true]
		ifNotNil: [(return includes: (arr at: 4)) ifFalse: [
			return add: (arr at: 4)]]]].
	"Add Empty Categories"
	(dict includesKey: (function, type)) ifTrue: [
		(dict at: (function, type)) do: [:cat |
			(return includes: cat) ifFalse: [return add: cat]]].
	return _ return asOrderedCollection.
	return addFirst: '-- all --'.
	ayu ifTrue: [return add: 'as yet unclassified'].
	^return! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 17:09'!
deleteShelfFunction: function type: type category: category
	| coll |
	coll _ dict at: function.
	coll do: [:arr | ((arr at: 4) = category) ifTrue: [
		arr at: 4 put: nil]].
	self putMetaColl: coll forDir: ((dir directoryNamed: 'default') directoryNamed: function).! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 4/2/2001 10:48'!
deleteShelfFunction: function type: type name: name
	| coll fDir |
	coll _ OrderedCollection new.
	fDir _ (dir directoryNamed: 'default') directoryNamed: function.
	(dict at: function) do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [fDir deleteFileNamed: (arr at: 1)]
		ifFalse: [coll add: arr]].
	dict at: function put: coll.
	"Update meta and browser log files"
	self putMetaColl: coll forDir: fDir.
	self logDeleteShelfFunction: function type: type name: name! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 3/19/2001 20:02'!
moveShelfFunction: function type: type name: name
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [arr at: 4 put: nil]].
	self putMetaColl: coll forDir: ((dir directoryNamed: 'default') directoryNamed: function)! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 3/19/2001 20:03'!
moveShelfFunction: function type: type name: name toCategory: category
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [arr at: 4 put: category]].
	self putMetaColl: coll forDir: ((dir directoryNamed: 'default') directoryNamed: function)! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 17:11'!
renameShelfFunction: function type: type category: fromName to: toName
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 4) = fromName])
		ifTrue: [arr at: 4 put: toName]].
	self putMetaColl: coll forDir: ((dir directoryNamed: 'default') directoryNamed: function)! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 4/2/2001 10:52'!
renameShelfFunction: function type: type name: fromName to: toName
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = fromName])
		ifTrue: [arr at: 3 put: toName]].
	"Update meta and browser log files"
	self putMetaColl: coll forDir: ((dir directoryNamed: 'default') directoryNamed: function).
	self logDeleteShelfFunction: function type: type name: fromName.
	self logChangeShelfFunction: function type: type name: toName! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 15:35'!
shelfFunction: function type: type category: category
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return
		select: [:arr | ((arr at: 2) = type) and: [(arr at: 4) = category]]
		thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 2/24/2001 15:42'!
shelfFunction: function type: type name: name
	| coll |
	coll _ dict at: function ifAbsent: [
		self error: (function, ' does not contain ', name, ' of type ', type)].
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name]) ifTrue: [
		^(((dir directoryNamed: 'default') directoryNamed: function) readOnlyFileNamed: (arr at: 1))
			contentsOfEntireFile]]! !

!SwikiStorage methodsFor: 'shelf (browser)' stamp: 'je77 4/2/2001 10:55'!
shelfFunction: function type: type name: name content: content
	| coll fDir file |
	coll _ dict at: function ifAbsent: [
		self error: (function, ' does not contain ', name, ' of type ', type)].
	fDir _ (dir directoryNamed: 'default') directoryNamed: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name]) ifTrue: [
		fDir deleteFileNamed: (arr at: 1).
		file _ fDir newFileNamed: (arr at: 1).
		file nextPutAll: content.
		file close.
		"Update browser log"
		self logChangeShelfFunction: function type: type name: name]]! !

!SwikiStorage methodsFor: 'shelf (logging)' stamp: 'je77 4/2/2001 14:44'!
logChangeShelfFunction: function type: type name: name
	((dir directoryNamed: 'default') fileNamed: 'browser.log')
		setToEnd;
		nextPutAll: (Date today asString);
		nextPut: Character tab;
		nextPutAll: (Time now asString);
		nextPut: Character tab;
		nextPutAll: 'changeShelfFunction';
		nextPut: Character tab;
		nextPutAll: function;
		nextPut: Character tab;
		nextPutAll: type;
		nextPut: Character tab;
		nextPutAll: name;
		nextPut: Character cr;
		close
! !

!SwikiStorage methodsFor: 'shelf (logging)' stamp: 'je77 4/2/2001 14:44'!
logDeleteShelfFunction: function type: type name: name
	((dir directoryNamed: 'default') fileNamed: 'browser.log')
		setToEnd;
		nextPutAll: (Date today asString);
		nextPut: Character tab;
		nextPutAll: (Time now asString);
		nextPut: Character tab;
		nextPutAll: 'deleteShelfFunction';
		nextPut: Character tab;
		nextPutAll: function;
		nextPut: Character tab;
		nextPutAll: type;
		nextPut: Character tab;
		nextPutAll: name;
		nextPut: Character cr;
		close
! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 2/24/2001 12:56'!
loadActionsForBook: book 
	| actionsDir metaColl content |
	(dir directoryExists: 'actions') ifFalse: [^self].
	actionsDir _ dir directoryNamed: 'actions'.
	metaColl _ self getMetaCollForDir: actionsDir.
	dict at: 'actions' put: metaColl.
	metaColl do: [:arr |
		content _ (actionsDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		(arr at: 2) caseOf: {
			['book']->[book bookActions at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book | ', content , ']')].
			['page']->[book pageActions at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book :page | ', content , ']')]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 2/24/2001 12:57'!
loadAddressesForBook: book 
	| addressesDir metaColl content |
	(dir directoryExists: 'addresses') ifFalse: [^self].
	addressesDir _ dir directoryNamed: 'addresses'.
	metaColl _ self getMetaCollForDir: addressesDir.
	dict at: 'addresses' put: metaColl.
	metaColl do: [:arr |
		content _ (addressesDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		(arr at: 2) caseOf: {
			['priv']->[book privAddresses at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book | ', content , ']')].
			['book']->[book bookAddresses at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book | ', content , ']')].
			['page']->[book pageAddresses at: (arr at: 3) put: (Compiler evaluate: '[:request :response :shelf :book :page | ', content , ']')]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 5/2/2000 09:20'!
loadBook: book
	self
		loadSettingsForBook: book;
		loadAddressesForBook: book;
		loadTemplatesForBook: book;
		loadActionsForBook: book! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 5/2/2000 09:19'!
loadSettingsForBook: book
	book rawSettings: Dictionary new! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 2/24/2001 13:45'!
loadTemplatesForBook: book 
	| templatesDir metaColl content |
	(dir directoryExists: 'templates') ifFalse: [^self].
	templatesDir _ dir directoryNamed: 'templates'.
	metaColl _ self getMetaCollForDir: templatesDir.
	dict at: 'templates' put: metaColl.
	metaColl do: [:arr |
		content _ (templatesDir readOnlyFileNamed: (arr at: 1)) contentsOfEntireFile.
		"Use Internet Line Endings"
		content _ TextFormatter crToCrlf: content.
		(arr at: 2) caseOf: {
			['book']->[book bookTemplates at: (arr at: 3) put: content].
			['page']->[book pageTemplates at: (arr at: 3) put: content]}
			otherwise: ["ignore"]].! !

!SwikiStorage methodsFor: 'book (load)' stamp: 'je77 2/24/2001 12:57'!
writeSettingsForBook: book! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:52'!
addBookFunction: function type: type category: category
	(dict includesKey: (function, type))
		ifTrue: [(dict at: (function, type)) add: category]
		ifFalse: [dict at: (function, type) put: (OrderedCollection with: category)]! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:52'!
addBookFunction: function type: type name: name
	^self addBookFunction: function type: type name: name category: nil! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 4/2/2001 11:01'!
addBookFunction: function type: type name: name category: category
	| fDir fileNames id coll |
	(dir directoryExists: function) ifFalse: [dir createDirectory: function].	
	fDir _ dir directoryNamed: function.
	fileNames _ fDir fileNames.
	id _ 1.
	[fileNames includes: id asString] whileTrue: [id _ id + 1].
	coll _ dict at: function ifAbsent: [dict at: function put: OrderedCollection new].
	coll add: (Array with: id asString with: type with: name with: category).
	(fDir newFileNamed: id asString) close.
	"Remove category from empty categories"
	(category notNil and: [dict includesKey: (function, type)]) ifTrue: [
		(dict at: (function, type)) remove: category ifAbsent: []].
	"Update meta and browser log files"
	self putMetaColl: coll forDir: fDir.
	self logChangeBookFunction: function type: type name: name! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:52'!
allBookFunction: function type: type
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return select: [:arr | (arr at: 2) = type] thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]
! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:52'!
ayuBookFunction: function type: type
	"As Yet Unclassified"
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return
		select: [:arr | ((arr at: 2) = type) and: [(arr at: 4) isNil]]
		thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:51'!
bookFunction: function type: type category: category
	| return |
	return _ dict at: function ifAbsent: [^OrderedCollection new].
	return _ return
		select: [:arr | ((arr at: 2) = type) and: [(arr at: 4) = category]]
		thenCollect: [:arr | arr at: 3].
	^return asSortedCollection: [:a :b | a asLowercase < b asLowercase]! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:52'!
bookFunction: function type: type name: name
	| coll |
	coll _ dict at: function ifAbsent: [
		self error: (function, ' does not contain ', name, ' of type ', type)].
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name]) ifTrue: [
		^((dir directoryNamed: function) readOnlyFileNamed: (arr at: 1))
			contentsOfEntireFile]]! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 4/2/2001 11:01'!
bookFunction: function type: type name: name content: content
	| coll fDir file |
	coll _ dict at: function ifAbsent: [
		self error: (function, ' does not contain ', name, ' of type ', type)].
	fDir _ dir directoryNamed: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name]) ifTrue: [
		fDir deleteFileNamed: (arr at: 1).
		file _ fDir newFileNamed: (arr at: 1).
		file nextPutAll: content.
		file close.
		"Update browser log"
		self logChangeBookFunction: function type: type name: name]]! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:53'!
categoriesBookFunction: function type: type
	| metaColl return ayu |
	metaColl _ dict at: function ifAbsent: [^(OrderedCollection with: '-- all --')].
	ayu _ false.
	return _ SortedCollection sortBlock: [:a :b | a asLowercase < b asLowercase].
	metaColl do: [:arr | ((arr at: 2) = type) ifTrue: [(arr at: 4)
		ifNil: [ayu _ true]
		ifNotNil: [(return includes: (arr at: 4)) ifFalse: [
			return add: (arr at: 4)]]]].
	"Add Empty Categories"
	(dict includesKey: (function, type)) ifTrue: [
		(dict at: (function, type)) do: [:cat |
			(return includes: cat) ifFalse: [return add: cat]]].
	return _ return asOrderedCollection.
	return addFirst: '-- all --'.
	ayu ifTrue: [return add: 'as yet unclassified'].
	^return! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:53'!
deleteBookFunction: function type: type category: category
	| coll |
	coll _ dict at: function.
	coll do: [:arr | ((arr at: 4) = category) ifTrue: [
		arr at: 4 put: nil]].
	self putMetaColl: coll forDir: (dir directoryNamed: function).! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 4/2/2001 11:02'!
deleteBookFunction: function type: type name: name
	| coll fDir |
	coll _ OrderedCollection new.
	fDir _ dir directoryNamed: function.
	(dict at: function) do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [fDir deleteFileNamed: (arr at: 1)]
		ifFalse: [coll add: arr]].
	dict at: function put: coll.
	"Update meta and browser log files"
	self putMetaColl: coll forDir: fDir.
	self logDeleteBookFunction: function type: type name: name! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:53'!
moveBookFunction: function type: type name: name
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [arr at: 4 put: nil]].
	self putMetaColl: coll forDir: (dir directoryNamed: function)! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:53'!
moveBookFunction: function type: type name: name toCategory: category
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = name])
		ifTrue: [arr at: 4 put: category]].
	self putMetaColl: coll forDir: (dir directoryNamed: function)! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 2/24/2001 12:54'!
renameBookFunction: function type: type category: fromName to: toName
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 4) = fromName])
		ifTrue: [arr at: 4 put: toName]].
	self putMetaColl: coll forDir: (dir directoryNamed: function)! !

!SwikiStorage methodsFor: 'book (browser)' stamp: 'je77 4/2/2001 11:03'!
renameBookFunction: function type: type name: fromName to: toName
	| coll |
	coll _ dict at: function.
	coll do: [:arr | (((arr at: 2) = type) and: [(arr at: 3) = fromName])
		ifTrue: [arr at: 3 put: toName]].
	"Update meta and browser log files"
	self putMetaColl: coll forDir: (dir directoryNamed: function).
	self logDeleteBookFunction: function type: type name: fromName.
	self logChangeBookFunction: function type: type name: toName! !

!SwikiStorage methodsFor: 'book (logging)' stamp: 'je77 4/2/2001 14:44'!
logChangeBookFunction: function type: type name: name
	(dir fileNamed: 'browser.log')
		setToEnd;
		nextPutAll: (Date today asString);
		nextPut: Character tab;
		nextPutAll: (Time now asString);
		nextPut: Character tab;
		nextPutAll: 'changeBookFunction';
		nextPut: Character tab;
		nextPutAll: function;
		nextPut: Character tab;
		nextPutAll: type;
		nextPut: Character tab;
		nextPutAll: name;
		nextPut: Character cr;
		close
! !

!SwikiStorage methodsFor: 'book (logging)' stamp: 'je77 4/2/2001 14:44'!
logDeleteBookFunction: function type: type name: name
	(dir fileNamed: 'browser.log')
		setToEnd;
		nextPutAll: (Date today asString);
		nextPut: Character tab;
		nextPutAll: (Time now asString);
		nextPut: Character tab;
		nextPutAll: 'deleteBookFunction';
		nextPut: Character tab;
		nextPutAll: function;
		nextPut: Character tab;
		nextPutAll: type;
		nextPut: Character tab;
		nextPutAll: name;
		nextPut: Character cr;
		close
! !

!SwikiStorage methodsFor: 'pages' stamp: 'je77 4/29/2000 12:34'!
multipleTextFrom: aPage
	^self subclassResponsibility
! !

!SwikiStorage methodsFor: 'pages' stamp: 'je77 4/29/2000 12:34'!
simpleTextFrom: aPage
	^self subclassResponsibility
! !

!SwikiStorage methodsFor: 'pages' stamp: 'je77 4/29/2000 12:33'!
textFrom: aPage
	| text |
	text _ aPage rawText.
	(text isKindOf: String) ifTrue: [^text].
	(text isKindOf: Array) ifTrue: [^self simpleTextFrom: aPage].
	(text isKindOf: Dictionary) ifTrue: [((text values at: 1) isKindOf: String)
		ifTrue: [^text]
		ifFalse: [^self multipleTextFrom: aPage]].
	^''
! !

!SwikiStorage methodsFor: 'private' stamp: 'je77 2/24/2001 12:55'!
getMetaCollForDir: aDir
	self subclassResponsibility! !

!SwikiStorage methodsFor: 'private' stamp: 'je77 2/24/2001 12:55'!
putMetaColl: coll forDir: aDir
	self subclassResponsibility! !


!SwikiStorage class methodsFor: 'instance creation' stamp: 'je77 4/29/2000 10:45'!
fromDir: aFileDirectory
	^self new dir: aFileDirectory! !

!SwikiStorage class methodsFor: 'testing class hierarchy' stamp: 'Je77 8/4/2000 14:31'!
handlesBookStorage
	^false! !

!SwikiStorage class methodsFor: 'testing class hierarchy' stamp: 'Je77 8/3/2000 08:31'!
handlesPageStorage
	^false! !


!SwikiStructure methodsFor: 'accessing' stamp: 'je77 2/7/2001 14:56'!
name
	^name! !

!SwikiStructure methodsFor: 'accessing' stamp: 'je77 2/7/2001 14:56'!
name: aString
	name _ aString! !

!SwikiStructure methodsFor: 'initialization' stamp: 'je77 2/7/2001 14:33'!
initialize
	modules _ Dictionary new.
	settings _ Dictionary new.
	sema _ Semaphore forMutualExclusion! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:43'!
modules
	^modules! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:44'!
modules: anObject
	modules _ anObject! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:44'!
modulesAt: key
	^modules at: key! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:44'!
modulesAt: key ifAbsent: block
	^modules at: key ifAbsent: block! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:44'!
modulesAt: key put: value
	modules at: key put: value! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 2/7/2001 14:44'!
modulesIncludes: key
	^modules includesKey: key! !

!SwikiStructure methodsFor: 'modules' stamp: 'je77 3/28/2001 15:40'!
modulesRemove: key
	^modules removeKey: key ifAbsent: []! !

!SwikiStructure methodsFor: 'storage' stamp: 'je77 2/7/2001 14:34'!
forbidWriting
	sema wait! !

!SwikiStructure methodsFor: 'storage' stamp: 'je77 2/7/2001 14:34'!
permitWriting
	sema signal! !

!SwikiStructure methodsFor: 'storage' stamp: 'je77 2/7/2001 14:42'!
storage
	^storage! !

!SwikiStructure methodsFor: 'storage' stamp: 'je77 2/7/2001 14:42'!
storage: aSwikiStorage
	storage _ aSwikiStorage! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:36'!
settings
	^settings! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:37'!
settings: anObject
	settings _ anObject! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:37'!
settingsAt: key
	^settings at: key! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:37'!
settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: block! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:37'!
settingsAt: key put: value
	^settings at: key put: value! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 2/7/2001 14:37'!
settingsIncludes: key
	^settings includesKey: key! !

!SwikiStructure methodsFor: 'settings' stamp: 'je77 3/28/2001 15:39'!
settingsRemove: key
	^settings removeKey: key ifAbsent: []! !

!SwikiStructure methodsFor: 'utility' stamp: 'je77 2/7/2001 14:55'!
asExplorerString
	^super asExplorerString, '--', name! !

!SwikiStructure methodsFor: 'utility' stamp: 'je77 2/7/2001 14:55'!
defaultLabelForInspector
	^super defaultLabelForInspector, ': ', name! !


!NuSwikiPage methodsFor: 'accessing'!
date
	^date! !

!NuSwikiPage methodsFor: 'accessing'!
date: aDate
	date _ aDate! !

!NuSwikiPage methodsFor: 'accessing'!
id
	^id! !

!NuSwikiPage methodsFor: 'accessing'!
id: anInteger
	id _ anInteger! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 5/25/2000 10:02'!
printDate
	^self class printDate: date! !

!NuSwikiPage methodsFor: 'accessing'!
printTime
	| stream |
	stream _ ReadWriteStream on: String new.
	time printOn: stream.
	^stream contents! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 12:31'!
rawText
	^text! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 5/1/2000 15:32'!
showName
	^self showName: name! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 5/1/2000 15:32'!
showName: theText
	^(PageFormatter toSafeAlias: theText)! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 13:45'!
storage
	^storage! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 13:44'!
storage: aSwikiStorage
	storage _ aSwikiStorage! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 12:26'!
text
	^storage textFrom: self! !

!NuSwikiPage methodsFor: 'accessing'!
text: anObject
	text _ anObject! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 13:01'!
textKey: key
	^storage textKey: key from: self! !

!NuSwikiPage methodsFor: 'accessing'!
time
	^time! !

!NuSwikiPage methodsFor: 'accessing'!
time: aTime
	time _ aTime! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 3/19/2001 11:37'!
user
	^user! !

!NuSwikiPage methodsFor: 'accessing'!
user: aString
	user _ aString! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 13:41'!
versionId
	^versionId! !

!NuSwikiPage methodsFor: 'accessing' stamp: 'je77 4/29/2000 13:41'!
versionId: anInteger
	"0 means current version"
	versionId _ anInteger! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/7/2000 16:12'!
appendFormat: oldText request: request response: response shelf: shelf book: book
	| formatter newText |

	"is a form"
	(self isAForm) ifTrue: [^self formAppendFormat: oldText request: request response: response shelf: shelf book: book].
	"is not a form"
	formatter _ self settingsAt: 'appendFormatter' ifAbsent: [book settingsAt: 'appendFormatter' ifAbsent: [^nil]].
	newText _ (formatter format: oldText request: request response: response shelf: shelf book: book page: self).
	"delete extra cr formed from appendFormatter"
	(newText endsWith: String cr) ifTrue: [(newText size > 1) ifTrue: [
		newText _ newText copyFrom: 1 to: (newText size - 1)]].
	^self text: newText! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/1/2000 13:15'!
appendFormatRequest: request response: response shelf: shelf book: book
	^self appendFormat: (self text) request: request response: response shelf: shelf book: book! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/7/2000 16:11'!
editFormat: aString request: request response: response shelf: shelf book: book
	| formatter |

	formatter _ self settingsAt: 'editFormatter' ifAbsent: [book settingsAt: 'editFormatter' ifAbsent: [^aString]].
	^formatter format: aString request: request response: response shelf: shelf book: book page: self! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/7/2000 16:07'!
editFormatRequest: request response: response shelf: shelf book: book
	^self editFormat: (self text) request: request response: response shelf: shelf book: book! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 3/29/2001 12:14'!
formAppendFormat: texts request: request response: response shelf: shelf book: book
	| formatter newText element |

	formatter _ self settingsAt: 'appendFormatter' ifAbsent: [book settingsAt: 'appendFormatter' ifAbsent: [^nil]].
	newText _ Dictionary new.
	texts keysAndValuesDo: [:key :value |
		request settingsRemove: 'appendId'.
		request settingsAt: 'formId' put: key.
		element _ (formatter format: value request: request response: response shelf: shelf book: book page: self).
		"delete extra cr formed from appendFormatter"
		(element endsWith: String cr) ifTrue: [(element size > 1) ifTrue: [
			element _ element copyFrom: 1 to: (element size - 1)]].
		newText at: key put: element].
	^self text: newText! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/7/2000 16:13'!
formSaveFormat: texts request: request response: response shelf: shelf book: book
	| formatter newText |

	formatter _ self settingsAt: 'saveFormatter' ifAbsent: [book settingsAt: 'saveFormatter' ifAbsent: [^nil]].
	newText _ Dictionary new.
	texts keysAndValuesDo: [:key :value | value translateWith: BadCharTable. "Fix for Lynx"
		newText at: key put: (formatter format: value request: request response: response shelf: shelf book: book page: self)].
	^self text: newText! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'Je77 7/31/2000 15:52'!
formUpdateFormat: texts request: request response: response shelf: shelf book: book
	| formatter newText |

	formatter _ self settingsAt: 'updateFormatter' ifAbsent: [book settingsAt: 'updateFormatter' ifAbsent: [^nil]].
	newText _ Dictionary new.
	texts keysAndValuesDo: [:key :value | newText at: key put: (formatter format: value request: request response: response shelf: shelf book: book page: self)].
	self text: newText.
	[self write] fork
! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 6/5/2000 14:30'!
renderFormat: aString request: request response: response shelf: shelf book: book
	| formatter |

	formatter _ self settingsAt: 'renderFormatter' ifAbsent: [book settingsAt: 'renderFormatter' ifAbsent: [^aString]].
	^formatter format: aString request: request response: response shelf: shelf book: book page: self! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 6/5/2000 14:31'!
renderFormatRequest: request response: response shelf: shelf book: book
	^self renderFormat: (self text) request: request response: response shelf: shelf book: book! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/7/2000 16:14'!
saveFormat: newText request: request response: response shelf: shelf book: book
	| formatter |

	(self class isFormText: newText) ifTrue: [^self formSaveFormat: newText request: request response: response shelf: shelf book: book].
	formatter _ self settingsAt: 'saveFormatter' ifAbsent: [book settingsAt: 'saveFormatter' ifAbsent: [^nil]].
	newText translateWith: BadCharTable. "Fix for Lynx"
	^self text: (formatter format: newText request: request response: response shelf: shelf book: book page: self)! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 1/2/2001 12:21'!
showFormat: aString request: request response: response shelf: shelf book: book
	| formatter |
	formatter _ self settingsAt: 'showFormatter' ifAbsent: [book settingsAt: 'showFormatter' ifAbsent: [^aString]].
	^formatter format: aString request: request response: response shelf: shelf book: book page: self! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/1/2000 15:31'!
showFormatRequest: request response: response shelf: shelf book: book
	^self showFormat: self text request: request response: response shelf: shelf book: book! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'Je77 7/31/2000 15:51'!
updateFormat: updateText request: request response: response shelf: shelf book: book
	| formatter |

	"is a form"
	(self isAForm) ifTrue: [^self formUpdateFormat: updateText request: request response: response shelf: shelf book: book].
	"is not a form"
	formatter _ self settingsAt: 'updateFormatter' ifAbsent: [book settingsAt: 'updateFormatter' ifAbsent: [^nil]].
	self text: (formatter format: updateText request: request response: response shelf: shelf book: book page: self).
	self write! !

!NuSwikiPage methodsFor: 'formatters' stamp: 'je77 5/1/2000 15:05'!
updateFormatRequest: request response: response shelf: shelf book: book
	^self updateFormat: self text request: request response: response shelf: shelf book: book! !

!NuSwikiPage methodsFor: 'storage' stamp: 'je77 4/29/2000 14:20'!
backup
	storage backupPage: self! !

!NuSwikiPage methodsFor: 'storage' stamp: 'je77 6/3/2000 22:03'!
version: vid
	"Returns the XmlSwikiPage version.
	If the version does not exist, return nil."
	| version |
	(vid > 0) ifFalse: [^nil].
	version _ self class new id: id; versionId: vid; storage: storage.
	(storage loadPage: version) ifNil: [^nil].
	^version! !

!NuSwikiPage methodsFor: 'storage' stamp: 'je77 4/29/2000 14:07'!
versions
	^storage loadVersionsFrom: self! !

!NuSwikiPage methodsFor: 'storage' stamp: 'je77 4/29/2000 14:26'!
write
	storage writePage: self! !

!NuSwikiPage methodsFor: 'testing' stamp: 'je77 7/16/2000 14:45'!
isAForm
	^storage isAComplexPage: self! !

!NuSwikiPage methodsFor: 'testing'!
textContains: aString caseSensitive: caseSensitive
	| tempText |

	tempText _ self text.
	(tempText isKindOf: Dictionary)
		ifTrue: [tempText valuesDo: [:value | (value includesSubstring: aString caseSensitive: caseSensitive) ifTrue: [^true]].
			^false]
		ifFalse: [^tempText  includesSubstring: aString caseSensitive: caseSensitive]! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 6/6/2000 12:19'!
alertsFrom: request
	| tokens alerts |

	tokens _ (request fieldsKey: 'alerts') findTokens: String crlf, ' ;,'.
	(tokens size > 0)
		ifTrue: [self settingsAt: 'alerts' put: ((tokens size = 1)
			ifTrue: [tokens at: 1]
			ifFalse: [alerts _ tokens at: 1.
				2 to: (tokens size) do: [:i | alerts _ alerts, ', ', (tokens at: i)].
				alerts])]
		ifFalse: [self settingsRemove: 'alerts'].! !

!NuSwikiPage methodsFor: 'utility'!
clearRefsCache
	settings removeKey: 'referenceCache' ifAbsent: []! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 8/31/2000 11:18'!
defaultLabelForInspector
	^ super defaultLabelForInspector, ': ', id asString! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 5/7/2000 11:52'!
isOlderThan: request
	| editTime |

	editTime _ request fieldsAsNumberKey: 'edittime' ifAbsent: [^true].
	editTime _ Time dateAndTimeFromSeconds: editTime.
	((editTime at: 1) < date) ifTrue: [^false].
	((editTime at: 1) = date) ifTrue: [((editTime at: 2) < time) ifTrue: [^false]].
	^true! !

!NuSwikiPage methodsFor: 'utility'!
nameUnique: aString book: book stripping: badElementString
	"First, strip aString of anything that would be bad."
	"Then, name the page uniquely."
	| stripped copy |

	stripped _ WriteStream on: (String new: aString size).
	aString do: [:char | (badElementString includes: char) ifFalse: [stripped nextPut: char]].
	stripped _ stripped contents.
	(stripped = name) ifFalse: ["It only needs to be checked if name is different"
		(book hasPageNamed: stripped)
			ifTrue: ["Check for names of aString, ' #X'."
				copy _ 2.
				[book hasPageNamed: (stripped, ' #', copy asString)] whileTrue: [copy _ copy + 1].
				self name: (stripped, ' #', copy asString)]
			ifFalse: [self name: stripped]]! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 6/6/2000 10:53'!
passwordFrom: request response: response shelf: shelf book: book
	| lock password check bookpw |

	lock _ (request fieldsKey: 'lock' ifAbsent: ['no']) = 'yes'.
	password _ request fieldsKey: 'password' ifAbsent: [nil].
	check _ request fieldsKey: 'passwordcheck' ifAbsent: [nil].
	bookpw _ book settingsAt: 'lockPassword' ifAbsent: [nil].
	password ifNotNil: [check
		ifNil: [lock
			ifTrue: [(password = bookpw) ifFalse: [self settingsAt: 'lockPassword' put: password].
				self settingsAt: 'lock' put: true]
			ifFalse: [self settingsRemove: 'lockPassword'.
				self settingsAt: 'lock' put: false]]
		ifNotNil: [(password = check) ifTrue: [lock
			ifTrue: [(password = bookpw) ifFalse: [self settingsAt: 'lockPassword' put: password].
				self settingsAt: 'lock' put: true]
			ifFalse: [self settingsRemove: 'lockPassword'.
				self settingsAt: 'lock' put: false]]]]! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 5/7/2000 11:49'!
passwordMatches: request response: response shelf: shelf book: book
	| password |

	password _ request fieldsKey: 'password' ifAbsent: [^false].
	(self settingsIncludes: 'lockPassword')
		ifTrue: [((self settingsAt: 'lockPassword') = password) ifTrue: [^true]].
	(book settingsIncludes: 'lockPassword')
		ifTrue: [((book settingsAt: 'lockPassword') = password) ifTrue: [^true]].
	^false! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 8/31/2000 11:13'!
reverseVersionsUsing: block
	| versions return size |

	versions _ self versions.
	size _ versions size.
	(size = 0) ifTrue: [^''].
	return _ WriteStream on: String new.
	1 to: size do: [:i | return nextPutAll: (block value: (versions at: (size + 1 - i)))].
	^return contents! !

!NuSwikiPage methodsFor: 'utility' stamp: 'je77 6/27/2001 12:27'!
sendAlerts: request response: response shelf: shelf book: book
	| alertSender alertText alertServer |

	(settings includesKey: 'alerts')
		ifTrue: ["Send Messages"
			alertSender _ self settingsAt: 'alertSender' ifAbsent: [book settingsAt: 'alertSender' ifAbsent: [^self]].
			alertServer _ self settingsAt: 'alertServer' ifAbsent: [book settingsAt: 'alertServer' ifAbsent: [^self]].
			alertText _ book formatPageTemplate: 'alert' request: request response: response shelf: shelf page: self.
			[SMTPSocket deliverMailFrom: alertSender to: ((settings at: 'alerts') findTokens: ', ') text: alertText usingServer: alertServer] ifError: [:a :b | "No error for bad e-mail addresses"]]
! !


!SwikiBook methodsFor: 'accessing'!
bookActions
	^bookActions! !

!SwikiBook methodsFor: 'accessing'!
bookAddresses
	^bookAddresses! !

!SwikiBook methodsFor: 'accessing'!
bookTemplates
	^bookTemplates! !

!SwikiBook methodsFor: 'accessing'!
pageActions
	^pageActions! !

!SwikiBook methodsFor: 'accessing'!
pageAddresses
	^pageAddresses! !

!SwikiBook methodsFor: 'accessing'!
pageTemplates
	^pageTemplates! !

!SwikiBook methodsFor: 'accessing'!
pages
	^pages! !

!SwikiBook methodsFor: 'accessing'!
pages: anObject
	pages _ anObject! !

!SwikiBook methodsFor: 'accessing'!
privAddresses
	^privAddresses! !

!SwikiBook methodsFor: 'accessing' stamp: 'je77 5/2/2000 14:42'!
setup
	^setup! !

!SwikiBook methodsFor: 'accessing' stamp: 'je77 5/2/2000 14:42'!
setup: dict
	setup _ dict! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 5/1/2000 15:37'!
addChild: aBook
	children ifNil: [children _ OrderedCollection new].
	children add: aBook! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 2/23/2001 17:19'!
allChildren
	| return |
	return _ OrderedCollection new.
	self hasChildren ifFalse: [^return].
	children do: [:child |
		return add: child.
		return addAll: child allChildren].
	^return! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 5/1/2000 15:38'!
children
	^children! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 5/2/2000 09:05'!
hasChildren
	^(children = nil) not! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:20'!
hasParent
	^false! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:22'!
hasSuper: aBook
	^false! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 5/2/2000 14:24'!
loadSelfAndChildrenFrom: shelf
	self loadFrom: shelf.
	children ifNotNil: [children do: [:child | child loadSelfAndChildrenFrom: shelf]]! !

!SwikiBook methodsFor: 'inheritance' stamp: 'je77 5/1/2000 15:39'!
removeChild: aBook
	children remove: aBook ifAbsent: [].
	(children size = 0) ifTrue: [children _ nil].! !

!SwikiBook methodsFor: 'initialization' stamp: 'je77 2/7/2001 14:50'!
initialize
	super initialize.
	pageAddresses _ Dictionary new.
	bookAddresses _ Dictionary new.
	privAddresses _ Dictionary new.
	pageTemplates _ Dictionary new.
	bookTemplates _ Dictionary new.
	pageActions _ Dictionary new.
	bookActions _ Dictionary new! !

!SwikiBook methodsFor: 'modules' stamp: 'je77 2/7/2001 12:45'!
modules
	^modules copy! !

!SwikiBook methodsFor: 'modules' stamp: 'je77 6/4/2000 08:17'!
rawModules
	^modules! !

!SwikiBook methodsFor: 'modules' stamp: 'je77 6/4/2000 08:16'!
rawModules: dict
	modules _ dict! !

!SwikiBook methodsFor: 'modules' stamp: 'je77 3/28/2001 15:34'!
rawModulesIncludes: key
	^modules includesKey: key! !

!SwikiBook methodsFor: 'modules' stamp: 'je77 3/28/2001 15:37'!
rawModulesRemove: key
	^modules removeKey: key ifAbsent: []! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:42'!
bookActionNamed: actionName
	^bookActions at: actionName ifAbsent: [nil]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:56'!
bookAddressNamed: addressName
	^bookAddresses at: addressName ifAbsent: [nil]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 11:06'!
bookTemplateNamed: templateName
	^bookTemplates at: templateName ifAbsent: [self error: ('book template ', templateName, ' does not exist')]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:43'!
formatBookAction: actionName with: args
	| action |
	^(action _ self bookActionNamed: actionName)
		ifNil: ['<?', actionName, '?>']
		ifNotNil: [action copy fixTemps valueWithArguments: args]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:46'!
formatPageAction: actionName with: args
	"Format book action if no page action is found"
	| action |
	^(action _ self pageActionNamed: actionName)
		ifNil: [self formatBookAction: actionName with: (args copyFrom: 1 to: 4)]
		ifNotNil: [action copy fixTemps valueWithArguments: args]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:44'!
pageActionNamed: actionName
	^pageActions at: actionName ifAbsent: [nil]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:56'!
pageAddressNamed: addressName
	^pageAddresses at: addressName ifAbsent: [nil]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 11:05'!
pageTemplateNamed: templateName
	^pageTemplates at: templateName ifAbsent: [self error: ('page template ', templateName, ' does not exist')]! !

!SwikiBook methodsFor: 'private' stamp: 'je77 2/7/2001 11:10'!
privAddressNamed: addressName
	^privAddresses at: addressName ifAbsent: [nil]! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 5/1/2000 12:00'!
formatBookAction: actionName request: request response: response shelf: shelf
	^self formatBookAction: actionName with: (Array with: request with: response with: shelf with: self)! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 2/7/2001 11:00'!
formatBookAddress: addressName request: request response: response shelf: shelf
	| address |
	(address _ self bookAddressNamed: addressName) ifNil: [
		address _ self bookAddressNamed: 'default'].
	^address copy fixTemps value: request value: response value: shelf value: self! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 2/7/2001 11:07'!
formatBookTemplate: templateName request: request response: response shelf: shelf
	^(BookTemplateFormatter swikiFormatter) format: (self bookTemplateNamed: templateName) request: request response: response shelf: shelf book: self! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 5/1/2000 12:03'!
formatPageAction: actionName request: request response: response shelf: shelf page: page
	^self formatPageAction: actionName with: (Array with: request with: response with: shelf with: self with: page)! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 2/7/2001 11:01'!
formatPageAddress: addressName request: request response: response shelf: shelf page: page
	| address |
	(address _ self pageAddressNamed: addressName) ifNil: [
		address _ self pageAddressNamed: 'default'].
	^address copy fixTemps valueWithArguments: (Array with: request with: response with: shelf with: self with: page)! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 2/7/2001 11:06'!
formatPageTemplate: templateName request: request response: response shelf: shelf page: page
	^(BookTemplateFormatter swikiFormatter) format: (self pageTemplateNamed: templateName) request: request response: response shelf: shelf book: self page: page! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 2/7/2001 11:11'!
formatPrivAddress: addressName request: request response: response shelf: shelf
	| address |
	(address _ self privAddressNamed: addressName) ifNil: [^nil].
	^address copy fixTemps value: request value: response value: shelf value: self! !

!SwikiBook methodsFor: 'processing' stamp: 'je77 5/21/2001 12:32'!
process: request response: response shelf: shelf
	"Process the swiki request to return the stream of the text."
	| filter page |
	"Filter Before Processing"
	(filter _ self formatPrivAddress: 'filter' request: request response: response shelf: shelf)
		ifNotNil: ["Return filter after logging"
			response at: 'content' put: filter.
			^self formatPrivAddress: 'log' request: request response: response shelf: shelf].
	"Process Normal Book or Page Request"
	pages ifNotNil: [request page ifNotNil: [
		page _ pages at: (request page) ifAbsent: [nil]]].
	response at: 'content' put: (page
		ifNil: [self formatBookAddress: (request address) request: request response: response shelf: shelf]
		ifNotNil: [self formatPageAddress: (request address) request: request response: response shelf: shelf page: page]).
	"Log After Processing"
	self formatPrivAddress: 'log' request: request response: response shelf: shelf! !

!SwikiBook methodsFor: 'settings' stamp: 'je77 4/30/2000 13:06'!
rawSettings
	^settings! !

!SwikiBook methodsFor: 'settings' stamp: 'je77 5/1/2000 12:35'!
rawSettings: dict
	settings _ dict! !

!SwikiBook methodsFor: 'settings' stamp: 'je77 3/28/2001 16:12'!
rawSettingsIncludes: key
	^settings includesKey: key! !

!SwikiBook methodsFor: 'settings' stamp: 'je77 3/28/2001 15:36'!
rawSettingsRemove: key
	^settings removeKey: key ifAbsent: []! !

!SwikiBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:44'!
settings
	^settings copy! !

!SwikiBook methodsFor: 'storage' stamp: 'je77 3/29/2001 18:26'!
loadFrom: shelf
	self loadStorageFrom: shelf.
	storage loadBook: self.
	self loadPages! !

!SwikiBook methodsFor: 'storage' stamp: 'je77 2/7/2001 12:53'!
loadPages
	| kind |
	kind _ setup at: 'pageStorage' ifAbsent: [XmlSwikiStorage].
	pages _ (storage dir directoryExists: 'pages')
		ifTrue: [(kind fromDir: (storage dir directoryNamed: 'pages')) loadPages]
		ifFalse: [nil]! !

!SwikiBook methodsFor: 'storage' stamp: 'je77 5/2/2000 14:27'!
loadStorageFrom: shelf
	| kind |
	kind _ setup at: 'bookStorage' ifAbsent: [XmlSwikiStorage].
	storage _  kind fromDir: (shelf storage dir directoryNamed: name)! !

!SwikiBook methodsFor: 'storage' stamp: 'je77 5/2/2000 09:25'!
writeSettings
	storage writeSettingsForBook: self! !

!SwikiBook methodsFor: 'testing'!
hasBookAddress: addressName
	^bookAddresses includesKey: addressName! !

!SwikiBook methodsFor: 'testing'!
hasPageAddress: addressName
	^pageAddresses includesKey: addressName! !

!SwikiBook methodsFor: 'testing'!
hasPageNamed: aString
	pages do: [:page | (page name = aString) ifTrue: [^true]].
	^false! !

!SwikiBook methodsFor: 'testing'!
hasPrivAddress: addressName
	^privAddresses includesKey: addressName! !

!SwikiBook methodsFor: 'utility' stamp: 'Je77 7/31/2000 15:31'!
addNewPage
	| test page |
	test _ pages at: 1.
	page _ test class new.
	page
		id: (pages size + 1);
		versionId: 0;
		storage: test storage.
	pages add: page.
	^page! !

!SwikiBook methodsFor: 'utility'!
pageAlmostNamed: addr ifThere: thereBlock ifNot: notBlock
	| dividers tokens isValid |

	dividers _ OrderedCollection new.
	dividers add: 1.
	(addr size > 1) ifTrue: [
		2 to: (addr size) do: [:i | (addr at: i) isUppercase ifTrue: [dividers add: i]]].
	tokens _ OrderedCollection new.
	(dividers size > 1) ifTrue: [
		1 to: (dividers size - 1) do: [:i | tokens add: (addr copyFrom: (dividers at: i) to: ((dividers at: i + 1) - 1)) asLowercase]].
	tokens add: (addr copyFrom: (dividers at: dividers size) to: addr size) asLowercase.
	pages do: [:page | isValid _ true.
		tokens do: [:token | (((page name asLowercase) findString: token) = 0) ifTrue: [isValid _ false]].
		isValid ifTrue: [^thereBlock value: page]].
	^notBlock value
! !

!SwikiBook methodsFor: 'utility' stamp: 'je77 5/1/2000 15:40'!
pageNamed: aString
	pages do: [:page | (page name = aString) ifTrue: [^page]].
	^nil! !

!SwikiBook methodsFor: 'utility' stamp: 'je77 8/31/2000 10:09'!
recentchanges: beforeBlock during: duringBlock after: afterBlock
	| return sortedPages page date |

	sortedPages _ pages asSortedCollection: [:x :y | (x date = y date) ifTrue: [x time > y time] ifFalse: [x date > y date]].
	page _ sortedPages at: 1.
	date _ page date.
	"First page"
	return _ WriteStream on: String new.
	return nextPutAll: (beforeBlock value: page).
	return nextPutAll: (duringBlock value: page).
	"Other pages"
	(sortedPages size = 1) ifFalse: [
		2 to: (sortedPages size) do: [:i | page _ sortedPages at: i.
			(page date = date) ifFalse: ["New Date"
				date _ page date.
				return nextPutAll: (afterBlock value).
				return nextPutAll: (beforeBlock value: page)].
			return nextPutAll: (duringBlock value: page)]].
	return nextPutAll: (afterBlock value).
	^return contents

! !

!SwikiBook methodsFor: 'utility' stamp: 'Je77 8/16/2000 15:09'!
references: page before: beforeBlock during: duringBlock after: afterBlock ifAbsent: absentBlock
	| results return |

	results _ OrderedCollection new.
	pages do: [:element | ((element settingsAt: 'referenceCache' ifAbsent: [OrderedCollection new]) includes: page id) ifTrue: [results add: element]].
	(results includes: (pages at: 1)) ifTrue: [results remove: (pages at: 1)].
	(results size > 0) ifTrue: [
		return _ beforeBlock value: results.
		results do: [:element | return _ return, (duringBlock value: element)].
		^return, (afterBlock value: results)].
	^absentBlock value! !

!SwikiBook methodsFor: 'utility' stamp: 'je77 1/11/2001 19:09'!
searchFor: text caseSensitive: caseSensitive and: performAnd matchBlock: matchBlock
	| tokens results isMatch remaining pos1 |

	results _ OrderedCollection new.
	"Smart tokenize text with quotes"
	tokens _ OrderedCollection new.
	remaining _ text.
	[(remaining size > 0) and: [(pos1 _ remaining findString: '"' startingAt: 1) > 0]]
		whileTrue: [(pos1 = 1)
			ifTrue: [(remaining size > 1)
				ifTrue: [remaining _ remaining copyFrom: 2 to: remaining size.
					(pos1 _ remaining findString: '"' startingAt: 1) = 0
						ifTrue: [tokens add: remaining.
							remaining _ '']
						ifFalse: [pos1 = 1 ifFalse: [tokens add: (remaining copyFrom: 1 to: (pos1 - 1))].
							(pos1 = remaining size)
								ifTrue: [remaining _ '']
								ifFalse: [remaining _ remaining copyFrom: (pos1 + 1) to: remaining size]]]
				ifFalse: [remaining _ '']]
			ifFalse: [tokens addAll: ((remaining copyFrom: 1 to: (pos1 - 1)) findTokens: ' ').
				remaining _ remaining copyFrom: pos1 to: remaining size]].
	tokens addAll: (remaining findTokens: ' ').
	"Return Results"
	results _ OrderedCollection new.
	(tokens size = 0) ifFalse: [
		performAnd
			ifTrue: [pages do: [:page | "Test Pages in an AND search manner"
				isMatch _ true.
				tokens do: [:token |
					((page textContains: token caseSensitive: caseSensitive) or:
						[page name includesSubstring: token caseSensitive: caseSensitive])
							ifFalse: [isMatch _ false]].
				isMatch ifTrue: [matchBlock value: page]]]
			ifFalse: [pages do: [:page | "Test Pages in an OR search manner"
				isMatch _ false.
				tokens do: [:token |
					((page textContains: token caseSensitive: caseSensitive) or:
						[page name includesSubstring: token caseSensitive: caseSensitive])
							ifTrue: [isMatch _ true]].
				isMatch ifTrue: [matchBlock value: page]]]].
	^results! !

!SwikiBook methodsFor: 'utility' stamp: 'je77 9/20/2000 14:22'!
showName
	^(TextFormatter encodeToXmlCrlf: name)! !


!SwikiShelf methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:17'!
bookActions
	^bookActions! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:17'!
bookTemplates
	^bookTemplates! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 5/2/2000 08:56'!
books
	^books! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 5/2/2000 08:57'!
books: anObject
	books _ anObject! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:16'!
privAddresses
	^privAddresses! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:18'!
shelfActions
	^shelfActions! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 6/3/2000 08:03'!
shelfAddresses
	^shelfAddresses! !

!SwikiShelf methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:17'!
shelfTemplates
	^shelfTemplates! !

!SwikiShelf methodsFor: 'initialization' stamp: 'je77 3/29/2001 18:36'!
initialize
	super initialize.
	privAddresses _ Dictionary new.
	shelfAddresses _ Dictionary new.
	bookTemplates _ Dictionary new.
	shelfTemplates _ Dictionary new.
	bookActions _ Dictionary new.
	shelfActions _ Dictionary new! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:37'!
formatBookAction: actionName request: request response: response book: book
	^self formatBookAction: actionName with: (Array with: request with: response with: self with: book)! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:39'!
formatBookAction: actionName with: args
	^(bookActions at: actionName ifAbsent: [^self formatShelfAction: actionName with: (args copyFrom: 1 to: 3)]) copy fixTemps valueWithArguments: args! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:35'!
formatBookTemplate: templateName request: request response: response book: book
	^(ShelfTemplateFormatter swikiFormatter) format: (bookTemplates at: templateName) request: request response: response shelf: self book: book! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:43'!
formatPrivAddress: addressName request: request response: response
	^(privAddresses at: addressName ifAbsent: [^nil]) copy fixTemps value: request value: response value: self! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:39'!
formatShelfAction: actionName request: request response: response
	^self formatShelfAction: actionName with: (Array with: request with: response with: self)! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/2/2000 12:42'!
formatShelfAction: actionName with: args
	^(shelfActions at: actionName ifAbsent: [^'<?', actionName, '?>']) copy fixTemps valueWithArguments: args! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 6/3/2000 07:39'!
formatShelfAddress: addressName request: request response: response
	^(shelfAddresses at: addressName ifAbsent: [^nil]) copy fixTemps value: request value: response value: self! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 5/6/2000 14:48'!
formatShelfTemplate: templateName request: request response: response
	^(ShelfTemplateFormatter swikiFormatter) format: (shelfTemplates at: templateName) request: request response: response shelf: self! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 6/3/2000 08:06'!
process: request response: response
	| book filter |
	"Filter Before Processing"
	filter _ self formatPrivAddress: 'filter' request: request response: response.
	filter
		ifNil: [(book _ self bookNamed: request book)
			ifNil: [response at: 'content' put: ((shelfAddresses at: (request book) ifAbsent: [shelfAddresses at: 'default']) copy fixTemps value: request value: response value: self)]
			ifNotNil: [(book setup at: 'accessible' ifAbsent: [true])
				ifTrue: [book process: request response: response shelf: self]
				ifFalse: [response at: 'content' put: (self formatShelfAddress: 'default' request: request response: response)]]]
		ifNotNil: [response at: 'content' put: filter].
	"Log After Processing"
	self formatPrivAddress: 'log' request: request response: response
! !

!SwikiShelf methodsFor: 'processing' stamp: 'je77 9/29/2000 10:18'!
stopProcessing
	"Stop Books"
	books do: [:book | book formatPrivAddress: 'stop' request: nil response: nil shelf: self].
	"Stop Self"
	self formatPrivAddress: 'stop' request: nil response: nil! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 3/29/2001 18:40'!
load
	storage loadShelf: self.
	books _ storage setupBooks.
	self loadInheritance.
	self loadBooks.
	self loadModules! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 5/2/2000 14:23'!
loadBooks
	books do: [:book | (book hasParent) ifFalse: [book loadSelfAndChildrenFrom: self]]! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 2/7/2001 13:26'!
loadInheritance
	| parent |
	books do: [:book | (book hasParent) ifTrue: [
		parent _ self bookNamed: (book setup at: 'parent').
		parent ifNil: [self error: ('parent book (', (book setup at: 'parent'), ') does not exits')].
		(parent setup at: 'inheritable' ifAbsent: [true])
			ifTrue: [parent addChild: book.
				book parent: parent]
			ifFalse: [self error: ('parent book (', (parent name), ') is not inheritable')]]]! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 3/29/2001 18:27'!
loadModules
	self formatPrivAddress: 'initialize' request: nil response: nil.
	books do: [:book |
		book formatPrivAddress: 'initialize' request: nil response: nil shelf: self]
! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 3/29/2001 18:35'!
reload
	"Stop First"
	self formatPrivAddress: 'stop' request: nil response: nil.
	"Reinitialize ATA"
	self initialize.
	storage loadShelf: self.
	"Reinitailize Modules"
	self loadModules! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 5/2/2000 09:26'!
writeSettings
	storage writeSettingsForShelf: self! !

!SwikiShelf methodsFor: 'storage' stamp: 'je77 7/24/2000 13:09'!
writeSetupForBook: book
	storage writeSetupForBook: book! !

!SwikiShelf methodsFor: 'testing' stamp: 'je77 5/2/2000 12:45'!
hasPrivAddress: addressName
	^privAddresses includesKey: addressName! !

!SwikiShelf methodsFor: 'utility' stamp: 'je77 5/2/2000 09:38'!
addNewBookNamed: aString
	| test book |
	test _ books at: 1.
	storage dir createDirectory: aString.
	book _ test class new.
	book name: aString.
	^book! !

!SwikiShelf methodsFor: 'utility' stamp: 'je77 5/7/2000 13:16'!
bookNamed: aString
	| lower |
	aString ifNil: [^nil].
	lower _ aString asLowercase.
	books do: [:book | (book name asLowercase = lower) ifTrue: [^book]].
	^nil! !


!SwikiStructure class methodsFor: 'instance creation' stamp: 'je77 2/7/2001 14:30'!
new
	^super new
		initialize;
		yourself! !


!NuSwikiPage class methodsFor: 'initialize-release'!
initialize
	BadCharTable _ String newFrom: ((0 to: 255) collect: [:i | i asCharacter]).
	BadCharTable at: 1 put: Character cr.! !

!NuSwikiPage class methodsFor: 'instance creation' stamp: 'Je77 7/31/2000 15:13'!
new
	| instance |
	instance _ super new.
	instance initialize.
	^instance! !

!NuSwikiPage class methodsFor: 'utility' stamp: 'je77 11/13/2000 13:25'!
hasAProtocol: text 
	(text includes: $:) ifFalse: [^ false].
	^ #('http' 'https' 'ftp' 'gopher' 'mailto' 'mailto' 'news' 'telnet' 'rlogin' 'tn3270' 'wais' 'file' ) includes: (text copyUpTo: $:) asLowercase! !

!NuSwikiPage class methodsFor: 'utility'!
isFormText: aText
	^(aText isKindOf: Dictionary)! !

!NuSwikiPage class methodsFor: 'utility' stamp: 'je77 3/29/2001 19:24'!
isTextAnEmailAddress: text
	(text includes: $@) ifFalse: [^false].
	(text includes: Character space) ifTrue: [^false].
	((text copyAfterLast: $@) includes: $.) ifFalse: [^false].
	^true
! !

!NuSwikiPage class methodsFor: 'utility' stamp: 'je77 5/25/2000 10:02'!
printDate: aDate
	^(aDate dayOfMonth asString), ' ', (aDate monthName), ' ', (aDate year asString)! !

!NuSwikiPage class methodsFor: 'utility' stamp: 'je77 6/4/2001 14:41'!
urlForProtocolText: text 
	"URLs such as http:myfile.txt should be myfile.txt &
	URLs sucha s http:/myfile.txt should be /myfile.txt"
	| lowerText |
	lowerText _ text asLowercase.
	(lowerText beginsWith: 'http:') ifFalse: [^text].
	^(lowerText beginsWith: 'http://')
		ifTrue: [text]
		ifFalse: [text copyAfter: $:]! !


!SwikiSubBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:20'!
hasParent
	^true! !

!SwikiSubBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:21'!
hasSuper: aBook
	^(parent = aBook)
		ifTrue: [true]
		ifFalse: [parent hasSuper: aBook]! !

!SwikiSubBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:34'!
parent
	^parent! !

!SwikiSubBook methodsFor: 'inheritance' stamp: 'je77 2/7/2001 10:34'!
parent: aBook
	parent _ aBook! !

!SwikiSubBook methodsFor: 'modules' stamp: 'je77 2/7/2001 12:45'!
modules
	^(parent modules) addAll: modules! !

!SwikiSubBook methodsFor: 'modules' stamp: 'je77 2/7/2001 10:28'!
modulesAt: key
	^modules at: key ifAbsent: [parent modulesAt: key]! !

!SwikiSubBook methodsFor: 'modules' stamp: 'je77 2/7/2001 10:29'!
modulesAt: key ifAbsent: block
	^modules at: key ifAbsent: [parent modulesAt: key ifAbsent: block]! !

!SwikiSubBook methodsFor: 'modules' stamp: 'je77 2/7/2001 10:30'!
modulesIncludes: key
	^(modules includesKey: key)
		ifTrue: [true]
		ifFalse: [parent modulesIncludes: key]! !

!SwikiSubBook methodsFor: 'modules' stamp: 'je77 2/7/2001 10:31'!
modulesRemove: key
	modules removeKey: key ifAbsent: [^self error: 'Parent modules must be removed from parent']! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:42'!
bookActionNamed: actionName
	^bookActions at: actionName ifAbsent: [parent bookActionNamed: actionName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:53'!
bookAddressNamed: addressName
	^bookAddresses at: addressName ifAbsent: [parent bookAddressNamed: addressName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:55'!
bookTemplateNamed: templateName
	^bookTemplates at: templateName ifAbsent: [parent bookTemplateNamed: templateName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:43'!
pageActionNamed: actionName
	^pageActions at: actionName ifAbsent: [parent pageActionNamed: actionName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:52'!
pageAddressNamed: addressName
	^pageAddresses at: addressName ifAbsent: [parent pageAddressNamed: addressName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 10:54'!
pageTemplateNamed: templateName
	^pageTemplates at: templateName ifAbsent: [parent pageTemplateNamed: templateName]! !

!SwikiSubBook methodsFor: 'private' stamp: 'je77 2/7/2001 11:10'!
privAddressNamed: addressName
	^privAddresses at: addressName ifAbsent: [parent privAddressNamed: addressName]! !

!SwikiSubBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:44'!
settings
	^(parent settings) addAll: settings! !

!SwikiSubBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:47'!
settingsAt: key
	^settings at: key ifAbsent: [parent settingsAt: key]! !

!SwikiSubBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:47'!
settingsAt: key ifAbsent: block
	^settings at: key ifAbsent: [parent settingsAt: key ifAbsent: block]! !

!SwikiSubBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:49'!
settingsIncludes: key
	^(settings includesKey: key)
		ifTrue: [true]
		ifFalse: [parent settingsIncludes: key]! !

!SwikiSubBook methodsFor: 'settings' stamp: 'je77 2/7/2001 12:50'!
settingsRemove: key
	settings removeKey: key ifAbsent: [self error: 'Parent settings must be removed from parent']! !

!SwikiSubBook methodsFor: 'storage' stamp: 'je77 2/7/2001 12:52'!
loadPages
	| kind |
	kind _ setup at: 'pageStorage' ifAbsent: [XmlSwikiStorage].
	pages _ (storage dir directoryExists: 'pages')
		ifTrue: [(kind fromDir: (storage dir directoryNamed: 'pages')) loadPages]
		ifFalse: [parent pages]! !

!SwikiSubBook methodsFor: 'testing' stamp: 'je77 2/7/2001 12:55'!
hasBookAddress: addressName
	^(bookAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasBookAddress: addressName]! !

!SwikiSubBook methodsFor: 'testing' stamp: 'je77 2/7/2001 12:55'!
hasPageAddress: addressName
	^(pageAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasPageAddress: addressName]! !

!SwikiSubBook methodsFor: 'testing' stamp: 'je77 2/7/2001 12:56'!
hasPrivAddress: addressName
	^(privAddresses includesKey: addressName)
		ifTrue: [true]
		ifFalse: [parent hasPrivAddress: addressName]! !


!SwikiSubDirectory methodsFor: 'accessing' stamp: 'je77 1/24/2001 14:27'!
containingDirectory
	^containingDirectory! !

!SwikiSubDirectory methodsFor: 'accessing' stamp: 'je77 1/24/2001 14:27'!
containingDirectory: aSwikiDirectory
	containingDirectory _ aSwikiDirectory! !

!SwikiSubDirectory methodsFor: 'accessing' stamp: 'je77 1/24/2001 14:28'!
httpPath
	^(containingDirectory httpPath), (self localHttpPath)! !

!SwikiSubDirectory methodsFor: 'accessing' stamp: 'je77 2/2/2001 15:02'!
localHttpPath
	^self httpName, '/'! !

!SwikiSubDirectory methodsFor: 'cacheing' stamp: 'je77 1/24/2001 14:30'!
addToDirServeCache: aSubSwikiDir at: key
	super addToDirServeCache: aSubSwikiDir at: key.
	"Recurse Upward in Hierarchy"
	containingDirectory addToDirServeCache: aSubSwikiDir at: (self localHttpPath, key)! !

!SwikiSubDirectory methodsFor: 'initialization' stamp: 'je77 1/24/2001 14:33'!
initializeDirectories
	super initializeDirectories.
	"dirServeCache"
	containingDirectory addToDirServeCache: self at: self localHttpPath! !

!SwikiSubDirectory methodsFor: 'testing' stamp: 'je77 2/1/2001 17:17'!
isASubDirectory
	^true! !


!SwikiSubDirectory class methodsFor: 'instance creation' stamp: 'je77 1/24/2001 14:35'!
fromArray: arr onDir: dir containingDirectory: aSwikiDirectory
	| instance |
	instance _ self fromArray: arr.
	instance dir: dir.
	instance containingDirectory: aSwikiDirectory.
	instance initialize.
	^instance! !


!Text methodsFor: 'converting' stamp: 'bolot 3/17/2001 22:55'!
asHtmlDocumentForRequest: request
	| readStream targetStream |

	readStream _ ReadStream on: (self string).
	targetStream _ WriteStream on: ''.
	targetStream nextPutAll: (HTMLformatter startPage: 'A page generated by Comanche').
	targetStream nextPutAll: '<PRE>'.
	(self runs values) with: (self runs runs) do:
		[:aValue :aRun |
			aValue do: [:attr | attr printHtmlOpenTagOn: targetStream].
			targetStream nextPutAll: (readStream next: aRun).
			aValue reverseDo: [:attr | attr printHtmlCloseTagOn: targetStream].
		].

	targetStream nextPutAll: '</PRE>'.
	targetStream nextPutAll: (HTMLformatter endPage).
	^targetStream contents! !


!TextAnchor methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:45'!
printHtmlOpenTagOn: strm
	"do nothing for now"
	"save the embedded image in a file to be served by Comanche"! !


!TextColor methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</FONT>'! !

!TextColor methodsFor: 'printing' stamp: 'bolot 3/17/2001 22:53'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<FONT COLOR="#';
		nextPutAll: self color hex;
		nextPutAll: '">'! !


!TextEmphasis methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:39'!
printHtmlCloseTagOn: strm
	emphasisCode = 1 ifTrue: [strm nextPutAll: '</B>'].
	emphasisCode = 2 ifTrue: [strm nextPutAll: '</I>'].
	emphasisCode = 4 ifTrue: [strm nextPutAll: '</U>'].
	emphasisCode = 16 ifTrue: [strm nextPutAll: '</S>']! !

!TextEmphasis methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:39'!
printHtmlOpenTagOn: strm
	emphasisCode = 1 ifTrue: [strm nextPutAll: '<B>'].
	emphasisCode = 2 ifTrue: [strm nextPutAll: '<I>'].
	emphasisCode = 4 ifTrue: [strm nextPutAll: '<U>'].
	emphasisCode = 16 ifTrue: [strm nextPutAll: '<S>']! !


!TextFontChange methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</FONT>'! !

!TextFontChange methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<FONT SIZE="';
		nextPutAll: (self fontNumber + 2) asString;
		nextPutAll: '">'! !


!TextFormatter methodsFor: 'accessing'!
addAction: block from: beginning to: end
	"When the Action is performed, the text is scanned for things that start with beginning
	and stop with end. Whatever is between these two is then put into the block and what
	gets returned is fed to the formatted document."
	"The format for an Action is a 3 element array of (beginning end block)."
	| starts formatter |

	starts _ beginning at: 1.
	match add: starts.
	formatter _ Array new: 3.
	beginning size = 1
		ifTrue: [formatter at: 1 put: '']
		ifFalse: [formatter at: 1 put: (beginning copyFrom: 2 to: beginning size)].
	formatter at: 2 put: end.
	formatter at: 3 put: block.
	self addFormatter: formatter at: (starts asInteger).! !

!TextFormatter methodsFor: 'accessing'!
addMappingFrom: original to: replacement
	"A Mapping is when the text is scanned and all instances of original are mapped to
	their replacements."
	"The format for a Mapping is an 3 element array of (original nil replacement)."
	| starts formatter |

	starts _ original at: 1.
	match add: starts.
	formatter _ Array new: 3.
	original size = 1
		ifTrue: [formatter at: 1 put: '']
		ifFalse: [formatter at: 1 put: (original copyFrom: 2 to: original size)].
	formatter at: 3 put: replacement.
	self addFormatter: formatter at: (starts asInteger).! !

!TextFormatter methodsFor: 'accessing'!
remove: key
	"Removes a formatter (action, mapping) from the TextFormatter."
	"It remove it if it matches the orginal for a mapping or the beginning for an action."
	| starts formatters ends |

	starts _ key at: 1. "First character in the key."
	formatters _ formattingArray at: (starts asInteger).
	formatters ifNil: ["There is no matching formatter, so stop" ^nil]
		ifNotNil: [((key size) = 1) ifTrue: [ends _ ''] ifFalse: [ends _ key copyFrom: 2 to: (key size)].
			formatters do: [:element | ((element at: 1) = ends) ifTrue: [formatters remove: element]].
			((formatters size) = 0) ifTrue: [
				formattingArray at: (starts asInteger) put: nil. "Removes formatter"
				match remove: starts. "Removes from match"
			]
		].
	^nil! !

!TextFormatter methodsFor: 'initializing'!
initialize
	match _ CharacterSet new.
	formattingArray _ Array new: 255.! !

!TextFormatter methodsFor: 'private'!
action: action value: value text: text
	^(action copy fixTemps) value: text! !

!TextFormatter methodsFor: 'private'!
addFormatter: formatter at: position
	"Adds a formatter to the position in the formattingArray."
	| formatters |

	formatters _ formattingArray at: position.
	formatters isNil
		ifTrue: [formatters _ SortedCollection new sortBlock: [:x :y | (x at: 1) size >= (y at: 1) size].
			formattingArray at: position put: formatters].
	formatters add: formatter.
! !

!TextFormatter methodsFor: 'private'!
format: text actionValue: value onTo: stream
	"Apply all the formatting on text and put it onto stream."
	| pos i maxSize formatters index formatter |

	"i is the position of a match"
	pos _ 1. "Position in text, marking the seperation of processed and yet to be processed"
	[(i _ text indexOfAnyOf: match startingAt: pos) > 0]
		whileTrue: [stream nextPutAll: (text copyFrom: pos to: i-1). "No formatting in this space"
			maxSize _ text size - i.
			formatters _ formattingArray at: (text at: i) asInteger.
			index _ 1.
			[formatters size >= index] "Index of Formatters"
				whileTrue: [ "see if formatters match"
					formatter _ formatters at: index.
					"Check that size of formatter is allowed."
					(maxSize >= (formatter at: 1) size) ifTrue: [
						"Check if the formatter matches"
						((text copyFrom: (i + 1) to: (i + (formatter at: 1) size)) = (formatter at: 1))
							ifTrue: [ index _ formatters size + 1. "Match => exit loop"
								"Set i to beyond beginning marker"
								pos _ i + 1 + (formatter at: 1) size.
								(formatter at: 2)
									ifNil: [ "Mapping"
											stream nextPutAll: (formatter at: 3)
										]
									ifNotNil: [ "Action"
											"This does not allow nesting, but that's probably good."
											i _ text findString: (formatter at: 2) startingAt: pos.
											"Check for no closing"
											i > 0 ifTrue: [stream nextPutAll: (self action: (formatter at: 3) value: value text: (text copyFrom: pos to: i-1)).
													pos _ i + (formatter at: 2) size
												]
										]
								]
						].
					index _ index + 1.
				].
				"Check for no formatter matched"
				((formatters size) = (index - 1)) ifTrue: [stream nextPut: (text at: i). pos _ i + 1]
		].
		"Add last section if there is one."
		(pos <= text size) ifTrue: [stream nextPutAll: (text copyFrom: pos to: (text size))].
	 ^stream! !

!TextFormatter methodsFor: 'processing'!
format: text
	"Apply all the formatting to the text and return it as a stream"
	| return |

	"Create a new stream to write it on."
	return _ WriteStream on: (String new: text size).
	self format: text onTo: return.
	^return contents
! !

!TextFormatter methodsFor: 'processing'!
format: text onTo: stream
	^self format: text actionValue: nil onTo: stream! !


!BookTemplateFormatter methodsFor: 'private' stamp: 'je77 5/1/2000 11:57'!
action: action value: value text: text
	"Overwrites parent class to add swiki action"
	^(value size = 5)
		ifTrue: ["Page Request"
			(value at: 4) formatPageAction: text with: value]
		ifFalse: ["Book Request"
			(value at: 4) formatBookAction: text with: value]! !

!BookTemplateFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 11:44'!
format: template request: request response: response shelf: shelf book: book
	"Formatting used for a book request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf with: book.
	self format: template actionValue: value onTo: stream.
	^stream contents! !

!BookTemplateFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 11:42'!
format: template request: request response: response shelf: shelf book: book page: page
	"Formatting used for a page request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf with: book with: page.
	self format: template actionValue: value onTo: stream.
	^stream contents! !


!PageFormatter methodsFor: 'accessing'!
storeID
	^storeID! !

!PageFormatter methodsFor: 'accessing'!
storeID: id
	storeID _ id! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/7/2000 13:35'!
addChangeLinks
	self addAction: [:text :request :response :shelf :book :page | self changeLinks: text request: request response: response shelf: shelf book: book page: page] from: '*' to: '*'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 9/20/2000 18:25'!
addCrToCrlf
	self
		addMappingFrom: String cr to: String crlf;
		addMappingFrom: String crlf to: String crlf;
		addMappingFrom: (Character lf asString) to: String crlf! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 9/20/2000 18:26'!
addCrlfToCr
	self
		addMappingFrom: String crlf to: String cr;
		addMappingFrom: (Character lf asString) to: String cr! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 9/20/2000 14:17'!
addEditHtml
	self addAction: [:text :request :response :shelf :book :page | '&lt;html&gt;', (TextFormatter encodeToXmlCrlf: text), '&lt;/html&gt;']from: '<html>' to: '</html>'.
	self addAction: [:text :request :response :shelf :book :page | '&lt;HTML&gt;', (TextFormatter encodeToXmlCrlf: text), '&lt;/HTML&gt;']from: '<HTML>' to: '</HTML>'! !

!PageFormatter methodsFor: 'functionality'!
addEditSpecialCharacters
	self addMappingFrom: '&amp;' to: '&amp;amp;'.
	self addMappingFrom: '&lt;' to: '&amp;lt;'.
	self addMappingFrom: '&gt;' to: '&amp;gt;'.
	self addMappingFrom: '&*' to: '&amp;star;'.
	self addMappingFrom: '&' to: '&amp;'.
	self addMappingFrom: '"' to: '&quot;'.
	self addMappingFrom: '<' to: '&lt;'.
	self addMappingFrom: '>' to: '&gt;'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:08'!
addInternalLinks
	self addAction: [:text :request :response :shelf :book :page | self internalLinks: text request: request response: response shelf: shelf book: book page: page] from: '*' to: '*'.
	self addMappingFrom: '&*' to: '*'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:08'!
addRenderInternalLinks
	self addAction: [:text :request :response :shelf :book :page | self renderInternalLinks: text request: request response: response shelf: shelf book: book page: page] from: '*' to: '*'.
	self addMappingFrom: '&*' to: '*'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:08'!
addRenderUploadLinks
	self addAction: [:text :request :response :shelf :book :page | self renderUploadLinks: text request: request response: response shelf: shelf book: book page: page] from: '*+' to: '+*'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:08'!
addReverseLinks
	self addAction: [:text :request :response :shelf :book :page | self reverseLinks: text request: request response: response shelf: shelf book: book page: page] from: '*' to: '*'.
	self addAction: [:text :request :response :shelf :book :page | '*+', text, '+*'] from: '*+' to: '+*'.
	self addMappingFrom: '&*' to: '&*'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 9/20/2000 18:06'!
addSaveHtml
	self addAction: [:text :request :response :shelf :book :page | '<html>', (TextFormatter crlfToCr: text), '</html>']from: '<html>' to: '</html>'.
	self addAction: [:text :request :response :shelf :book :page | '<HTML>', (TextFormatter crlfToCr: text), '</HTML>']from: '<HTML>' to: '</HTML>'! !

!PageFormatter methodsFor: 'functionality'!
addSaveSpecialCharacters
	self addMappingFrom: '&&' to: '&amp;'.
	self addMappingFrom: '&<' to: '&lt;'.
	self addMappingFrom: '&>' to: '&gt;'! !

!PageFormatter methodsFor: 'functionality'!
addShowSpecialCharacters
	self addMappingFrom: '&amp;' to: '&amp;'.
	self addMappingFrom: '&star;' to: '*'.
	self addMappingFrom: '&at;' to: '@'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:06'!
addTagIntegrity
	self addAction: [:text :request :response :shelf :book :page | '<', text, '>' ] from: '<' to: '>'
! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:06'!
addUpdateHtml
	self addAction: [:text :request :response :shelf :book :page | '<html>', text, '</html>'] from: '<html>' to: '</html>'.
	self addAction: [:text :request :response :shelf :book :page | '<HTML>', text, '</HTML>'] from: '<HTML>' to: '</HTML>'! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:09'!
addUpdateLinks
	self addAction: [:text :request :response :shelf :book :page | self updateLinks: text request: request response: response shelf: shelf book: book page: page] from: '*' to: '*'.
	self addAction: [:text :request :response :shelf :book :page | '*+', text, '+*'] from: '*+' to: '+*'.
	self addMappingFrom: '&*' to: '&*'.
! !

!PageFormatter methodsFor: 'functionality' stamp: 'je77 5/1/2000 10:09'!
addUploadLinks
	self addAction: [:text :request :response :shelf :book :page | self uploadLinks: text request: request response: response shelf: shelf book: book page: page] from: '*+' to: '+*'! !

!PageFormatter methodsFor: 'private' stamp: 'je77 5/1/2000 09:56'!
action: action value: value text: text
	value at: 1 put: text.
	^action copy fixTemps valueWithArguments: value! !

!PageFormatter methodsFor: 'private'!
storeString
	"Overwrite of Object method to save space for storing"
	(storeID) ifNotNil: ["Check to make sure this storeID is valid"
		(self class respondsTo: storeID)
			ifTrue: [^'(', self class asString, ' ', storeID asString, ')']].
	^super storeString! !

!PageFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 09:55'!
format: text request: request response: response shelf: shelf book: book page: page
	|value stream|

	stream _ WriteStream on: (String new: text size).
	value _ Array with: nil with: request with: response with: shelf with: book with: page.
	self format: text actionValue: value onTo: stream.
	^stream contents! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 9/20/2000 14:20'!
changeLinks: text request: request response: response shelf: shelf book: book page: page
	"edit formatter"
	| alias remaining pageEntry |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>), '>'.
			((alias size) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 1) to: (remaining size)]]
		ifFalse: [alias _ ''].
	"e-mail address"
	(NuSwikiPage isTextAnEmailAddress: remaining)
		ifTrue: [^'*', (TextFormatter encodeToXmlCrlf: (alias, remaining)), '*'].
	"http address"
	(NuSwikiPage hasAProtocol: remaining)
		ifTrue: [^'*', (TextFormatter encodeToXmlCrlf: (alias, remaining)), '*'].
	"Get pageEntry"
	(remaining includes: $@)
		ifTrue: [pageEntry _ remaining copyUpTo: $@.
			remaining _ remaining copyFrom: (pageEntry size + 1) to: (remaining size)]
		ifFalse: [pageEntry _ remaining.
			remaining _ ''].
	"Transform digit to title"
	((pageEntry isAllDigits) and: [pageEntry ~= ''])
		ifTrue: [(book pages size) >= (pageEntry asNumber)
			ifTrue: [^'*', (TextFormatter encodeToXmlCrlf: (alias, (book pages at: pageEntry asNumber) name, remaining)), '*']].
	^'*', (TextFormatter encodeToXmlCrlf: (alias, pageEntry, remaining)), '*'! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 6/4/2001 14:31'!
internalLinks: text request: request response: response shelf: shelf book: book page: page
	"show formatter"
	| alias remaining pageEntry location lPage url |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>).
			((alias size + 1) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 2) to: (remaining size)].
			alias _ PageFormatter toSafeAlias: alias]
		ifFalse: [alias _ ''].
	"e-mail address"
	(NuSwikiPage isTextAnEmailAddress: remaining)
		ifTrue: [(alias = '')
			ifTrue: [^'<a href="mailto:', remaining, '">', remaining, '</a>']
			ifFalse: [^'<a href="mailto:', remaining, '">', alias, '</a>']].
	"URL address"
	(NuSwikiPage hasAProtocol: remaining)
		ifTrue: [url _ NuSwikiPage urlForProtocolText: remaining.
			(self class isAnImage: remaining)
				ifTrue: [(alias = '')
					ifTrue: [^'<img alt="External Image" src="', url, '">']
					ifFalse: [^'<img alt="', alias, '" src="', url, '">']]
				ifFalse: [(alias = '')
					ifTrue: [^'<a href="', url, '">', remaining, '</a>']
					ifFalse: [^'<a href="', url, '">', alias, '</a>']]].
	"Get pageEntry and location"
	(remaining includes: $@)
		ifTrue: [pageEntry _ remaining copyUpTo: $@.
			((pageEntry size + 1) = (remaining size))
				ifTrue: [location _ '']
				ifFalse: [location _ remaining copyFrom: (pageEntry size + 2) to: (remaining size)]]
		ifFalse: [pageEntry _ remaining.
			location _ ''].
	"No page entry"
	(pageEntry = '') ifTrue: [(location = '')
		ifTrue: [^'Error: this should not happen']
		ifFalse: [(alias = '')
			ifTrue: [^'<a href="#', (PageFormatter toSafeLocation: location), '">', (PageFormatter toSafeAlias: location), '</a>']
			ifFalse: [^'<a href="#', (PageFormatter toSafeLocation: location), '">', alias, '</a>']]].
	"Page Link"
	(alias = '')
		ifTrue: [request settingsRemove: 'alias']
		ifFalse: [request settingsAt: 'alias' put: alias].
	(location = '')
		ifTrue: [request settingsRemove: 'location']
		ifFalse: [request settingsAt: 'location' put: location].
	(pageEntry isAllDigits)
		ifTrue: [(book pages size) >= (pageEntry asNumber)
			ifTrue: [lPage _ book pages at: pageEntry asNumber]
			ifFalse: [^'Error: this should not happen']]
		ifFalse: [(book hasPageNamed: pageEntry)
			ifTrue: [lPage _ book pageNamed: pageEntry]
			ifFalse: ["New Page: uses newlink.page template"
				request settingsAt: 'pageEntry' put: pageEntry.
				^book formatPageTemplate: 'newLink' request: request response: response shelf: shelf page: page]].
	"Existing Page: uses link.page template"
	^book formatPageTemplate: 'link' request: request response: response shelf: shelf page: lPage.! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 6/4/2001 14:34'!
renderInternalLinks: text request: request response: response shelf: shelf book: book page: page
	"render formatter"
	| alias remaining pageEntry rawLocation location lPage url |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>).
			((alias size + 1) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 2) to: (remaining size)].
			alias _ PageFormatter toSafeAlias: alias]
		ifFalse: [alias _ ''].
	"e-mail address"
	(NuSwikiPage isTextAnEmailAddress: remaining)
		ifTrue: [(alias = '')
			ifTrue: [^'<a href="mailto:', remaining, '">', remaining, '</a>']
			ifFalse: [^'<a href="mailto:', remaining, '">', alias, '</a>']].
	"URL address"
	(NuSwikiPage hasAProtocol: remaining)
		ifTrue: [url _ NuSwikiPage urlForProtocolText: remaining.
			(self class isAnImage: remaining)
				ifTrue: [(alias = '')
					ifTrue: [^'<img alt="External Image" src="', url, '">']
					ifFalse: [^'<img alt="', alias, '" src="', url, '">']]
				ifFalse: [(alias = '')
					ifTrue: [^'<a href="', url, '">', remaining, '</a>']
					ifFalse: [^'<a href="', url, '">', alias, '</a>']]].
	"Get pageEntry and location"
	(remaining includes: $@)
		ifTrue: [pageEntry _ remaining copyUpTo: $@.
			((pageEntry size + 1) = (remaining size))
				ifTrue: [location _ '']
				ifFalse: [location _ remaining copyFrom: (pageEntry size + 2) to: (remaining size)]]
		ifFalse: [pageEntry _ remaining.
			location _ ''].
	(location = '') ifFalse: [rawLocation _ (PageFormatter toSafeAlias: location).
		location _ '#', (PageFormatter toSafeLocation: location)].
	"No page entry"
	(pageEntry = '') ifTrue: [(location = '')
		ifTrue: [^'Error: this should not happen']
		ifFalse: [(alias = '')
			ifTrue: [^'<a href="', location, '">', rawLocation, '</a>']
			ifFalse: [^'<a href="', location, '">', alias, '</a>']]].
	"Existing page"
	(pageEntry isAllDigits)
		ifTrue: [
			lPage _ book pages at: (pageEntry asNumber) ifAbsent: [^'Error: this should not happen'].
			(alias = '')
				ifTrue: [(location = '')
					ifTrue: [^'<a href="', pageEntry, '.html">', lPage showName, '</a>']
					ifFalse: [^'<a href="', pageEntry, '.html', location, '">', (lPage showName), ' (', rawLocation, '(</a>']]
				ifFalse: [^'<a href="', pageEntry, '.html', location, '">', alias, '</a>']].
	"Page named this"
	(book hasPageNamed: pageEntry)
		ifTrue: [lPage _ book pageNamed: pageEntry.
			(alias = '')
				ifTrue: [(location = '')
					ifTrue: [^'<a href="', (lPage id asString), '.html">', (lPage showNameRequest: request book: book), '</a>']
					ifFalse: [^'<a href="', (lPage id asString), '.html', location, '">', (lPage showNameRequest: request book: book), ' (', rawLocation, ')</a>']]
				ifFalse: [^'<a href="', (lPage id asString), '.html', location, '">', alias, '</a>']].
	"New page (kind of stupid to render a link that isn't existing)"
	^'*', (TextFormatter encodeToXmlCrlf: text), '*'! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 1/9/2001 10:51'!
renderUploadLinks: text request: request response: response shelf: shelf book: book page: page
	"render formatter"
	| alias remaining uploads pageUploads upload |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>).
			((alias size + 1) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 2) to: (remaining size)].
			alias _ PageFormatter toSafeAlias: alias]
		ifFalse: [alias _ ''].
	"use page upload server if possible"
	uploads _ book modulesAt: 'uploads'.
	(pageUploads _ uploads directoryNamed: (page id asString) ifAbsent: [nil])
		ifNil: [upload _ uploads fileRefsCacheAt: remaining ifAbsent: [nil]]
		ifNotNil: [(upload _ pageUploads fileRefsCacheAt: remaining ifAbsent: [nil])
			ifNil: [upload _ uploads fileRefsCacheAt: remaining ifAbsent: [nil]]
			ifNotNil: [uploads _ pageUploads]].
	upload
		ifNil: [^'Missing File (', (TextFormatter encodeToXmlCrlf: remaining), ')'].
	^upload last isAnImage
		ifTrue: ['<img src="uploads/', uploads httpPath, upload last httpName, '" width=', upload last width asString, ' height=', upload last height asString, ' alt="', ((alias = '') ifTrue: ['Uploaded Image: ', upload strictXmlName] ifFalse: [TextFormatter encodeToStrictXmlCrlf: alias]), '">']
		ifFalse: ['<a href="uploads/', uploads httpPath, upload last httpName, '">', ((alias = '') ifTrue: [upload xmlName] ifFalse: [TextFormatter encodeToStrictXmlCrlf: alias]), '</a>']! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 6/4/2001 14:35'!
reverseLinks: text request: request response: response shelf: shelf book: book page: page
	"save formatter"
	| alias remaining pageEntry refId |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>), '>'.
			((alias size) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 1) to: (remaining size)]]
		ifFalse: [alias _ ''].
	"e-mail address"
	(NuSwikiPage isTextAnEmailAddress: remaining)
		ifTrue: [^'*', text, '*'].
	"URL address"
	(NuSwikiPage hasAProtocol: remaining)
		ifTrue: [^'*', text, '*'].
	"Get pageEntry"
	(remaining includes: $@)
		ifTrue: [pageEntry _ remaining copyUpTo: $@.
			remaining _ remaining copyFrom: (pageEntry size + 1) to: (remaining size)]
		ifFalse: [pageEntry _ remaining.
			remaining _ ''].
	"No page entry"
	(pageEntry = '')
		ifTrue: [^'*', text, '*'].
	"Check for digit"
	(pageEntry isAllDigits) ifTrue: [
		refId _ pageEntry asNumber.
		(book pages size >= refId) ifTrue: [(page settings at: 'referenceCache' ifAbsentPut: [OrderedCollection new]) addIfNotPresent: refId].
		^'*', alias, pageEntry, remaining, '*'].
	"Transform title to digit"
	(book hasPageNamed: pageEntry) ifTrue: [
		refId _ (book pageNamed: pageEntry) id.
		(page settings at: 'referenceCache' ifAbsentPut: [OrderedCollection new]) 
			addIfNotPresent: refId.
		^'*', alias, (refId asString), remaining, '*'].
	"Not an identified page"
	^'*', text, '*'! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 6/4/2001 14:35'!
updateLinks: text request: request response: response shelf: shelf book: book page: page
	"update formatter"
	| alias remaining pageEntry refId |
	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: 
			[alias _ (remaining copyUpTo: $>)
						, '>'.
			alias size = remaining size
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: alias size + 1 to: remaining size]]
		ifFalse: [alias _ ''].
	"e-mail address"
	(NuSwikiPage isTextAnEmailAddress: remaining)
		ifTrue: [^ '*' , text , '*'].
	"URL address"
	(NuSwikiPage hasAProtocol: remaining)
		ifTrue: [^ '*' , text , '*'].
	"Get pageEntry"
	(remaining includes: $@)
		ifTrue: 
			[pageEntry _ remaining copyUpTo: $@.
			remaining _ remaining copyFrom: pageEntry size + 1 to: remaining size]
		ifFalse: 
			[pageEntry _ remaining.
			remaining _ ''].
	"Digit already"
	pageEntry isAllDigits ifTrue: [^ '*' , text , '*'].
	"Transform title to digit"
	(book hasPageNamed: pageEntry)
		ifTrue: 
			[refId _ (book pageNamed: pageEntry) id.
			(page settings at: 'referenceCache' ifAbsentPut: [OrderedCollection new])
				addIfNotPresent: refId.
			^ '*' , alias , refId asString , remaining , '*'].
	"Not an identified page"
	^ '*' , text , '*'! !

!PageFormatter methodsFor: 'utility' stamp: 'je77 5/21/2001 12:39'!
uploadLinks: text request: request response: response shelf: shelf book: book page: page
	"show formatter"
	| alias remaining |

	remaining _ text copy.
	"alias"
	(remaining includes: $>)
		ifTrue: [alias _ (remaining copyUpTo: $>).
			((alias size + 1) = (remaining size))
				ifTrue: [remaining _ '']
				ifFalse: [remaining _ remaining copyFrom: (alias size + 2) to: (remaining size)].
			alias _ PageFormatter toSafeAlias: alias]
		ifFalse: [alias _ ''].
	"Use upload.page action"
	(alias = '')
		ifTrue: [request settingsRemove: 'alias']
		ifFalse: [request settingsAt: 'alias' put: alias].
	request settingsAt: 'file' put: remaining.
	^book formatPageAction: 'upload' request: request response: response shelf: shelf page: page! !


!ShelfTemplateFormatter methodsFor: 'private' stamp: 'je77 5/1/2000 12:10'!
action: action value: value text: text
	"Overwrites parent class to add swiki action"
	^(value size = 4)
		ifTrue: ["Page Request"
			(value at: 3) formatBookAction: text with: value]
		ifFalse: ["Book Request"
			(value at: 3) formatShelfAction: text with: value]! !

!ShelfTemplateFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 12:11'!
format: template request: request response: response shelf: shelf
	"Formatting used for a shelf request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf.
	self format: template actionValue: value onTo: stream.
	^stream contents! !

!ShelfTemplateFormatter methodsFor: 'processing' stamp: 'je77 5/1/2000 12:10'!
format: template request: request response: response shelf: shelf book: book
	"Formatting used for a book request"
	| value stream |

	stream _ WriteStream on: (String new: template size).
	value _ Array with: request with: response with: shelf with: book.
	self format: template actionValue: value onTo: stream.
	^stream contents! !


!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 13:50'!
crToCrlf: aCrDelimitedString
	^CrToCrlf format: aCrDelimitedString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 13:51'!
crlfToCr: aCrlfDelimitedString
	^CrlfToCr format: aCrlfDelimitedString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 13:54'!
decodeFromHttp: aHttpString
	^DecodeFromHttp format: aHttpString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:25'!
decodeFromXmlCr
	^DecodeFromXmlCr! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:00'!
decodeFromXmlCr: xml
	^DecodeFromXmlCr format: xml! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:25'!
decodeFromXmlCrlf
	^DecodeFromXmlCrlf! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:00'!
decodeFromXmlCrlf: xml
	^DecodeFromXmlCrlf format: xml! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 13:52'!
encodeToHttp: aString
	^EncodeToHttp format: aString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:24'!
encodeToStrictXmlCr
	^EncodeToStrictXmlCr! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:01'!
encodeToStrictXmlCr: aString
	^EncodeToStrictXmlCr format: aString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:24'!
encodeToStrictXmlCrlf
	^EncodeToStrictXmlCrlf! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:01'!
encodeToStrictXmlCrlf: aString
	^EncodeToStrictXmlCrlf format: aString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:25'!
encodeToXmlCr
	^EncodeToXmlCr! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:01'!
encodeToXmlCr: aString
	^EncodeToXmlCr format: aString! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:25'!
encodeToXmlCrlf
	^EncodeToXmlCrlf! !

!TextFormatter class methodsFor: 'formatting' stamp: 'je77 9/20/2000 14:01'!
encodeToXmlCrlf: aString
	^EncodeToXmlCrlf format: aString! !

!TextFormatter class methodsFor: 'initialize-release' stamp: 'je77 9/20/2000 14:00'!
initialize
	| char translation |
	"Carriage Return Conversions"
	CrToCrlf _ self new
		addMappingFrom: String cr to: String crlf;
		addMappingFrom: String crlf to: String crlf;
		addMappingFrom: (Character lf asString) to: String crlf;
		yourself.
	CrlfToCr _ self new
		addMappingFrom: String crlf to: String cr;
		addMappingFrom: (Character lf asString) to: String cr;
		yourself.
	"Http Conversions"
	EncodeToHttp _ self new.
	DecodeFromHttp _ self new.
	1 to: 255 do: [:i | char _ Character value: i.
		(char isSafeForHTTP or: [char = #/]) ifFalse: [
			translation _ '%', (i // 16) asString, (i \\ 16) asString.
			char _ char asString.
			EncodeToHttp addMappingFrom: char to: translation.
			DecodeFromHttp addMappingFrom: translation to: char asString]].
	"Xml Conversions"
	EncodeToStrictXmlCr _ self new
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '&' to: '&amp;';
		addMappingFrom: '"' to: '&quot;';
		addMappingFrom: String crlf to: String cr;
		addMappingFrom: (Character lf asString) to: String cr;
		yourself.
	EncodeToStrictXmlCrlf _ self new
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '&' to: '&amp;';
		addMappingFrom: '"' to: '&quot;';
		addMappingFrom: String cr to: String crlf;
		addMappingFrom: String crlf to: String crlf;
		addMappingFrom: (Character lf asString) to: String crlf;
		yourself.
	EncodeToXmlCr _ self new
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '&' to: '&amp;';
		addMappingFrom: String crlf to: String cr;
		addMappingFrom: (Character lf asString) to: String cr;
		yourself.
	EncodeToXmlCrlf _ self new
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '&' to: '&amp;';
		addMappingFrom: String cr to: String crlf;
		addMappingFrom: String crlf to: String crlf;
		addMappingFrom: (Character lf asString) to: String crlf;
		yourself.
	DecodeFromXmlCr _ self new
		addMappingFrom: '&lt;' to: '<';
		addMappingFrom: '&gt;' to: '>';
		addMappingFrom: '&amp;' to: '&';
		addMappingFrom: '&quot;' to: '"';
		addMappingFrom: String crlf to: String cr;
		addMappingFrom: (Character lf asString) to: String cr;
		yourself.
	DecodeFromXmlCrlf _ self new
		addMappingFrom: '&lt;' to: '<';
		addMappingFrom: '&gt;' to: '>';
		addMappingFrom: '&amp;' to: '&';
		addMappingFrom: '&quot;' to: '"';
		addMappingFrom: String cr to: String crlf;
		addMappingFrom: String crlf to: String crlf;
		addMappingFrom: (Character lf asString) to: String crlf;
		yourself.! !

!TextFormatter class methodsFor: 'instance creation' stamp: 'je77 9/20/2000 13:36'!
new
	^super new initialize! !


!BookTemplateFormatter class methodsFor: 'accessing' stamp: 'je77 4/29/2000 10:30'!
swikiFormatter
	^SwikiFormatter! !

!BookTemplateFormatter class methodsFor: 'initialize-release' stamp: 'je77 4/29/2000 10:29'!
initialize
	SwikiFormatter _ self new.
	SwikiFormatter
		initialize;
		addAction: #swikiAction from: '<?' to: '?>'! !


!PageFormatter class methodsFor: 'formatting'!
toSafeAlias
	^ToSafeAlias! !

!PageFormatter class methodsFor: 'formatting' stamp: 'je77 5/1/2000 10:11'!
toSafeAlias: aString
	^ToSafeAlias format: aString! !

!PageFormatter class methodsFor: 'formatting'!
toSafeLocation
	^ToSafeLocation! !

!PageFormatter class methodsFor: 'formatting' stamp: 'je77 5/1/2000 10:12'!
toSafeLocation: aString
	^ToSafeLocation format: aString! !

!PageFormatter class methodsFor: 'initialize-release' stamp: 'je77 9/22/2000 16:58'!
initialize
	ToSafeAlias _ TextFormatter new.
	ToSafeAlias initialize;
		addMappingFrom: '>' to: '';
		addMappingFrom: '<' to: '';
		addMappingFrom: '@' to: '';
		addMappingFrom: '&star;' to: '*';
		addMappingFrom: '&at;' to: '@';
		addMappingFrom: '&lt;' to: '&lt;';
		addMappingFrom: '&gt;' to: '&gt;';
		addMappingFrom: '&amp;' to: '&amp;';
		addMappingFrom: '&' to: '&amp;'.
	ToSafeLocation _ TextFormatter new.
	ToSafeLocation initialize;
		addMappingFrom: '>' to: '&gt;';
		addMappingFrom: '<' to: '&lt;';
		addMappingFrom: '"' to: '&quot;';
		addMappingFrom: '&' to: '&amp;';
		addMappingFrom: '#' to: ''.! !

!PageFormatter class methodsFor: 'instance creation' stamp: 'je77 9/20/2000 18:23'!
editFormatter
	| return |
	return _ self new.
	return initialize;
		addCrToCrlf;
		addEditHtml;
		addChangeLinks;
		addEditSpecialCharacters;
		storeID: #editFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation'!
saveFormatter
	| return |
	return _ self new.
	return
		initialize;
		addCrlfToCr;
		addReverseLinks;
		addSaveHtml;
		addSaveSpecialCharacters;
		storeID: #saveFormatter.
	^return! !

!PageFormatter class methodsFor: 'instance creation' stamp: 'je77 4/8/2000 17:05'!
updateFormatter
	| return |
	return _ self new.
	return initialize;
		addUpdateLinks;
		addUpdateHtml;
		storeID: #updateFormatter.
	^return! !

!PageFormatter class methodsFor: 'utility' stamp: 'je77 2/18/2001 17:00'!
copyTreeFromDir: fromDir toDir: toDir
	| fromFile toFile |
	fromDir directoryNames do: [:dName |
		(toDir directoryExists: dName) ifFalse: [toDir createDirectory: dName].
		self copyTreeFromDir: (fromDir directoryNamed: dName) toDir: (toDir directoryNamed: dName)].
	fromDir fileNames do: [:fName |
		(toDir fileExists: fName) ifTrue: [toDir deleteFileNamed: fName].
		fromFile _ fromDir readOnlyFileNamed: fName.
		toFile _ toDir newFileNamed: fName.
		toDir copyFile: fromFile toFile: toFile.
		fromFile close.
		toFile close]! !

!PageFormatter class methodsFor: 'utility' stamp: 'je77 2/18/2001 17:08'!
deleteTreeForDir: dir
	dir directoryNames do: [:dName |
		self deleteTreeForDir: (dir directoryNamed: dName).
		dir deleteDirectory: dName].
	dir fileNames do: [:fName |
		dir deleteFileNamed: fName]! !

!PageFormatter class methodsFor: 'utility' stamp: 'je77 1/8/2001 18:08'!
isAnImage: aFileName
	^#('gif' 'jpeg' 'jpg' 'png') includes: ((aFileName copyAfterLast: $.) asLowercase)! !


!ShelfTemplateFormatter class methodsFor: 'accessing' stamp: 'je77 5/1/2000 12:13'!
swikiFormatter
	^SwikiFormatter! !

!ShelfTemplateFormatter class methodsFor: 'initialize-release' stamp: 'je77 5/1/2000 12:12'!
initialize
	SwikiFormatter _ self new.
	SwikiFormatter
		initialize;
		addAction: #swikiAction from: '<?' to: '?>'! !


!TextURL methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlCloseTagOn: strm
	strm
		nextPutAll: '</A>'! !

!TextURL methodsFor: 'as yet unclassified' stamp: 'bolot 3/17/2001 22:40'!
printHtmlOpenTagOn: strm
	strm
		nextPutAll: '<A HREF="';
		nextPutAll: self info;
		nextPutAll: '">'! !


!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 Time fromString: '11:55:23 am'
	"

	^self readFrom: (ReadStream on: aString)! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:10'!
midnight
	"Answer a new instance at midnight."

	^self fromSeconds: 0! !

!Time class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:09'!
noon
	"Answer a new instance at noon."

	^self fromSeconds: 43200! !


!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:51'!
date
	"Answer the date of the receiver."

	^date! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:52'!
date: aDate
	"Private - set the date of the receiver."

	date := aDate! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:53'!
time
	"Answer the time of the receiver."

	^time! !

!TimeStamp methodsFor: 'accessing' stamp: 'ccn 10/6/2000 22:54'!
time: aTime
	"Private - set the time of the receiver."

	time := aTime! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
minusDays: anInteger
	"Answer a TimeStamp which is anInteger days before the receiver."

	^self class date: (self date addDays: anInteger negated) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:03'!
minusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds before the receiver."

	^self class fromSeconds: ((self asSeconds) - anInteger)! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:00'!
plusDays: anInteger
	"Answer a TimeStamp which is anInteger days after the receiver."

	^self class date: (self date addDays: anInteger) time: self time! !

!TimeStamp methodsFor: 'arithmetic' stamp: 'ccn 10/7/2000 00:02'!
plusSeconds: anInteger
	"Answer a TimeStamp which is anInteger number of seconds after the receiver."

	^self class fromSeconds: ((self asSeconds) + anInteger)! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:22'!
< aTimeStamp
	"Answer true if the receiver is less than aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date 
		or: [self date = aTimeStamp date and: [self time < aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
<= aTimeStamp
	"Answer true if the receiver is less than or equal to aTimeStamp, otherwise answer false."

	^self date < aTimeStamp date
		or: [self date = aTimeStamp date and: [self time <= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:41'!
= aTimeStamp
	"ccn Note:  this does not take TimeZones into account.  Some day that should be fixed..."

	^self class = aTimeStamp class
		and: [self date = aTimeStamp date
		and: [self time = aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:23'!
> aTimeStamp
	"Answer true if the receiver is greater than aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time > aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:24'!
>= aTimeStamp
	"Answer true if the receiver is greater than or equal to aTimeStamp, otherwise answer false."

	^self date > aTimeStamp date
		or: [self date = aTimeStamp date and: [self time >= aTimeStamp time]]! !

!TimeStamp methodsFor: 'comparing' stamp: 'ccn 10/6/2000 23:06'!
hash
	"Answer the Integer hash value for the receiver."

	^self date hash bitXor: self time hash! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asDate
	"Answer the receiver as an instance of Date."

	^self date! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:25'!
asSeconds
	"Return the number of seconds in the receiver."

	^(self date asSeconds + self time asSeconds)! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:04'!
asTime
	"Answer the receiver as an instance of Time."

	^self time! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:33'!
asTimeStamp
	"Answer the receiver as an instance of TimeStamp."

	^self! !

!TimeStamp methodsFor: 'converting' stamp: 'ccn 10/6/2000 23:34'!
dateAndTime
	"Answer a two element Array containing the receiver's date and time."

	^Array with: self date with: self time! !

!TimeStamp methodsFor: 'printing' stamp: 'ccn 10/6/2000 23:51'!
printOn: aStream
	"Print receiver's date and time on aStream."

	| dateString timeString |
	dateString _ (self date isNil)
		ifTrue: ['no date']
		ifFalse: [self date printString].
	timeString _ (self time isNil)
		ifTrue: ['no time']
		ifFalse: [self time printString].
	(self date isNil and: [self time isNil])
		ifTrue:
			[super printOn: aStream.
			aStream nextPutAll: ' '].
	aStream 
		nextPutAll: dateString;
		nextPutAll: ', ';
		nextPutAll: timeString! !


!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 22:59'!
current
	"Answer the current date and time as a TimeStamp."

	| array |
	array _ Time dateAndTimeNow.
	^self date: array first time: array last! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/6/2000 23:00'!
date: aDate time: aTime
	"Answer a new instance based on the given date and time."

	^self
		new date: aDate;
		time: aTime;
		yourself! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:07'!
fromSeconds: anInteger
	"Answer a new instance based on the given number of seconds."

	| date |
	date _ Date fromSeconds: anInteger.
	^self date: date time: (Time fromSeconds: (anInteger - date asSeconds))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:36'!
fromString: aString
	"Answer a new instance for the value given by aString.

	 TimeStamp fromString: '1-10-2000 11:55:00 am'. 
	"

	| stream |
	stream := ReadStream on: aString withBlanksTrimmed.
	^self 
		date: (Date fromString: (stream upTo: $ )) 
		time: (Time fromString: (stream upTo: nil))! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:18'!
midnight
	"Answer a new instance that represents today at midnight."

	^self midnightOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:19'!
midnightOn: aDate
	"Answer a new instance that represents aDate at midnight."

	^self date: aDate time: Time midnight! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noon
	"Answer a new instance that represents today at noon."

	^self noonOn: Date today! !

!TimeStamp class methodsFor: 'instance creation' stamp: 'ccn 10/7/2000 00:16'!
noonOn: aDate
	"Answer a new instance that represents aDate at noon."

	^self date: aDate time: Time noon! !


!TurtleGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 03:15'!
initialize
	form _ Form extent: 300@300 depth: 8.
	pen _ Pen newOnForm: form.
	pen goto: form extent // 2.
! !

!TurtleGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/1/2001 03:13'!
process: request
	| operation amount |

	(self matchesUrl: request url)
		ifFalse: [^nil].

	(request url asLowercase endsWith: '.gif')
		ifTrue: [^form].

	operation _ request getFields at: 'operation' ifAbsent: [].
	amount _ request getFields at: 'amount' ifAbsent: [].

	(operation isNil or: [amount isNil])
		ifFalse: [amount _ amount asNumber.
			operation = 'forward' ifTrue: [pen go: amount].
			operation = 'left' ifTrue: [pen turn: amount].
			operation = 'right' ifTrue: [pen turn: amount negated]].

^'<HTML>
<HEAD><TITLE>Comanche Turtle</TITLE></HEAD>

<BODY>
<IMG SRC="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '">
<FORM ACTION="', request url, '" METHOD="GET">
<INPUT TYPE="text" NAME="amount">
<INPUT TYPE="submit" NAME="operation" VALUE="forward">
<INPUT TYPE="submit" NAME="operation" VALUE="left">
<INPUT TYPE="submit" NAME="operation" VALUE="right">
</FORM>
</BODY>
</HTML>'! !


!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 18:56'!
commandConsoleForRequest: request
^'<HTML>
<HEAD><TITLE>Comanche Turtle</TITLE></HEAD>

<BODY>
<FORM ACTION="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '" METHOD="GET" TARGET="turtleimageframe">
<INPUT TYPE="text" NAME="amount">
<INPUT TYPE="submit" NAME="operation" VALUE="forward">
<INPUT TYPE="submit" NAME="operation" VALUE="left">
<INPUT TYPE="submit" NAME="operation" VALUE="right">
</FORM>
</BODY>
</HTML>'! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 18:57'!
imageForRequest: request
	| operation amount |

	operation _ request getFields at: 'operation' ifAbsent: [].
	amount _ request getFields at: 'amount' ifAbsent: [].

	(operation isNil or: [amount isNil])
		ifFalse: [amount _ amount asNumber.
			operation = 'forward' ifTrue: [pen go: amount].
			operation = 'left' ifTrue: [pen turn: amount].
			operation = 'right' ifTrue: [pen turn: amount negated]].

	^form! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 19:02'!
process: request
	(self matchesUrl: request url)
		ifFalse: [^nil].

	(request url asLowercase endsWith: 'turtle.gif')
		ifTrue: [^self imageForRequest: request].

	(request url asLowercase endsWith: 'command.html')
		ifTrue: [^self commandConsoleForRequest: request].

	^self topFrameForRequest: request! !

!TurtleFrameGraphicsModule methodsFor: 'comanche' stamp: 'bolot 5/7/2001 19:01'!
topFrameForRequest: request
^'<HTML>
<HEAD>
<TITLE>Turtle Graphics in Comanche, with Frames</TITLE>
</HEAD>
<FRAMESET ROWS="*,150">
<FRAME NAME="turtleimageframe" SRC="', (self urlPattern copyReplaceAll: '*' with: '/turtle.gif'), '">
<FRAME NAME="turtlecmd" SRC="', (self urlPattern copyReplaceAll: '*' with: '/command.html'), '">
</FRAMESET>
</HTML>'! !


!UndefinedObject methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:08'!
asHttpResponseTo: request

	^HttpResponse 
		status: #notFound 
		description: 'The object you requested was not found on this server.'! !


!WriteStream methodsFor: 'converting' stamp: 'bolot 1/3/2000 17:13'!
asHttpResponseTo: request

	^HttpResponse fromMIMEDocument: 
		(MIMEDocument contentType: self mimeType content: self contents)! !

!WriteStream methodsFor: 'as yet unclassified' stamp: 'SVP 8/24/1999 15:49'!
mimeType

	^'text/html'! !


!ReadWriteStream methodsFor: 'converting' stamp: 'SVP 8/23/1999 19:07'!
asHttpResponseTo: request

	^HttpResponse fromStream: self! !


!StandardFileStream methodsFor: 'access' stamp: 'SVP 8/24/1999 15:47'!
mimeType

	^MIMEDocument guessTypeFromName: self name.
! !


!XmlSwikiStorage methodsFor: 'shelf' stamp: 'je77 5/2/2000 14:57'!
loadSettingsForShelf: shelf
	| ddir raw pos1 pos2 |
	ddir _ dir directoryNamed: 'default'.
	shelf settings: ((ddir fileExists: 'settings.xml')
		ifTrue: [raw _ (ddir readOnlyFileNamed: 'settings.xml') contentsOfEntireFile.
			pos1 _ raw findString: '<settings>' startingAt: 1.
			pos2 _ raw findString: '</settings>' startingAt: pos1.
			self class settingsDictFrom: (raw copyFrom: pos1 to: pos2 + 10)]
		ifFalse: [Dictionary new])! !

!XmlSwikiStorage methodsFor: 'shelf' stamp: 'je77 2/7/2001 13:06'!
setupBooks
	| books book bdir raw pos1 pos2 setup |
	books _ OrderedCollection new.
	dir directoryNames do: [:dname | (dname = 'default') ifFalse: [
		bdir _ dir directoryNamed: dname.
		(bdir fileExists: 'setup.xml') ifTrue: [
			raw _ (bdir readOnlyFileNamed: 'setup.xml') contentsOfEntireFile.
			pos1 _ raw findString: '<setup>' startingAt: 1.
			pos2 _ raw findString: '</setup>' startingAt: pos1.
			setup _ XmlSwikiStorage settingsDictFrom: (raw copyFrom: pos1 to: pos2 + 7).
			book _ (setup includesKey: 'parent')
				ifTrue: [SwikiSubBook new]
				ifFalse: [SwikiBook new].
			book
				name: dname;
				setup: setup.
			books add: book]]].
	^books! !

!XmlSwikiStorage methodsFor: 'shelf' stamp: 'Je77 8/7/2000 15:18'!
writeSettingsForShelf: shelf
	| ddir file |
	"Delete Old Settings"
	(ddir _ dir directoryNamed: 'default') deleteFileNamed: 'settings.xml'.
	"Add New Settings"
	file _ ddir newFileNamed: 'settings.xml'.
	file nextPutAll: '<?xml version="1.0"?>', String cr.
	file nextPutAll: '<settings>', String cr.
	file nextPutAll: (self class settingsStringFrom: shelf settings).
	file nextPutAll: '</settings>'.
	file close.! !

!XmlSwikiStorage methodsFor: 'shelf' stamp: 'je77 7/24/2000 13:27'!
writeSetupForBook: book
	| bdir file |
	bdir _ dir directoryNamed: book name.
	"Delete Old Setup"
	bdir deleteFileNamed: 'setup.xml'.
	"Add New Setup"
	file _ bdir newFileNamed: 'setup.xml'.
	file nextPutAll: '<?xml version="1.0"?>', String cr.
	file nextPutAll: '<setup>', String cr.
	file nextPutAll: (self class settingsStringFrom: book setup).
	file nextPutAll: '</setup>'.
	file close.! !

!XmlSwikiStorage methodsFor: 'book (load)' stamp: 'je77 5/2/2000 09:46'!
loadSettingsForBook: book
	| raw pos1 pos2 |
	book rawSettings: ((dir fileExists: 'settings.xml')
		ifTrue: [raw _ (dir readOnlyFileNamed: 'settings.xml') contentsOfEntireFile.
			pos1 _ raw findString: '<settings>' startingAt: 1.
			pos2 _ raw findString: '</settings>' startingAt: pos1.
			XmlSwikiStorage settingsDictFrom: (raw copyFrom: pos1 to: pos2 + 10)]
		ifFalse: [Dictionary new])! !

!XmlSwikiStorage methodsFor: 'book (load)' stamp: 'je77 5/2/2000 09:46'!
writeSettingsForBook: book
	| file |
	"Delete Old Settings"
	dir deleteFileNamed: 'settings.xml'.
	"Add New Settings"
	file _ dir newFileNamed: 'settings.xml'.
	file nextPutAll: '<?xml version="1.0"?>', String cr.
	file nextPutAll: '<settings>', String cr.
	file nextPutAll: (self class settingsStringFrom: book rawSettings).
	file nextPutAll: '</settings>'.
	file close.! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 5/7/2000 14:18'!
backupPage: aPage
	"Back-up a .xml page to put it's contents into a .old page."
	| oldPath oldStream file pos |

	"Get the path for the .old file."
	oldPath _ (aPage id asString), '.old'.
	"Get the .old stream to write on"
	(dir fileExists: oldPath)
		ifTrue: [oldStream _ dir oldFileNamed: oldPath.
				oldStream setToEnd]
		ifFalse: [oldStream _ dir newFileNamed: oldPath].
	file _ (dir readOnlyFileNamed: (aPage id asString, '.xml')) contentsOfEntireFile.
	pos _ file findString: '<page>' startingAt: 1.
	"Add current page."
	oldStream nextPutAll: (file copyFrom: pos to: file size).
	oldStream nextPutAll: String cr.
	oldStream close! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 7/16/2000 14:45'!
isAComplexPage: aPage
	| text |
	text _ aPage rawText.
	(text isKindOf: String) ifTrue: [^false].
	(text isKindOf: Array) ifTrue: [^false].
	^true
! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 2/19/2001 16:48'!
loadPage: aPage
	| xml pos0 |
	xml _ (aPage versionId = 0)
		ifTrue: [(dir readOnlyFileNamed: ((aPage id asString), '.xml')) contentsOfEntireFile]
		ifFalse: [dir readOnlyFileNamed: ((aPage id asString), '.old')].
	(aPage versionId > 0)
		ifTrue: [pos0 _ 0.
			1 to: (aPage versionId) do: [:i | pos0 _ xml findString: '<page>' startingAt: (pos0 + 1).
				(pos0 = 0) ifTrue: [^nil]]]
		ifFalse: [pos0 _ 1].
	self loadPage: aPage from: xml startingAt: pos0! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 9/20/2000 14:29'!
loadPage: aPage from: xml startingAt: pos0
	| pos1 pos2 date |

	"Version"
	pos1 _ xml findString: '<version date="' startingAt: pos0.
	pos2 _ xml findString: '" time="' startingAt: pos1.
	date _ (xml copyFrom: (pos1 + 15) to: (pos2 - 1)) findTokens: './'.
	aPage date: (Date newDay: (date at: 1) asNumber month: (date at: 2) asNumber year: (date at: 3) asNumber).
	pos1 _ xml findString: '" user="' startingAt: pos2.
	aPage time: (Time readFrom: (ReadStream on: (xml copyFrom: (pos2 + 8) to: (pos1 - 1)))).
	pos2 _ xml findString: '" />' startingAt: pos1.
	aPage user: (xml copyFrom: (pos1 + 8) to: (pos2 - 1)).
	"Settings"
	pos1 _ xml findString: '<settings>' startingAt: pos2.
	pos2 _ xml findString: '</settings>' startingAt: pos1.
	aPage settings: (self class settingsDictFrom: (xml copyFrom: (pos1) to: (pos2 + 10))).
	"Name"
	pos1 _ xml findString: '<name>' startingAt: pos2.
	pos2 _ xml findString: '</name>' startingAt: pos1.
	aPage name: (TextFormatter decodeFromXmlCr: (xml copyFrom: (pos1 + 6) to: (pos2 - 1))).
	"Text"
	pos1 _ xml findString: '<text>' startingAt: pos2.
	pos2 _ xml findString: '</text>' startingAt: pos1.
	aPage text: (self class textFrom: xml start: (pos1 + 6) end: (pos2 - 1))! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'Je77 8/17/2000 08:58'!
loadPages
	| id pages page files |
	pages _ OrderedCollection new.
	id _ 1.
	files _ dir fileNames.
	[files includes: (id asString, '.xml')] whileTrue: [
		page _ NuSwikiPage new id: id; versionId: 0; storage: self.
		self loadPage: page.
		pages add: page.
		id _ id + 1].
	^pages! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 2/19/2001 15:36'!
loadVersionsFrom: aPage
	| versions xml pos0 version vid |
	versions _ OrderedCollection new.
	(dir fileExists: (aPage id asString, '.old'))
		ifTrue: [xml _ dir readOnlyFileNamed: (aPage id asString, '.old').
			vid _ 1.
			pos0 _ 0.
			[0 = (pos0 _ xml findString: '<page>' startingAt: (pos0 + 1))] whileFalse: [
				version _ aPage class new id: (aPage id); versionId: vid; storage: self.
				self loadPage: version from: xml startingAt: pos0.
				versions add: version.
				vid _ vid + 1]].
	^versions! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 9/20/2000 14:30'!
multipleTextFrom: aPage
	| file return |
	file _ dir readOnlyFileNamed: (self pathFrom: aPage).
	return _ Dictionary new.
	aPage rawText keysAndValuesDo: [:key :value |
		(value isKindOf: Array)
			ifTrue: [file position: ((value at: 1) - 1).
				return at: key put: (TextFormatter decodeFromXmlCr: (file next: (1 + (value at: 2) - (value at: 1))))]
			ifFalse: [return at: key put: value]].
	file close.
	^return
! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 5/2/2000 14:54'!
pathFrom: aPage
	^(aPage versionId = 0)
		ifTrue: [(aPage id asString), '.xml']
		ifFalse: [(aPage id asString), '.old']
! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 9/20/2000 14:31'!
simpleTextFrom: aPage
	| file return |
	file _ dir readOnlyFileNamed: (self pathFrom: aPage).
	file position: ((aPage rawText at: 1) - 1).
	return _ TextFormatter decodeFromXmlCr: (file next: (1 + (aPage rawText at: 2) - (aPage rawText at: 1))).
	file close.
	^return
! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 4/29/2000 12:33'!
textFrom: aPage
	| text |
	text _ aPage rawText.
	(text isKindOf: String) ifTrue: [^text].
	(text isKindOf: Array) ifTrue: [^self simpleTextFrom: aPage].
	(text isKindOf: Dictionary) ifTrue: [((text values at: 1) isKindOf: String)
		ifTrue: [^text]
		ifFalse: [^self multipleTextFrom: aPage]].
	^''
! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 9/20/2000 14:31'!
textKey: key from: aPage
	| text arr return file |
	text _ aPage rawText.
	(text isKindOf: String) ifTrue: [^''].
	(text isKindOf: Array) ifTrue: [^''].
	arr _ text at: key ifAbsent: [^''].
	(arr isKindOf: String) ifTrue: [^arr].
	file _ dir readOnlyFileNamed: (self pathFrom: aPage).
	file position: ((arr at: 1) - 1).
	return _ TextFormatter decodeFromXmlCr: (file next: (1 + (arr at: 2) - (arr at: 1))).
	file close.
	^return! !

!XmlSwikiStorage methodsFor: 'pages' stamp: 'je77 9/20/2000 14:32'!
writePage: aPage
	| file |

	"Delete Old Version"
	dir deleteFileNamed: (self pathFrom: aPage).
	"Header"
	file _ dir newFileNamed: (self pathFrom: aPage).
	file nextPutAll: '<?xml version="1.0"?>', String cr.
	file nextPutAll: '<page>', String cr.
	"Version"
	file nextPutAll: '<version date="'.
	file nextPutAll: (aPage date dayOfMonth asString, '/', aPage date monthIndex asString, '/', aPage date year asString).
	file nextPutAll: '" time="'.
	aPage time printOn: file.
	file nextPutAll: '" user="', aPage user, '" />', String cr.
	"Settings"
	file nextPutAll: '<settings>', String cr.
	file nextPutAll: (self class settingsStringFrom: aPage settings).
	file nextPutAll: '</settings>', String cr.
	"Name"
	file nextPutAll: '<name>'.
	TextFormatter encodeToXmlCr format: aPage name onTo: file.
	file nextPutAll: '</name>', String cr.
	"Text"
	file nextPutAll: '<text>'.
	self addTextFrom: aPage to: file.
	file nextPutAll: '</text>', String cr.
	file nextPutAll: '</page>'.
	file close.! !

!XmlSwikiStorage methodsFor: 'private' stamp: 'je77 9/20/2000 14:27'!
addTextFrom: aPage to: file
	| saveText new arr|
	saveText _ aPage text.
	(saveText isKindOf: Dictionary)
		ifTrue: [new _ Dictionary new.
			file nextPutAll: String cr.
			saveText keysAndValuesDo: [:key :value |
				arr _ Array new: 2.
				file nextPutAll: '<t name="'.
				TextFormatter encodeToStrictXmlCr format: key onTo: file.
				file nextPutAll: '">'.
				arr at: 1 put: (1 + file position).
				TextFormatter encodeToXmlCr format: value onTo: file.
				arr at: 2 put: (file position).
				new at: key put: arr.
				file nextPutAll: '</t>', String cr]]
		ifFalse: [new _ Array new: 2.
			new at: 1 put: (1 + file position).
			TextFormatter encodeToXmlCr format: saveText onTo: file.
			new at: 2 put: file position].
	aPage text: new! !

!XmlSwikiStorage methodsFor: 'private' stamp: 'je77 2/23/2001 11:19'!
getMetaCollForDir: aDir
	| tokens return id type name category pos1 pos2 |
	return _ OrderedCollection new.
	(aDir fileExists: 'meta.xml') ifFalse: [^return].
	tokens _ (aDir readOnlyFileNamed: 'meta.xml') contentsOfEntireFile findTokens: String crlf.
	tokens do: [:token | (token beginsWith: '<file') ifTrue: [
		pos1 _ token findString: 'id="'.
		pos2 _ token findString: '"' startingAt: (pos1 + 4).
		id _ token copyFrom: (pos1+4) to: (pos2 - 1).
		pos1 _ token findString: 'type="'.
		pos2 _ token findString: '"' startingAt: (pos1 + 6).
		type _ token copyFrom: (pos1+6) to: (pos2 - 1).
		pos1 _ token findString: 'name="'.
		pos2 _ token findString: '"' startingAt: (pos1 + 6).
		name _ token copyFrom: (pos1+6) to: (pos2 - 1).
		category _ ((pos1 _ token findString: 'category="') = 0)
			ifTrue: [nil]
			ifFalse: [pos2 _ token findString: '"' startingAt: (pos1 + 10).
				token copyFrom: (pos1 + 10) to: (pos2 - 1)].
		return add: (Array with: id with: type with: name with: category)]].
	^return! !

!XmlSwikiStorage methodsFor: 'private' stamp: 'je77 3/8/2001 16:20'!
putMetaColl: coll forDir: aDir
	| file |
	(aDir fileExists: 'meta.xml') ifTrue: [aDir deleteFileNamed: 'meta.xml'].
	file _ aDir newFileNamed: 'meta.xml'.
	file
		nextPutAll: '<?xml version="1.0"?>';
		nextPut: Character cr;
		nextPutAll: '<meta>';
		nextPut: Character cr.
	coll do: [:arr |
		file
			nextPutAll: '<file id="';
			nextPutAll: (arr at: 1);
			nextPutAll: '" type="';
			nextPutAll: (arr at: 2);
			nextPutAll: '" name="';
			nextPutAll: (arr at: 3).
		(arr at: 4) ifNotNil: [file
			nextPutAll: '" category="';
			nextPutAll: (arr at: 4)].
		file
			nextPutAll: '" />';
			nextPut: Character cr].
	file
		nextPutAll: '</meta>';
		close
! !


!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 11:53'!
booleanSettingFrom: xml
	^xml = 'true'
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:34'!
booleanSettingNamed: aString value: value
	^'<s name="', (TextFormatter encodeToStrictXmlCr: aString), '" type="boolean">', (value ifTrue: ['true'] ifFalse: ['false']), '</s>'! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:34'!
codeSettingFrom: xml
	^Compiler evaluate: (TextFormatter decodeFromXmlCr: xml)
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:36'!
codeSettingNamed: aString value: value
	^'<s name="', (TextFormatter encodeToStrictXmlCr: aString), '" type="code">', (TextFormatter encodeToXmlCr: (self storeStringFor: value)), '</s>'! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 11:56'!
collSettingFrom: xml
	| return |
	return _ OrderedCollection new.
	(xml findTokens: ' ') do: [:element | return add: element asNumber].
	^return
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:36'!
collSettingNamed: aString value: value
	| return |
	return _ '<s name="', (TextFormatter encodeToStrictXmlCr: aString), '" type="coll">'.
	value do: [:element | return _ return, (element asString), ' '].
	^(return copyFrom: 1 to: (return size - 1)), '</s>'! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 11:52'!
numberSettingFrom: xml
	^xml asNumber
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:37'!
numberSettingNamed: aString value: value
	^'<s name="', (TextFormatter encodeToStrictXmlCr: aString), '" type="number">', (value asString), '</s>'! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 11:19'!
performerFor: value
	TypesDict keysAndValuesDo: [:class :selector |
		(value isKindOf: class) ifTrue: [^selector]].
	^#codeSettingNamed:value:! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:38'!
settingAssocFromXml: xml
	| pos1 pos2 pos3 key type value |
	pos1 _ xml findString: 'name="' startingAt: 1.
	pos2 _ xml findString: '"' startingAt: (pos1 + 6).
	key _ TextFormatter decodeFromXmlCr: (xml copyFrom: (pos1 + 6) to: (pos2 - 1)).
	pos3 _ xml findString: '>' startingAt: pos2.
	pos1 _ xml findString: 'type="' startingAt: 1.
	((pos1 < pos3) and: [pos1 > 0])
		ifTrue: [pos2 _ xml findString: '"' startingAt: (pos1 + 6).
			type _ xml copyFrom: (pos1 + 6) to: (pos2 - 1)]
		ifFalse: [type _ 'code'].
	pos1 _ xml findString: '</s>' startingAt: pos3.
	value _ xml copyFrom: (pos3 + 1) to: (pos1 - 1).
	value _ self perform: (AssocDict at: type) with: value.
	^Association key: key value: value
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 11:17'!
settingStringNamed: aString value: value
	^self perform: (self performerFor: value) with: aString with: value! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 5/2/2000 14:57'!
settingsDictFrom: xml
	| pos1 pos2 dict |

	dict _ Dictionary new.
	pos1 _ 1.
	[0 = (pos1 _ xml findString: '<s ' startingAt: pos1)] whileFalse: [
		pos2 _ xml findString: '</s>' startingAt: pos1.
		dict add: (self settingAssocFromXml: (xml copyFrom: pos1 to: (pos2 + 3))).
		pos1 _ pos1 + 1].
	^dict
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/30/2000 10:37'!
settingsStringFrom: dict
	"Converts a dictionary to a xml string."
	| xml |

	xml _ ''.
	dict keysAndValuesDo: [:key :value | xml _ xml, (self settingStringNamed: key value: value), String cr].
	^xml! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/29/2000 14:43'!
storeStringFor: object
	| return |

	(object isKindOf: OrderedCollection) ifTrue: [
		((object at: 1 ifAbsent: ['do not do']) isKindOf: Integer)
			ifTrue: [return _ '#('.
				object do: [:element | return _ return, (element storeString), ' '].
				^return, ') asOrderedCollection']].
	^object storeString! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:40'!
textDictionaryFrom: xml start: start end: end
	| dict pos1 pos2 key value |

	dict _ Dictionary new.
	pos2 _ start - 1.
	[pos1 _ xml findString: '<t name="' startingAt: pos2. (pos1 = 0) or: [pos1 > end]] whileFalse: ["Keep adding elements"
		pos2 _ xml findString: '">' startingAt: pos1.
		key _ TextFormatter decodeFromXmlCr: (xml copyFrom: (pos1 + 9) to: (pos2 - 1)).
		pos1 _ xml findString: '</t>' startingAt: pos2.
		value _ Array new: 2.
		value at: 1 put: (pos2 + 2).
		value at: 2 put: (pos1 - 1).
		dict at: key put: value.
		pos2 _ pos1 + 2].
	^dict
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 4/29/2000 14:42'!
textFrom: xml start: start end: end
	| arr test |

	(start < end) ifTrue: [test _ xml findString: '<' startingAt: start.
		(test < end) ifTrue: [^self textDictionaryFrom: xml start: start end: end]].
	arr _ Array new: 2.
	arr at: 1 put: start.
	arr at: 2 put: end.
	^arr! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:41'!
textSettingFrom: xml
	^TextFormatter decodeFromXmlCr: xml
! !

!XmlSwikiStorage class methodsFor: 'conversion' stamp: 'je77 9/20/2000 14:42'!
textSettingNamed: aString value: value
	^'<s name="', (TextFormatter encodeToStrictXmlCr: aString), '" type="text">', (TextFormatter encodeToXmlCr: value), '</s>'! !

!XmlSwikiStorage class methodsFor: 'initialize-release' stamp: 'je77 9/20/2000 14:23'!
initialize
	"Dictionaries"
	TypesDict _ Dictionary new.
	TypesDict
		at: String put: #textSettingNamed:value:;
		at: Number put: #numberSettingNamed:value:;
		at: Boolean put: #booleanSettingNamed:value:;
		at: OrderedCollection put: #collSettingNamed:value:.
	AssocDict _ Dictionary new.
	AssocDict
		at: 'text' put: #textSettingFrom:;
		at: 'number' put: #numberSettingFrom:;
		at: 'boolean' put: #booleanSettingFrom:;
		at: 'coll' put: #collSettingFrom:;
		at: 'code' put: #codeSettingFrom:.! !

!XmlSwikiStorage class methodsFor: 'instance creation' stamp: 'je77 4/29/2000 13:12'!
loadPagesFromDir: dir
	^(self fromDir: dir) loadPages
! !

!XmlSwikiStorage class methodsFor: 'testing class hierarchy' stamp: 'Je77 8/4/2000 14:32'!
handlesBookStorage
	^true! !

!XmlSwikiStorage class methodsFor: 'testing class hierarchy' stamp: 'Je77 8/3/2000 08:31'!
handlesPageStorage
	^true! !

XmlSwikiStorage initialize!

!TurtleGraphicsModule reorganize!
('comanche' initialize process:)
!

ShelfTemplateFormatter initialize!
PageFormatter initialize!
BookTemplateFormatter initialize!
TextFormatter initialize!
NuSwikiPage initialize!
SwikiFile initialize!
SwikiImage initialize!
HttpRequest initialize!
MIMEDocument initialize!
LineFormatter initialize!
HttpResponse initialize!
ComancheService initialize!
ComancheServer initialize!
ComSwikiLauncher initialize!
"Postscript:
Set preferences."
Preferences initializeHelpMessages.
Preferences initializeAddedPreferences.
Preferences addPreference: #standaloneServer category: #comanche default: true balloonHelp: 'If true, then errors are suppressed.
If false, all errors are popped up'.
Preferences addPreference: #keepAliveConnections category: #comanche default: false balloonHelp: 'Keep connections alive or terminate after each request'.!

